Package: imcRtools
Version: 1.19.1
Title: Methods for imaging mass cytometry data analysis
Description: 
    This R package supports the handling and analysis of imaging mass cytometry 
    and other highly multiplexed imaging data. The main functionality includes 
    reading in single-cell data after image segmentation and measurement, data 
    formatting to perform channel spillover correction and a number of spatial 
    analysis approaches. First, cell-cell interactions are detected via spatial 
    graph construction; these graphs can be visualized with cells representing 
    nodes and interactions representing edges. Furthermore, per cell, its direct 
    neighbours are summarized to allow spatial clustering. Per image/grouping 
    level, interactions between types of cells are counted, averaged and 
    compared against random permutations. In that way, types of cells that 
    interact more (attraction) or less (avoidance) frequently than expected by 
    chance are detected. 
Authors@R: 
    c(person("Nils", "Eling", role = "aut"),
      person("Tobias", "Hoch", role = "ctb"),
      person("Vito", "Zanotelli", role = "ctb"),
      person("Jana", "Fischer", role = "ctb"),
      person("Daniel", "Schulz", role = c("ctb", "cre"),email = "daniel.schulz@uzh.ch",comment = c(ORCID = "0000-0002-0913-1678")),
      person("Lasse","Meyer", role = "ctb"),
      person("Lutz","Marlene", role = "ctb"),
      person("Schiller","Chiara", role = "ctb"),
      person("Ibañez", "Victor", role = "ctb"))
License: GPL-3
Depends: R (>= 4.1), SpatialExperiment
Imports: S4Vectors, stats, utils, SummarizedExperiment, methods,
        pheatmap, scrapper, stringr, readr, EBImage, cytomapper, abind,
        BiocParallel, viridis, dplyr, magrittr, DT, igraph,
        SingleCellExperiment, vroom, BiocNeighbors, RTriangle, ggraph,
        tidygraph, ggplot2, data.table, sf, concaveman, tidyselect,
        distances, MatrixGenerics, rlang, grDevices
Suggests: CATALYST, grid, tidyr, BiocStyle, knitr, rmarkdown, markdown,
        testthat
biocViews: ImmunoOncology, SingleCell, Spatial, DataImport, Clustering
VignetteBuilder: knitr
URL: https://github.com/BodenmillerGroup/imcRtools
BugReports: https://github.com/BodenmillerGroup/imcRtools/issues
RoxygenNote: 7.3.3
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/imcRtools
git_branch: devel
git_last_commit: 6b31abd
git_last_commit_date: 2026-05-09
Repository: Bioconductor 3.24
Date/Publication: 2026-05-10
NeedsCompilation: no
Packaged: 2026-05-10 22:37:27 UTC; biocbuild
Author: Nils Eling [aut],
  Tobias Hoch [ctb],
  Vito Zanotelli [ctb],
  Jana Fischer [ctb],
  Daniel Schulz [ctb, cre] (ORCID:
    <https://orcid.org/0000-0002-0913-1678>),
  Lasse Meyer [ctb],
  Lutz Marlene [ctb],
  Schiller Chiara [ctb],
  Ibañez Victor [ctb]
Maintainer: Daniel Schulz <daniel.schulz@uzh.ch>

<img src="vignettes/imcRtools_sticker.png" align="right" alt="" width="100" />

# imcRtools

<!-- badges: start -->
[![codecov](https://codecov.io/gh/BodenmillerGroup/imcRtools/branch/devel/graph/badge.svg)](https://codecov.io/gh/BodenmillerGroup/imcRtools)
[![docs](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/docs.yml/badge.svg?branch=devel)](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/docs.yml)
<!-- badges: end -->

This R/Bioconductor package contains helper functions to analyse IMC (or other multiplexed imaging) data.

Its official package page can be found here: [https://bioconductor.org/packages/imcRtools](https://bioconductor.org/packages/imcRtools)

**Bug notice: we discovered and fixed a bug in the `testInteractions` function in version below 1.5.5 which affected `SingleCellExperiment` or `SpatialExperiment` objects in which cells were not grouped by image. Please install the newest version of `imcRtools` directly from Github as explained below.**  

## Check status

| Bioc branch | Checks |
|:-----------:|:------:|
| Release     |[![build-check-release](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/build-checks-release.yml/badge.svg?branch=devel)](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/build-checks-release.yml)|
| Devel       |[![build-check-devel](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/build-checks-devel.yml/badge.svg?branch=devel)](https://github.com/BodenmillerGroup/imcRtools/actions/workflows/build-checks-devel.yml)|

## Introduction

Highly multiplexed imaging techniques such as imaging mass cytometry (IMC), 
multiplexed ion beam imaging (MIBI) and cyclic immunofluorescence techniques
acquire read-outs of the expression of tens of protein in a spatially resolved
manner.

This R package supports the handling and analysis of imaging mass cytometry 
and other highly multiplexed imaging data. The main functionality includes 
reading in single-cell data after image segmentation and measurement, data 
formatting to perform channel spillover correction and a number of spatial 
analysis approaches. First, cell-cell interactions are detected via spatial 
graph construction; these graphs can be visualized with cells representing 
nodes and interactions representing edges. Furthermore, per cell, its direct 
neighbours are summarized to allow spatial clustering. Per image/grouping 
level, interactions between types of cells are counted, averaged and 
compared against random permutations. In that way, types of cells that 
interact more (attraction) or less (avoidance) frequently than expected by 
chance are detected. 

## Installation

The `imcRtools` package can be installed from `Bioconductor` via:

```r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("imcRtools")
```

The development version of `imcRtools` can be installed from Github via:

```r
if (!requireNamespace("remotes", quietly = TRUE))
    install.packages("remotes")

remotes::install_github("BodenmillerGroup/imcRtools")
```

## Getting help

The analysis of highly multiplexed imaging data requires multiple pre-processing
and diverse analysis steps.

1. Processing of raw data and segmentation: The 
[ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline) and 
the [steinbock](https://github.com/BodenmillerGroup/steinbock) 
library can be used to process and segment IMC data. The
`imcRtools` package provides reader functions for outputs generated by these 
approaches.  

2. Single-cell analysis using the [Bioconductor](https://www.bioconductor.org/) framework: The 
[Orchestrating Single-Cell Analysis with Bioconductor](https://bioconductor.org/books/release/OSCA/)
book is an excellent resource for beginners and advanced analysis concerning
single-cell data. Common analysis steps include dimensionality reduction, 
unsupervised clustering for cell type detection and data visualization.
The `imcRtools` package supports data structures that fully
integrate with the analysis presented in the OSCA book.  

3. Handling multiplexed images in R: the 
[cytomapper](https://www.bioconductor.org/packages/release/bioc/html/cytomapper.html)
Bioconductor package provides functions and data structure to handle and 
analyse highly multiplexed imaging data (images, masks and single-cell data)
natively in R.

## Citation

Please cite the following paper when using `imcRtools` in your research:

>  Windhager, J., Zanotelli, V.R.T., Schulz, D. et al. An end-to-end workflow for multiplexed image processing and analysis. Nat Protoc (2023). https://doi.org/10.1038/s41596-023-00881-0

    @article{Windhager2023,
        author = {Windhager, Jonas and Zanotelli, Vito R.T. and Schulz, Daniel and Meyer, Lasse and Daniel, Michelle and Bodenmiller, Bernd and Eling, Nils},
        title = {An end-to-end workflow for multiplexed image processing and analysis},
        year = {2023},
        doi = {10.1038/s41596-023-00881-0},
        URL = {https://www.nature.com/articles/s41596-023-00881-0},
        journal = {Nature Protocols}
    }

## Contributing

For feature requests, please open an issue [here](https://github.com/BodenmillerGroup/imcRtools/issues).

Alternatively, you can fork the repository, add your change and issue a pull request.

## Maintainer

**Daniel Schulz**

#' @rdname testInteractions
#' @title Tests if cell types interact more or less frequently than random
#'
#' @description Cell-cell interactions are summarized in different ways and
#' the resulting count is compared to a distribution of counts arising 
#' from random permutations.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object.
#' @param group_by a single character indicating the \code{colData(object)}
#' entry by which interactions are grouped. This is usually the image ID or
#' patient ID.
#' @param label single character specifying the \code{colData(object)} entry
#' which stores the cell labels. These can be cell-types labels or other
#' metadata entries. 
#' @param method which cell-cell interaction counting method to use 
#' (see details)
#' @param patch_size if \code{method = "patch"}, a single numeric specifying
#' the minimum number of neighbors of the same type to be considered a patch
#' (see details)
#' @param colPairName single character indicating the \code{colPair(object)}
#' entry containing cell-cell interactions in form of an edge list.
#' @param iter single numeric specifying the number of permutations to perform
#' @param p_threshold single numeric indicating the empirical p-value 
#' threshold at which interactions are considered to be significantly 
#' enriched or depleted per group.
#' @param return_samples single logical indicating if the permuted interaction
#' counts of all iterations should be returned.
#' @param tolerance single numeric larger than 0. This parameter defines the
#' difference between the permuted count and the actual counts at which both
#' are regarded as equal. Default taken from \code{all.equal}.
#' @param BPPARAM parameters for parallelized processing. 
#'
#' @section Counting and summarizing cell-cell interactions:
#' In principle, the \code{\link{countInteractions}} function counts the number
#' of edges (interactions) between each set of unique entries in 
#' \code{colData(object)[[label]]}. Simplified, it counts for each cell of
#' type A the number of neighbors of type B.
#' This count is averaged within each unique entry 
#' \code{colData(object)[[group_by]]} in four different ways:
#' 
#' 1. \code{method = "classic"}: The count is divided by the total number of 
#' cells of type A. The final count can be interpreted as "How many neighbors 
#' of type B does a cell of type A have on average?" 
#' 
#' 2. \code{method = "conditional"}: Formerly named "histocat". The count is divided 
#' by the number of cells of type A that have at least one neighbor of type B. The 
#' final count can be interpreted as "How many neighbors of type B has a cell of 
#' type A on average, given it has at least one neighbor of type B?".
#' 
#' 3. \code{method = "patch"}: For each cell, the count is binarized to 0 
#' (less than \code{patch_size} neighbors of type B) or 1 (more or equal to 
#' \code{patch_size} neighbors of type B). The binarized counts are averaged 
#' across all cells of type A. The final count can be interpreted as "What 
#' fraction of cells of type A have at least a given number of neighbors of 
#' type B?"
#' 
#' 4. \code{method = "interaction"}: The count is divided by the total number of 
#' interactions from cell type A. The final count can be interpreted as "What 
#' fraction of interactions of cell type A occur with cell type B."
#' 
#' @section Testing for significance: Within each unique entry to
#' \code{colData(object)[[group_by]]}, the entries of
#' \code{colData(object)[[label]]} are randomized \code{iter} times. For each
#' iteration, the interactions are counted as described above. The result is a
#' distribution of the interaction count under spatial randomness. The
#' observed interaction count is compared against this Null distribution to
#' derive empirical p-values:
#' 
#' \code{p_gt}: fraction of perturbations equal or greater than the observed 
#' count
#' 
#' \code{p_lt}: fraction of perturbations equal or less than the observed count
#' 
#' Based on these empirical p-values, the \code{interaction} score (attraction
#' or avoidance), overall \code{p} value and significance by comparison to
#' \code{p_treshold} (\code{sig} and \code{sigval}) are derived.
#' 
#' @return a DataFrame containing one row per \code{group_by} entry and unique
#' \code{label} entry combination (\code{from_label}, \code{to_label}). The
#' object contains following entries:
#' 
#' \itemize{
#' \item{\code{ct}:}{ stores the interaction count as described in the details} 
#' \item{\code{p_gt}:}{ stores the fraction of perturbations equal or greater 
#' than \code{ct}}  
#' \item{\code{p_lt}:}{ stores the fraction of perturbations equal or less than 
#' \code{ct}}
#' \item{\code{zscore}:}{ (observed count - mean of permuted counts) / sd of 
#' permuted counts 
#' \item{\code{interaction}:}{ is there the tendency for a positive interaction
#' (attraction) between \code{from_label} and \code{to_label}? Is \code{p_lt}
#' greater than \code{p_gt}?}
#' \item{\code{p}:}{ the smaller value of \code{p_gt} and \code{p_lt}.} 
#' \item{\code{sig}:}{ is \code{p} smaller than \code{p_threshold}?}
#' \item{\code{sigval}:}{ Combination of \code{interaction} and \code{sig}.}
#' \itemize{
#' \item{-1:}{ \code{interaction == FALSE} and \code{sig == TRUE}}  
#' \item{0:}{ \code{sig == FALSE}}  
#' \item{1:}{ \code{interaction == TRUE} and \code{sig == TRUE}}
#' }
#' }
#' 
#' \code{NA} is returned if a certain label is not present in this grouping 
#' level.
#'  
#' @examples 
#' library(cytomapper)
#' library(BiocParallel)
#' data(pancreasSCE)
#'
#' pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                                  type = "knn", k = 3)
#'                                
#' # Classic style calculation - setting the seed inside SerialParam for reproducibility
#' (out <- testInteractions(pancreasSCE, 
#'                          group_by = "ImageNb",
#'                          label = "CellType", 
#'                          method = "classic",
#'                          colPairName = "knn_interaction_graph",
#'                          iter = 1000,
#'                          BPPARAM = SerialParam(RNGseed = 123)))
#'                                 
#' # Conditional style calculation
#' (out <- testInteractions(pancreasSCE, 
#'                          group_by = "ImageNb",
#'                          label = "CellType", 
#'                          method = "conditional",
#'                          colPairName = "knn_interaction_graph",
#'                          iter = 1000,
#'                          BPPARAM = SerialParam(RNGseed = 123)))
#'                                 
#' # Patch style calculation
#' (out <- testInteractions(pancreasSCE, 
#'                          group_by = "ImageNb",
#'                          label = "CellType", 
#'                          method = "patch",
#'                          patch_size = 3,
#'                          colPairName = "knn_interaction_graph",
#'                          iter = 1000,
#'                          BPPARAM = SerialParam(RNGseed = 123)))
#'                          
#' # Interaction style calculation
#' (out <- testInteractions(pancreasSCE, 
#'                          group_by = "ImageNb",
#'                          label = "CellType", 
#'                          method = "interaction",
#'                          colPairName = "knn_interaction_graph"))
#' 
#' @seealso 
#' \code{\link{countInteractions}} for counting (but not testing) cell-cell
#' interactions per grouping level.
#'   
#' \code{\link[BiocParallel]{bpparam}} for the parallelised backend
#'
#' @author Vito Zanotelli
#' @author Jana Fischer
#' @author adapted by Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' @author adapted by Marlene Lutz (\email{marlene.lutz@@uzh.ch})
#' @author adapted by Chiara Schiller (\email{chiara.schiller@uni-heidelberg.de})
#' 
#' @references
#' \href{https://www.sciencedirect.com/science/article/pii/S2405471217305434}{
#' Schulz, D. et al., Simultaneous Multiplexed Imaging of mRNA and Proteins with 
#' Subcellular Resolution in Breast Cancer Tissue Samples by Mass Cytometry., 
#' Cell Systems 2018 6(1):25-36.e5}
#' 
#' \href{https://www.nature.com/articles/nmeth.4391}{
#' Schapiro, D. et al., histoCAT: analysis of cell phenotypes and interactions in 
#' multiplex image cytometry data, Nature Methods 2017 14, p. 873–876}
#' 
#' \href{https://doi.org/10.1101/2025.03.31.646289}{
#' Schiller, C. et al., Comparison and Optimization of Cellular Neighbor Preference Methods 
#' for Quantitative Tissue Analysis, biorRxiv 2025.03.31.646289}
#' 
#' @export
testInteractions <- function(object, 
                                group_by,
                                label,
                                colPairName,
                                method = c("classic", "conditional", "patch", "interaction"),
                                patch_size = NULL,
                                iter = 1000,
                                p_threshold = 0.01,
                                return_samples = FALSE,
                                tolerance = sqrt(.Machine$double.eps),
                                BPPARAM = SerialParam()){

    # Input check
    .valid.countInteractions.input(object, group_by, label, method,
                                    patch_size, colPairName)
    .valid.testInteractions.input(iter, p_threshold, return_samples, method,
                                  tolerance)
    method <- match.arg(method)
    
    # Re-level group_by label
    if(is.factor(colData(object)[[group_by]])) {
        colData(object)[[group_by]] <- as.factor(as.character(colData(object)[[group_by]]))
    }
    
    # Strictly work with characters 
    colData(object)[[label]] <- as.character(colData(object)[[label]])

    cur_label <- as.factor(colData(object)[[label]])
    cur_table <- .prepare_table(object, group_by, cur_label, colPairName)
    
    # Count interactions
    if (method == "classic") {
        cur_count <- .aggregate_classic(cur_table, object, group_by, label)
    } else if (method == "conditional") {
        cur_count <- .aggregate_conditional(cur_table, object, group_by, label)
    } else if (method == "patch") {
        cur_count <- .aggregate_classic_patch(cur_table, 
                                            patch_size = patch_size, 
                                            object, group_by, label)
    } else if (method == "interaction") {
        cur_count <- .aggregate_interaction(cur_table, object, group_by, label)
    }
    
    # Permute the labels
    cur_out <- .permute_labels(object, group_by, label, iter, patch_size,
                                colPairName, method, BPPARAM)
    
    cur_out <- .calc_p_vals(cur_count, cur_out, n_perm = iter,
                            p_thres = p_threshold,
                            return_samples = return_samples,
                            tolerance = tolerance)

    setorder(cur_out, "group_by", "from_label", "to_label")

    cur_out <- as(cur_out, "DataFrame")

    return(cur_out)
}

test_that("plotInteractions function works", {
  set.seed(22)
  library(cytomapper)
  data(pancreasSCE)
  
  pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                   k = 3)
  
  
  ################################ classic ###################################
  cur_out <- testInteractions(pancreasSCE, 
                              group_by = "ImageNb",
                              label = "CellType",
                              method = "classic",
                              colPairName = "knn_interaction_graph",
                              iter = 100, p_threshold = 0.5,
                              BPPARAM = SerialParam(RNGseed = 123))
  
  ## Plot spatial context - basic tests
  expect_silent(p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb"))
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", draw_edges = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name",
                          node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_by = "color_by_sig")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_fix = "green")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_by = "ct")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_fix = 3)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", graph_layout = "linear")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  # return data - tests
  p <- plotInteractions(cur_out,pancreasSCE, label = "CellType",group_by = "ImageNb", return_data = TRUE) 
  expect_type(p, "list")
  expect_equal(names(p), c("edges", "vertices"))
  expect_equal(p$edges[,1], c("celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", "celltype_C",
                              "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", 
                              "celltype_C", "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", 
                              "celltype_C", "celltype_C", "celltype_C"))
  expect_equal(p$edges[,2], c("celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", 
                              "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", 
                              "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", 
                              "celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$edges[,3], c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1))
  expect_equal(p$vertices[,1], c("celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$vertices[,2], c(62, 111, 189))
  expect_equal(p$vertices[,3], c(2, 3, 3))
  
  #Errors
  expect_error(plotInteractions(out = cur_out[,1:2], object = pancreasSCE, label = "CellType", group_by = "ImageNb"),
               regexp = "'out' needs to contain columns 'group_by', 'from_label', 'to_label'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = colData(pancreasSCE), label = "CellType", group_by = "ImageNb"),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "celltype", group_by = "ImageNb"),
               regexp = "'label' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "imagenb"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb", 
                                node_color_by = "NAME"),
               regexp = "'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "name"),
               regexp = "'node_size_by' has to be 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_fix = factor("black")),
               regexp = "'node_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_fix = "3"),
               regexp = "'node_size_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = "TRUE"),
               regexp = "'node_label_repel' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "NAME"),
               regexp = "'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_fix = factor("black")),
               regexp = "'node_label_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                draw_edges = "TRUE"),
               regexp = "'draw_edges' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                return_data = "TRUE"),
               regexp = "'return_data' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = FALSE, node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_color_fix = "blue"),
               regexp = "'node_color_by' and 'node_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "name", node_label_color_fix = "blue"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_label_color_by = "n_cells"),
               regexp = "'node_label_color_by' and 'node_color_by' have to be identical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "n_group", node_size_fix = 22),
               regexp = "'node_size_by' and 'node_size_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  cur_out[sample(nrow(cur_out), 1), "color_by_sig"] <- NA
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig"),
               regexp = "'edge_color_by' contains NA values.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color"),
               regexp = "'edge_color_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  cur_out$color_by_random <- rownames(cur_out)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_random"),
               regexp = "'edge_color_by' needs to be unique for all 'from_label'-'to_label' pairs.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_fix = factor("black")),
               regexp = "'edge_color_fix' has to be a character.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig", edge_color_fix = "blue"),
               regexp = "'edge_color_by' and 'edge_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = 2),
               regexp = "'edge_width_by' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "weight"),
               regexp = "'edge_width_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "interaction"),
               regexp = "'edge_width_by' entries need to be numeric.",
               fixed = TRUE)
  
  cur_out$weight <- ifelse(cur_out$from_label == "celltype_A" & cur_out$to_label == "celltype_B", NA, cur_out$ct)
  expect_error(
    plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                     edge_width_by = "weight"),
    regexp = "Missing weights for some 'from_label'-'to_label' pairs",
    fixed = FALSE
  )
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "ct", edge_width_fix = 2),
               regexp = "'edge_width_by' and 'edge_width_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_fix = "3"),
               regexp = "'edge_width_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = 2),
               regexp = "'graph_layout' has to be a character.",
               fixed = TRUE)

  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                  graph_layout = "unsupported_layout"),
                 regexp = "Layout 'unsupported_layout' not in supported list. Refer to: https://cran.r-project.org/web/packages/ggraph/vignettes/Layouts.html",
                 fixed = TRUE)
  
  
  ################################ conditional ###################################
  cur_out <- testInteractions(pancreasSCE, 
                              group_by = "ImageNb",
                              label = "CellType",
                              method = "conditional",
                              colPairName = "knn_interaction_graph",
                              iter = 100, p_threshold = 0.5,
                              BPPARAM = SerialParam(RNGseed = 123))
  
  ## Plot spatial context - basic tests
  expect_silent(p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb"))
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", draw_edges = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name",
                        node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_by = "color_by_sig")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_fix = "green")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_by = "ct")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_fix = 3)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", graph_layout = "linear")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  # return data - tests
  p <- plotInteractions(cur_out,pancreasSCE, label = "CellType",group_by = "ImageNb", return_data = TRUE) 
  expect_type(p, "list")
  expect_equal(names(p), c("edges", "vertices"))
  expect_equal(p$edges[,1], c("celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", "celltype_C",
                              "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", 
                              "celltype_C", "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", 
                              "celltype_C", "celltype_C", "celltype_C"))
  expect_equal(p$edges[,2], c("celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", 
                              "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", 
                              "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", 
                              "celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$edges[,3], c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1))
  expect_equal(p$vertices[,1], c("celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$vertices[,2], c(62, 111, 189))
  expect_equal(p$vertices[,3], c(2, 3, 3))
  
  #Errors
  expect_error(plotInteractions(out = cur_out[,1:2], object = pancreasSCE, label = "CellType", group_by = "ImageNb"),
               regexp = "'out' needs to contain columns 'group_by', 'from_label', 'to_label'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = colData(pancreasSCE), label = "CellType", group_by = "ImageNb"),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "celltype", group_by = "ImageNb"),
               regexp = "'label' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "imagenb"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb", 
                                node_color_by = "NAME"),
               regexp = "'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "name"),
               regexp = "'node_size_by' has to be 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_fix = factor("black")),
               regexp = "'node_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_fix = "3"),
               regexp = "'node_size_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = "TRUE"),
               regexp = "'node_label_repel' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "NAME"),
               regexp = "'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_fix = factor("black")),
               regexp = "'node_label_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                draw_edges = "TRUE"),
               regexp = "'draw_edges' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                return_data = "TRUE"),
               regexp = "'return_data' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = FALSE, node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_color_fix = "blue"),
               regexp = "'node_color_by' and 'node_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "name", node_label_color_fix = "blue"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_label_color_by = "n_cells"),
               regexp = "'node_label_color_by' and 'node_color_by' have to be identical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "n_group", node_size_fix = 22),
               regexp = "'node_size_by' and 'node_size_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  cur_out[sample(nrow(cur_out), 1), "color_by_sig"] <- NA
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig"),
               regexp = "'edge_color_by' contains NA values.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color"),
               regexp = "'edge_color_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  cur_out$color_by_random <- rownames(cur_out)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_random"),
               regexp = "'edge_color_by' needs to be unique for all 'from_label'-'to_label' pairs.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_fix = factor("black")),
               regexp = "'edge_color_fix' has to be a character.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig", edge_color_fix = "blue"),
               regexp = "'edge_color_by' and 'edge_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = 2),
               regexp = "'edge_width_by' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "weight"),
               regexp = "'edge_width_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "interaction"),
               regexp = "'edge_width_by' entries need to be numeric.",
               fixed = TRUE)
  
  cur_out$weight <- ifelse(cur_out$from_label == "celltype_A" & cur_out$to_label == "celltype_B", NA, cur_out$ct)
  expect_error(
    plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                     edge_width_by = "weight"),
    regexp = "Missing weights for some 'from_label'-'to_label' pairs",
    fixed = FALSE
  )
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "ct", edge_width_fix = 2),
               regexp = "'edge_width_by' and 'edge_width_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_fix = "3"),
               regexp = "'edge_width_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = 2),
               regexp = "'graph_layout' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = "unsupported_layout"),
               regexp = "Layout 'unsupported_layout' not in supported list. Refer to: https://cran.r-project.org/web/packages/ggraph/vignettes/Layouts.html",
               fixed = TRUE)
  
  ################################ patch ###################################
  cur_out <- testInteractions(pancreasSCE, 
                              group_by = "ImageNb",
                              label = "CellType",
                              method = "patch",
                              patch_size = 3,
                              colPairName = "knn_interaction_graph",
                              iter = 100, p_threshold = 0.5,
                              BPPARAM = SerialParam(RNGseed = 123))
  
  ## Plot spatial context - basic tests
  expect_silent(p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb"))
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", draw_edges = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name",
                        node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_by = "color_by_sig")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_fix = "green")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_by = "ct")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_fix = 3)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", graph_layout = "linear")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  # return data - tests
  p <- plotInteractions(cur_out,pancreasSCE, label = "CellType",group_by = "ImageNb", return_data = TRUE) 
  expect_type(p, "list")
  expect_equal(names(p), c("edges", "vertices"))
  expect_equal(p$edges[,1], c("celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", "celltype_C",
                              "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", 
                              "celltype_C", "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", 
                              "celltype_C", "celltype_C", "celltype_C"))
  expect_equal(p$edges[,2], c("celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", 
                              "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", 
                              "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", 
                              "celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$edges[,3], c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1))
  expect_equal(p$vertices[,1], c("celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$vertices[,2], c(62, 111, 189))
  expect_equal(p$vertices[,3], c(2, 3, 3))
  
  #Errors
  expect_error(plotInteractions(out = cur_out[,1:2], object = pancreasSCE, label = "CellType", group_by = "ImageNb"),
               regexp = "'out' needs to contain columns 'group_by', 'from_label', 'to_label'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = colData(pancreasSCE), label = "CellType", group_by = "ImageNb"),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "celltype", group_by = "ImageNb"),
               regexp = "'label' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "imagenb"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb", 
                                node_color_by = "NAME"),
               regexp = "'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "name"),
               regexp = "'node_size_by' has to be 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_fix = factor("black")),
               regexp = "'node_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_fix = "3"),
               regexp = "'node_size_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = "TRUE"),
               regexp = "'node_label_repel' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "NAME"),
               regexp = "'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_fix = factor("black")),
               regexp = "'node_label_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                draw_edges = "TRUE"),
               regexp = "'draw_edges' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                return_data = "TRUE"),
               regexp = "'return_data' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = FALSE, node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_color_fix = "blue"),
               regexp = "'node_color_by' and 'node_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "name", node_label_color_fix = "blue"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_label_color_by = "n_cells"),
               regexp = "'node_label_color_by' and 'node_color_by' have to be identical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "n_group", node_size_fix = 22),
               regexp = "'node_size_by' and 'node_size_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  cur_out[sample(nrow(cur_out), 1), "color_by_sig"] <- NA
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig"),
               regexp = "'edge_color_by' contains NA values.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color"),
               regexp = "'edge_color_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  cur_out$color_by_random <- rownames(cur_out)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_random"),
               regexp = "'edge_color_by' needs to be unique for all 'from_label'-'to_label' pairs.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_fix = factor("black")),
               regexp = "'edge_color_fix' has to be a character.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig", edge_color_fix = "blue"),
               regexp = "'edge_color_by' and 'edge_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = 2),
               regexp = "'edge_width_by' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "weight"),
               regexp = "'edge_width_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "interaction"),
               regexp = "'edge_width_by' entries need to be numeric.",
               fixed = TRUE)
  
  cur_out$weight <- ifelse(cur_out$from_label == "celltype_A" & cur_out$to_label == "celltype_B", NA, cur_out$ct)
  expect_error(
    plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                     edge_width_by = "weight"),
    regexp = "Missing weights for some 'from_label'-'to_label' pairs",
    fixed = FALSE
  )
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "ct", edge_width_fix = 2),
               regexp = "'edge_width_by' and 'edge_width_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_fix = "3"),
               regexp = "'edge_width_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = 2),
               regexp = "'graph_layout' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = "unsupported_layout"),
               regexp = "Layout 'unsupported_layout' not in supported list. Refer to: https://cran.r-project.org/web/packages/ggraph/vignettes/Layouts.html",
               fixed = TRUE)
  
  ################################ interaction ###################################
  cur_out <- testInteractions(pancreasSCE, 
                              group_by = "ImageNb",
                              label = "CellType",
                              method = "interaction",
                              colPairName = "knn_interaction_graph",
                              iter = 100, p_threshold = 0.5,
                              BPPARAM = SerialParam(RNGseed = 123))
  
  ## Plot spatial context - basic tests
  expect_silent(p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb"))
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_size_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_label_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", draw_edges = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", node_color_by = "name",
                        node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_by = "color_by_sig")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_color_fix = "green")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_by = "ct")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", edge_width_fix = 3)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  p <- plotInteractions(cur_out, pancreasSCE, "CellType", "ImageNb", graph_layout = "linear")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(pancreasSCE$CellType)))
  expect_equal(p$data$n_cells, as.integer(table(pancreasSCE$CellType)[p$data$name[order(p$data$n_cells)]] %>% unname))
  expect_equal(p$data$n_group, colSums(table(pancreasSCE$ImageNb, pancreasSCE$CellType)[, p$data$name[order(p$data$n_group)]] != 0) %>% unname)
  
  # return data - tests
  p <- plotInteractions(cur_out,pancreasSCE, label = "CellType",group_by = "ImageNb", return_data = TRUE) 
  expect_type(p, "list")
  expect_equal(names(p), c("edges", "vertices"))
  expect_equal(p$edges[,1], c("celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", "celltype_C",
                              "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", "celltype_C", 
                              "celltype_C", "celltype_C", "celltype_A", "celltype_A", "celltype_A", "celltype_B", "celltype_B", "celltype_B", 
                              "celltype_C", "celltype_C", "celltype_C"))
  expect_equal(p$edges[,2], c("celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", 
                              "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", 
                              "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", "celltype_A", "celltype_B", "celltype_C", 
                              "celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$edges[,3], c(1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1))
  expect_equal(p$vertices[,1], c("celltype_A", "celltype_B", "celltype_C"))
  expect_equal(p$vertices[,2], c(62, 111, 189))
  expect_equal(p$vertices[,3], c(2, 3, 3))
  
  #Errors
  expect_error(plotInteractions(out = cur_out[,1:2], object = pancreasSCE, label = "CellType", group_by = "ImageNb"),
               regexp = "'out' needs to contain columns 'group_by', 'from_label', 'to_label'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = colData(pancreasSCE), label = "CellType", group_by = "ImageNb"),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "celltype", group_by = "ImageNb"),
               regexp = "'label' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "imagenb"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb", 
                                node_color_by = "NAME"),
               regexp = "'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "name"),
               regexp = "'node_size_by' has to be 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_fix = factor("black")),
               regexp = "'node_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_fix = "3"),
               regexp = "'node_size_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = "TRUE"),
               regexp = "'node_label_repel' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "NAME"),
               regexp = "'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_fix = factor("black")),
               regexp = "'node_label_color_fix' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                draw_edges = "TRUE"),
               regexp = "'draw_edges' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                return_data = "TRUE"),
               regexp = "'return_data' has to be logical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_repel = FALSE, node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_color_fix = "blue"),
               regexp = "'node_color_by' and 'node_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_label_color_by = "name", node_label_color_fix = "blue"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_color_by = "name", node_label_color_by = "n_cells"),
               regexp = "'node_label_color_by' and 'node_color_by' have to be identical.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                node_size_by = "n_group", node_size_fix = 22),
               regexp = "'node_size_by' and 'node_size_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  cur_out[sample(nrow(cur_out), 1), "color_by_sig"] <- NA
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig"),
               regexp = "'edge_color_by' contains NA values.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color"),
               regexp = "'edge_color_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  cur_out$color_by_random <- rownames(cur_out)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_random"),
               regexp = "'edge_color_by' needs to be unique for all 'from_label'-'to_label' pairs.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_fix = factor("black")),
               regexp = "'edge_color_fix' has to be a character.",
               fixed = TRUE)
  
  cur_out <- cur_out %>% as.data.frame() %>% group_by(from_label, to_label) %>% mutate(color_by_sig = sum(sigval, na.rm = TRUE) > 0)
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_color_by = "color_by_sig", edge_color_fix = "blue"),
               regexp = "'edge_color_by' and 'edge_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = 2),
               regexp = "'edge_width_by' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "weight"),
               regexp = "'edge_width_by' needs to be contained in 'out'.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "interaction"),
               regexp = "'edge_width_by' entries need to be numeric.",
               fixed = TRUE)
  
  cur_out$weight <- ifelse(cur_out$from_label == "celltype_A" & cur_out$to_label == "celltype_B", NA, cur_out$ct)
  expect_error(
    plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                     edge_width_by = "weight"),
    regexp = "Missing weights for some 'from_label'-'to_label' pairs",
    fixed = FALSE
  )
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_by = "ct", edge_width_fix = 2),
               regexp = "'edge_width_by' and 'edge_width_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                edge_width_fix = "3"),
               regexp = "'edge_width_fix' has to be numeric.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = 2),
               regexp = "'graph_layout' has to be a character.",
               fixed = TRUE)
  
  expect_error(plotInteractions(out = cur_out, object = pancreasSCE, label = "CellType", group_by = "ImageNb",
                                graph_layout = "unsupported_layout"),
               regexp = "Layout 'unsupported_layout' not in supported list. Refer to: https://cran.r-project.org/web/packages/ggraph/vignettes/Layouts.html",
               fixed = TRUE)
  
}
)
  

test_that("testInteractions function works", {
    library(cytomapper)
    library(BiocParallel)
    library(data.table)
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    ################################ classic ###################################
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                                group_by = "ImageNb", 
                                                label = "CellType",
                                                colPairName = "knn_interaction_graph",
                                                iter = 100))
    
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "classic",
                                                  colPairName = "knn_interaction_graph",
                                                  iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "classic",
                                                  colPairName = "knn_interaction_graph",
                                                  iter = 100,
                                                BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_identical(cur_out, cur_out_2)
    
    # Check numerical values
    expect_equal(cur_out$ct, c(1.8235294, 0.4705882, 0.7058824, 0.8750000, 0.2500000, 
                 1.8750000, 0.1250000, 0.1704545, 2.7045455, 2.3111111, 0.5111111, 
                 0.1777778, 0.7837838, 1.5675676, 0.6486486, 0.2000000, 0.6250000, 
                 2.1750000, NA, NA, NA, NA, 2.3636364, 0.6363636, NA, 0.7049180, 2.2950820), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.00990099, 0.01980198, 1.00000000, 0.02970297, 0.53465347, 0.96039604, 
                                 1.00000000, 0.90099010, 0.00990099, 0.00990099, 1.00000000, 1.00000000, 
                                 0.99009901, 0.00990099, 1.00000000, 1.00000000, 0.99009901, 0.00990099,
                                 NA, NA, NA, NA, 0.00990099, 1.00000000, NA, 1.00000000, 0.00990099), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1.00000000, 0.99009901, 0.00990099, 1.00000000, 0.80198020, 
                                 0.06930693, 0.00990099, 0.19801980, 1.00000000, 1.00000000, 
                                 0.00990099, 0.00990099, 0.01980198, 1.00000000, 0.00990099, 
                                 0.00990099, 0.01980198, 1.00000000, NA, NA, NA, NA, 
                                 1.00000000, 0.00990099, NA, 0.00990099, 1.00000000), 
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "classic",
                                                  colPairName = "knn_interaction_graph"))
    
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "classic",
                                                  colPairName = "knn_interaction_graph",
                                                  iter = 100, p_threshold = 0.5,
                                                BPPARAM = SerialParam(RNGseed = 123)))    
    
    expect_equal(cur_out_2$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out_2$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out_2$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out_2$ct, cur_sn$ct)

    cur_test <- cur_out_2[!is.na(cur_out_2$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.5, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)  
    
    ################################ conditional ###################################
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "conditional",
                                                  colPairName = "knn_interaction_graph",
                                                  iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                    group_by = "ImageNb", 
                                                    label = "CellType",
                                                    method = "conditional",
                                                    colPairName = "knn_interaction_graph",
                                                    iter = 100,
                                                BPPARAM = SerialParam(RNGseed = 123)))
    
    # Check numerical values
    expect_equal(cur_out$ct, c(1.937500, 1.142857, 1.333333, 1.166667, 1.000000, 
                               1.875000, 1.222222, 1.363636, 2.735632, 2.476190, 
                               1.352941, 1.142857, 1.450000, 1.757576, 1.263158, 
                               1.333333, 1.666667, 2.636364, NA, NA, NA, NA,
                               2.363636, 1.312500, NA, 1.653846, 2.456140), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.02970297, 0.19801980, 1.00000000, 0.43564356, 
                                 0.71287129, 0.98019802, 0.19801980, 0.00990099, 
                                 0.00990099, 0.00990099, 0.51485149, 1.00000000, 
                                 0.57425743, 0.00990099, 0.93069307, 0.88118812, 
                                 0.00990099, 0.00990099, NA, NA, NA, NA, 0.00990099,
                                 1.00000000, NA, 0.83168317, 0.00990099), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(0.98019802, 0.81188119, 0.00990099, 0.57425743, 0.94059406, 
                                 0.02970297, 0.82178218, 1.00000000, 1.00000000, 
                                 1.00000000, 0.51485149, 0.00990099, 0.43564356, 
                                 1.00000000, 0.07920792, 0.15841584, 1.00000000, 
                                 1.00000000, NA, NA, NA, NA, 1.00000000, 0.00990099,
                                 NA, 0.18811881, 1.00000000), 
                 tolerance = 0.00001)
    expect_equal(cur_out$zscore, c(3.54062176, 0.37556137, -5.60655578, -0.01781509, -0.29137853,
                                -2.13349269, 0.81789731, 4.48870979, 5.13383290, 7.79746558,
                                -0.08460062, -2.54180172, -0.22904290, 3.65574596, -1.39152154,
                                -1.20085979, 2.99514694, 9.00740472, NA, NA, NA, NA, 5.71983107,
                                -4.28630534, NA, -0.97188642, 7.43428730), 
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "conditional",
                                                  colPairName = "knn_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                    group_by = "ImageNb", 
                                                    label = "CellType",
                                                    method = "conditional",
                                                    colPairName = "knn_interaction_graph",
                                                    iter = 100, p_threshold = 0.5,
                                                BPPARAM = SerialParam(RNGseed = 123)))    
    
    expect_equal(cur_out_2$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out_2$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out_2$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out_2$ct, cur_sn$ct)
    
    cur_test <- cur_out_2[!is.na(cur_out_2$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.5, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)  
    
    ################################ patch ###################################
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "patch",
                                                  patch_size = 3,
                                                  colPairName = "knn_interaction_graph",
                                                  iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                    group_by = "ImageNb", 
                                                    label = "CellType",
                                                    method = "patch",
                                                    patch_size = 3,
                                                    colPairName = "knn_interaction_graph",
                                                    iter = 100,
                                                BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_identical(cur_out, cur_out_2)
    
    # Check numerical values
    expect_equal(cur_out$ct, c(0.23529412, 0.00000000, 0.00000000, 0.00000000, 
                               0.00000000, 0.25000000, 0.00000000, 0.00000000, 
                               0.81818182, 0.55555556, 0.02222222, 0.00000000, 
                               0.02702703, 0.05405405, 0.00000000, 0.00000000, 
                               0.12500000, 0.52500000, NA, NA, NA, NA, 0.51515152, 
                               0.00000000, NA, 0.06557377, 0.57377049), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.00990099, 1.00000000, 1.00000000, 1.00000000, 1.00000000, 
                                 0.98019802, 1.00000000, 1.00000000, 0.00990099, 0.00990099, 
                                 0.63366337, 1.00000000, 0.82178218, 0.21782178, 1.00000000, 
                                 1.00000000, 0.00990099, 0.00990099, NA, NA, NA, NA, 0.00990099,
                                 1.00000000, NA, 0.99009901, 0.00990099), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1.00000000, 1.00000000, 0.00990099, 0.97029703, 1.00000000, 
                                 0.18811881, 0.80198020, 0.97029703, 1.00000000, 1.00000000,
                                 0.64356436, 0.22772277, 0.43564356, 0.94059406, 0.28712871, 
                                 0.14851485, 1.00000000, 1.00000000, NA, NA, NA, NA,
                                 1.00000000, 0.00990099, NA, 0.03960396, 1.00000000), 
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(pancreasSCE, 
                                                  group_by = "ImageNb", 
                                                  label = "CellType",
                                                  method = "patch",
                                                  patch_size = 3,
                                                  colPairName = "knn_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                    group_by = "ImageNb", 
                                                    label = "CellType",
                                                    method = "patch",
                                                    patch_size = 3,
                                                    colPairName = "knn_interaction_graph",
                                                    iter = 100, p_threshold = 0.5,
                                                BPPARAM = SerialParam(RNGseed = 123)))    
    
    expect_equal(cur_out_2$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out_2$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out_2$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out_2$ct, cur_sn$ct)
    
    cur_test <- cur_out_2[!is.na(cur_out_2$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.5, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    ############################ interaction ###############################
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              colPairName = "knn_interaction_graph",
                                              iter = 100))
    
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "interaction",
                                              colPairName = "knn_interaction_graph",
                                              iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                group_by = "ImageNb", 
                                                label = "CellType",
                                                method = "interaction",
                                                colPairName = "knn_interaction_graph",
                                                iter = 100,
                                                BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_identical(cur_out, cur_out_2)
    
    # Check numerical values
    expect_equal(cur_out$ct, c(0.60784314, 0.15686275, 0.23529412, 0.29166667, 0.08333333, 0.62500000, 
                               0.04166667, 0.05681818, 0.90151515, 0.77037037, 0.17037037, 0.05925926, 
                               0.26126126, 0.52252252, 0.21621622, 0.06666667, 0.20833333, 0.72500000,
                               NA, NA, NA, NA, 0.78787879, 0.21212121, NA, 0.23497268, 0.76502732),
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.00990099, 0.01980198, 1.00000000, 0.02970297, 0.53465347, 0.96039604, 
                                 1.00000000, 0.90099010, 0.00990099, 0.00990099, 1.00000000, 1.00000000, 
                                 0.99009901, 0.00990099, 1.00000000, 1.00000000, 0.99009901, 0.00990099,         
                                 NA, NA, NA, NA, 0.00990099, 1.00000000, NA, 1.00000000, 0.00990099),
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1.00000000, 0.99009901, 0.00990099, 1.00000000, 0.80198020, 0.06930693, 
                                 0.00990099, 0.19801980, 1.00000000, 1.00000000, 0.00990099, 0.00990099, 
                                 0.01980198, 1.00000000, 0.00990099, 0.00990099, 0.01980198, 1.00000000,         
                                 NA, NA, NA, NA, 1.00000000, 0.00990099, NA, 0.00990099, 1.00000000),
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "interaction",
                                              colPairName = "knn_interaction_graph"))
    
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                                group_by = "ImageNb", 
                                                label = "CellType",
                                                method = "interaction",
                                                colPairName = "knn_interaction_graph",
                                                iter = 100, p_threshold = 0.5,
                                                BPPARAM = SerialParam(RNGseed = 123)))    
    
    expect_equal(cur_out_2$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out_2$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out_2$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out_2$ct, cur_sn$ct)
    
    cur_test <- cur_out_2[!is.na(cur_out_2$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.5, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    # ct values sum up to 1 for the "from_label" cell-type per grouping level
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "interaction",
                                              colPairName = "knn_interaction_graph",
                                              iter = 100, p_threshold = 0.5,
                                              BPPARAM = SerialParam(RNGseed = 123))) 
    
    test <- cur_out %>% as.data.frame() %>% filter(!is.na(ct)) %>% group_by(group_by, from_label) %>% summarise(sum_ct = sum(ct))
    
    expect_equal(sum(test$sum_ct)/nrow(test), 1)
    
    # Corner case settings
    # one cell of a given cell-type and no neighbors
    cur_sce <- pancreasSCE
    cur_sce$CellType[123] <- "test"
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "expansion", threshold = 7)
    
    plotSpatial(cur_sce, node_color_by = "CellType", img_id = "ImageNb", 
                draw_edges = TRUE, colPairName = "expansion_interaction_graph")
    
    expect_silent(cur_out <- testInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              colPairName = "expansion_interaction_graph",
                                              iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    # Check numerical values
    expect_equal(cur_out$ct, c(0.23529412, 0.00000000, 0.00000000, NA, 0.00000000, 0.00000000, 
                               0.00000000, NA, 0.00000000, 0.00000000, 0.20454545, NA, NA, NA, 
                               NA, NA, 0.13333333, 0.06666667, 0.00000000, 0.00000000, 0.08108108, 
                               0.05405405, 0.08108108, 0.00000000, 0.00000000, 0.07692308, 0.10256410, 
                               0.00000000, 0.00000000, 0.00000000, 0.00000000, 0.00000000, NA, NA, NA,
                               NA, NA, 0.30303030, 0.06060606, NA, NA, 0.06557377, 0.36065574, NA, NA,
                               NA, NA, NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.01980198, 1.00000000, 1.00000000, NA, 1.00000000, 1.00000000, 1.00000000, 
                                 NA, 1.00000000, 1.00000000, 0.10891089, NA, NA, NA, NA, NA, 0.22772277, 
                                 0.50495050, 1.00000000, 1.00000000, 0.50495050, 0.70297030, 0.45544554, 1.00000000, 
                                 1.00000000, 0.45544554, 0.37623762, 1.00000000, 1.00000000, 1.00000000, 1.00000000,
                                 1.00000000, NA, NA, NA, NA, NA, 0.10891089, 1.00000000, NA, NA, 1.00000000, 
                                 0.01980198, NA, NA, NA, NA, NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1, 0.782178217821782, 0.0297029702970297, NA, 0.782178217821782, 
                                 0.97029702970297, 0.247524752475248, NA, 0.0297029702970297, 
                                 0.247524752475248, 0.99009900990099, NA, NA, NA, NA, NA, 0.940594059405941, 
                                 0.732673267326733, 0.0594059405940594, 0.930693069306931, 0.732673267326733, 
                                 0.693069306930693, 0.762376237623762, 0.940594059405941, 0.0594059405940594, 
                                 0.762376237623762, 0.940594059405941, 0.95049504950495, 0.930693069306931, 
                                 0.940594059405941, 0.95049504950495, 1, NA, NA, NA, NA, NA, 0.96039603960396, 
                                 0.0099009900990099, NA, NA, 0.0099009900990099, 1, NA, NA, NA, 
                                 NA, NA), 
                 tolerance = 0.00001)
    
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              colPairName = "expansion_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    ## conditional
    expect_silent(cur_out <- testInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "conditional",
                                              colPairName = "expansion_interaction_graph",
                                              iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_equal(cur_out$ct, c(1.000000, 0.000000, 0.000000,       NA, 0.000000, 0.000000, 
                               0.000000,       NA, 0.000000, 0.000000, 1.058824,       NA,
                               NA,       NA,       NA,       NA, 1.000000, 1.000000, 
                               0.000000, 0.000000, 1.000000, 1.000000, 1.000000, 0.000000,
                               0.000000, 1.000000, 1.000000, 0.000000, 0.000000, 0.000000, 0.000000, 
                               0.000000,       NA,       NA,       NA,       NA,
                               NA, 1.250000, 1.000000,       NA,       NA, 1.000000, 
                               1.100000,       NA,       NA,       NA,       NA,       NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.158415841584158, 1, 1, NA, 1, 1, 1, NA, 1, 1, 0.495049504950495, 
                                 NA, NA, NA, NA, NA, 0.792079207920792, 0.920792079207921, 1, 
                                 1, 0.920792079207921, 0.702970297029703, 0.910891089108911, 1, 
                                 1, 0.910891089108911, 0.742574257425743, 1, 1, 1, 1, 1, NA, NA, 
                                 NA, NA, NA, 0.099009900990099, 1, NA, NA, 1, 0.465346534653465, 
                                 NA, NA, NA, NA, NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(0.99009900990099, 0.782178217821782, 0.0297029702970297, NA, 
                                 0.782178217821782, 0.97029702970297, 0.247524752475248, NA, 0.0297029702970297, 
                                 0.247524752475248, 0.574257425742574, NA, NA, NA, NA, NA, 0.900990099009901, 
                                 0.930693069306931, 0.0594059405940594, 0.930693069306931, 0.900990099009901, 
                                 0.99009900990099, 0.96039603960396, 0.940594059405941, 0.0594059405940594, 
                                 0.95049504950495, 0.910891089108911, 0.95049504950495, 0.930693069306931, 
                                 0.940594059405941, 0.95049504950495, 1, NA, NA, NA, NA, NA, 0.940594059405941, 
                                 0.297029702970297, NA, NA, 0.297029702970297, 0.544554455445545, 
                                 NA, NA, NA, NA, NA), 
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "conditional",
                                              colPairName = "expansion_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    ## interaction
    expect_silent(cur_out <- testInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "interaction",
                                              colPairName = "expansion_interaction_graph",
                                              iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_equal(cur_out$ct, c(1.0000000, 0.0000000, 0.0000000, NA, 0.0000000, 0.0000000, 0.0000000, 
                               NA, 0.0000000, 0.0000000, 1.0000000, NA, NA, NA, NA, NA, 0.6666667, 
                               0.3333333, 0.0000000, 0.0000000, 0.3750000, 0.2500000, 0.3750000, 
                               0.0000000, 0.0000000, 0.4285714, 0.5714286, 0.0000000, 0.0000000, 
                               0.0000000, 0.0000000, 0.0000000, NA, NA, NA, NA, NA, 0.8333333, 0.1666667,
                               NA, NA, 0.1538462, 0.8461538, NA, NA, NA, NA, NA),
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.00990099, 1.00000000, 1.00000000, NA, 1.00000000, 1.00000000, 1.00000000,
                                 NA, 1.00000000, 1.00000000, 0.00990099, NA, NA, NA, NA, NA, 0.10891089,
                                 0.46534653, 1.00000000, 1.00000000, 0.43564356, 0.64356436, 0.45544554, 
                                 1.00000000, 1.00000000, 0.30693069, 0.14851485, 1.00000000, 1.00000000,
                                 1.00000000, 1.00000000, 1.00000000, NA, NA, NA, NA, NA, 0.00990099,
                                 1.00000000, NA, NA, 1.00000000, 0.00990099, NA, NA, NA, NA, NA),
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1.00000000, 0.78217822, 0.02970297, NA, 0.78217822, 0.97029703, 0.24752475,
                                 NA, 0.02970297, 0.24752475, 1.00000000, NA, NA, NA, NA, NA, 0.95049505, 
                                 0.62376238, 0.05940594, 0.93069307, 0.61386139, 0.49504950, 0.56435644, 
                                 0.94059406, 0.05940594, 0.71287129, 0.92079208, 0.95049505, 0.93069307, 
                                 0.94059406, 0.95049505, 1.00000000, NA, NA, NA, NA, NA, 1.00000000, 
                                 0.00990099, NA, NA, 0.00990099, 1.00000000, NA, NA, NA, NA, NA),
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "interaction",
                                              colPairName = "expansion_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    ## patch
    expect_silent(cur_out <- testInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "patch",
                                              patch_size = 1,
                                              colPairName = "expansion_interaction_graph",
                                              iter = 100,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_equal(cur_out$ct, c(0.235294117647059, 0, 0, NA, 0, 0, 0, NA, 0, 0, 0.193181818181818, 
                               NA, NA, NA, NA, NA, 0.133333333333333, 0.0666666666666667, 0, 
                               0, 0.0810810810810811, 0.0540540540540541, 0.0810810810810811, 
                               0, 0, 0.0769230769230769, 0.102564102564103, 0, 0, 0, 0, 0, NA, 
                               NA, NA, NA, NA, 0.242424242424242, 0.0606060606060606, NA, NA, 
                               0.0655737704918033, 0.327868852459016, NA, NA, NA, NA, NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_gt, c(0.0099009900990099, 1, 1, NA, 1, 1, 1, NA, 1, 1, 0.108910891089109, 
                                 NA, NA, NA, NA, NA, 0.198019801980198, 0.495049504950495, 1, 
                                 1, 0.495049504950495, 0.702970297029703, 0.455445544554455, 1, 
                                 1, 0.445544554455446, 0.326732673267327, 1, 1, 1, 1, 1, NA, NA, 
                                 NA, NA, NA, 0.168316831683168, 1, NA, NA, 1, 0.0099009900990099, 
                                 NA, NA, NA, NA, NA), 
                 tolerance = 0.00001)
    expect_equal(cur_out$p_lt, c(1, 0.782178217821782, 0.0297029702970297, NA, 0.782178217821782, 
                                 0.97029702970297, 0.247524752475248, NA, 0.0297029702970297, 
                                 0.247524752475248, 0.96039603960396, NA, NA, NA, NA, NA, 0.940594059405941, 
                                 0.752475247524752, 0.0594059405940594, 0.930693069306931, 0.792079207920792, 
                                 0.693069306930693, 0.762376237623762, 0.940594059405941, 0.0594059405940594, 
                                 0.772277227722772, 0.940594059405941, 0.95049504950495, 0.930693069306931, 
                                 0.940594059405941, 0.95049504950495, 1, NA, NA, NA, NA, NA, 0.900990099009901, 
                                 0.0099009900990099, NA, NA, 0.0099009900990099, 1, NA, NA, NA, 
                                 NA, NA), 
                 tolerance = 0.00001)
    
    # Check against countInteractions
    expect_silent(cur_sn <- countInteractions(cur_sce, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "patch",
                                              patch_size = 1,
                                              colPairName = "expansion_interaction_graph"))
    expect_equal(cur_out$group_by, as.character(cur_sn$group_by))
    expect_equal(cur_out$from_label, as.character(cur_sn$from_label))
    expect_equal(cur_out$to_label, as.character(cur_sn$to_label))
    expect_equal(cur_out$ct, cur_sn$ct)
    
    cur_test <- cur_out[!is.na(cur_out$ct),]
    expect_equal(rowMin(as.matrix(cur_test[,c("p_gt", "p_lt")])), cur_test$p)
    expect_equal(cur_test$p_gt < cur_test$p_lt, cur_test$interaction)
    expect_equal(cur_test$p < 0.01, cur_test$sig)
    expect_equal(cur_test$sig * sign(cur_test$interaction - 0.5), cur_test$sigval)
    
    # Return samples
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "expansion",
                                     threshold = 20)
    expect_silent(cur_out <- testInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "classic",
                                              iter = 100,
                                              colPairName = "expansion_interaction_graph",
                                              return_samples = TRUE,
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_silent(cur_out_2 <- testInteractions(pancreasSCE, 
                                              group_by = "ImageNb", 
                                              label = "CellType",
                                              method = "classic",
                                              iter = 100,
                                              colPairName = "expansion_interaction_graph",
                                              BPPARAM = SerialParam(RNGseed = 123)))
    
    expect_equal(cur_out$group_by, as.character(cur_out_2$group_by))
    expect_equal(cur_out$from_label, as.character(cur_out_2$from_label))
    expect_equal(cur_out$to_label, as.character(cur_out_2$to_label))
    expect_equal(cur_out$ct, cur_out_2$ct)
    expect_equal(cur_out$p_lt, cur_out_2$p_lt)
    expect_equal(cur_out$p_gt, cur_out_2$p_gt)
    expect_equal(cur_out$interaction, cur_out_2$interaction)
    expect_equal(cur_out$p, cur_out_2$p)
    expect_equal(cur_out$sig, cur_out_2$sig)
    expect_equal(cur_out$sigval, cur_out_2$sigval)
    
    expect_equal(dim(cur_out), c(27, 111))

    expect_equal(cur_out$iter_1, c(1.29411764705882, 0.352941176470588, 7.29411764705882, 0.75, 
                                   0.25, 7.125, 1.40909090909091, 0.647727272727273, 7.34090909090909, 
                                   3.64444444444444, 3.22222222222222, 2.95555555555556, 3.91891891891892, 
                                   3.08108108108108, 3.37837837837838, 3.325, 3.125, 3.3, 0, 0, 
                                   0, 0, 5.6969696969697, 5.51515151515152, 0, 5.9672131147541, 
                                   4.81967213114754))
    expect_equal(cur_out$iter_13, c(1.05882352941176, 0.470588235294118, 7.64705882352941, 1, 0.5, 
                                    6.5, 1.47727272727273, 0.590909090909091, 7.29545454545454, 4.31111111111111, 
                                    2.88888888888889, 2.75555555555556, 3.51351351351351, 3.67567567567568, 
                                    3.16216216216216, 3.1, 2.925, 3.6, 0, 0, 0, 0, 6.36363636363636, 
                                    5.03030303030303, 0, 5.44262295081967, 5.14754098360656))
    expect_equal(cur_out$iter_26, c(1.29411764705882, 0.882352941176471, 7.58823529411765, 1.875, 
                                    0.25, 7.125, 1.46590909090909, 0.647727272727273, 7.02272727272727, 
                                    3.91111111111111, 3.42222222222222, 3.11111111111111, 4.16216216216216, 
                                    2.54054054054054, 3.13513513513514, 3.5, 2.9, 3.15, 0, 0, 0, 
                                    0, 6.06060606060606, 5.09090909090909, 0, 5.50819672131148, 5.34426229508197
    ))
    expect_equal(cur_out$iter_67, c(1.64705882352941, 0.529411764705882, 6.29411764705882, 1.125, 
                                    0.25, 6.75, 1.21590909090909, 0.613636363636364, 7.65909090909091, 
                                    4.53333333333333, 2.86666666666667, 3.44444444444444, 3.48648648648649, 
                                    2.32432432432432, 3.13513513513514, 3.875, 2.9, 3.15, 0, 0, 0, 
                                    0, 5.96969696969697, 5.33333333333333, 0, 5.77049180327869, 4.91803278688525
    ))
    expect_equal(cur_out$iter_99, c(1.41176470588235, 0, 7.35294117647059, 0, 1.75, 8, 1.42045454545455, 
                                    0.727272727272727, 7.13636363636364, 3.91111111111111, 3.13333333333333, 
                                    3.53333333333333, 3.81081081081081, 2.86486486486486, 3.08108108108108, 
                                    3.975, 2.85, 2.65, 0, 0, 0, 0, 6.15151515151515, 5.31818181818182, 
                                    0, 5.75409836065574, 4.75409836065574))
    
    # Fail
    expect_error(testInteractions("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "test", label = "CellType", 
                                      colPairName = "knn_interaction_graph"),
                 regexp = "'group_by' not in colData(object).",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = 1, label = "CellType", 
                                      colPairName = "knn_interaction_graph"),
                 regexp = "'group_by' must be a single string.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "test", 
                                      colPairName = "knn_interaction_graph"),
                 regexp = "'label' not in colData(object).",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = 1, 
                                      colPairName = "knn_interaction_graph"),
                 regexp = "'label' must be a single string.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "test"),
                 regexp = "'colPairName' not in colPairNames(object).",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", colPairName = 1),
                 regexp = "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                       method = "patch"),
                 regexp = "When method = 'patch', please specify 'patch_size'.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                       method = "patch", patch_size = "test"),
                 regexp = "'patch_size' must be a single numeric.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      iter = "test"),
                 regexp = "'iter' must be a single positive numeric.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      iter = c(1,2)),
                 regexp = "'iter' must be a single positive numeric.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      iter = -20),
                 regexp = "'iter' must be a single positive numeric.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      p_threshold = "test"),
                 regexp = "'p_threshold' must be a single numeric between 0 and 1.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      p_threshold = c(1,2)),
                 regexp = "'p_threshold' must be a single numeric between 0 and 1.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                      colPairName = "knn_interaction_graph",
                                      p_threshold = 3),
                 regexp = "'p_threshold' must be a single numeric between 0 and 1.",
                 fixed = TRUE)    
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                  colPairName = "knn_interaction_graph",
                                  return_samples = 1),
                 regexp = "'return_samples' must be a single logical.",
                 fixed = TRUE)
    expect_error(testInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", 
                                  colPairName = "knn_interaction_graph",
                                  return_samples = c("test", "test2")),
                 regexp = "'return_samples' must be a single logical.",
                 fixed = TRUE)
    

})

test_that("testInteractions function works if cells are not grouped by image", {
    library(cytomapper)
    library(BiocParallel)
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "expansion",
                                     threshold = 10)
    
    plotSpatial(pancreasSCE, img_id = "ImageNb", draw_edges = TRUE, 
                colPairName = "expansion_interaction_graph", 
                node_color_by = "CellType", scales = "free")
    
    out <- testInteractions(pancreasSCE, group_by = "ImageNb", 
                            label = "CellType", method = "classic", 
                            iter = 200, colPairName = "expansion_interaction_graph", 
                            BPPARAM = SerialParam(RNGseed = 111))
    
    set.seed(123)
    cur_sce <- pancreasSCE[,sample(ncol(pancreasSCE))]
    
    plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE, 
                colPairName = "expansion_interaction_graph", 
                node_color_by = "CellType", scales = "free")
    
    out2 <- testInteractions(cur_sce, group_by = "ImageNb", 
                            label = "CellType", method = "classic", 
                            iter = 200, 
                            colPairName = "expansion_interaction_graph",
                            BPPARAM = SerialParam(RNGseed = 111))
    
    ## Sampling is different between grouped and non-grouped cells
    ## Therefore the p values are close but not identical
    expect_equal(out$group_by, out2$group_by)
    expect_equal(out$from_label, out2$from_label)
    expect_equal(out$to_label, out2$to_label)
    expect_equal(out$ct, out2$ct)
    expect_equal(out$p_gt, out2$p_gt, tolerance = 0.1)
    expect_equal(out$p_lt, out2$p_lt, tolerance = 0.1)
    expect_equal(out$interaction, out2$interaction)
    expect_equal(out$p, out2$p, tolerance = 0.1)
    expect_equal(out$sig, out2$sig)
    expect_equal(out$sigval, out2$sigval)
    
    out <- testInteractions(pancreasSCE, group_by = "ImageNb", 
                            label = "CellType", method = "conditional", 
                            iter = 400, colPairName = "expansion_interaction_graph", 
                            BPPARAM = SerialParam(RNGseed = 111))
    
    out2 <- testInteractions(cur_sce, group_by = "ImageNb", 
                             label = "CellType", method = "conditional", 
                             iter = 400, 
                             colPairName = "expansion_interaction_graph",
                             BPPARAM = SerialParam(RNGseed = 111))
    
    expect_equal(out$group_by, out2$group_by)
    expect_equal(out$from_label, out2$from_label)
    expect_equal(out$to_label, out2$to_label)
    expect_equal(out$ct, out2$ct)
    expect_equal(out$p_gt, out2$p_gt, tolerance = 0.1)
    expect_equal(out$p_lt, out2$p_lt, tolerance = 0.1)
    expect_equal(out$interaction, out2$interaction)
    expect_equal(out$p, out2$p, tolerance = 0.1)
    #expect_equal(out$sig, out2$sig)
    #expect_equal(out$sigval, out2$sigval)
    expect_equal(out$zscore, out2$zscore, tolerance = 0.1)
    
    out <- testInteractions(pancreasSCE, group_by = "ImageNb", 
                            label = "CellType", method = "patch", patch_size = 2,
                            iter = 300, colPairName = "expansion_interaction_graph", 
                            BPPARAM = SerialParam(RNGseed = 111))
    
    out2 <- testInteractions(cur_sce, group_by = "ImageNb", 
                             label = "CellType", method = "patch", patch_size = 2,
                             iter = 300, 
                             colPairName = "expansion_interaction_graph",
                             BPPARAM = SerialParam(RNGseed = 111))
    
    expect_equal(out$group_by, out2$group_by)
    expect_equal(out$from_label, out2$from_label)
    expect_equal(out$to_label, out2$to_label)
    expect_equal(out$ct, out2$ct)
    expect_equal(out$p_gt, out2$p_gt, tolerance = 0.1)
    expect_equal(out$p_lt, out2$p_lt, tolerance = 0.1)
    expect_equal(out$interaction, out2$interaction)
    expect_equal(out$p, out2$p, tolerance = 0.1)
    #expect_equal(out$sig, out2$sig)
    #expect_equal(out$sigval, out2$sigval)
    })

#' @title Function to aggregate all neighbors of each cell.
#'
#' @description Function to summarize categorical or expression values of all
#' neighbors of each cell.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param colPairName single character indicating the \code{colPair(object)}
#' entry containing the neighbor information.
#' @param aggregate_by character specifying whether the neighborhood should be
#' summarized by cellular features stored in \code{colData(object)}
#' (\code{aggregate_by = "metdata"}) or by marker expression of the
#' neighboring cells (\code{aggregate_by = "expression"}).
#' @param count_by for \code{summarize_by = "metadata"}, a single character
#' specifying the \code{colData(object)} entry containing the cellular
#' metadata that should be summarized across each cell's neighborhood.
#' @param proportions single logical indicating whether aggregated metadata
#' should be returned in form of proportions instead of absolute counts.
#' @param assay_type for \code{summarize_by = "expression"}, single character
#' indicating the assay slot to use.
#' @param subset_row for \code{summarize_by = "expression"}, an integer, logical
#' or character vector specifying the features to use. If NULL, defaults to
#' all features.
#' @param statistic for \code{summarize_by = "expression"}, a single character
#' specifying the statistic to be used for summarizing the expression values
#' across all neighboring cells. Supported entries are "mean", "median", "sd",
#' "var". Defaults to "mean" if not specified.
#' @param name single character specifying the name of the data frame to be
#' saved in the \code{colData(object)}. Defaults to "aggregatedNeighbors" when
#' \code{summarize_by = "metadata"} or "{statistic}_aggregatedExpression" when
#' \code{summarize_by = "expression"}.
#'
#' @return returns an object of \code{class(object)} containing the aggregated
#' values in form of a \code{DataFrame} object in
#' \code{colData(object)[[name]]}.
#' 
#' @examples
#' library(cytomapper)
#' data(pancreasSCE)
#' 
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                          type = "knn", k = 3)
#'                          
#' # Aggregating neighboring cell-types
#' sce <- aggregateNeighbors(sce, colPairName = "knn_interaction_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "CellType")
#' sce$aggregatedNeighbors
#' 
#' # Aggregating neighboring expression values
#' sce <- aggregateNeighbors(sce, colPairName = "knn_interaction_graph",
#'                          aggregate_by = "expression",
#'                          assay_type = "exprs",
#'                          statistic = "mean")
#' sce$mean_aggregatedExpression
#'   
#' @author Daniel Schulz (\email{daniel.schulz@@uzh.ch})
#'
#' @importFrom data.table as.data.table dcast melt :=
#' @importFrom S4Vectors DataFrame
#' @importFrom utils globalVariables
#' @importFrom SummarizedExperiment assay
#' @importFrom SingleCellExperiment colPair colData
#' @importFrom stats median sd var
#' @export
aggregateNeighbors <- function(object,
                            colPairName,
                            aggregate_by = c("metadata", "expression"),
                            count_by = NULL,
                            proportions = TRUE,
                            assay_type = NULL,
                            subset_row = NULL,
                            statistic = c("mean", "median", "sd", "var"),
                            name = NULL){

    summarize_by <- match.arg(aggregate_by)
  
    summaryStats <- match.arg(statistic)

    .valid.aggregateNeighbors.input(object, colPairName, summarize_by, 
                                count_by, proportions, assay_type, subset_row,
                                name)

    if (summarize_by == "metadata") {

        cur_dat <- as.data.table(colPair(object, colPairName))
        
        cur_factor <- factor(colData(object)[[count_by]])
        
        cur_dat[, "celltype" := cur_factor[cur_dat$to]]

        cur_dat <- dcast(cur_dat, formula = "from ~ celltype", 
                                fun.aggregate = length, drop = FALSE)

        if (proportions) {
            .SD <- NULL
            all_col <- names(cur_dat)[-1]
            row_sums <- rowSums(cur_dat[,-1])
            cur_dat[, (all_col) := lapply(.SD, function(x){x / row_sums}), 
                    .SDcols = all_col]
        }
    
        name <- ifelse(is.null(name), "aggregatedNeighbors", name)
        
        out_dat <- DataFrame(matrix(data = 0, nrow = ncol(object), 
                                    ncol = ncol(cur_dat) - 1))
        names(out_dat) <- names(cur_dat)[-1]
        out_dat[cur_dat$from,] <- cur_dat[,-1]

        colData(object)[[name]] <- out_dat

        return(object)

    } else {
      
        if (is.null(subset_row)) {
            subset_row <- rownames(object)
        }

        cur_dat <- as.data.table(colPair(object, colPairName))

        cur_dat <- cbind(cur_dat,t(assay(object, assay_type))[cur_dat$to,
                                                                subset_row])
        
        cur_dat <- melt(cur_dat, id.vars = c("from", "to"))
        
        cur_dat <- cur_dat[,eval(parse(text = paste0(statistic, "(value)"))), 
                            by=c("from","variable")]
        
        cur_dat <- dcast(cur_dat, formula = "from ~ variable", 
                        value.var = "V1")

        name <- ifelse(is.null(name), 
                        paste0(statistic,"_aggregatedExpression"), name)
        
        out_dat <- DataFrame(matrix(data = NA, nrow = ncol(object), 
                                    ncol = ncol(cur_dat) - 1))
        names(out_dat) <- names(cur_dat)[-1]
        out_dat[cur_dat$from,] <- cur_dat[,-1]

        colData(object)[[name]] <- out_dat

        return(object)
    }
}

test_that("filterSpatialContext function works", {
  set.seed(22)
  library(cytomapper)
  data(pancreasSCE)
  
  ## 1. Cellular neighborhood (CN)
  sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                           type = "knn",
                           name = "knn_cn_graph",
                           k = 5)
  
  sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
                            aggregate_by = "metadata",
                            count_by = "CellType",
                            name = "aggregatedCellTypes")
  
  cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
  sce$cellular_neighborhood <- factor(cur_cluster$cluster)
  
  ## 2. Spatial context (SC)
  sce <- buildSpatialGraph(sce, img_id = "ImageNb",
                           type = "knn",
                           name = "knn_sc_graph",
                           k = 15)
  
  sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
                            aggregate_by = "metadata",
                            count_by = "cellular_neighborhood",
                            name = "aggregatedNeighborhood")
  
  # Detect spatial context
  sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                              threshold = 0.9)
  
  ## Filter spatial context - tests
  # basics
  expect_silent(cur_sce <- filterSpatialContext(sce, group_by = "ImageNb", group_threshold = 2))
  
  expect_equal(names(colData(cur_sce)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb", 
                 "CellNb", "MaskName", "Pattern", "aggregatedCellTypes", "cellular_neighborhood", 
                 "aggregatedNeighborhood", "spatial_context", "spatial_context_filtered"))
  
  expect_s4_class(cur_sce , class = "SingleCellExperiment") 
  expect_type(cur_sce$spatial_context_filtered, "character")
  expect_equal(length(cur_sce$spatial_context), length(cur_sce$spatial_context_filtered))
  
  # check that detected spatial_context_filtered remain the same
  expect_equal(cur_sce$spatial_context_filtered[200:210], c("3", NA, NA, "1_3", "1_3", "1_3", "1_3", NA, NA, "3", "1_3"))
  
  # change filtering
  expect_silent(cur_sce2 <- filterSpatialContext(sce, group_by = "ImageNb", cells_threshold = 15))
  
  expect_false(identical(cur_sce$spatial_context_filtered, cur_sce2$spatial_context_filtered))
  expect_equal(cur_sce$spatial_context, cur_sce2$spatial_context)
  
  # filtering with 0
  expect_silent(cur_sce3 <- filterSpatialContext(sce, group_by = "ImageNb", 
                                                 group_threshold = 0, 
                                                 cells_threshold = 0))
  expect_equal(cur_sce3$spatial_context, cur_sce3$spatial_context_filtered)
  
  # filtering with values higher than input
  expect_silent(cur_sce4 <- filterSpatialContext(sce, group_by = "ImageNb", 
                                                 group_threshold = 4, 
                                                 cells_threshold = 100))
  expect_equal(as.character(cur_sce4$spatial_context_filtered), 
               as.character(rep(NA, length(cur_sce4$spatial_context_filtered))))
  
  # manual filtering should give the same results
  cur_anno <- colData(sce) %>% as.data.frame() %>% select("spatial_context", "ImageNb") %>% 
    table() %>% as.data.frame()
  cur_anno <- data.frame(spatial_context = unique(cur_anno$spatial_context) %>% unfactor(), 
                     n_cells = cur_anno %>% group_by_at("spatial_context") %>% 
                       summarise(sum = sum(Freq)) %>% pull(sum), 
                     n_group = cur_anno %>% group_by_at("spatial_context") %>% 
                       filter(Freq != 0) %>% count() %>% pull(n)
  )
  
  manual_selected <- cur_anno %>% filter(n_group >= 2 & n_cells >= 15) %>% 
    pull(spatial_context) %>% sort()
  
  expect_silent(cur_sce5 <- filterSpatialContext(sce, group_by = "ImageNb", 
                                                 group_threshold = 2, 
                                                 cells_threshold = 15))
  
  function_selected <- unique(cur_sce5$spatial_context_filtered) %>% sort()

  expect_equal(manual_selected, function_selected)
  
  #metadata entry check
  manual_anno <- cur_anno[cur_anno$n_group >= 2,]
  expect_equal(metadata(cur_sce)$filterSpatialContext, manual_anno)
  
  # aggregatedNeighbors colnames as characters
  cur_sce_6 <- sce
  colnames(cur_sce_6$aggregatedNeighborhood) <- c("B_CN","T_CN","DC_CN")
  expect_silent(cur_sce_6 <- detectSpatialContext(cur_sce_6, entry = "aggregatedNeighborhood",
                                                  threshold = 0.9))
  expect_silent(cur_sce_6 <- filterSpatialContext(cur_sce_6, group_by = "ImageNb", 
                                                  group_threshold = 2))
  expect_equal(cur_sce_6$spatial_context_filtered[200:210], 
               c("DC.CN", NA, NA, "B.CN_DC.CN", "B.CN_DC.CN", "B.CN_DC.CN", 
                 "B.CN_DC.CN", NA, NA, "DC.CN", "B.CN_DC.CN"))
  
  #Errors
  expect_error(filterSpatialContext(colData(sce)),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)

  expect_error(filterSpatialContext(sce, entry = "spatialcontext"),
               regexp = "'entry' not in 'colData(object)'.",
               fixed = TRUE)

  expect_error(filterSpatialContext(sce, group_by = "ImageNb", cells_threshold = "10"),
               regexp = "'cells_threshold' needs to be a single numeric.",
               fixed = TRUE)
  
  expect_error(filterSpatialContext(sce, group_by = "Image", group_threshold = "2"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)

  expect_error(filterSpatialContext(sce, group_by = "ImageNb", group_threshold = "2"),
               regexp = "'group_threshold' needs to be a single numeric.",
               fixed = TRUE)
  
  expect_error(filterSpatialContext(sce, group_by = "ImageNb"),
               regexp = "One of 'group_threshold' and 'cells_threshold' has to be defined.",
               fixed = TRUE)
  
  expect_error(filterSpatialContext(sce, group_by = "ImageNb", cells_threshold = 10, 
                                    name = c("spatial","context","filtered")),
               regexp = "'name' has to be a single character'.",
               fixed = TRUE)
}
)
  

test_that("detectSpatialContext function works", {
  set.seed(22)
  library(cytomapper)
  data(pancreasSCE)
  
  cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
  cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
  cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
  
  cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
  cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
  cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
  cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
  cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
  cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
  
  pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
  
  ## 1. Cellular neighborhood (CN)
  sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                           type = "knn", 
                           name = "knn_cn_graph", 
                           k = 5)
  
  sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph", 
                            aggregate_by = "metadata", 
                            count_by = "CellType",
                            name = "aggregatedCellTypes")
  
  cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
  sce$cellular_neighborhood <- factor(cur_cluster$cluster)
  
  ## 2. Spatial context (SC)
  sce <- buildSpatialGraph(sce, img_id = "ImageNb", 
                           type = "knn", 
                           name = "knn_sc_graph", 
                           k = 15)
  
  sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph", 
                            aggregate_by = "metadata", 
                            count_by = "cellular_neighborhood",
                            name = "aggregatedNeighborhood")
  
  ## Detect spatial context - tests
  # basics
  expect_silent(cur_sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                                                threshold = 0.9))
  expect_equal(names(colData(cur_sce)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                 "CellNb", "MaskName", "Pattern", "aggregatedCellTypes","cellular_neighborhood",
                 "aggregatedNeighborhood", "spatial_context"))
  expect_s4_class(cur_sce , class = "SingleCellExperiment") 
  expect_type(cur_sce$spatial_context, "character")
  expect_equal(length(cur_sce$spatial_context), length(cur_sce$cellular_neighborhood))
  
  # check that changing name works 
  expect_silent(cur_sce_2 <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                                                  threshold = 0.9, name = "SC"))
  expect_equal(names(colData(cur_sce_2)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                 "CellNb", "MaskName", "Pattern", "aggregatedCellTypes","cellular_neighborhood",
                 "aggregatedNeighborhood", "SC"))
  
  # check that detected spatial_contexts remain the same
  expect_equal(cur_sce$spatial_context[1:10], c("1", "1", "1", "1", "1", "1", "1", "1", "1", "1"))
  
  # change threshold
  expect_silent(cur_sce_3 <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                                                  threshold = 0.5))
  expect_false(identical(cur_sce$spatial_context, cur_sce_3$spatial_context))
  
  # aggregatedNeighbors DataFrame contains a row with 0s
  cur_sce_3$aggregatedNeighborhood[1,] <- 0
  expect_silent(cur_sce_4 <- detectSpatialContext(cur_sce_3, entry = "aggregatedNeighborhood",
                                                  threshold = 0.9))
  expect_true(is.na(cur_sce_4$spatial_context[1]))
  
  # aggregatedNeighbors input checks 
  expect_s4_class(sce$aggregatedNeighborhood, "DFrame")
  expect_silent(as.matrix(colData(sce)[,"aggregatedNeighborhood"]))
  
  # aggregatedNeighbors colnames as characters
  cur_sce_5 <- sce
  colnames(cur_sce_5$aggregatedNeighborhood) <- c("B_CN","T_CN","DC_CN")
  expect_silent(cur_sce_5 <- detectSpatialContext(cur_sce_5, entry = "aggregatedNeighborhood",
                                                  threshold = 0.9))
  expect_equal(names(colData(cur_sce_5)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                 "CellNb", "MaskName", "Pattern", "aggregatedCellTypes","cellular_neighborhood",
                 "aggregatedNeighborhood", "spatial_context"))
  expect_equal(cur_sce_5$spatial_context[1:10], 
               c("B.CN", "B.CN", "B.CN", "B.CN", "B.CN", "B.CN", "B.CN", "B.CN", 
                                                  "B.CN", "B.CN"))
  # Errors 
  expect_error(detectSpatialContext(colData(sce)),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(detectSpatialContext(sce, entry = "agregatedNeighbors"),
               regexp = "'entry' not in 'colData(object)'.",
               fixed = TRUE)
  
  sce$aggregatedNeighbors_DF <- as.data.frame(sce$aggregatedNeighborhood)
  expect_error(detectSpatialContext(sce, entry = "aggregatedNeighbors_DF"),
               regexp = "'colData(object)[,entry]' needs to be a DFrame object.",
               fixed = TRUE)
  
  expect_error(detectSpatialContext(sce, entry = "aggregatedNeighborhood", threshold = 1.1),
               regexp = "'threshold' needs to be a single numeric between 0-1.",
               fixed = TRUE)
  
  expect_error(detectSpatialContext(sce, entry = "aggregatedNeighborhood", threshold = "0.9"),
               regexp = "'threshold' needs to be a single numeric between 0-1.",
               fixed = TRUE)
  
  expect_error(detectSpatialContext(sce, entry = "aggregatedNeighborhood", name = c("spatial","context")),
               regexp = "'name' has to be a single character'.",
               fixed = TRUE)
}
)

test_that("plotSpatialContext function works", {
  set.seed(22)
  library(cytomapper)
  data(pancreasSCE)

  ## 1. Cellular neighborhood (CN)
  sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                          type = "knn",
                          name = "knn_cn_graph",
                          k = 5)

  sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
                           aggregate_by = "metadata",
                           count_by = "CellType",
                           name = "aggregatedCellTypes")

  cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
  sce$cellular_neighborhood <- factor(cur_cluster$cluster)

  ## 2. Spatial context (SC)
  sce <- buildSpatialGraph(sce, img_id = "ImageNb",
                          type = "knn",
                          name = "knn_sc_graph",
                          k = 15)

  sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
                           aggregate_by = "metadata",
                           count_by = "cellular_neighborhood",
                           name = "aggregatedNeighborhood")

  # Detect spatial context
  sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                             threshold = 0.9)
  
  ## Plot spatial context - basic tests
  expect_silent(p <- plotSpatialContext(sce, group_by = "ImageNb"))
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_size_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_size_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_label_color_by = "name")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_label_color_by = "n_group")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_label_color_by = "n_cells")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", draw_edges = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "name",
                          node_label_repel = FALSE)
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce$spatial_context)),"_"),length))
  
  # filtered entries - tests
  sce_fil <- filterSpatialContext(sce, group_by = "ImageNb", group_threshold = 2)
  
  p <- plotSpatialContext(sce_fil, group_by = "ImageNb", entry = "spatial_context_filtered")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(sce_fil$spatial_context_filtered)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(sce_fil$spatial_context_filtered)),"_"),length))
  
  # return data - tests
  p <- plotSpatialContext(sce, group_by = "ImageNb", return_data = TRUE) 
  expect_type(p, "list")
  expect_equal(names(p), c("edges", "vertices"))
  expect_equal(p$edges[,1], c("1", "1", "1_2", "1_3", "2", "2", "2_3", "3", "3"))
  expect_equal(p$edges[,2], c("1_2", "1_3", "1_2_3", "1_2_3", "1_2", "2_3", "1_2_3", 
                              "1_3", "2_3"))
  expect_equal(p$vertices[,1], c("1", "1_2", "1_2_3", "1_3", "2", "2_3", "3"))
  expect_equal(p$vertices[,2], c(87L, 71L, 16L, 90L, 55L, 29L, 14L))
  
  #metadata entry and vertices comp
  sce_fil <- filterSpatialContext(sce, group_by = "ImageNb", group_threshold = 0)
  expect_equal(metadata(sce_fil)$filterSpatialContext, p$vertices[,1:3])
  
  # aggregatedNeighbors colnames as characters
  cur_sce <- sce
  colnames(cur_sce$aggregatedNeighborhood) <- c("B_CN","T_CN","DC_CN")
  expect_silent(cur_sce <- detectSpatialContext(cur_sce, entry = "aggregatedNeighborhood",
                                                  threshold = 0.9))
  expect_silent(cur_sce <- filterSpatialContext(cur_sce, group_by = "ImageNb", 
                                                  group_threshold = 2))
  
  p <- plotSpatialContext(cur_sce, group_by = "ImageNb")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(cur_sce$spatial_context)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(cur_sce$spatial_context)),"_"),length))
  
  p <- plotSpatialContext(cur_sce, group_by = "ImageNb", entry = "spatial_context_filtered")
  expect_s3_class(p, "ggraph")
  expect_silent(print(p))
  expect_equal(p$data$name, sort(unique(cur_sce$spatial_context_filtered)))
  expect_equal(p$data$length, sapply(str_split(sort(unique(cur_sce$spatial_context_filtered)),"_"),length))
  
  #Errors
  expect_error(plotSpatialContext(colData(sce)),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, entry = "spatialcontext"),
               regexp = "'entry' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "Image"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "NAME"),
               regexp = "'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_size_by = "name"),
               regexp = "'node_size_by' has to be 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_color_fix = factor("black")),
               regexp = "'node_color_fix' has to be a character'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_size_fix = 3),
               regexp = "'node_size_fix' has to be a character'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_repel = "TRUE"),
               regexp = "'node_label_repel' has to be logical'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_color_by = "NAME"),
               regexp = "'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_color_fix = factor("black")),
               regexp = "'node_label_color_fix' has to be a character'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", draw_edges = "TRUE"),
               regexp = "'draw_edges' has to be logical'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", edge_color_fix = factor("black")),
               regexp = "'edge_color_fix' has to be a character'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", return_data = "TRUE"),
               regexp = "'return_data' has to be logical'.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_repel = FALSE, 
                                  node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_repel = FALSE, 
                                  node_label_color_by = "name"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined when node_label_repel == FALSE",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "name", 
                                  node_color_fix = "blue"),
               regexp = "'node_color_by' and 'node_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_label_color_by = "name", 
                                  node_label_color_fix = "blue"),
               regexp = "'node_label_color_by' and 'node_label_color_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_color_by = "name", 
                                  node_label_color_by = "n_cells"),
               regexp = "'node_label_color_by' and 'node_color_by' have to be identical.",
               fixed = TRUE)
  
  expect_error(plotSpatialContext(sce, group_by = "ImageNb", node_size_by = "n_group", 
                                  node_size_fix = "22"),
               regexp = "'node_size_by' and 'node_size_fix' can not be defined at the same time.",
               fixed = TRUE)
  
  
  #spatial context is NA vector
  sce$spatial_context <- NA
  expect_error(plotSpatialContext(sce, group_by = "ImageNb"), 
               regexp = "'entry' contains only NAs.", 
               fixed = TRUE)
  
}
)

test_that("aggregateNeighbors function works", {
    library(cytomapper)
    library(dplyr)
    data("pancreasSCE")
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     name = "knn_10")
    
    # Works metadata version on knn
    # Directed
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    
    # with machine tolerance
    tolerance <- sqrt(.Machine$double.eps)
    expect_equal(
      rowSums(as.matrix(cur_sce$aggregatedNeighbors)),
      rep(1, nrow(cur_sce$aggregatedNeighbors)),
      tolerance = tolerance
    )
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"knn_10"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType[cur_dat$to])
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% 
        select(-from) %>% as.matrix()
    
    cur_dat <- cur_dat / rowSums(cur_dat)
    
    expect_equal(cur_sce$aggregatedNeighbors,
                 DataFrame(cur_dat))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == 10))
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"knn_10"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType[cur_dat$to])
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% 
        select(-from) %>% as.matrix()
    
    expect_equal(cur_sce$aggregatedNeighbors,
                 DataFrame(cur_dat))
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 215,]
    cur_sce2 <- cur_sce2[,c(215, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 215])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 10,]
    cur_sce2 <- cur_sce2[,c(10, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 10])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 322,]
    cur_sce2 <- cur_sce2[,c(322, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 322])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    # Undirected
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     directed = FALSE,
                                     name = "knn_10")
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_equal(
      rowSums(as.matrix(cur_sce$aggregatedNeighbors)),
      rep(1, nrow(cur_sce$aggregatedNeighbors)),
      tolerance = tolerance
    )
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"knn_10"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType[cur_dat$to])
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% 
        select(-from) %>% as.matrix()
    
    cur_dat <- cur_dat / rowSums(cur_dat)
    
    expect_equal(cur_sce$aggregatedNeighbors,
                 DataFrame(cur_dat))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == countLnodeHits(colPair(cur_sce, "knn_10"))))
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"knn_10"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType[cur_dat$to])
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% 
        select(-from) %>% as.matrix()
    
    expect_equal(cur_sce$aggregatedNeighbors,
                 DataFrame(cur_dat))
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 215,]
    cur_sce2 <- cur_sce2[,c(215, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 215])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 10,]
    cur_sce2 <- cur_sce2[,c(10, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 10])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "knn_10") <- colPair(cur_sce2, "knn_10")[from(colPair(cur_sce2, "knn_10")) == 322,]
    cur_sce2 <- cur_sce2[,c(322, to(colPair(cur_sce2, "knn_10"))[from(colPair(cur_sce2, "knn_10")) == 322])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "knn_10")
    cur_sce2$aggregatedNeighbors
    
    # Works expression version on knn
    # Directed
    # Mean
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     name = "knn_10")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "exprs"))
    
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))

    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2,"exprs"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)

    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "counts"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2,"counts"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(as.matrix(cur_sce_2$sums/cur_sce_2$counts)), check.attributes = FALSE)
    
    # Median
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     name = "knn_10")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
    expect_equal(as.matrix(cur_sce$median_aggregatedExpression),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "counts",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "counts"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
    expect_equal(as.matrix(cur_sce$median_aggregatedExpression),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    
    # Undirected
    ## Mean
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     name = "knn_10", directed = FALSE)
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "exprs"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "counts"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "counts"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    
    # Median
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "knn",k = 10,
                                     name = "knn_10",
                                     directed = FALSE)
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
        expect_equal(as.matrix(cur_sce$median_aggregatedExpression),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "knn_10",
                                                aggregate_by = "expression",
                                                assay_type = "counts",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"knn_10"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"knn_10"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "counts"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
    expect_equal(as.matrix(cur_sce$median_aggregatedExpression),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    
    # Expansion
    ## metadata
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 5,
                                     name = "exp_20")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"exp_20"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(cur_sce$aggregatedNeighbors[cur_dat[,"from"],],
                 DataFrame(cur_dat[,-1]))
    expect_true(all(as.matrix(cur_sce$aggregatedNeighbors[-cur_dat[,"from"],]) == 0))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == countLnodeHits(colPair(cur_sce, "exp_20"))))
    
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 10,
                                     name = "exp_20")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"exp_20"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(cur_sce$aggregatedNeighbors[cur_dat[,"from"],],
                 DataFrame(cur_dat[,-1]))
    expect_true(all(as.matrix(cur_sce$aggregatedNeighbors[-cur_dat[,"from"],]) == 0))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == countLnodeHits(colPair(cur_sce, "exp_20"))))
    
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 15,
                                     name = "exp_20")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"exp_20"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(cur_sce$aggregatedNeighbors[cur_dat[,"from"],],
                 DataFrame(cur_dat[,-1]))
    expect_true(all(as.matrix(cur_sce$aggregatedNeighbors[-cur_dat[,"from"],]) == 0))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == countLnodeHits(colPair(cur_sce, "exp_20"))))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "Pattern"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_equal(
      rowSums(as.matrix(cur_sce$aggregatedNeighbors)),
      rep(1, nrow(cur_sce$aggregatedNeighbors)),
      tolerance = tolerance
    )
    
    cur_dat <- data.frame(colPair(pancreasSCE,"exp_20"))
    cur_dat$Pattern <- factor(colData(cur_sce)$Pattern)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(Pattern, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "Pattern", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(as.matrix(cur_sce$aggregatedNeighbors),
                 as.matrix(DataFrame(cur_dat[,-1])), check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "Area"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_equal(
      rowSums(as.matrix(cur_sce$aggregatedNeighbors)),
      rep(1, nrow(cur_sce$aggregatedNeighbors)),
      tolerance = tolerance
    )
    
    cur_dat <- data.frame(colPair(pancreasSCE,"exp_20"))
    cur_dat$Area <- factor(colData(cur_sce)$Area)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(Area, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "Area", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(as.matrix(cur_sce$aggregatedNeighbors),
                 as.matrix(DataFrame(cur_dat[,-1])), check.attributes = FALSE)
    
    ## expression
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 5,
                                     name = "exp_20")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "expression",
                                                assay_type = "exprs"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"exp_20"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"exp_20"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression[unique(from(colPair(pancreasSCE,"exp_20"))),]),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    expect_true(all(is.na(as.matrix(cur_sce$mean_aggregatedExpression[-unique(from(colPair(pancreasSCE,"exp_20"))),]))))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "expression",
                                                assay_type = "counts"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"exp_20"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"exp_20"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "counts"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression[from(colPair(pancreasSCE,"exp_20")),]),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    expect_true(all(is.na(as.matrix(cur_sce$mean_aggregatedExpression[-from(colPair(pancreasSCE,"exp_20")),]))))
    
    # Median
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"exp_20"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"exp_20"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
    expect_equal(as.matrix(cur_sce$median_aggregatedExpression[unique(from(colPair(pancreasSCE,"exp_20"))),]),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    expect_true(all(is.na(as.matrix(cur_sce$median_aggregatedExpression[-unique(from(colPair(pancreasSCE,"exp_20"))),]))))
    
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 15,
                                     name = "exp_20")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "expression",
                                                assay_type = "exprs"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"exp_20"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"exp_20"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression[unique(from(colPair(pancreasSCE,"exp_20"))),]),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    expect_true(all(is.na(as.matrix(cur_sce$mean_aggregatedExpression[-unique(from(colPair(pancreasSCE,"exp_20"))),]))))
    
    
    # Delaunay
    ## metadata
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "delaunay")
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    
    # check for correct results of neighboring metadata
    cur_dat <- data.frame(colPair(pancreasSCE,"delaunay_interaction_graph"))
    cur_dat$celltype <- factor(colData(cur_sce)$CellType)[cur_dat$to]
    
    cur_dat <- cur_dat %>% group_by(from) %>% count(celltype, .drop = FALSE) %>% 
        tidyr::pivot_wider(names_from = "celltype", values_from = "n") %>% ungroup() %>% as.matrix()
    
    cur_dat[,-1] <- cur_dat[,-1] / rowSums(cur_dat[,-1])
    
    expect_equal(cur_sce$aggregatedNeighbors,
                 DataFrame(cur_dat[,-1]))
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "metadata",
                                                count_by = "CellType",
                                                proportions = FALSE))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "aggregatedNeighbors"))
    expect_s4_class(cur_sce$aggregatedNeighbors, "DataFrame")
    expect_true(all(rowSums(as.matrix(cur_sce$aggregatedNeighbors)) == countLnodeHits(colPair(cur_sce, "delaunay_interaction_graph"))))
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "delaunay_interaction_graph") <- colPair(cur_sce2, "delaunay_interaction_graph")[from(colPair(cur_sce2, "delaunay_interaction_graph")) == 215,]
    cur_sce2 <- cur_sce2[,c(215, to(colPair(cur_sce2, "delaunay_interaction_graph"))[from(colPair(cur_sce2, "delaunay_interaction_graph")) == 215])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "delaunay_interaction_graph")
    cur_sce2$aggregatedNeighbors
    
    cur_sce2 <- cur_sce
    colPair(cur_sce2, "delaunay_interaction_graph") <- colPair(cur_sce2, "delaunay_interaction_graph")[from(colPair(cur_sce2, "delaunay_interaction_graph")) == 12,]
    cur_sce2 <- cur_sce2[,c(12, to(colPair(cur_sce2, "delaunay_interaction_graph"))[from(colPair(cur_sce2, "delaunay_interaction_graph")) == 12])]
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType", draw_edges = TRUE,
                colPairName = "delaunay_interaction_graph")
    cur_sce2$aggregatedNeighbors
    
    ## expression
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "expression",
                                                assay_type = "exprs"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "mean_aggregatedExpression"))
    expect_s4_class(cur_sce$mean_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$mean_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"delaunay_interaction_graph"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"delaunay_interaction_graph"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                statistic = "median"))
    
    expect_s4_class(cur_sce , class = "SingleCellExperiment")
    expect_equal(names(colData(cur_sce)), 
                 c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb",
                   "CellNb", "MaskName", "Pattern", "median_aggregatedExpression"))
    expect_s4_class(cur_sce$median_aggregatedExpression, "DataFrame")
    expect_equal(dim(t(cur_sce$median_aggregatedExpression)), dim(cur_sce))
    
    # check for correct results of neighboring metadata
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"delaunay_interaction_graph"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"delaunay_interaction_graph"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs"),
                                      factors = list(from = cur_sce_2$from),
                                      compute.median = TRUE)
    
    expect_equal(as.matrix(cur_sce$median_aggregatedExpression),
                 t(as.matrix(cur_sce_2$medians)), check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                subset_row = c("H3", "PIN")))
    expect_equal(colnames(cur_sce$mean_aggregatedExpression), c("H3", "PIN"))
    
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"delaunay_interaction_graph"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"delaunay_interaction_graph"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs")[c("H3", "PIN"),],
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                subset_row = c(1,4)))
    expect_equal(colnames(cur_sce$mean_aggregatedExpression), c("H3", "CD8a"))
    
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"delaunay_interaction_graph"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"delaunay_interaction_graph"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs")[c(1,4),],
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
    
    expect_silent(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "delaunay_interaction_graph",
                                                aggregate_by = "expression",
                                                assay_type = "exprs",
                                                subset_row = !(rownames(pancreasSCE) %in% c("H3", "PIN"))))
    expect_equal(colnames(cur_sce$mean_aggregatedExpression), c("CD99", "CD8a", "CDH"))
    
    cur_sce_2 <- cur_sce[,to(colPair(pancreasSCE,"delaunay_interaction_graph"))]
    colData(cur_sce_2)$from <- from(colPair(pancreasSCE,"delaunay_interaction_graph"))
    
    cur_sce_2 <- aggregateAcrossCells(assay(cur_sce_2, "exprs")[!rownames(pancreasSCE) %in% c("H3", "PIN"),],
                                      factors = list(from = cur_sce_2$from))
    
    expect_equal(as.matrix(cur_sce$mean_aggregatedExpression),
                 t(cur_sce_2$sums)/cur_sce_2$counts, check.attributes = FALSE)
   
    # Error
    pancreasSCE <- buildSpatialGraph(object = pancreasSCE,
                                     img_id = "ImageNb",
                                     type = "expansion",
                                     threshold = 1,
                                     name = "exp_20")
    expect_error(cur_sce <- aggregateNeighbors(object = pancreasSCE,
                                                colPairName = "exp_20",
                                                aggregate_by = "metadata",
                                                count_by = "CellType"),
                 regexp = "No interactions found.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE),
                 regexp = "argument \"colPairName\" is missing, with no default",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName =  c("test", 1)),
                 regexp = "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName =  "test"),
                 regexp = "'colPairName' not in 'colPairNames(object)'.",
                 fixed = TRUE)
    
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "metadata"),
                 regexp = "Provide a 'colData(object)' entry to aggregate by.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "metadata", count_by = 1),
                 regexp = "'count_by' must be a single string.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "metadata", count_by = c("CellType", "test")),
                 regexp = "'count_by' must be a single string.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "metadata", count_by = "test"),
                 regexp = "'count_by' is not a valid enty of 'colData(object)'.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "metadata", count_by = "CellType",
                                    proportions = "test"),
                 regexp = "'proportions' must be a single logical",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression"),
                 regexp = "'assay_type' not provided",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression", assay_type = 1),
                 regexp = "'assay_type' must be a single string.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression", assay_type = "test"),
                 regexp = "'assay_type' not an assay in the 'object'.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression", assay_type = "counts",
                                    subset_row = c(1, "test")),
                 regexp = "'subset_row' not in rownames(object).",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression", assay_type = "counts",
                                    subset_row = TRUE),
                 regexp = "'subset_row' logical entries must be as long as 'nrow(object)'.",
                 fixed = TRUE)
    expect_error(aggregateNeighbors(object = pancreasSCE, colPairName = "knn_10",
                                    aggregate_by = "expression", assay_type = "counts",
                                    name = TRUE),
                 regexp = "'name' must be a single string.",
                 fixed = TRUE)
})

#' @title Detect the spatial context of each cell based on its neighborhood
#'
#' @description Function to detect the spatial context (SC) of each cell. 
#' Based on its sorted (high-to-low) cellular neighborhood (CN) fractions in a 
#' spatial interaction graph, the SC of each cell is assigned as the set of CNs 
#' that cumulatively exceed a user-defined fraction threshold. 
#' 
#' The term was coined by \href{https://doi.org/10.1016/j.cels.2021.09.012}{
#' Bhate S. et al., Tissue schematics map the specialization of immune tissue 
#' motifs and their appropriation by tumors, Cell Systems, 2022} and describes 
#' tissue regions in which distinct CNs may be interacting. 
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param entry single character specifying the \code{colData(object)}
#' entry containing the \code{aggregateNeighbors} DataFrame output. 
#' Defaults to "aggregatedNeighbors". 
#' @param threshold single numeric between 0 and 1 that specifies the fraction 
#' threshold for SC assignment. Defaults to 0.9.
#' @param name single character specifying the name of the output saved in 
#'  \code{colData(object)}. Defaults to "spatial_context".
#'
#' @section Spatial context background:
#' The function relies on CN fractions for each cell in a 
#' spatial interaction graph (originally a k-nearest neighbor (KNN) graph).
#'
#' We can retrieve the CN fractions using the \link[imcRtools]{buildSpatialGraph} 
#' and \link[imcRtools]{aggregateNeighbors} functions.
#' 
#' The window size (k for KNN) for \link[imcRtools]{buildSpatialGraph} should 
#' reflect a length scale on which biological signals can be exchanged and 
#' depends, among others, on cell density and tissue area. In view of their 
#' divergent functionality, we recommend to use a larger window size for SC 
#' (interaction between local processes) than for CN (local processes) detection.
#'
#' Subsequently, the CN fractions are sorted from high-to-low and the SC of
#' each cell is assigned the minimal combination of SCs that additively
#' surpass a user-defined threshold. The default threshold of 0.9 aims to
#' represent the dominant CNs, hence the most prevalent signals, in a given window.
#'
#' For more details, please refer to:
#' \href{https://doi.org/10.1016/j.cels.2021.09.012}{ Bhate S. et al., Tissue
#' schematics map the specialization of immune tissue motifs and their
#' appropriation by tumors, Cell Systems, 2022}.
#' 
#' @return returns an object of \code{class(object)} containing a new column 
#' entry to \code{colData(object)[[name]]}
#' 
#' @examples 
#' set.seed(22)
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' ## 1. Cellular neighborhood (CN)
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_cn_graph",
#'                         k = 5)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "CellType",
#'                          name = "aggregatedCellTypes")
#'
#' cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
#' sce$cellular_neighborhood <- factor(cur_cluster$cluster)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_cn_graph",
#'            node_color_by = "cellular_neighborhood",
#'            scales = "free")
#'
#' ## 2. Spatial context (SC)
#' sce <- buildSpatialGraph(sce, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_sc_graph",
#'                         k = 15)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "cellular_neighborhood",
#'                          name = "aggregatedNeighborhood")
#'
#' # Detect spatial context
#' sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
#'                            threshold = 0.9)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_sc_graph",
#'            node_color_by = "spatial_context",
#'            scales = "free")
#'            
#' @seealso 
#' \code{\link[imcRtools]{filterSpatialContext}} for the function to filter 
#' spatial contexts
#'
#' \code{\link[imcRtools]{plotSpatialContext}} for the function to plot 
#' spatial context graphs 
#' 
#' @author Lasse Meyer (\email{lasse.meyer@@uzh.ch})
#' 
#' @references
#' \href{https://doi.org/10.1016/j.cels.2021.09.012}{
#' Bhate S. et al., Tissue schematics map the specialization of immune tissue 
#' motifs and their appropriation by tumors, Cell Systems, 2022}
#' 
#' @importFrom SingleCellExperiment colData
#' @importFrom stringr str_replace
#' @export

detectSpatialContext <- function(object,
                                 entry = "aggregatedNeighbors",
                                 threshold = 0.9,
                                 name = "spatial_context"){
  
  .valid.detectSpatialContext.input(object, entry, threshold, name) 
  
  cur_dat <- colData(object)[,entry]
  
  colnames(cur_dat) <- str_replace(colnames(cur_dat),"_",".")
  
  out_dat <- apply(cur_dat, 1, function(x){
    
    out <- cumsum(sort(x, decreasing = TRUE))
    
    if (sum(out) != 0) {
      cur_out <- names(out[seq_len(sum(out < threshold) + 1)])
      cur_out <- paste(sort(cur_out), collapse = "_")
      return(cur_out)
    } else {
        return(NA)
    }
  })
  
  colData(object)[[name]] <- out_dat
  return(object)
}

#' @title Visualizes the spatial locations and interactions of cells
#'
#' @description A general function to plot spatial locations of cells while 
#' specifying color, shape, size. Cell-cell interactions can be visualized
#' in form of edges between points.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object.
#' @param img_id single character indicating the \code{colData(object)} entry
#' containing the unique image identifiers.
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries indicating the the cells' x and y locations.
#' @param node_color_by single character indicating the \code{colData(object)}
#' entry or marker name by which the nodes (cell locations) should be colored. 
#' @param node_shape_by single character indicating the \code{colData(object)}
#' entry by which the shape of the nodes are defined. 
#' @param node_size_by single character indicating the \code{colData(object)}
#' entry by which the size of the nodes are defined. 
#' @param node_color_fix single character or numeric specifying the color of all 
#' nodes.
#' @param node_size_fix single numeric specifying the size of all nodes
#' @param node_shape_fix single numeric or character specifying the shape of all 
#' nodes.
#' @param assay_type single character indicating the assay slot from which
#' to extract the expression data when \code{node_color_by} is set to one of
#' \code{rownames(object)}.
#' @param draw_edges should cell-cell interactions be drawn as edges between
#' nodes? 
#' @param directed should cell-cell interactions be handled as a directed graph?
#' @param colPairName single character specifying the 
#' \code{colPair(object)} slot to retrieve the cell-cell pairings.
#' @param edge_color_by single character indicating by which to color the edges.
#' See details for more information.
#' @param edge_width_by single character determining the size of the edges.
#' See details for more information.
#' @param edge_color_fix single character or numeric specifying the color of all 
#' edges.
#' @param edge_width_fix single numeric specifying the size of all edges.
#' @param arrow an \code{\link[grid]{arrow}} object specifying how to draw
#' arrows between cells.
#' @param end_cap a \code{\link[ggraph]{geometry}} object specifying how long
#' the edges are. This only takes effect when drawing arrows. Default:
#' \code{end_cap = circle(0.1, 'cm')}
#' @param nodes_first should the nodes be plotted first and then the edges?
#' @param ncols number of columns of the grid to arrange individual images.
#' @param nrows number of rows of the grid to arrange individual images.
#' @param scales one of \code{"free"}, \code{"fixed"}, \code{"free_x"} or 
#' \code{"free_y"} indicating if x- and y-axis ranges should be fixed across
#' all images. Defaults to "fixed" to match physical units on the x- and y-axis.
#' @param flip_x flip the x-axis?
#' @param flip_y flip the y-axis?
#' @param aspect_ratio single numeric, "auto" or NULL to define the relative
#' ratio between the physical units of the x and y axis. If \code{"auto"}
#' (default), the physical units match between the x and y axis if
#' \code{scales = "fixed"}. If \code{scales = "free"}, the default aspect
#' ratio is set to 1. Ignore setting the aspect ratio with \code{aspect_ratio
#' = NULL}.
#' 
#' @return returns a \code{ggplot} object.
#' 
#' @section Visualizing cell locations and cell-cell interactions: 
#' By default, the cells' locations are visualized in form of points (here also
#' referred to as "nodes") on a 2-dimensional plane. The cells' coordinates are
#' extracted either from \code{colData(object)} slot (for a
#' \code{SingleCellExperiment} input object) or from the
#' \code{spatialCoords(object)} slot (for a \code{SpatialExperiment} input
#' object). Node aesthetics are controlled by setting \code{node_color_by}, 
#' \code{node_shape_by} and \code{node_size_by} for associating the aesthetics
#' with variables. If node aesthetics should be the same for all nodes,  
#' \code{node_color_fix}, \code{node_shape_fix} and \code{node_size_fix} can 
#' be set.
#' 
#' When \code{draw_edges = TRUE}, cell-cell interactions are visualized in form
#' of edges between nodes. For this, \code{object} needs to contain 
#' column pairings in \code{colPair(object, colPairName)}. Edge color and size
#' can be set by specifying either an entry in 
#' \code{mcols(colPair(object, colPairName))} (edge attributes) or in 
#' \code{colData(object)}. In the latter case, edges are colored by attributes 
#' associated to the "from" node. Variable aesthetics can be set using 
#' \code{edge_color_by} and \code{edge_width_by}. If all edges should have 
#' the same width or color, \code{edge_color_fix} and \code{edge_width_fix}
#' can be set.
#' 
#' Arrows for displaying directed graphs can be drawn by supplying a 
#' \code{\link[grid]{arrow}} object. Arrow attributes can be set within this 
#' class. To cap the edge before it reaches the next node, the \code{end_cap}
#' parameter can be used. 
#' 
#' @examples
#' library(cytomapper)
#' data(pancreasSCE)
#' 
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                          type = "knn", k = 3, directed = FALSE)
#'
#' # Only nodes
#' plotSpatial(sce, img_id = "ImageNb",
#'             node_color_by = "CellType",
#'             node_shape_by = "ImageNb",
#'             node_size_by = "Area",
#'             scales = "free")
#'   
#' # With edges and nodes colored by expression
#' plotSpatial(sce, img_id = "ImageNb",
#'             node_color_by = "PIN",
#'             assay_type = "exprs",
#'             node_shape_by = "ImageNb",
#'             node_size_by = "Area",
#'             draw_edges = TRUE,
#'             colPairName = "knn_interaction_graph",
#'             edge_color_by = "Pattern",
#'             scales = "free")
#'             
#' # With arrows
#' plotSpatial(sce, img_id = "ImageNb",
#'             node_color_by = "CellType",
#'             node_shape_by = "ImageNb",
#'             node_size_by = "Area",
#'             draw_edges = TRUE,
#'             colPairName = "knn_interaction_graph",
#'             edge_color_fix = "green",
#'             arrow = grid::arrow(length = grid::unit(0.1, "inch")),
#'             end_cap = ggraph::circle(0.2, "cm"),
#'             scales = "free")
#'   
#' @seealso 
#' \code{\link{buildSpatialGraph}} for constructing interaction graphs
#' 
#' \code{\link{ggraph}} for handling graph aesthetics
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @import ggraph
#' @importFrom tidygraph tbl_graph  
#' @importFrom ggplot2 theme element_text element_blank scale_color_manual
#' scale_size_manual scale_shape_manual aes
#' @importFrom rlang .data
#' @export
plotSpatial <- function(object,
                        img_id,
                        coords = c("Pos_X", "Pos_Y"),
                        node_color_by = NULL,
                        node_shape_by = NULL,
                        node_size_by = NULL,
                        node_color_fix = NULL,
                        node_shape_fix = NULL,
                        node_size_fix = NULL,
                        assay_type = NULL,
                        draw_edges = FALSE,
                        directed = TRUE,
                        edge_color_by = NULL,
                        edge_width_by = NULL,
                        edge_color_fix = NULL,
                        edge_width_fix = NULL,
                        arrow = NULL,
                        end_cap = NULL,
                        colPairName = NULL,
                        nodes_first = TRUE,
                        ncols = NULL,
                        nrows = NULL,
                        scales = "fixed",
                        flip_x = FALSE,
                        flip_y = TRUE,
                        aspect_ratio = "auto"){
    
    .valid.plotSpatial.input(object, img_id, coords, node_color_by, 
                             node_shape_by, node_size_by, edge_color_by,
                             assay_type, edge_width_by, draw_edges, directed, 
                             arrow, end_cap, colPairName, nodes_first,
                             ncols, nrows, scales, flip_x, flip_y, aspect_ratio)
    
    nodes <- .makeNodes(object, node_color_by, img_id, node_shape_by,
                        node_size_by, assay_type)
    
    cur_graph <- .generateGraph(object, nodes, colPairName, draw_edges, 
                                edge_color_by, edge_width_by, directed)
    
    if (is(object, "SpatialExperiment")) {
        layout <- create_layout(cur_graph, layout = "manual",
                                x = spatialCoords(object)[,coords[1]],
                                y = spatialCoords(object)[,coords[2]])
    } else {
        layout <- create_layout(cur_graph, layout = "manual",
                                x = colData(object)[[coords[1]]],
                                y = colData(object)[[coords[2]]])
    }
    
    # Define column and row number
    if (is.null(ncols) && is.null(nrows)) {
        ni <- length(unique(colData(object)[[img_id]]))
        ncols <- ceiling(sqrt(ni))
        nrows <- ceiling(ncols)
    }
    
    p <- .generatePlot(layout, draw_edges, directed, arrow, end_cap, 
                       node_color_by, node_size_by, node_shape_by, 
                       node_color_fix, node_size_fix, node_shape_fix, 
                       edge_color_by, edge_width_by, edge_color_fix, 
                       edge_width_fix, nodes_first)
    
    p <- .postProcessPlot(p, object, img_id, nrows, ncols, node_color_by, 
                          node_color_fix,
                          node_shape_fix, node_size_fix, edge_color_fix, 
                          edge_width_fix, scales, flip_x, flip_y, aspect_ratio)
        
    return(p)
}

test_that("findBorderCells function works", {
    path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
    spe <- read_steinbock(path)

    spe  <- findBorderCells(spe, img_id = "sample_id", border_dist = 10)
    
    plotSpatial(spe, img_id = "sample_id", node_color_by = "border_cells")
    
    cur_ind <- unique(spe$sample_id)
    
    out <- lapply(cur_ind, function(x){
        cur_obj <- spe[,spe$sample_id == x]
        min_x <- min(spatialCoords(cur_obj)[,"Pos_X"])
        max_x <- max(spatialCoords(cur_obj)[,"Pos_X"])
        min_y <- min(spatialCoords(cur_obj)[,"Pos_Y"])
        max_y <- max(spatialCoords(cur_obj)[,"Pos_Y"])
        cur_x <- spatialCoords(cur_obj)[,"Pos_X"]
        cur_y <- spatialCoords(cur_obj)[,"Pos_Y"]
        cur_cells <- cur_x <= min_x + 10 | cur_x >= max_x - 10 |
            cur_y <= min_y + 10 | cur_y >= max_y - 10
        cur_obj$border_cells <- cur_cells
        return(cur_obj)
    })
    
    out <- do.call("cbind", out)
    
    expect_equal(spe$border_cells, out$border_cells, check.attributes = FALSE)
    
    spe  <- findBorderCells(spe, img_id = "sample_id", border_dist = 5)
    
    plotSpatial(spe, img_id = "sample_id", node_color_by = "border_cells")
    
    cur_ind <- unique(spe$sample_id)
    
    out <- lapply(cur_ind, function(x){
        cur_obj <- spe[,spe$sample_id == x]
        min_x <- min(spatialCoords(cur_obj)[,"Pos_X"])
        max_x <- max(spatialCoords(cur_obj)[,"Pos_X"])
        min_y <- min(spatialCoords(cur_obj)[,"Pos_Y"])
        max_y <- max(spatialCoords(cur_obj)[,"Pos_Y"])
        cur_x <- spatialCoords(cur_obj)[,"Pos_X"]
        cur_y <- spatialCoords(cur_obj)[,"Pos_Y"]
        cur_cells <- cur_x <= min_x + 5 | cur_x >= max_x - 5 |
            cur_y <= min_y + 5 | cur_y >= max_y - 5
        cur_obj$border_cells <- cur_cells
        return(cur_obj)
    })
    
    out <- do.call("cbind", out)
    
    expect_equal(spe$border_cells, out$border_cells, check.attributes = FALSE)
    
    path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
    sce <- read_steinbock(path, return_as = "sce")
    
    sce  <- findBorderCells(sce, img_id = "sample_id", border_dist = 10)
    
    plotSpatial(sce, img_id = "sample_id", node_color_by = "border_cells")
    
    cur_ind <- unique(sce$sample_id)
    
    out <- lapply(cur_ind, function(x){
        cur_obj <- sce[,sce$sample_id == x]
        min_x <- min(colData(cur_obj)[,"Pos_X"])
        max_x <- max(colData(cur_obj)[,"Pos_X"])
        min_y <- min(colData(cur_obj)[,"Pos_Y"])
        max_y <- max(colData(cur_obj)[,"Pos_Y"])
        cur_x <- colData(cur_obj)[,"Pos_X"]
        cur_y <- colData(cur_obj)[,"Pos_Y"]
        cur_cells <- cur_x <= min_x + 10 | cur_x >= max_x - 10 |
            cur_y <= min_y + 10 | cur_y >= max_y - 10
        cur_obj$border_cells <- cur_cells
        return(cur_obj)
    })
    
    out <- do.call("cbind", out)
    
    expect_equal(sce$border_cells, out$border_cells, check.attributes = FALSE)
    
    sce  <- findBorderCells(sce, img_id = "sample_id", border_dist = 5)
    
    plotSpatial(sce, img_id = "sample_id", node_color_by = "border_cells")
    
    cur_ind <- unique(sce$sample_id)
    
    out <- lapply(cur_ind, function(x){
        cur_obj <- sce[,sce$sample_id == x]
        min_x <- min(colData(cur_obj)[,"Pos_X"])
        max_x <- max(colData(cur_obj)[,"Pos_X"])
        min_y <- min(colData(cur_obj)[,"Pos_Y"])
        max_y <- max(colData(cur_obj)[,"Pos_Y"])
        cur_x <- colData(cur_obj)[,"Pos_X"]
        cur_y <- colData(cur_obj)[,"Pos_Y"]
        cur_cells <- cur_x <= min_x + 5 | cur_x >= max_x - 5 |
            cur_y <= min_y + 5 | cur_y >= max_y - 5
        cur_obj$border_cells <- cur_cells
        return(cur_obj)
    })
    
    out <- do.call("cbind", out)
    
    expect_equal(sce$border_cells, out$border_cells, check.attributes = FALSE)
    
    # SingleCellExperiment
    library(cytomapper)
    data(pancreasSCE)
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)

    expect_silent(pancreasSCE  <- findBorderCells(pancreasSCE, img_id = "ImageNb", border_dist = 10))
    plotSpatial(pancreasSCE, img_id = "ImageNb", node_color_by = "border_cells")
    
    # Error
    expect_error(findBorderCells("test"), 
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(findBorderCells(sce, img_id = c(1,2)), 
                 regexp = "'img_id' must be a single string.",
                 fixed = TRUE)
    expect_error(findBorderCells(sce, img_id = "test"), 
                 regexp = "'img_id' not in colData(object).",
                 fixed = TRUE)
    expect_error(findBorderCells(sce, img_id = "sample_id", coords = "test"), 
                 regexp = "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(findBorderCells(sce, img_id = "sample_id", coords = c("Pos_x", "Pos_Y")), 
                 regexp = "'coords' not in colData(object).",
                 fixed = TRUE)
    expect_error(findBorderCells(spe, img_id = "sample_id", coords = c("Pos_x", "Pos_Y")), 
                 regexp = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    expect_error(findBorderCells(spe, img_id = "sample_id", border_dist = "test"), 
                 regexp = "'border_dist' must be a single numeric.",
                 fixed = TRUE)
    expect_error(findBorderCells(spe, img_id = "sample_id", border_dist = c(1,2)), 
                 regexp = "'border_dist' must be a single numeric.",
                 fixed = TRUE)
})

test_that("findBorderCells function works if cells are not ordered by image", {
    # SingleCellExperiment
    library(cytomapper)
    data(pancreasSCE)
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    expect_silent(pancreasSCE  <- findBorderCells(pancreasSCE, img_id = "ImageNb", border_dist = 10))
    plotSpatial(pancreasSCE, img_id = "ImageNb", node_color_by = "border_cells")
    
    set.seed(123)
    sce2 <- pancreasSCE[,sample(ncol(pancreasSCE))]
    
    expect_silent(sce2  <- findBorderCells(sce2, img_id = "ImageNb", border_dist = 10))
    plotSpatial(sce2, img_id = "ImageNb", node_color_by = "border_cells")
    
    expect_equal(pancreasSCE$border_cells, sce2[,colnames(pancreasSCE)]$border_cells)

    })

test_that("buildSpatialGraph function works", {
    library(cytomapper)
    data("pancreasSCE")
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    # Delauney
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "delaunay"),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "delaunay_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 2082)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                colPairName = "delaunay_interaction_graph")
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4))
    expect_equal(to(colPair(cur_sce))[10:20], c(6, 11, 13, 50,  4,  6, 10, 12,  1,  2,  3))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "delaunay", directed = FALSE)
    expect_equal(length(colPair(cur_sce)), 2082)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                              colPairName = "delaunay_interaction_graph")
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4))
    expect_equal(to(colPair(cur_sce))[10:20], c(6, 11, 13, 50,  4,  6, 10, 12,  1,  2,  3))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    # Max dist
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "delaunay", max_dist = 20),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "delaunay_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 1956)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "delaunay_interaction_graph")
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(3L, 4L, 4L, 4L, 4L, 5L, 5L, 5L, 5L, 5L, 5L))
    expect_equal(to(colPair(cur_sce))[10:20], c(12L, 3L, 7L, 8L, 10L, 2L, 9L, 13L, 14L, 19L, 24L))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    # KNN
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 5),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 1810)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                              colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                              colPairName = "knn_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4))
    expect_equal(to(colPair(cur_sce))[10:20], c(22,  4,  6, 10, 12, 17,  3,  7,  8, 10, 16))
    
    cur_ks <- table(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_ks <- rowSums(cur_ks)
    expect_true(all(cur_ks == 5))
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 5, directed = FALSE),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 2068)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4))
    expect_equal(to(colPair(cur_sce))[10:20], c(22,  4,  6, 10, 12, 17,  3,  7,  8, 10, 16))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    # Other ks
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 10),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 3620)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    
    cur_ks <- table(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_ks <- rowSums(cur_ks)
    expect_true(all(cur_ks == 10))
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){which(x == 1)})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 10, directed = FALSE),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 4124)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:11])})
    cur_ind_real <- graph_from_adj_list(as.list(as.data.frame(cur_ind_real)))
    cur_ind_real <- as.undirected(cur_ind_real)
    cur_ind_real <- as.directed(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    # Other algorithm
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 10),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_message(cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 10, name = "vptree",
                                 BNPARAM = BiocNeighbors::VptreeParam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_message(cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 10, name = "annoy",
                                 BNPARAM = BiocNeighbors::AnnoyParam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_message(cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 10, name = "hnsw",
                                 BNPARAM = BiocNeighbors::HnswParam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    
    expect_equal(colPairNames(cur_sce), 
                 c("knn_interaction_graph", "vptree", "annoy", "hnsw"))
    expect_equal(colPair(cur_sce, "knn_interaction_graph"),
                 colPair(cur_sce, "vptree"))
    
    # Max dist
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "knn", k = 5, max_dist = 10),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 711)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "knn_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(9, 9, 10, 10, 11, 12, 12, 12, 13, 13, 13))
    expect_equal(to(colPair(cur_sce))[10:20], c(6, 14,  4,  7, 13,  3, 17, 18,  5, 11, 19))
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_dist_real <- apply(as.matrix(cur_dist), 1, function(x){x[sort(order(x)[2:6])]})
    cur_ind_real <- lapply(1:ncol(cur_ind_real), function(x){
        cur_ind_real[cur_dist_real[,x] <= 10,x]
    })
    cur_ind_real <- cur_ind_real[lapply(cur_ind_real, length) > 0]
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){as.numeric(names(which(x == 1)))})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_dist_real <- apply(as.matrix(cur_dist), 1, function(x){x[sort(order(x)[2:6])]})
    cur_ind_real <- lapply(1:ncol(cur_ind_real), function(x){
        cur_ind_real[cur_dist_real[,x] <= 10,x]
    })
    cur_ind_real <- cur_ind_real[lapply(cur_ind_real, length) > 0]
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){as.numeric(names(which(x == 1)))})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
   
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){sort(order(x)[2:6])})
    cur_dist_real <- apply(as.matrix(cur_dist), 1, function(x){x[sort(order(x)[2:6])]})
    cur_ind_real <- lapply(1:ncol(cur_ind_real), function(x){
        cur_ind_real[cur_dist_real[,x] <= 10,x]
    })
    cur_ind_real <- cur_ind_real[lapply(cur_ind_real, length) > 0]
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    cur_ind_test <- apply(cur_ind_test, 1, function(x){as.numeric(names(which(x == 1)))})
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    # Expansion
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "expansion", threshold = 15),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "expansion_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 2042)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6))
    expect_equal(to(colPair(cur_sce))[10:20], c(3, 7,  8, 10,  2, 11, 13, 19,  3,  9, 12))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "expansion", threshold = 15, directed = FALSE),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "expansion_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 2042)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    expect_equal(from(colPair(cur_sce))[10:20], c(4, 4, 4, 4, 5, 5, 5, 5, 6, 6, 6))
    expect_equal(to(colPair(cur_sce))[10:20], c(3, 7,  8, 10,  2, 11, 13, 19,  3,  9, 12))
    
    cur_edges_1 <- paste(from(colPair(cur_sce)), to(colPair(cur_sce)))
    cur_edges_2 <- paste(to(colPair(cur_sce)), from(colPair(cur_sce)))
    
    expect_equal(sort(cur_edges_1), sort(cur_edges_2))
    
    expect_equal(sum(isRedundantHit(colPair(cur_sce))), length(colPair(cur_sce))/2)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 1]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){which(x <= 15)})
    cur_ind_real <- graph_from_adj_list(cur_ind_real)
    cur_ind_real <- simplify(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 2]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){which(x <= 15)})
    cur_ind_real <- graph_from_adj_list(cur_ind_real)
    cur_ind_real <- simplify(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    cur_sce_1 <- cur_sce[,cur_sce$ImageNb == 3]
    
    cur_dist <- dist(as.matrix(colData(cur_sce_1)[,c("Pos_X", "Pos_Y")]))
    cur_ind_real <- apply(as.matrix(cur_dist), 1, function(x){which(x <= 15)})
    cur_ind_real <- graph_from_adj_list(cur_ind_real)
    cur_ind_real <- simplify(cur_ind_real)
    cur_ind_real <- as_edgelist(cur_ind_real)
    cur_ind_real <- table(cur_ind_real[,1], cur_ind_real[,2])
    cur_ind_test <- table(from(colPair(cur_sce_1)), to(colPair(cur_sce_1)))
    
    expect_equal(cur_ind_real, cur_ind_test, check.attributes = FALSE)
    
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "expansion", threshold = 1),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "expansion_interaction_graph")
    expect_true(!is.null(colPair(cur_sce)))
    expect_equal(length(colPair(cur_sce)), 0)
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph")
    expect_silent(print(p))
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                     colPairName = "expansion_interaction_graph", 
                     directed = FALSE)
    expect_silent(print(p))
    
    # SpatialExperiment
    library(SpatialExperiment)
    pancreasSPE <- SpatialExperiment(assays = list(counts = counts(pancreasSCE)),
                                 sample_id = pancreasSCE$ImageName) 
    colData(pancreasSPE) <- colData(pancreasSCE)
    colData(pancreasSPE)[,c("Pos_X", "Pos_Y")] <- NULL
    colPairs(pancreasSPE) <- colPairs(pancreasSCE)
    
    expect_error(cur_sce <- buildSpatialGraph(pancreasSPE, img_id = "ImageNb", 
                                               type = "expansion", threshold = 15),
                 regexp = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    
    spatialCoords(pancreasSPE) <- as.matrix(colData(pancreasSCE)[,c("Pos_X", "Pos_Y")])
    
    expect_message(cur_spe <- buildSpatialGraph(pancreasSPE, img_id = "ImageNb", 
                                               type = "expansion", threshold = 15),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    
    expect_equal(colPairNames(cur_spe), "expansion_interaction_graph")
    expect_message(cur_spe <- buildSpatialGraph(pancreasSPE, img_id = "ImageNb", 
                                               type = "delaunay"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_spe), "delaunay_interaction_graph")
    expect_message(cur_spe <- buildSpatialGraph(pancreasSPE, img_id = "ImageNb", 
                                               type = "knn", k = 5),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_spe), "knn_interaction_graph")
    
    # Check that metadata is not duplicated
    cur_sce <- pancreasSCE
    metadata(cur_sce) <- list(test = c(1,2))
    
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 5)
    
    expect_equal(length(metadata(cur_sce)), 1)
    expect_equal(metadata(cur_sce), list(test = c(1, 2)))
    
    int_metadata(cur_sce) <- list(version = "1.16.0")
    
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 5)
    
    expect_equal(length(int_metadata(cur_sce)), 1)
    expect_equal(int_metadata(cur_sce), list(version = "1.16.0"))
    
    # Fail
    expect_error(buildSpatialGraph("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE),
                 regexp = "argument \"img_id\" is missing, with no default",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = 1),
                 regexp = "'img_id' must be a single string.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "test"),
                 regexp = "'img_id' not in colData(object).",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "expansion"),
                 regexp = "When constructing a graph via expansion, please specify 'threshold'.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "expansion"),
                 regexp = "When constructing a graph via expansion, please specify 'threshold'.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "expansion",
                                   threshold = "test"),
                 regexp = "'threshold' must be a single numeric",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn"),
                 regexp = "When constructing a graph via nearest neighbour detection, please specify 'k'.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                   k = "test"),
                 regexp = "'k' must be a single numeric",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                   k = 10, max_dist = "test"),
                 regexp = "'max_dist' must be a single numeric",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "delaunay",
                                   coords = "test"),
                 regexp = "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "delaunay",
                                   coords = c(2, 1)),
                 regexp = "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "delaunay",
                                   coords = c("Pos_X", "test")),
                 regexp = "'coords' not in colData(object).",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSPE, img_id = "ImageNb", type = "delaunay",
                                   coords = c("Pos_X", "test")),
                 regexp = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "delaunay",
                                   name = 1),
                 regexp = "'name' must be a single string.",
                 fixed = TRUE)
    expect_error(buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "delaunay",
                                   directed = 1),
                 regexp = "'directed' must be a single logical.",
                 fixed = TRUE)
})

test_that("buildSpatialGraph function works", {
    
    skip_on_os(os = "windows")
    
    library(cytomapper)
    data("pancreasSCE")
    
    # Parallelisation
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "expansion", threshold = 15,
                                               BPPARAM = BiocParallel::bpparam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "expansion_interaction_graph")
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "delaunay",
                                               BPPARAM = BiocParallel::bpparam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "delaunay_interaction_graph")
    expect_message(cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                               type = "knn", k = 5,
                                               BPPARAM = BiocParallel::bpparam()),
                  regexp = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(colPairNames(cur_sce), "knn_interaction_graph")
    
})

test_that("plotSpatial function works", {
    library(cytomapper)
    library(ggraph)
    data("pancreasSCE")
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    cur_sce <- pancreasSCE

    # SingleCellExperiment
    expect_silent(p <- plotSpatial(cur_sce, img_id = "ImageNb"))
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$CellType, pancreasSCE$CellType)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Area, pancreasSCE$Area)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "Pattern")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Pattern, pancreasSCE$Pattern)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "PIN", assay_type = "counts")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$PIN, counts(pancreasSCE)["PIN",], check.attributes = FALSE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "PIN", assay_type = "exprs")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$PIN, assay(pancreasSCE, "exprs")["PIN",], check.attributes = FALSE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CDH", assay_type = "exprs")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$CDH, assay(pancreasSCE, "exprs")["CDH",], check.attributes = FALSE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_shape_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$CellType, pancreasSCE$CellType)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_shape_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_warning(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Area, as.character(pancreasSCE$Area))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_shape_by = "Pattern")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Pattern, as.character(pancreasSCE$Pattern))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_size_by = "CellType")
    expect_s3_class(p, "ggraph")
    #expect_warning(print(p), regexp = "Using size for a discrete variable is not advised.")
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$CellType, pancreasSCE$CellType)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_size_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Area, pancreasSCE$Area)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_size_by = "Pattern")
    expect_s3_class(p, "ggraph")
    #expect_warning(print(p), regexp = "Using size for a discrete variable is not advised.")
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Pattern, pancreasSCE$Pattern)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType",
                     node_shape_by = "Pattern", node_size_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    expect_equal(p$data$Pattern, as.character(pancreasSCE$Pattern))
    expect_equal(p$data$CellType, pancreasSCE$CellType)
    expect_equal(p$data$Area, pancreasSCE$Area)
    
    cur_sce <- pancreasSCE
    cur_sce$ImageNb <- as.factor(cur_sce$ImageNb) 
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    cur_sce <- pancreasSCE
    cur_sce$ImageNb <- as.numeric(cur_sce$ImageNb) 
    p <- plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType",
                     node_color_fix = "red")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName",
                     node_color_fix = "red")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName",
                     node_color_fix = 1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_shape_by = "ImageNb",
                     node_shape_fix = "+")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName",
                     node_shape_fix = "+")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_shape_by = "ImageNb",
                     node_shape_fix = 21)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName",
                     node_shape_fix = 21)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_size_by = "Area",
                     node_size_fix = 5)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName",
                     node_size_fix = 5)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    cur_sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 3)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    expect_equal(p$data$x, pancreasSCE$Pos_X)
    expect_equal(p$data$y, pancreasSCE$Pos_Y)
    expect_equal(p$data$ImageNb, pancreasSCE$ImageNb)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType", node_color_by = "PIN",
                     assay_type = "exprs", node_size_fix = 5)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "Pattern", node_color_by = "Pattern")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "Pattern", node_color_by = "Pattern",
                     nodes_first = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "Area", node_color_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "CellType")
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "Pattern")
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "Area")
    expect_s3_class(p, "ggraph")
    
    mcols(colPair(cur_sce, "knn_interaction_graph"))$test <- runif(length(colPair(cur_sce, "knn_interaction_graph")))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "test")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    mcols(colPair(cur_sce, "knn_interaction_graph"))$test_2 <- letters[sample(x = 1:10,
                                            size = length(colPair(cur_sce, "knn_interaction_graph")),
                                            replace = TRUE)]
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "test_2")
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType",
                     edge_color_fix = "red")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_fix = "red")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_fix = 0.1, edge_width_by = "Area")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_fix = 0.1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p2 <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     directed = FALSE)
    expect_s3_class(p2, "ggraph")
    expect_silent(print(p2))
    expect_equal(p2$data$x, pancreasSCE$Pos_X)
    expect_equal(p2$data$y, pancreasSCE$Pos_Y)
    expect_equal(p2$data$ImageNb, pancreasSCE$ImageNb)
    
    cur_graph <- igraph::as.igraph(attributes(p$data)$graph)
    cur_graph <- igraph::as.undirected(cur_graph)
    cur_graph_2 <- igraph::as.igraph(attributes(p2$data)$graph)
    
    cur_edges <- igraph::as_edgelist(cur_graph)
    cur_edges_2 <- igraph::as_edgelist(cur_graph_2)

    cur_edges <- cur_edges[order(paste(cur_edges[,1], cur_edges[,2])),]
    cur_edges_2 <- cur_edges_2[order(paste(cur_edges_2[,1], cur_edges_2[,2])),]
    
    expect_equal(cur_edges, cur_edges_2)
    
    # Delaunay
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "delaunay")
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "delaunay_interaction_graph",
                     edge_width_fix = 0.1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p2 <- plotSpatial(cur_sce, img_id = "ImageNb", 
                      draw_edges = TRUE, colPairName = "delaunay_interaction_graph",
                      directed = FALSE)
    expect_s3_class(p2, "ggraph")
    expect_silent(print(p2))
    expect_equal(p2$data$x, pancreasSCE$Pos_X)
    expect_equal(p2$data$y, pancreasSCE$Pos_Y)
    expect_equal(p2$data$ImageNb, pancreasSCE$ImageNb)
    
    cur_graph <- igraph::as.igraph(attributes(p$data)$graph)
    cur_graph <- igraph::as.undirected(cur_graph)
    cur_graph_2 <- igraph::as.igraph(attributes(p2$data)$graph)
    
    cur_edges <- igraph::as_edgelist(cur_graph)
    cur_edges_2 <- igraph::as_edgelist(cur_graph_2)
    
    cur_edges <- cur_edges[order(paste(cur_edges[,1], cur_edges[,2])),]
    cur_edges_2 <- cur_edges_2[order(paste(cur_edges_2[,1], cur_edges_2[,2])),]
    
    expect_equal(cur_edges, cur_edges_2)
    
    # Expansion
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "expansion", threshold = 15)
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "expansion_interaction_graph",
                     edge_width_fix = 0.1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p2 <- plotSpatial(cur_sce, img_id = "ImageNb", 
                      draw_edges = TRUE, colPairName = "expansion_interaction_graph",
                      directed = FALSE)
    expect_s3_class(p2, "ggraph")
    expect_silent(print(p2))
    expect_equal(p2$data$x, pancreasSCE$Pos_X)
    expect_equal(p2$data$y, pancreasSCE$Pos_Y)
    expect_equal(p2$data$ImageNb, pancreasSCE$ImageNb)
    
    cur_graph <- igraph::as.igraph(attributes(p$data)$graph)
    cur_graph <- igraph::as.undirected(cur_graph)
    cur_graph_2 <- igraph::as.igraph(attributes(p2$data)$graph)
    
    cur_edges <- igraph::as_edgelist(cur_graph)
    cur_edges_2 <- igraph::as_edgelist(cur_graph_2)
    
    cur_edges <- cur_edges[order(paste(cur_edges[,1], cur_edges[,2])),]
    cur_edges_2 <- cur_edges_2[order(paste(cur_edges_2[,1], cur_edges_2[,2])),]
    
    expect_equal(cur_edges, cur_edges_2)
    
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType", node_color_by = "CellType",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "Pattern", node_color_by = "Pattern",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "Area", node_color_by = "Area",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "CellType",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "Pattern",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "Area",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "test",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))

    p <- plotSpatial(cur_sce, img_id = "ImageNb", 
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "test_2",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_by = "CellType",
                     edge_color_fix = "red",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_fix = "red",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_fix = 0.1, edge_width_by = "Area",
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_fix = 0.1,
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_width_by = "CellType", edge_color_by = "Area", node_color_by = "CellType",
                     node_shape_by = "ImageNb", node_size_by = "Area",
                     directed = TRUE)
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     arrow = arrow(),
                     directed = TRUE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.1, "inch"), type = "closed"),
                     directed = TRUE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.1, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = TRUE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.1, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType",
                     flip_y = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType",
                     flip_x = TRUE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType",
                     flip_x = TRUE, flip_y = FALSE)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageName", node_color_by = "CellType",
                     aspect_ratio = 2)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    # making one image smaller
    cur_sce_2 <- cur_sce[,cur_sce$ImageNb == "1"]
    cur_sce_2 <- cur_sce_2[,cur_sce_2$Pos_X > 30 & cur_sce_2$Pos_Y > 50]
    
    cur_sce_3 <- cur_sce[,cur_sce$ImageNb == "2"]
    cur_sce_3 <- cur_sce_3[,cur_sce_3$Pos_X > 30 & cur_sce_3$Pos_Y > 70]
    
    cur_sce_4 <- cbind(cur_sce_2, cur_sce_3, cur_sce[,cur_sce$ImageNb == "3"])
    
    p <- plotSpatial(cur_sce_4, img_id = "ImageName", node_color_by = "CellType")
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    # Testing the aspect_ratio
    cur_sce_5 <- cur_sce_4[,cur_sce_4$ImageNb == 1 | cur_sce_4$ImageNb == 2]
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", aspect_ratio = NULL)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", scales = "free")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", scales = "free", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType", scales = "free")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType", scales = "free", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_3, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph", aspect_ratio = 2)
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph", aspect_ratio = 2, scales = "free")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph", scales = "free")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce_5, img_id = "ImageName", node_color_by = "CellType", draw_edges = TRUE, colPairName = "knn_interaction_graph", scales = "free", aspect_ratio = NULL)
    expect_silent(print(p))
    
    ## Subsetting
    cur_sce2 <- cur_sce[,cur_sce$Pattern]
    
    p <- plotSpatial(cur_sce2, img_id = "ImageNb", draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.05, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = TRUE, scales = "fixed", node_size_fix = 0.1, edge_width_fix = 0.5)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce2, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph", edge_width_by = "CellType", 
                     edge_color_by = "Area", node_color_by = "CellType",
                     node_shape_by = "ImageNb", node_size_by = "Area",)
    expect_s3_class(p, "ggraph")
    
    p <- plotSpatial(cur_sce2[,cur_sce2$ImageNb == 2], img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.05, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = TRUE, scales = "fixed", node_size_fix = 0.1, 
                     edge_width_fix = 0.5)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.05, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = TRUE, scales = "free", nrow = 1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph",
                     arrow = arrow(angle = 10, length = unit(0.05, "inch"), type = "closed"),
                     end_cap = circle(0.3, "cm"),
                     directed = TRUE, scales = "free", ncol = 1)
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))

    ## Modify plots
    p <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph", node_color_by = "CellType",
                     node_shape_by = "ImageName", node_size_by = "Area", edge_color_by = "Pattern",
                     edge_width_by = "Area") + 
        scale_edge_color_brewer(palette = "Set1") +
        scale_color_manual(values = c(celltype_A = "yellow",
                                      celltype_C = "green",
                                      celltype_B = "dark blue")) +
        scale_shape_manual(values = c(E34_imc.tiff = 10,
                                      G01_imc.tiff = 12,
                                      J02_imc.tiff = 14)) +
        scale_edge_width(range = c(0.1,2)) +
        scale_size(range = c(4, 12))
    expect_s3_class(p, "ggraph")
    expect_silent(print(p))
    
    # SpatialExperiment
    library(SpatialExperiment)
    cur_spe <- SpatialExperiment(assays = list(counts = counts(cur_sce)),
                                 sample_id = cur_sce$ImageName) 
    colData(cur_spe) <- colData(cur_sce)
    colData(cur_spe)[,c("Pos_X", "Pos_Y")] <- NULL
    colPairs(cur_spe) <- colPairs(cur_sce)
    
    # Error
    expect_error(p <- plotSpatial(cur_spe, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph", node_color_by = "CellType",
                     node_shape_by = "ImageName", node_size_by = "Area", edge_color_by = "Pattern",
                     edge_width_by = "Area"), regex = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    
    spatialCoords(cur_spe) <- as.matrix(colData(cur_sce)[,c("Pos_X", "Pos_Y")])
    p1 <- plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE, 
                      colPairName = "knn_interaction_graph", node_color_by = "CellType",
                      node_shape_by = "ImageName", node_size_by = "Area", edge_color_by = "Pattern",
                      edge_width_by = "Area")
    p2 <- plotSpatial(cur_spe, img_id = "ImageNb", draw_edges = TRUE, 
                     colPairName = "knn_interaction_graph", node_color_by = "CellType",
                     node_shape_by = "ImageName", node_size_by = "Area", edge_color_by = "Pattern",
                     edge_width_by = "Area")
    expect_s3_class(p2, "ggraph")
    expect_silent(print(p2))
    expect_equal(p$data, p2$data, check.attributes = FALSE)
    expect_equal(p$layers, p2$layers, check.attributes = FALSE)
    expect_equal(p$mapping, p2$mapping, check.attributes = FALSE)
    expect_equal(p$theme, p2$theme, check.attributes = FALSE)
    expect_equal(p$coordinates, p2$coordinates, check.attributes = FALSE)
    expect_equal(p$plot_env, p2$plot_env, check.attributes = FALSE)
    expect_equal(p$labels, p2$labels, check.attributes = FALSE)
    
    # Fail
    expect_error(plotSpatial("test"), "'object' not of type 'SingleCellExperiment'.")
    expect_error(plotSpatial(cur_sce), 'argument "img_id" is missing, with no default')
    expect_error(plotSpatial(cur_sce, img_id = "test"), "'img_id' not in colData(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = 1), "'img_id' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", coords = 1), 
                 "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", coords = c(1, 2)), 
                 "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", coords = c("Pos_X", "test")), 
                 "'coords' not in colData(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_spe, img_id = "ImageNb", coords = c("Pos_X", "test")), 
                 "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = 1), 
                 "'node_color_by' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = c("test", "test2")), 
                 "'node_color_by' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "test"), 
                 "'node_color_by' not in colData(object) or rownames(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "PIN"), 
                 "When coloring nodes by marker expression, please specify 'assay_type'.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "PIN", assay_type = 1), 
                 "'assay_type' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "PIN", assay_type = "test"), 
                 "'assay_type' not an assay in object.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_shape_by = c("test", "test2")), 
                 "'node_shape_by' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_shape_by = "test"), 
                 "'node_shape_by' not in colData(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_size_by = c("test", "test2")), 
                 "'node_size_by' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", node_size_by = "test"), 
                 "'node_size_by' not in colData(object).",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = "test"), 
                 "'draw_edges' must be a single logical",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = c("test", "test2")), 
                 "'draw_edges' must be a single logical",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE), 
                 "Please specify the name of the column pairing via 'colPairName'.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "test"), 
                 "No column pairing with name test found.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = 1), 
                 "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = c("test", "test2")), 
                 "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             edge_color_by = "test2"), 
                 "'edge_color_by' not in 'colData(object)' or in 'mcols(colPair(object, colPairName))'.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             edge_color_by = c("test", "test2")), 
                 "'edge_color_by' must be a single string.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             edge_width_by = "test2"), 
                 "'edge_width_by' not in 'colData(object)' or in 'mcols(colPair(object, colPairName))'.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             edge_width_by = c("test", "test2")), 
                 "'edge_width_by' must be a single string.",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             directed = "test"), 
                 "'directed' must be a single logical",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             arrow = "test"), 
                 "'arrow' must be of class grid::arrow.",
                 fixed = TRUE)
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb", draw_edges = TRUE,
                             colPairName = "knn_interaction_graph",
                             arrow = grid::arrow(),
                             end_cap = "test"), 
                 "'end_cap' must be of type 'ggraph_geometry'.",
                 fixed = TRUE)

    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             nodes_first = "test"), 
                 "'nodes_first' must be a single logical",
                 fixed = TRUE)
        
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             ncols = "test"), 
                 "'ncols' must be a single numeric",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             nrows = "test"), 
                 "'nrows' must be a single numeric",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             scales = "test"), 
                 "'scales' should be one of 'fixed', 'free_x', 'free_y', 'free'.",
                 fixed = TRUE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb",
                     node_color_fix = "test")
    
    expect_error(print(p), 
                 "Unknown colour name: test",
                 fixed = TRUE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb",
                     node_size_fix = "test")
    
    expect_error(print(p), 
                 "non-numeric argument to binary operator",
                 fixed = TRUE)
    
    p <- plotSpatial(cur_sce, img_id = "ImageNb",
                     draw_edges = TRUE, colPairName = "knn_interaction_graph",
                     edge_color_fix = "test")
    
    expect_error(print(p), 
                 "Unknown colour name: test",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             flip_x = "test"), 
                 "'flip_x' must be a single logical",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             flip_x = c(1, 2)), 
                 "'flip_x' must be a single logical",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             flip_y = "test"), 
                 "'flip_y' must be a single logical",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             flip_y = c(1, 2)), 
                 "'flip_y' must be a single logical",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             aspect_ratio = c(1, 2)), 
                 "'aspect_ratio' must be a single positive number, NULL or 'auto'.",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             aspect_ratio = "test"), 
                 "'aspect_ratio' must be a single positive number, NULL or 'auto'.",
                 fixed = TRUE)
    
    expect_error(plotSpatial(cur_sce, img_id = "ImageNb",
                             aspect_ratio = -1), 
                 "'aspect_ratio' must be a single positive number, NULL or 'auto'.",
                 fixed = TRUE)
    
})

test_that("patchDetection function works", {
    library(cytomapper)
    data(pancreasSCE)
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                    type = "expansion", threshold = 20)

    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                   patch_cells = pancreasSCE$CellType == "celltype_B",
                                   colPairName = "expansion_interaction_graph"))
    
    expect_true(is(cur_sce, "SingleCellExperiment"))
    expect_true("patch_id" %in% names(colData(cur_sce)))
    expect_equal(unique(cur_sce$patch_id), c(NA, "1", "2", "3", "4", "5", "6", "7", "8"))
    
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")  
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            min_patch_size = 5))
    
    expect_equal(unique(cur_sce$patch_id), c(NA, "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType %in% c("celltype_B", "celltype_A"),
                                            colPairName = "expansion_interaction_graph"))
    expect_equal(unique(cur_sce$patch_id), c(NA, "1", "2", "3"))
    
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType %in% c("celltype_B", "celltype_A", "celltype_C"),
                                            colPairName = "expansion_interaction_graph"))
    expect_equal(unique(cur_sce$patch_id), c("1", "2", "3"))
    
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 10, img_id = "ImageNb",
                                            name = "patch_id_2"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id_2), c(NA, "1", "2", "3", "4", "5", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id_2")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 50, img_id = "ImageNb",
                                            name = "patch_id"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c(NA,  "1", "3", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 1000, img_id = "ImageNb",
                                            name = "patch_id"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c("3", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 20, img_id = "ImageNb",
                                            name = "patch_id",
                                            min_patch_size = 5), 
                   regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c(NA, "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    cur_sce_2 <- pancreasSCE
    cur_sce_2$X <- cur_sce_2$Pos_X
    cur_sce_2$Y <- cur_sce_2$Pos_Y    
    cur_sce_2$Pos_X <- NULL
    cur_sce_2$Pos_y <- NULL
    
    expect_message(cur_sce <- patchDetection(cur_sce_2, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 30,
                                            img_id = "ImageNb",
                                            coords = c("X", "Y")), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    
    expect_equal(unique(cur_sce$patch_id), c(NA, "1", "3", "4", "6", "7", "8"))
    
    # Concave and convex
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 1, img_id = "ImageNb",
                                            name = "patch_id",
                                            convex = TRUE), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c(NA, "1", "2", "3", "4", "5", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 20, img_id = "ImageNb",
                                            name = "patch_id",
                                            convex = TRUE), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c(NA, "1", "2", "3", "4", "5", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 1000, img_id = "ImageNb",
                                            name = "patch_id",
                                            convex = TRUE), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_sce$patch_id), c("3", "6", "7", "8"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    # Other graph constructors
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                     type = "expansion", threshold = 1)
    
    expect_error(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph"),
                 regexp = "No interactions found.",
                 fixed = TRUE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                     type = "expansion", threshold = 10)
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_equal(unique(cur_sce$patch_id), c(NA, as.character(seq_len(39))))
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                     type = "knn", k = 3)
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "knn_interaction_graph"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_equal(unique(cur_sce$patch_id), c(NA, as.character(seq_len(13))))
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                     type = "delaunay")
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "delaunay_interaction_graph"))
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_equal(unique(cur_sce$patch_id), c(NA, as.character(seq_len(9))))
    
    # Spatial Experiment
    cur_spe <- SpatialExperiment:::.sce_to_spe(pancreasSCE, sample_id = as.character(pancreasSCE$ImageNb))
    spatialCoords(cur_spe) <- as.matrix(colData(pancreasSCE)[,c("Pos_X", "Pos_Y")])
    colData(cur_spe)[c("Pos_X", "Pos_Y")] <- NULL
    
    cur_spe <- buildSpatialGraph(cur_spe, img_id = "ImageNb", 
                                     type = "expansion", threshold = 20)
    
    expect_message(cur_spe_2 <- patchDetection(cur_spe, 
                                            patch_cells = cur_spe$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 10, img_id = "ImageNb",
                                            name = "patch_id_2"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(unique(cur_spe_2$patch_id_2), c(NA, "1", "2", "3", "4", "5", "6", "7", "8"))
    plotSpatial(cur_spe_2, img_id = "ImageNb", node_color_by = "patch_id_2")
    
    cur_spe_3 <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "expansion", threshold = 20)
    
    expect_message(cur_spe_3 <- patchDetection(cur_spe_3, 
                                              patch_cells = cur_spe_3$CellType == "celltype_B",
                                              colPairName = "expansion_interaction_graph",
                                              expand_by = 10, img_id = "ImageNb",
                                              name = "patch_id_2"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    expect_equal(cur_spe_3$patch_id_2, cur_spe_2$patch_id_2)
    plotSpatial(cur_spe_3, img_id = "ImageNb", node_color_by = "patch_id_2")
    
    # Check that metadata is not duplicated
    cur_sce <- pancreasSCE
    metadata(cur_sce) <- list(test = c(1,2))
    
    cur_sce <- patchDetection(cur_sce, 
                              patch_cells = cur_sce$CellType == "celltype_B",
                              colPairName = "expansion_interaction_graph")
    
    expect_equal(length(metadata(cur_sce)), 1)
    expect_equal(metadata(cur_sce), list(test = c(1, 2)))
    
    int_metadata(cur_sce) <- list(version = "1.16.0")
    
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "knn", k = 5)
    
    expect_equal(length(int_metadata(cur_sce)), 1)
    expect_equal(int_metadata(cur_sce), list(version = "1.16.0"))
    
    # Check for sparse graphs
    cur_sce <- pancreasSCE
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                     type = "expansion", threshold = 10)
    
    expect_silent(cur_sce <- patchDetection(cur_sce, 
                                            patch_cells = cur_sce$CellType == "celltype_C",
                                            colPairName = "expansion_interaction_graph"))
    
    # Error
    expect_error(patchDetection("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = "test"),
                 regexp = "'patch_cells' must all be logical.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = TRUE),
                 regexp = "Length of 'patch_cells' must match the number of cells in 'object'.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = 1),
                 regexp = "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "test"),
                 regexp = "'colPairName' not in 'colPairNames(object)'.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                min_patch_size = c(1,2)),
                 regexp = "'min_patch_size' must be a single numeric.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                coords = 1),
                 regexp = "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                coords = c("test", "Pos_y")),
                 regexp = "'coords' not in colData(object).",
                 fixed = TRUE)
    expect_error(patchDetection(cur_spe, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                coords = c("test", "Pos_y")),
                 regexp = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                name = c("test", "Pos_y")),
                 regexp = "'name' must be a single string.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                expand_by = "test"),
                 regexp = "'expand_by' must be a single numeric.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                convex = "test"),
                 regexp = "'convex' must be a single logical.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                expand_by = 10),
                 regexp = "'img_id' must be specified when patch expansion is performed.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                expand_by = 10, img_id = 1),
                 regexp = "'img_id' must be a single string.",
                 fixed = TRUE)
    expect_error(patchDetection(pancreasSCE, patch_cells = pancreasSCE$Pattern,
                                colPairName = "expansion_interaction_graph",
                                expand_by = 10, img_id = "test"),
                 regexp = "'img_id' not in colData(object).",
                 fixed = TRUE)
                     
})

test_that("patchDetection function works if cells are not ordered by image", {
    library(cytomapper)
    data(pancreasSCE)
    
    cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
    cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
    cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
    
    cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
    cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
    cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
    cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
    cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
    cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
    
    pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                     type = "expansion", threshold = 20)
    pancreasSCE$index <- 1:ncol(pancreasSCE)
    
    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph"))
    
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")  
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    set.seed(1234)
    shuffled_sce <- pancreasSCE[,sample(ncol(pancreasSCE))]
    
    cur_sce2 <- patchDetection(shuffled_sce, 
                               patch_cells = shuffled_sce$CellType == "celltype_B",
                               colPairName = "expansion_interaction_graph")
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType")  
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_equal(is.na(cur_sce2$patch_id[order(cur_sce2$index)]), is.na(cur_sce$patch_id[order(cur_sce$index)]))
    
    expect_message(cur_sce <- patchDetection(pancreasSCE, img_id = "ImageNb",
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            expand_by = 10,
                                            colPairName = "expansion_interaction_graph"), 
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "CellType")  
    plotSpatial(cur_sce, img_id = "ImageNb", node_color_by = "patch_id")
    
    set.seed(1234)
    shuffled_sce <- pancreasSCE[,sample(ncol(pancreasSCE))]
    
    cur_sce2 <- patchDetection(shuffled_sce, img_id = "ImageNb",
                               expand_by = 10,
                               patch_cells = shuffled_sce$CellType == "celltype_B",
                               colPairName = "expansion_interaction_graph")
    
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "CellType")  
    plotSpatial(cur_sce2, img_id = "ImageNb", node_color_by = "patch_id")
    
    expect_equal(is.na(cur_sce2$patch_id[order(cur_sce2$index)]), is.na(cur_sce$patch_id[order(cur_sce$index)]))
    
    })

#' @title Generates a SingleCellExperiment from .txt files
#'
#' @description Helper function to process raw .txt files acquired by the
#' Hyperion imaging system into a \code{\linkS4class{SingleCellExperiment}}
#' object. This function is mainly used to read-in data generated from a
#' "spillover slide". Here, each .txt file contains the measurements of
#' multiple pixels for a single stain across all open channels.
#'
#' @param x input can be of different types:
#' \describe{
#' \item{A path}{Full path to where the single stain .txt files are located.}
#' \item{A list object}{A named list object where each entry is a
#' \code{data.frame} or coercible to one. The names of each entry indicate the
#' spotted metals (see details).}
#' }
#' @param pattern pattern to select which files should be read in (default
#' \code{".txt$"}). Only used when \code{x} is a path.
#' @param metadata_cols character vector indicating which column entries of the
#' .txt files should be saved in the \code{colData(sce)} slot.
#' @param verbose logical indicating if additional information regarding the
#' spotted and acquired masses should be shown.
#' @param read_metal_from_filename should the sample metal and mass be extracted
#' from the file/object names?
#' 
#' @return returns a SCE object where pixels are stored as columns and acquired
#' channels are stored as rows.
#' 
#' @section Reading in .txt files for spillover correction:
#' 
#' As described in the original publication, single metal spots are acquired
#' using the Hyperion imaging system. Each acquisition corresponds to one spot.
#' All acquisitions are stored in a single .mcd file and individual acquisitions
#' are stored in single .txt files.
#' 
#' This function aggregates these measurements into a single
#' \code{SingleCellExperiment} object. For this, two inputs are possible:
#' 
#' \enumerate{
#' \item \code{x} is a path:
#' By default all .txt files are read in from the specified path. Here, the path
#' should indicate the location of the spillover slide measurement. The file
#' names of the .txt file must contain the spotted metal isotope name in the
#' format \code{(mt)(mass)} (e.g. \code{Sm152} for Samarium isotope with the
#' atomic mass 152). Internally, the last occurrence of such a pattern is read
#' in as the metal isotope name and stored in the \code{colData(sce)$sample_id}
#' slot.
#' 
#' \item \code{x} is a named list:
#' If there are issues with reading in the metal isotope names from the .txt
#' file names, the user can provide a list for which each entry contains the
#' contents of a single .txt file. The names of the list must indicate the
#' spotted metal in the format \code{(mt)(mass)}. These names will be stored in
#' the \code{colData(sce)$sample_id} slot.
#' }
#' 
#' When \code{read_metal_from_filename = FALSE}, the function will not attempt
#' to read in the spotted metal isotopes from the file or list names. Therefore,
#' only the \code{sample_id} will be set based on the file/list names.
#'
#' @examples
#' # Read files from path
#' path <- system.file("extdata/spillover", package = "imcRtools")
#' 
#' sce <- readSCEfromTXT(path) 
#' sce
#' 
#' # Read files as list
#' cur_file_names <- list.files(path, pattern = ".txt", full.names = TRUE)
#' cur_files <- lapply(cur_file_names, read.delim)
#' names(cur_files) <- sub(".txt", "", basename(cur_file_names))
#' 
#' sce <- readSCEfromTXT(cur_files) 
#' sce
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @references
#' \href{https://www.sciencedirect.com/science/article/pii/S1550413118306910}{Chevrier,
#' S. et al. 2017. “Compensation of Signal Spillover in Suspension and Imaging
#' Mass Cytometry.” Cell Systems 6: 612–20.}
#'
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom S4Vectors DataFrame
#' @importFrom SummarizedExperiment colData<- rowData<-
#' @importFrom stringr str_extract str_split str_extract_all
#' @importFrom readr read_delim
#' @export
readSCEfromTXT <- function(x, 
                            pattern = ".txt$",
                            metadata_cols = c("Start_push", "End_push", 
                                                "Pushes_duration", "X", 
                                                "Y", "Z"),
                            verbose = TRUE,
                            read_metal_from_filename = TRUE){
    
    if (all(is.character(x)) & length(x) == 1) {
        
        if (!dir.exists(x)) {
            stop("Path does not exist.")
        }
        
        cur_names <- list.files(x, pattern = pattern, full.names = FALSE)
        
        if (length(cur_names) == 0) {
            stop("Files could not be read in.")
        }
        
        if (read_metal_from_filename) {
            cur_names <- str_extract_all(cur_names, "[A-Z]{1}[a-z]{0,1}[0-9]{2,3}")
            cur_names <- unlist(lapply(cur_names, function(y){y[length(y)]}))
        } else {
            cur_names <- sub("\\.[^.]*$", "", basename(cur_names))
        }
        
        txt_list <- list.files(x, pattern = pattern, full.names = TRUE)
        txt_list <- lapply(txt_list, read_delim, delim = "\t", 
                            show_col_types = FALSE)
        txt_list <- lapply(txt_list, as.data.frame)
        names(txt_list) <- cur_names
        
    } else if (is.list(x)) {
        
        if (is.null(names(x))) {
            stop("If 'x' is a list, it needs to be named.")
        }
        cur_names <- names(x)
        txt_list <- lapply(x, as.data.frame)
        
    } else {
        stop("Input 'x' is not of the correct format.")
    }
    
    .valid.readSCEfromTXT.input(txt_list, cur_names,
                                metadata_cols, verbose,
                                read_metal_from_filename)
   
    cur_out <- do.call(rbind, txt_list)
    
    # Construct SCE object
    cell_meta <- DataFrame(cur_out[metadata_cols]) 
    
    if (read_metal_from_filename) {
        cell_meta$sample_id <- str_extract(rownames(cell_meta), 
                                            "^[A-Z]{1}[a-z]{0,1}[0-9]{2,3}")
        cell_meta$sample_metal <- str_extract(cell_meta$sample_id, 
                                                "^[A-Z]{1}[a-z]{0,1}")
        cell_meta$sample_mass <- str_extract(cell_meta$sample_id, "[0-9]{2,3}$")
    } else {
        cell_meta$sample_id <- str_split(rownames(cell_meta), "\\.", 
                                            simplify = TRUE)[,1]
    }
    
    cur_counts <- cur_out[grepl("[A-Z]{1}[a-z]{0,1}[0-9]{2,3}", colnames(cur_out))]
    cur_counts <- t(cur_counts)
    
    channel_name <- str_extract(rownames(cur_counts), 
                                "[A-Z]{1}[a-z]{0,1}[0-9]{2,3}Di")
    
    channel_meta <- DataFrame(channel_name = channel_name,
                              marker_name = sub("Di", "", channel_name))
    
    sce <- SingleCellExperiment(assays = list(counts = cur_counts))
    colData(sce) <- cell_meta
    rowData(sce) <- channel_meta
    
    return(sce)
}

test_that("plotSpotHeatmap function works.", {
    path <- system.file("extdata/spillover", package = "imcRtools")
    
    # Read in .txt
    cur_sce <- readSCEfromTXT(path, verbose = FALSE)
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    # Defaults work
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce))
    expect_equal(class(cur_out), "pheatmap")
    
    cur_colours <- matrix(c("#35B779FF", "#424186FF", "#470D60FF", "#440154FF",
                            "#26818EFF", "#FDE725FF", "#20A486FF", "#31688EFF",
                            "#481E70FF", "#3D4D8AFF", "#92D741FF", "#34608DFF",
                            "#3F4788FF", "#355E8DFF", "#25858EFF", "#DDE318FF"),
                          ncol = 4, byrow = TRUE)
    colnames(cur_colours) <- c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")
    rownames(cur_colours) <- c("Dy161", "Dy162", "Dy163", "Dy164")
    expect_equal(cur_out$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, log = FALSE))
    cur_colours <- matrix(c("#481E70FF", "#440154FF", "#440154FF", "#440154FF",
                            "#450558FF", "#FDE725FF", "#471063FF", "#440154FF",
                            "#440154FF", "#440154FF", "#355E8DFF", "#440154FF",
                            "#440154FF", "#440154FF", "#450558FF", "#39BA76FF"),
                          ncol = 4, byrow = TRUE)
    colnames(cur_colours) <- c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")
    rownames(cur_colours) <- c("Dy161", "Dy162", "Dy163", "Dy164")
    expect_equal(cur_out$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, order_metals = FALSE, cluster_cols = TRUE, cluster_rows = TRUE))
    cur_colours <- matrix(c("#35B779FF", "#440154FF", "#424186FF", "#470D60FF",
                            "#26818EFF", "#31688EFF", "#FDE725FF", "#20A486FF",
                            "#481E70FF", "#34608DFF", "#3D4D8AFF", "#92D741FF",
                            "#3F4788FF", "#DDE318FF", "#355E8DFF", "#25858EFF"),
                          ncol = 4, byrow = TRUE)
    colnames(cur_colours) <- c("Dy161Di", "Dy164Di", "Dy162Di", "Dy163Di")
    rownames(cur_colours) <- c("Dy161", "Dy162", "Dy163", "Dy164")
    expect_equal(cur_out$gtable$grobs[[3]]$children[[1]]$gp$fill,
                 cur_colours)
    
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, threshold = 200))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, threshold = 0))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, log = FALSE, threshold = 200))
    cur_colours <- matrix(c("#FDE725FF", "#440154FF", "#440154FF", "#440154FF",
                            "#FDE725FF", "#FDE725FF", "#FDE725FF", "#440154FF",
                            "#440154FF", "#440154FF", "#FDE725FF", "#440154FF",
                            "#440154FF", "#440154FF", "#FDE725FF", "#FDE725FF"),
                          ncol = 4, byrow = TRUE)
    colnames(cur_colours) <- c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")
    rownames(cur_colours) <- c("Dy161", "Dy162", "Dy163", "Dy164")
    expect_equal(cur_out$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    expect_silent(cur_out_2 <- plotSpotHeatmap(cur_sce, log = TRUE, threshold = log10(200)))
    expect_equal(cur_out_2$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    cur_sce$test_spot <- cur_sce$sample_id
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, spot_id = "test_spot"))
    cur_colours <- matrix(c("#35B779FF", "#424186FF", "#470D60FF", "#440154FF",
                            "#26818EFF", "#FDE725FF", "#20A486FF", "#31688EFF",
                            "#481E70FF", "#3D4D8AFF", "#92D741FF", "#34608DFF",
                            "#3F4788FF", "#355E8DFF", "#25858EFF", "#DDE318FF"),
                          ncol = 4, byrow = TRUE)
    colnames(cur_colours) <- c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")
    rownames(cur_colours) <- c("Dy161", "Dy162", "Dy163", "Dy164")
    expect_equal(cur_out$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    rowData(cur_sce)$test_channel <-  rowData(cur_sce)$channel_name
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, channel_id = "test_channel"))
    expect_equal(cur_out$gtable$grobs[[1]]$children[[1]]$gp$fill,
                 cur_colours)
    
    assay(cur_sce, "exprs") <- log10(counts(cur_sce))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, assay_type = "exprs", log = FALSE))
    
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, statistic = "mean"))
    
    # Passing parameters to pheatmap
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, order_metals = FALSE, 
                                             cluster_rows = TRUE))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, order_metals = FALSE, 
                                             cluster_cols = TRUE))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, color = viridis::inferno(50)))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, color = c("red", "green", "blue", "yellow"),
                                             breaks = c(0, 1, 2, 3, 4)))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, color = c("red", "green", "blue", "yellow"),
                                             breaks = c(0, 1, 2, 3, 4), legend_breaks = c(0, 2)))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, cellwidth = 5))
    expect_silent(cur_out <- plotSpotHeatmap(cur_sce, cellwidth = 5, 
                                             annotation_col = data.frame(row.names = c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"),
                                                                         labels = c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"))))
    
    # Error
    expect_error(plotSpotHeatmap("test"), 
                 regexp = "'object' needs to be a SingleCellExperiment object.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, spot_id = "test"), 
                 regexp = "'spot_id' not in 'colData(object)'.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, channel_id = "test"), 
                 regexp = "'channel_id' not in 'rowData(object)'.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, assay_type = "test"), 
                 regexp = "'assay_type' not in 'assayNames(object)'.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, statistic = "test"), 
                 regexp = "'statistic' must be either 'median', 'mean' or 'sum'", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, log = 1), 
                 regexp = "'log' needs to be logical.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, threshold = "test"), 
                 regexp = "'threshold' needs to be a single numeric.", 
                 fixed = TRUE)
    expect_error(plotSpotHeatmap(cur_sce, order_metals = 1), 
                 regexp = "'order_metals' needs to be logical.", 
                 fixed = TRUE)
    
    
})

test_that("readSCEfromTXT function reads in correct objects.", {
    path <- system.file("extdata/spillover", package = "imcRtools")
    
    # Read in .txt
    cur_sce <- readSCEfromTXT(path, verbose = FALSE)
    expect_s4_class(cur_sce, "SingleCellExperiment")
    expect_equal(rowData(cur_sce)$channel_name, c("Dy161Di", "Dy162Di", 
                                                  "Dy163Di","Dy164Di"))
    expect_equal(rowData(cur_sce)$marker_name, c("Dy161", "Dy162", 
                                                  "Dy163","Dy164"))
    expect_equal(cur_sce$Start_push[1:10], c(1570, 1955, 2341, 2726, 3111,
                                             3497, 3882, 4267, 4653, 5038))
    expect_equal(cur_sce$End_push[1:10], c(1953, 2338, 2724, 3109, 3494, 
                                           3880, 4265, 4650, 5036, 5421))
    expect_equal(cur_sce$Pushes_duration[1:10], cur_sce$End_push[1:10] - cur_sce$Start_push[1:10] + 1)
    expect_equal(cur_sce$X, rep(0:99, 4))
    expect_equal(cur_sce$Y, rep(0, 400))
    expect_equal(cur_sce$Z, cur_sce$X)
    expect_equal(cur_sce$sample_id, rep(c("Dy161", "Dy162", 
                                          "Dy163","Dy164"), each = 100))
    expect_equal(cur_sce$sample_metal, rep(c("Dy", "Dy", 
                                          "Dy","Dy"), each = 100))
    expect_equal(cur_sce$sample_mass, rep(c("161", "162", 
                                            "163","164"), each = 100))
    
    expect_equal(assayNames(cur_sce), "counts")
    
    cur_txt <- lapply(list.files(path, full.names = TRUE), read_delim, delim = "\t")
    cur_txt <- lapply(cur_txt, as.data.frame)
    cur_txt <- do.call("rbind", cur_txt)
    
    expect_equal(as.numeric(counts(cur_sce)[1,]), cur_txt$`161Dy(Dy161Di)`)
    expect_equal(as.numeric(counts(cur_sce)[2,]), cur_txt$`162Dy(Dy162Di)`)
    expect_equal(as.numeric(counts(cur_sce)[3,]), cur_txt$`163Dy(Dy163Di)`)
    expect_equal(as.numeric(counts(cur_sce)[4,]), cur_txt$`164Dy(Dy164Di)`)
    expect_equal(dim(cur_sce), c(4, 400))
    
    # Verbose output
    cur_out <- capture_output(cur_sce <- readSCEfromTXT(path))
    expect_equal(gsub(".*\nSpotted","Spotted",cur_out), "Spotted channels:  Dy161, Dy162, Dy163, Dy164\nAcquired channels:  Dy161, Dy162, Dy163, Dy164\nChannels spotted but not acquired:  \nChannels acquired but not spotted:  ")
    
    # Other parameters
    cur_sce_2 <- readSCEfromTXT(path, pattern = "Dy162", verbose = FALSE)
    expect_s4_class(cur_sce_2, "SingleCellExperiment")
    expect_equal(dim(cur_sce_2), c(4, 100))
    expect_equal(rowData(cur_sce)$channel_name, c("Dy161Di", "Dy162Di", 
                                                  "Dy163Di","Dy164Di"))
    
    cur_sce_2 <- readSCEfromTXT(path, metadata_cols = "X", verbose = FALSE)
    expect_s4_class(cur_sce_2, "SingleCellExperiment")
    expect_equal(counts(cur_sce), counts(cur_sce_2))
    expect_equal(names(colData(cur_sce_2)), c("X", "sample_id", "sample_metal", 
                                              "sample_mass" ))
    
    # Read in list
    cur_files <- list.files(path, pattern = ".txt", full.names = TRUE)
    cur_files_names <- list.files(path, pattern = ".txt")
    cur_files <- lapply(cur_files, read_delim, delim = "\t")
    names(cur_files) <- str_extract(cur_files_names, "[A-Za-z]{1,2}[0-9]{2,3}")
    
    cur_sce_3 <- readSCEfromTXT(cur_files, verbose = FALSE)
    expect_s4_class(cur_sce_3, "SingleCellExperiment")
    expect_equal(cur_sce, cur_sce_3)
    expect_silent(cur_sce_4 <- readSCEfromTXT(cur_files, metadata_cols = "X", verbose = FALSE))
    expect_equal(cur_sce_2, cur_sce_4)
    
    # Don't extract metal names
    cur_sce_5 <- readSCEfromTXT(path, verbose = FALSE, read_metal_from_filename = FALSE)
    
    expect_equal(counts(cur_sce), counts(cur_sce_5))
    expect_equal(names(colData(cur_sce_5)), c("Start_push", "End_push",
                                              "Pushes_duration", "X", "Y",
                                              "Z", "sample_id"))

    # Error
    names(cur_files)[1] <- "test" 
    expect_error(readSCEfromTXT(cur_files, verbose = FALSE), 
                 regexp = "Not all names match the pattern (mt)(mass).",
                 fixed = TRUE)
    
    expect_error(readSCEfromTXT(path, pattern = "Dy175", verbose = FALSE),
                 regexp = "Files could not be read in.",
                 fixed = TRUE)
    
    names(cur_files)[1] <- "test" 
    expect_error(readSCEfromTXT(cur_files, verbose = FALSE), 
                 regexp = "Not all names match the pattern (mt)(mass).",
                 fixed = TRUE)
    
    names(cur_files)[1] <- "XYZ1" 
    expect_error(readSCEfromTXT(cur_files, verbose = FALSE), 
                 regexp = "Not all names match the pattern (mt)(mass).",
                 fixed = TRUE)
    
    names(cur_files) <- NULL
    expect_error(readSCEfromTXT(cur_files, verbose = FALSE), 
                 regexp = "If 'x' is a list, it needs to be named.",
                 fixed = TRUE)
    
    expect_error(readSCEfromTXT("test", verbose = FALSE), 
                 regexp = "Path does not exist.",
                 fixed = TRUE)
    
    expect_error(readSCEfromTXT(c("test", "test2"), verbose = FALSE), 
                 regexp = "Input 'x' is not of the correct format.",
                 fixed = TRUE)
    
    expect_error(readSCEfromTXT(path, metadata_cols = "test", verbose = FALSE), 
                 regexp = "Not all 'metadata_cols' are present in entries to 'txt_list'",
                 fixed = TRUE)
    
})

test_that("readSCEfromTXT function detects channels that were not acquired.", {
    path <- system.file("extdata/spillover", package = "imcRtools")
    
    # Move files to tmp location
    cur_path <- tempdir()
    file.copy(path, cur_path, recursive = TRUE)
    
    # Alter the files
    lapply(list.files(paste0(cur_path, "/spillover"), full.names = TRUE),
           function(x) {
               cur_file <- read.csv(x)
               cur_file <- cur_file[,-8]
               write.csv(cur_file, x)
           })
    
    # Read in .txt
    expect_error(cur_sce <- readSCEfromTXT(paste0(cur_path, "/spillover"), 
                                            verbose = FALSE),
                 regexp = "Not all spotted channels were acquired.",
                 fixed = TRUE)

    
})

test_that("binAcrossPixels function works.", {
    path <- system.file("extdata/spillover", package = "imcRtools")
    
    # Read in .txt
    cur_sce <- readSCEfromTXT(path, verbose = FALSE)
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    # Works
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 10))
    expect_s4_class(out, "SingleCellExperiment")
    expect_equal(dim(out), c(nrow(cur_sce), ncol(cur_sce)/10))
    
    # colData are correct
    expect_equal(out$sample_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 10))
    expect_equal(out$spot_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 10))
    expect_equal(as.numeric(out$bin), rep(1:10, 4))
    expect_equal(as.numeric(out$ncells), rep(10, 40))
    
    # rowData are correct
    expect_equal(rowData(cur_sce), rowData(out))
    
    # Summarized counts are correct
    expect_equal(counts(out)[,1], rowSums(counts(cur_sce)[,1:10]))
    expect_equal(counts(out)[,2], rowSums(counts(cur_sce)[,11:20]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,1], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,1:10]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,2], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,11:20]))
    
    test <- aggregate(t(counts(cur_sce)), by = list(cur_sce$sample_id, rep(rep(1:10, each = 10), 4)), FUN = "sum")
    test <- test[order(test$Group.1, test$Group.2),]
    
    test2 <- counts(out)
    test <- t(as.matrix(test[,-c(1,2)]))
    
    dimnames(test2) <- NULL
    dimnames(test)  <- NULL
    
    expect_equal(test2, test)
    
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 10, statistic = "mean"))
    
    test <- aggregate(t(counts(cur_sce)), by = list(cur_sce$sample_id, rep(rep(1:10, each = 10), 4)), FUN = "mean")
    test <- test[order(test$Group.1, test$Group.2),]
    
    test2 <- counts(out)
    test <- t(as.matrix(test[,-c(1,2)]))
    
    dimnames(test2) <- NULL
    dimnames(test)  <- NULL
    
    expect_equal(test2, test)
    
    # Works
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 2))
    expect_s4_class(out, "SingleCellExperiment")
    expect_equal(dim(out), c(nrow(cur_sce), ncol(cur_sce)/2))
    
    # colData are correct
    expect_equal(out$sample_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 50))
    expect_equal(out$spot_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 50))
    expect_equal(as.numeric(out$bin), rep(1:50, 4))
    expect_equal(as.numeric(out$ncells), rep(2, 200))
    
    # rowData are correct
    expect_equal(rowData(cur_sce), rowData(out))
    
    # Summarized counts are correct
    expect_equal(counts(out)[,1], rowSums(counts(cur_sce)[,1:2]))
    expect_equal(counts(out)[,2], rowSums(counts(cur_sce)[,3:4]))
    expect_equal(counts(out)[,3], rowSums(counts(cur_sce)[,5:6]))
    expect_equal(counts(out)[,4], rowSums(counts(cur_sce)[,7:8]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,1], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,1:2]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,2], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,3:4]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,3], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,5:6]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,4], rowSums(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,7:8]))
    
    cur_sce$test_id <- cur_sce$sample_id
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 5, spot_id = "test_id"))
    
    assay(cur_sce, "test") <- counts(cur_sce)
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 5, assay_type = "test"))
    
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 5, statistic = "mean"))
    
    expect_equal(counts(out)[,1], rowMeans(counts(cur_sce)[,1:5]))
    expect_equal(counts(out)[,2], rowMeans(counts(cur_sce)[,6:10]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,1], rowMeans(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,1:5]))
    expect_equal(counts(out)[,out$sample_id == "Dy164"][,2], rowMeans(counts(cur_sce)[,cur_sce$sample_id == "Dy164"][,6:10]))
    
    # Works
    expect_silent(out <- binAcrossPixels(cur_sce, bin_size = 3))
    expect_s4_class(out, "SingleCellExperiment")
    
    # colData are correct
    expect_equal(out$sample_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 34))
    expect_equal(out$spot_id, rep(c("Dy161", "Dy162", "Dy163", "Dy164"), each = 34))
    expect_equal(as.numeric(out$bin), rep(1:34, 4))
    expect_equal(as.numeric(out$ncells), rep(c(rep(3, 33), 1), 4))
    
    # rowData are correct
    expect_equal(rowData(cur_sce), rowData(out))
    
    # Summarized counts are correct
    expect_equal(counts(out)[,1], rowSums(counts(cur_sce)[,1:3]))
    expect_equal(counts(out)[,2], rowSums(counts(cur_sce)[,4:6]))
    expect_equal(counts(out)[,3], rowSums(counts(cur_sce)[,7:9]))
    expect_equal(counts(out)[,4], rowSums(counts(cur_sce)[,10:12]))
    expect_equal(counts(out)[,34], counts(cur_sce)[,100])    
    
    # Error
    expect_error(binAcrossPixels("test"),
                 regexp = "'object' needs to be a SingleCellExperiment object.",
                 fixed = TRUE)
    expect_error(binAcrossPixels(cur_sce, bin_size = c(1,2)),
                 regexp = "'bin_size' needs to be single numeric.",
                 fixed = TRUE)
    expect_error(binAcrossPixels(cur_sce, bin_size = "test"),
                 regexp = "'bin_size' needs to be single numeric.",
                 fixed = TRUE)
    expect_error(binAcrossPixels(cur_sce, spot_id = "test"),
                 regexp = "'spot_id' not in 'colData(object)'.",
                 fixed = TRUE)
    expect_error(binAcrossPixels(cur_sce, bin_size = 10, assay_type = "test_1"),
                 regexp = "'assay_type' not in 'assayNames(object)'.",
                 fixed = TRUE)
    expect_error(binAcrossPixels(cur_sce, bin_size = 10, statistic = "test"),
                 regexp = "'statistic' must be 'sum', 'mean' or 'median'.",
                 fixed = TRUE)
    
    cur_sce <- cur_sce[,sample(ncol(cur_sce))]
    
    expect_error(binAcrossPixels(cur_sce, bin_size = 10),
                 regexp = "Spot IDs of pixels within 'object' are not ordered alphabetically.",
                 fixed = TRUE)
})

test_that("filterPixels function works.", {
    path <- system.file("extdata/spillover", package = "imcRtools")
    
    # Read in .txt
    cur_sce <- readSCEfromTXT(path, verbose = FALSE)
    expect_s4_class(cur_sce, "SingleCellExperiment")
    assay(cur_sce, "exprs") <- asinh(counts(cur_sce)/5)

    bc_key <- as.numeric(unique(cur_sce$sample_mass))
    
    expect_silent(cur_sce <- CATALYST::assignPrelim(cur_sce, bc_key = bc_key, 
                                          verbose = FALSE))
    
    expect_true(all(is.character(cur_sce$bc_id)))
    
    expect_equal(cur_sce$sample_mass, cur_sce$bc_id)
    expect_equal(cur_sce$delta[1:5], 
                 c(0.5496888, 0.5281406, 0.4944301, 0.4765845, 0.4958716),
                 tolerance = 0.000001)
    
    cur_sce <- CATALYST::estCutoffs(cur_sce)
    
    expect_equal(metadata(cur_sce)$sep_cutoffs, 
                 c("161" = 0.3900550, "162" = 0.2900170, "163" = 0.3900138, "164" = 0.3500177),
                 tolerance = 0.000001)
    
    expect_silent(cur_sce <- CATALYST::applyCutoffs(cur_sce))
    expect_equal(sum(cur_sce$bc_id == "0"), 2)
    
    expect_true(all(is.character(cur_sce$bc_id)))
    
    # Filter function shouldn't do anything
    expect_silent(cur_sce_2 <- filterPixels(cur_sce))
    expect_identical(cur_sce_2, cur_sce)
    
    sm_1 <- CATALYST::computeSpillmat(cur_sce)
    sm_1 <- metadata(sm_1)$spillover_matrix
    
    cur_sm <- matrix(c(1.000000000, 0.031443129, 0.009734712, 0.006518048,
                       0.015715159, 1.000000000, 0.048116187, 0.008250039,
                       0.003809504, 0.012159704, 1.000000000, 0.020214651,
                       0.005058069, 0.008457546, 0.028912343, 1.000000000),
                     ncol = 4, nrow = 4, byrow = TRUE, 
                     dimnames = list(c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"),
                                     c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")))
    
    expect_equal(sm_1, cur_sm)
    
    # Change a few pixels
    cur_sce_test <- cur_sce
    
    set.seed(12345)
    cur_sam <- sample(1:ncol(cur_sce), 20)
    
    cur_sce_test$bc_id[cur_sam] <- "test"
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test))
    
    expect_true(all(cur_sce_2$bc_id[cur_sam] == "0"))
    expect_equal(sum(cur_sce_2$bc_id == "0"), 22)
    
    cur_sce_test <- cur_sce
    cur_sce_test$sample_mass[cur_sam] <- "test"
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test))
    
    expect_true(all(cur_sce_2$bc_id[cur_sam] == "0"))
    expect_equal(sum(cur_sce_2$bc_id == "0"), 22)
    
    sm_2 <- CATALYST::computeSpillmat(cur_sce_2)
    sm_2 <- metadata(sm_2)$spillover_matrix
    
    cur_sm <- matrix(c(1.000000000, 0.031379344, 0.009734712, 0.006434588,
                       0.015716916, 1.000000000, 0.048159650, 0.008242979,
                       0.003791071, 0.012178834, 1.000000000, 0.020185447,
                       0.005052712, 0.008413039, 0.028952340, 1.000000000),
                     ncol = 4, nrow = 4, byrow = TRUE, 
                     dimnames = list(c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"),
                                     c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")))
    
    expect_equal(sm_2, cur_sm)
    
    # Don't correct pixels
    cur_sce_test <- cur_sce
    
    set.seed(12345)
    cur_sam <- sample(1:ncol(cur_sce), 20)
    
    cur_sce_test$bc_id[cur_sam] <- "test"
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test, 
                                            correct_pixels = FALSE,
                                            minevents = 18))
    
    expect_true(all(cur_sce_2$bc_id[cur_sam] == "test"))
    
    # Filter based on size
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test, 
                                            correct_pixels = FALSE,
                                            minevents = 22))
    
    expect_true(all(cur_sce_2$bc_id[cur_sam] == "0"))
    
    cur_sce_test <- cur_sce
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test, minevents = 120))
    
    expect_true(all(cur_sce_2$bc_id == "0"))
    
    sm_3 <- CATALYST::computeSpillmat(cur_sce_2)
    sm_3 <- metadata(sm_3)$spillover_matrix
    
    cur_sm <- matrix(c(1, 0, 0, 0,
                       0, 1, 0, 0,
                       0, 0, 1, 0,
                       0, 0, 0, 1),
                     ncol = 4, nrow = 4, byrow = TRUE, 
                     dimnames = list(c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"),
                                     c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")))
    
    expect_equal(sm_3, cur_sm)
    
    cur_sce_test <- cur_sce
    cur_sce_test$bc_id[cur_sce_test$bc_id == "161"] <- c(rep("161", 20), rep("0", 80))
    expect_silent(cur_sce_2 <- filterPixels(cur_sce_test, minevents = 21))
    
    expect_true(all(cur_sce_2$bc_id[cur_sce$bc_id == "161"] == "0"))
    
    sm_4 <- CATALYST::computeSpillmat(cur_sce_2)
    sm_4 <- metadata(sm_4)$spillover_matrix
    
    cur_sm <- matrix(c(1, 0, 0, 0,
                       0.015715159, 1, 0.04811619, 0.008250039,
                       0.003809504, 0.012159704, 1, 0.020214651,
                       0.005058069, 0.008457546, 0.02891234, 1),
                     ncol = 4, nrow = 4, byrow = TRUE, 
                     dimnames = list(c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di"),
                                     c("Dy161Di", "Dy162Di", "Dy163Di", "Dy164Di")))
    
    expect_equal(sm_4, cur_sm)
    
    # Error
    expect_error(filterPixels("test"),
                 regexp = "'object' needs to be a SingleCellExperiment object.",
                 fixed = TRUE)
    
    expect_error(filterPixels(object = cur_sce, bc_id = "test"),
                 regexp = "'bc_id' not in 'colData(object)'",
                 fixed = TRUE)

    expect_error(filterPixels(object = cur_sce, spot_mass = "test"),
                 regexp = "'spot_mass' not in 'colData(object)'",
                 fixed = TRUE)
    
    expect_error(filterPixels(object = cur_sce, minevents = "test"),
                 regexp = "'minevents' needs to be single numeric.",
                 fixed = TRUE)
    
    expect_error(filterPixels(object = cur_sce, correct_pixels = "test"),
                 regexp = "'correct_pixels' needs to be single logical.",
                 fixed = TRUE)
})

test_that("readSCEfromTIFF function reads in correct objects.", {
  path <- system.file("extdata/spillover_tiff/img", package = "imcRtools")
  image_df_path <- system.file("extdata/spillover_tiff/images.csv", package = "imcRtools")
  panel_df_path <- system.file("extdata/spillover_tiff/panel.csv", package = "imcRtools")
  
  # Read in .tiff
  expect_silent(cur_sce <- readSCEfromTIFF(path, image_df_path, panel_df_path, verbose = FALSE))
  expect_equal(rowData(cur_sce)$channel_name, c("Dy161Di", "Dy162Di", 
                                                "Dy163Di","Dy164Di"))
  expect_equal(rowData(cur_sce)$marker_name, c("Dy161", "Dy162", 
                                               "Dy163","Dy164"))
  expect_equal(cur_sce$sample_id, rep(c("Dy161", "Dy162", 
                                        "Dy163","Dy164"), each = 20000))
  expect_equal(cur_sce$sample_metal, rep(c("Dy", "Dy", 
                                           "Dy","Dy"), each = 20000))
  expect_equal(cur_sce$sample_mass, rep(c("161", "162", 
                                          "163","164"), each = 20000))
  expect_equal(assayNames(cur_sce), "counts")
  expect_equal(dim(cur_sce), c(4, 80000))
  
  # Verbose output
  cur_out <- capture_output(cur_sce <- readSCEfromTIFF(path, image_df_path, panel_df_path))
  expect_equal(cur_out, "Spotted channels:  Dy161, Dy162, Dy163, Dy164\nAcquired channels:  Dy161, Dy162, Dy163, Dy164\nChannels spotted but not acquired:  \nChannels acquired but not spotted:  ")
  
  # Compare spillover matrix created with readSCEfromTXT to readSCEfromTIFF
  path_txt <- system.file("extdata/spillover_tiff/txt", package = "imcRtools")
  txt_sce <- readSCEfromTXT(path_txt, verbose = FALSE)
  txt_sce <- readSCEfromTXT(path_txt, verbose = FALSE)
  assay(txt_sce, "exprs") <- asinh(counts(txt_sce) / 5)
  bc_key_txt <- as.numeric(unique(txt_sce$sample_mass))
  bc_key_txt <- bc_key_txt[order(bc_key_txt)]
  txt_sce <- CATALYST::assignPrelim(txt_sce, bc_key = bc_key_txt)
  txt_sce <- CATALYST::estCutoffs(txt_sce)
  txt_sce <- CATALYST::applyCutoffs(txt_sce)
  txt_sce <- filterPixels(txt_sce, minevents = 40, correct_pixels = TRUE)
  txt_sce <- CATALYST::computeSpillmat(txt_sce)
  
  assay(cur_sce, "exprs") <- asinh(counts(cur_sce) / 5)
  bc_key_tiff <- as.numeric(unique(cur_sce$sample_mass))
  bc_key_tiff <- bc_key_tiff[order(bc_key_tiff)]
  cur_sce <- CATALYST::assignPrelim(cur_sce, bc_key = bc_key_tiff)
  cur_sce <- CATALYST::estCutoffs(cur_sce)
  cur_sce <- CATALYST::applyCutoffs(cur_sce)
  cur_sce <- filterPixels(cur_sce, minevents = 40, correct_pixels = TRUE)
  cur_sce <- CATALYST::computeSpillmat(cur_sce)
  
  expect_equal(
    metadata(cur_sce)$spillover_matrix,
    metadata(txt_sce)$spillover_matrix,
    tolerance = 1e-3
  )
  
  # Error
  expect_error(readSCEfromTIFF("test", image_df_path, panel_df_path, verbose = FALSE), 
               regexp = "Image folder path does not exist.",
               fixed = TRUE)
  
  expect_error(readSCEfromTIFF(path, "test", panel_df_path, verbose = FALSE), 
               regexp = "Image dataframe path does not exist.",
               fixed = TRUE)
  
  expect_error(readSCEfromTIFF(path, image_df_path, "test", verbose = FALSE), 
               regexp = "Panel dataframe path does not exist.",
               fixed = TRUE)
})

#' @rdname findBorderCells
#' @title Find cells at the image border
#'
#' @description  
#' Detection of cells close to the image border for subsequent exclusion from
#' downstream analyses.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object.
#' @param img_id single character indicating the \code{colData(object)} entry
#' containing the unique image identifiers. 
#' @param border_dist single numeric defining the distance to the image border.
#' The image border here is defined as the minimum and maximum among the 
#' cells' x and y location.
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries indicating the cells' x and y locations.
#' 
#' @return an object of \code{class(object)} containing the logical
#' \code{border_cells} entry in the \code{colData} slot.
#'  
#' @examples 
#' library(cytomapper)
#' data("pancreasSCE")
#' 
#' sce <- findBorderCells(pancreasSCE, img_id = "ImageNb", 
#'                        border_dist = 10)
#' 
#' plotSpatial(sce, 
#'             img_id = "ImageNb", 
#'             node_color_by = "border_cells",
#'             scales = "free")
#'
#' @importFrom data.table as.data.table setnames
#' @importFrom SpatialExperiment spatialCoords
#'
#' @export
findBorderCells <- function(object,
                            img_id,
                            border_dist,
                            coords = c("Pos_X", "Pos_Y")){
    
    # Input check
    .valid.findBorderCells.input(object, img_id, border_dist, coords)
    
    if (is(object, "SpatialExperiment")) {
        cur_df <- as.data.table(cbind.data.frame(colData(object)[,img_id], 
                                        spatialCoords(object)[,coords]))
    } else {
        cur_df <- as.data.table(colData(object)[,c(img_id, coords)])
    }
    
    Pos_X <- Pos_Y <- border_cells <- NULL
    
    setnames(cur_df, old = names(cur_df), c("img_id", "Pos_X", "Pos_Y")) 
    cur_df[,border_cells := Pos_X <= min(Pos_X) + border_dist | 
                            Pos_X >= max(Pos_X) - border_dist |
                            Pos_Y <= min(Pos_Y) + border_dist |
                            Pos_Y >= max(Pos_Y) - border_dist, by = img_id]
    colData(object)$border_cells <- cur_df$border_cells
    
    return(object)
}

# Check function for SCE from TXT function
#' @importFrom stringr str_extract
.valid.readSCEfromTXT.input <- function(txt_list, cur_names,
                                        metadata_cols, verbose,
                                        read_metal_from_filename){

    # Check if names are all of the format Mt123 where Mt is the metal name
    # and 123 is the mass
    if (read_metal_from_filename) {
        cur_mass <- str_extract(cur_names, "[0-9]{2,3}$")
        cur_names <- cur_names[order(as.numeric(cur_mass))]

        if (!all(grepl("^[A-Z]{1}[a-z]{0,1}[0-9]{2,3}$", cur_names))) {
            stop("Not all names match the pattern (mt)(mass).")
        }

        # Check if spotted channel is also open
        cur_channels <- str_extract(colnames(txt_list[[1]]),
                                    "[A-Z]{1}[a-z]{0,1}[0-9]{2,3}Di")
        cur_channels <- cur_channels[!is.na(cur_channels)]
        cur_channels <- sub("Di", "", cur_channels)

        # Verbose option will print possible missmatched between acquired and
        # open channels
        spot_not_ac <- cur_names[!(cur_names %in% cur_channels)]
        ac_not_spot <- cur_channels[!(cur_channels %in% cur_names)]
        if (verbose) {
            cat("Spotted channels: ", paste(cur_names, collapse = ", "))
            cat("\n")
            cat("Acquired channels: ", paste(cur_channels, collapse = ", "))
            cat("\n")
            cat("Channels spotted but not acquired: ",
                paste(spot_not_ac, collapse = ", "))
            cat("\n")
            cat("Channels acquired but not spotted: ",
                paste(ac_not_spot, collapse = ", "))
        }

        if (!all(cur_names %in% cur_channels)) {
            stop("Not all spotted channels were acquired.")
        }
    }

    # Check if metadata_cols are in each file
    cur_check <- lapply(txt_list, function(x){
        all(metadata_cols %in% colnames(x))
    })

    if (!all(unlist(cur_check))) {
        stop("Not all 'metadata_cols' are present in entries to 'txt_list'")
    }
}

.valid.readSCEfromTIFF.input <- function (img_df, panel_df, verbose) {
  cur_names <- img_df$acquisition_description
  cur_mass <- str_extract(cur_names, "[0-9]{2,3}$")
  cur_names <- cur_names[order(as.numeric(cur_mass))]
  if (!all(grepl("^[A-Z]{1}[a-z]{0,1}[0-9]{2,3}$", cur_names))) {
    stop("Not all names match the pattern (mt)(mass).")
  }
  cur_channels <- panel_df$channel
  spot_not_ac <- cur_names[!(cur_names %in% cur_channels)]
  ac_not_spot <- cur_channels[!(cur_channels %in% cur_names)]
  if (verbose) {
    cat("Spotted channels: ", paste(cur_names, collapse = ", "))
    cat("\n")
    cat("Acquired channels: ", paste(cur_channels, collapse = ", "))
    cat("\n")
    cat("Channels spotted but not acquired: ", paste(spot_not_ac, 
                                                     collapse = ", "))
    cat("\n")
    cat("Channels acquired but not spotted: ", paste(ac_not_spot, 
                                                     collapse = ", "))
  }
  if (!all(cur_names %in% cur_channels)) {
    stop("Not all spotted channels were acquired.")
  }
}

#' @importFrom SummarizedExperiment colData assayNames
#' @importFrom methods is
.valid.plotSpotHeatmap.input <- function(object, spot_id, channel_id,
                                    assay_type, log,
                                    threshold, order_metals){

    # Check sce object
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' needs to be a SingleCellExperiment object.")
    }
    if (!spot_id %in% names(colData(object))) {
        stop("'spot_id' not in 'colData(object)'.")
    }
    if (!channel_id %in% names(rowData(object))) {
        stop("'channel_id' not in 'rowData(object)'.")
    }
    if (!assay_type %in% assayNames(object)) {
        stop("'assay_type' not in 'assayNames(object)'.")
    }

    if (!all(is.logical(log)) || length(log) != 1) {
        stop("'log' needs to be logical.")
    }

    if (!is.null(threshold) & (length(threshold) != 1 ||
                                !all(is.numeric(threshold)))) {
        stop("'threshold' needs to be a single numeric.")
    }

    if (!all(is.logical(order_metals)) || length(order_metals) != 1) {
        stop("'order_metals' needs to be logical.")
    }
}

#' @importFrom SummarizedExperiment colData assayNames
.valid.binAcrossPixels.input <- function(object, bin_size, spot_id, assay_type){

    # Check sce object
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' needs to be a SingleCellExperiment object.")
    }
    if (!spot_id %in% names(colData(object))) {
        stop("'spot_id' not in 'colData(object)'.")
    }
    if (!assay_type %in% assayNames(object)) {
        stop("'assay_type' not in 'assayNames(object)'.")
    }

    if (!all(is.numeric(bin_size)) || length(bin_size) != 1) {
        stop("'bin_size' needs to be single numeric.")
    }
}

.valid.filterPixels.input <- function(object, bc_id, spot_mass,
                                    minevents, correct_pixels){

    # Check sce object
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' needs to be a SingleCellExperiment object.")
    }
    if (!bc_id %in% names(colData(object))) {
        stop("'bc_id' not in 'colData(object)'.")
    }
    if (!spot_mass %in% names(colData(object))) {
        stop("'spot_mass' not in 'colData(object)'.")
    }


    if (!all(is.numeric(minevents)) || length(minevents) != 1) {
        stop("'minevents' needs to be single numeric.")
    }
    if (!all(is.logical(correct_pixels)) || length(correct_pixels) != 1) {
        stop("'correct_pixels' needs to be single logical.")
    }
}

.valid.readImagefromTXT.input <- function(path, pattern){
    # Check if input is character
    if (!all(is.character(path)) | length(path) != 1) {
        stop("Please provide a string input indicating a path.")
    }

    if (!is.character(pattern) | length(pattern) != 1) {
        stop("'pattern' must be indicated as single character")
    }

    if (!dir.exists(path)) {
        stop("The indicated path does not exist")
    }

    out <- list.files(path, pattern = pattern, full.names = TRUE)

    if (length(out) == 0) {
        stop("The pattern does not match any\n",
                "of the files in the provided directory.")
    }
}


.valid.read_steinbock.input <- function(path, intensities_folder, graphs_folder,
                                    regionprops_folder, cell_id, coords,
                                    image_file, extract_imagemetadata_from,
                                    panel, name, pattern) {
    if (length(path) != 1 | !is.character(path)) {
        stop("'path' must be a single string.")
    }

    if (!dir.exists(path)) {
        stop("'path' doesn't exist.")
    }

    if (is.null(intensities_folder)) {
        stop("'intensities_folder' must be specified.")
    }

    if (length(intensities_folder) != 1 | !is.character(intensities_folder)) {
        stop("'intensities_folder' must be a single string.")
    }

    if (!dir.exists(file.path(path, intensities_folder))) {
        stop("'intensities_folder' doesn't exist.")
    }

    # Check if any files can be read in
    all_files <- list.files(file.path(path, intensities_folder),
                            pattern =  pattern, full.names = TRUE)

    if (length(all_files) == 0) {
        stop("No files were read in.")
    }

    # Check cell_id
    cur_file <- vroom(all_files[1],
                      progress = FALSE,
                      show_col_types = FALSE)

    if (length(cell_id) != 1 | !is.character(cell_id)) {
        stop("'extract_cellid_from' must be a single string.")
    }

    if (!cell_id %in% colnames(cur_file)) {
        stop("'extract_cellid_from' not in intensities files.")
    }

    cur_int <- lapply(all_files, function(x){
        x <- vroom(x, n_max = 0, show_col_types = FALSE)
        return(colnames(x))
    })

    if (length(unique(cur_int)) != 1) {
        stop("'colnames' of files in '", intensities_folder, "' do not match.")
    }

    all_int <- list.files(file.path(path, intensities_folder),
                            pattern =  pattern, full.names = FALSE)

    if (!is.null(graphs_folder)) {

        if (length(graphs_folder) != 1 | !is.character(graphs_folder)) {
            stop("'graphs_folder' must be a single string.")
        }

        if (!dir.exists(file.path(path, graphs_folder))) {
            stop("'graphs_folder' doesn't exist.")
        }

        all_graph <- list.files(file.path(path, graphs_folder),
                                pattern =  pattern, full.names = FALSE)

        if (!identical(all_int, all_graph)) {
            stop("File names in '", intensities_folder, "' and '",
                 graphs_folder, "' do not match.")
        }

        all_files <- list.files(file.path(path, graphs_folder),
                                pattern =  pattern, full.names = TRUE)

        cur_graphs <- lapply(all_files, function(x){
            x <- vroom(x, n_max = 0, show_col_types = FALSE)
            return(colnames(x))
        })

        if (length(unique(cur_graphs)) != 1) {
            stop("'colnames' of files in '", graphs_folder, "' do not match.")
        }

    }

    if (!is.null(regionprops_folder)) {

        if (length(regionprops_folder) != 1 |
            !is.character(regionprops_folder)) {
            stop("'regionprops_folder' must be a single string.")
        }

        if (!dir.exists(file.path(path, regionprops_folder))) {
            stop("'regionprops_folder' doesn't exist.")
        }

        all_region <- list.files(file.path(path, regionprops_folder),
                                pattern =  pattern, full.names = FALSE)

        if (!identical(all_int, all_region)) {
            stop("File names in '", intensities_folder, "' and '",
                 regionprops_folder, "' do not match.")
        }

    }

    # Check coords
    if (!is.null(regionprops_folder)) {
        all_files <- list.files(file.path(path, regionprops_folder),
                                pattern =  pattern, full.names = TRUE)

        if (length(all_files) > 0) {
            cur_file <- vroom(all_files[1],
                                progress = FALSE,
                                show_col_types = FALSE)

            if (!all(is.character(coords))) {
                stop("'extract_coords_from' must be characters.")
            }

            if (!all(coords %in% colnames(cur_file))) {
                stop("'coords' not in regionprops files.")
            }

            cur_region <- lapply(all_files, function(x){
                    x <- vroom(x, n_max = 0, show_col_types = FALSE)
                    return(colnames(x))
                })

            if (length(unique(cur_region)) != 1) {
                stop("'colnames' of files in '", regionprops_folder, "' do not match.")
            }
        }
    }

    # Check image file
    if (!is.null(image_file)) {
        if (length(image_file) != 1 | !is.character(image_file)) {
            stop("'image_file' must be a single string.")
        }

        if (!file.exists(file.path(path, image_file))) {
            stop("'image_file' doesn't exist.")
        }

        if (!all(is.character(extract_imagemetadata_from))) {
            stop("'extract_imagemetadata_from' should only contain characters.")
        }

        cur_images_file <- vroom(file.path(path, image_file), progress = FALSE,
                                 show_col_types = FALSE)

        if (!all(extract_imagemetadata_from %in% colnames(cur_images_file))) {
            stop("'extract_imagemetadata_from' not in images file.")
        }

        # Compare against intensity files
        all_int <- list.files(file.path(path, intensities_folder),
                              pattern =  pattern, full.names = FALSE)

        cur_sample_id <- sub("\\.[^.]*$", "", all_int)

        if (!all(cur_sample_id %in% sub("\\.[^.]*$", "", cur_images_file$image))) {
            stop("Files found in '", intensities_folder,
                 "' do not match the 'image' entry in '", image_file, "'.")
        }
    }

    # Check panel
    if (!is.null(panel)) {
        if (length(panel) != 1 | !is.character(panel)) {
            stop("'panel_file' must be a single string.")
        }

        if (file.exists(file.path(path, panel))) {
            cur_panel <- vroom(file.path(path, panel),
                                progress = FALSE,
                               show_col_types = FALSE)
        } else if (file.exists(panel)) {
            cur_panel <- vroom(panel,
                                progress = FALSE,
                               show_col_types = FALSE)
        }

        if (exists("cur_panel")) {

            if (length(name) != 1 | !is.character(name)) {
                stop("'extract_names_from' must be a single string.")
            }

            if (!name %in% colnames(cur_panel)) {
                stop("'extract_names_from' not in panel file.")
            }
        }
    }
}

#' @importFrom stringr str_count
.valid.read_cpout.input <- function(path, object_file, image_file,
                            panel_file, graph_file, object_feature_file,
                            intensities, extract_imgid_from,
                            extract_cellid_from,
                            extract_coords_from,
                            extract_cellmetadata_from,
                            extract_imagemetadata_from,
                            extract_graphimageid_from,
                            extract_graphcellids_from,
                            extract_metal_from, scale_intensities,
                            extract_scalingfactor_from){

    if (length(path) != 1 | !is.character(path)) {
        stop("'path' must be a single string.")
    }

    if (!dir.exists(path)) {
        stop("'path' doesn't exist.")
    }

    if (is.null(object_file)) {
        stop("'object_file' must be specified.")
    }

    if (is.null(object_feature_file)) {
        stop("'object_feature_file' must be specified.")
    }

    if (length(object_file) != 1 | !is.character(object_file)) {
        stop("'object_file' must be a single string.")
    }

    if (length(object_feature_file) != 1 | !is.character(object_feature_file)) {
        stop("'object_feature_file' must be a single string.")
    }

    if (!file.exists(file.path(path, object_file))) {
        stop("'object_file' doesn't exist.")
    }

    if (!file.exists(file.path(path, object_feature_file))) {
        stop("'object_feature_file' doesn't exist.")
    }

    if (!is.null(image_file)) {

        if (length(image_file) != 1 | !is.character(image_file)) {
            stop("'image_file' must be a single string.")
        }

        if (!file.exists(file.path(path, image_file))) {
            stop("'image_file' doesn't exist.")
        }

    }

    if (!is.null(graph_file)) {

        if (length(graph_file) != 1 | !is.character(graph_file)) {
            stop("'graph_file' must be a single string.")
        }

        if (!file.exists(file.path(path, graph_file))) {
            stop("'graph_file' doesn't exist.")
        }

    }

    # Check panel
    if (!is.null(panel_file)) {
        if (length(panel_file) != 1 | !is.character(panel_file)) {
            stop("'panel_file' must be a single string.")
        }

        if (file.exists(file.path(path, panel_file))) {
            cur_panel <- vroom(file.path(path, panel_file),
                                progress = FALSE,
                               show_col_types = FALSE)
        } else if (file.exists(panel_file)) {
            cur_panel <- vroom(panel_file,
                                progress = FALSE,
                               show_col_types = FALSE)
        }

        if (exists("cur_panel")) {

            if (is.null(extract_metal_from)) {
                stop("'extract_metal_from' must be specified.")
            }

            if (length(extract_metal_from) != 1 |
                !is.character(extract_metal_from)) {
                stop("'extract_metal_from' must be a single string.")
            }

            if (!extract_metal_from %in% colnames(cur_panel)) {
                stop("'extract_metal_from' not in panel file.")
            }
        }
    }

    # Check object files
    cur_file <- vroom(file.path(path, object_file), n_max = 1,
                      show_col_types = FALSE)

    if (is.null(intensities)) {
        stop("'intensities' must be specified.")
    }

    if (length(intensities) != 1 | !is.character(intensities)) {
        stop("'intensities' must be a single string.")
    }

    feature_count <- sum(str_count(colnames(cur_file), intensities))

    if (feature_count == 0) {
        stop("No intensity features were read in.",
             " Please check the 'intensities' parameter.")
    }

    cur_features <- cur_file %>% select(contains(intensities))
    cur_channels <- str_extract(colnames(cur_features), "c[0-9]*$")
    cur_channels <- as.numeric(table(cur_channels))

    if (any(cur_channels > 1)) {
        stop("Some of the features set via 'intensities'",
             " cannot be uniquely accessed.")
    }

    if (is.null(extract_imgid_from)) {
        stop("'extract_imgid_from' must be specified.")
    }

    if (length(extract_imgid_from) != 1 | !is.character(extract_imgid_from)) {
        stop("'extract_imgid_from' must be a single string.")
    }

    if (!extract_imgid_from %in% colnames(cur_file)) {
        stop("'extract_imgid_from' not in 'object_file'.")
    }

    if (is.null(extract_cellid_from)) {
        stop("'extract_cellid_from' must be specified.")
    }

    if (length(extract_cellid_from) != 1 | !is.character(extract_cellid_from)) {
        stop("'extract_cellid_from' must be a single string.")
    }

    if (!extract_cellid_from %in% colnames(cur_file)) {
        stop("'extract_cellid_from' not in 'object_file'.")
    }

    if (!is.null(extract_coords_from)) {
        if (!all(extract_coords_from %in% colnames(cur_file))) {
            stop("'extract_coords_from' not in 'object_file'.")
        }
    }

    if (!is.null(extract_cellmetadata_from)) {
        if (!all(extract_cellmetadata_from %in% colnames(cur_file))) {
            stop("'extract_cellmetadata_from' not in 'object_file'.")
        }
    }


    # Check image files
    if (is.null(scale_intensities)) {
        stop("'scale_intensities' needs to be logical.")
    }

    if (length(scale_intensities) != 1) {
        stop("'scale_intensities' needs to be of length 1.")
    } else {
        if (!is.logical(scale_intensities)) {
            stop("'scale_intensities' needs to be logical.")
        }
    }

    if (scale_intensities & is.null(image_file)) {
        stop("When scaling the summarized object intensities, ",
        "please supply the 'image_file'.")
    }

    if (!is.null(image_file)) {
        cur_file <- vroom(file.path(path, image_file), n_max = 1,
                          show_col_types = FALSE)

        if (!is.null(extract_imagemetadata_from)) {
            if (!all(extract_imagemetadata_from %in% colnames(cur_file))) {
                stop("'extract_imagemetadata_from' not in 'image_file'.")
            }
        }

        if (length(extract_scalingfactor_from) != 1 |
            !is.character(extract_scalingfactor_from)) {
            stop("'extract_scalingfactor_from' must be a single string.")
        }

        if (scale_intensities &
            !extract_scalingfactor_from %in% colnames(cur_file)) {
            stop("'extract_scalingfactor_from' not in 'image_file'.")
        }

    }

    # Check graph file
    if (!is.null(graph_file)) {
        cur_file <- vroom(file.path(path, graph_file), n_max = 1,
                          show_col_types = FALSE)

        if (is.null(extract_graphimageid_from)) {
            stop("'extract_graphimageid_from' must be specified.")
        }

        if (length(extract_graphimageid_from) != 1 |
            !is.character(extract_graphimageid_from)) {
            stop("'extract_graphimageid_from' must be a single string.")
        }

        if (!extract_graphimageid_from %in% colnames(cur_file)) {
            stop("'extract_graphimageid_from' not in 'graph_file'.")
        }

        if (is.null(extract_graphcellids_from)) {
            stop("'extract_graphcellids_from' must be specified.")
        }

        if (!all(extract_graphcellids_from %in% colnames(cur_file))) {
            stop("'extract_graphcellids_from' not in 'graph_file'.")
        }

    }

}

#' @importFrom SpatialExperiment spatialCoordsNames
.valid.buildSpatialGraph.input <- function(object, type, img_id, k,
                                    threshold, coords, name,
                                    directed, max_dist){

    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(img_id) != 1 | !is.character(img_id)) {
        stop("'img_id' must be a single string.")
    }

    if (!img_id %in% names(colData(object))) {
        stop("'img_id' not in colData(object).")
    }

    if (type == "expansion") {

        if (is.null(threshold)) {
            stop("When constructing a graph via expansion,",
                 " please specify 'threshold'.")
        }

        if (length(threshold) != 1 || !is.numeric(threshold)) {
            stop("'threshold' must be a single numeric")
        }

    }

    if (type == "knn") {

        if (is.null(k)) {
            stop("When constructing a graph via nearest neighbour detection, ",
                 "please specify 'k'.")
        }

        if (length(k) != 1 || !is.numeric(k)) {
            stop("'k' must be a single numeric")
        }

        if (!is.null(max_dist) & (length(max_dist) != 1 ||
                                    !is.numeric(max_dist))) {
            stop("'max_dist' must be a single numeric")
        }

    }

    if (length(coords) != 2 | !all(is.character(coords))) {
        stop("'coords' must be a character vector of length 2.")
    }


    if (is(object, "SpatialExperiment")) {
        if (!all(coords %in% spatialCoordsNames(object))) {
            stop("'coords' not in spatialCoords(object).")
        }
    } else {
        if (!all(coords %in% names(colData(object)))) {
            stop("'coords' not in colData(object).")
        }

    }

    if (!is.null(name)) {
        if (length(name) != 1 | !is.character(name)) {
            stop("'name' must be a single string.")
        }
    }

    if (length(directed) != 1 | !is.logical(directed)) {
        stop("'directed' must be a single logical.")
    }

}

.valid.aggregateNeighbors.input <- function(object, colPairName, aggregate_by,
                                        count_by, proportions, assay_type,
                                        subset_row, name){

    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(colPairName) != 1 | !is.character(colPairName)) {
        stop("'colPairName' must be a single string.")
    }

    if (! colPairName %in% colPairNames(object)) {
        stop("'colPairName' not in 'colPairNames(object)'.")
    }

    if (length(colPair(object, colPairName)) == 0) {
        stop("No interactions found.")
    }

    if (aggregate_by == "metadata") {

        if (is.null(count_by)) {
            stop("Provide a 'colData(object)' entry to aggregate by.")
        }

        if (length(count_by) != 1 | !is.character(count_by)) {
            stop("'count_by' must be a single string.")
        }

        if (! count_by %in% colnames(colData(object))) {
            stop("'count_by' is not a valid enty of 'colData(object)'.")
        }

        if (length(proportions) != 1 | !is.logical(proportions)) {
            stop("'proportions' must be a single logical")
        }
    }

    if (aggregate_by == "expression") {

        if (is.null(assay_type)) {
            stop("'assay_type' not provided")
        }

        if (length(assay_type) != 1 | !is.character(assay_type)) {
            stop("'assay_type' must be a single string.")
        }

        if (! assay_type %in% assayNames(object)) {
            stop("'assay_type' not an assay in the 'object'.")
        }

        if (!is.null(subset_row)) {
            if (all(is.character(subset_row)) &
                !all(subset_row %in% rownames(object))) {
                stop("'subset_row' not in rownames(object).")
            }

            if (all(is.logical(subset_row)) &
                length(subset_row) != nrow(object)) {
                stop("'subset_row' logical entries",
                     " must be as long as 'nrow(object)'.")
            }
        }
    }

    if (!is.null(name) & (length(name) != 1 | !is.character(name))) {
        stop("'name' must be a single string.")
    }
}

#' @importFrom S4Vectors mcols
.valid.plotSpatial.input <- function(object, img_id, coords, node_color_by,
                                    node_shape_by, node_size_by, edge_color_by,
                                    assay_type, edge_width_by, draw_edges,
                                    directed,  arrow,  end_cap, colPairName,
                                    nodes_first, ncols, nrows, scales,
                                    flip_x, flip_y, aspect_ratio){

    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(img_id) != 1 | !is.character(img_id)) {
        stop("'img_id' must be a single string.")
    }

    if (!img_id %in% names(colData(object))) {
        stop("'img_id' not in colData(object).")
    }

    if (length(coords) != 2 | !all(is.character(coords))) {
        stop("'coords' must be a character vector of length 2.")
    }

    if (is(object, "SpatialExperiment")) {
        if (!all(coords %in% spatialCoordsNames(object))) {
            stop("'coords' not in spatialCoords(object).")
        }
    } else {
        if (!all(coords %in% names(colData(object)))) {
            stop("'coords' not in colData(object).")
        }
    }

    if (!is.null(node_color_by) && (length(node_color_by) != 1 |
        !is.character(node_color_by))) {
        stop("'node_color_by' must be a single string.")
    }

    cur_accepted <- c(names(colData(object)), rownames(object))

    if (!is.null(node_color_by) && !node_color_by %in% cur_accepted) {
        stop("'node_color_by' not in colData(object) or rownames(object).")
    }

    if (!is.null(node_color_by) && node_color_by %in% rownames(object)) {
        if (is.null(assay_type)) {
            stop("When coloring nodes by marker expression,",
                    " please specify 'assay_type'.")
        }

        if (length(assay_type) != 1 | !is.character(assay_type)) {
            stop("'assay_type' must be a single string.")
        }

        if (!assay_type %in% assayNames(object)) {
            stop("'assay_type' not an assay in object.")
        }
    }

    if (!is.null(node_shape_by) &&
        (length(node_shape_by) != 1 | !is.character(node_shape_by))) {
        stop("'node_shape_by' must be a single string.")
    }

    if (!is.null(node_shape_by) &&
        (!node_shape_by %in% names(colData(object)))) {
        stop("'node_shape_by' not in colData(object).")
    }

    if (!is.null(node_size_by) &&
        (length(node_size_by) != 1 | !is.character(node_size_by))) {
        stop("'node_size_by' must be a single string.")
    }

    if (!is.null(node_size_by) &&
        (!node_size_by %in% names(colData(object)))) {
        stop("'node_size_by' not in colData(object).")
    }

    if (length(draw_edges) != 1 | !is.logical(draw_edges)) {
        stop("'draw_edges' must be a single logical")
    }

    if (draw_edges) {
        if (is.null(colPairName)) {
            stop("Please specify the name of the",
                " column pairing via 'colPairName'.")
        }

        if (length(colPairName) != 1 | !is.character(colPairName)) {
            stop("'colPairName' must be a single string.")
        }

        if (!colPairName %in% colPairNames(object)) {
            stop("No column pairing with name ", colPairName, " found.")
        }

        if (!is.null(edge_color_by) &&
            (length(edge_color_by) != 1 | !is.character(edge_color_by))) {
            stop("'edge_color_by' must be a single string.")
        }

        if (!is.null(edge_color_by) &&
            (!edge_color_by %in% names(colData(object)) &&
            !edge_color_by %in% names(mcols(colPair(object, colPairName))))) {
            stop("'edge_color_by' not in 'colData(object)'",
                 " or in 'mcols(colPair(object, colPairName))'.")
        }

        if (!is.null(edge_width_by) &&
            (length(edge_width_by) != 1 | !is.character(edge_width_by))) {
            stop("'edge_width_by' must be a single string.")
        }

        if (!is.null(edge_width_by) &&
            (!edge_width_by %in% names(colData(object)) &&
            !edge_width_by %in% names(mcols(colPair(object, colPairName))))) {
            stop("'edge_width_by' not in 'colData(object)'",
                 " or in 'mcols(colPair(object, colPairName))'.")
        }

        if (length(directed) != 1 | !is.logical(directed)) {
            stop("'directed' must be a single logical")
        }

        if (!is.null(arrow) && !is(arrow, "arrow")) {
            stop("'arrow' must be of class grid::arrow.")
        }

        if (!is.null(end_cap) && !is(end_cap, "ggraph_geometry")) {
            stop("'end_cap' must be of type 'ggraph_geometry'.")
        }
    }

    if (length(nodes_first) != 1 | !is.logical(nodes_first)) {
        stop("'nodes_first' must be a single logical")
    }

    if (!is.null(ncols) && (length(ncols) != 1 | !is.numeric(ncols))) {
        stop("'ncols' must be a single numeric")
    }

    if (!is.null(nrows) && (length(nrows) != 1 | !is.numeric(nrows))) {
        stop("'nrows' must be a single numeric")
    }

    if (!scales %in% c("fixed", "free_x", "free_y", "free")) {
        stop("'scales' should be one of 'fixed', 'free_x', 'free_y', 'free'.")
    }

    if (length(flip_y) != 1 | !is.logical(flip_y)) {
        stop("'flip_y' must be a single logical")
    }

    if (length(flip_x) != 1 | !is.logical(flip_x)) {
        stop("'flip_x' must be a single logical")
    }

    if (!is.null(aspect_ratio) & length(aspect_ratio) != 1) {
        stop("'aspect_ratio' must be a single positive number, NULL or 'auto'.")
    }

    if (!is.null(aspect_ratio)) {
        if (aspect_ratio != "auto" &
            (!is.numeric(aspect_ratio) |
            any(aspect_ratio < 0))) {
                stop("'aspect_ratio' must be a single positive number, NULL or 'auto'.")
        }
    }

}

.valid.countInteractions.input <- function(object, group_by, label, method,
                                                patch_size, colPairName){

    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(group_by) != 1 | !is.character(group_by)) {
        stop("'group_by' must be a single string.")
    }

    if (any(is.na(object[[group_by]]))) {
        stop("Please remove NAs from the grouping vector.")
    }

    if (!group_by %in% names(colData(object))) {
        stop("'group_by' not in colData(object).")
    }

    if (length(colPairName) != 1 | !is.character(colPairName)) {
        stop("'colPairName' must be a single string.")
    }

    if (!colPairName %in% colPairNames(object)) {
        stop("'colPairName' not in colPairNames(object).")
    }

    if (length(label) != 1 | !is.character(label)) {
        stop("'label' must be a single string.")
    }

    if (!label %in% names(colData(object))) {
        stop("'label' not in colData(object).")
    }

    if (any(is.na(object[[label]]))) {
        stop("Please remove NAs from the label vector.")
    }

    if (length(method) == 1 && method == "histocat") {
        stop("The method 'histocat' has been renamed to 'conditional' since imcRtools version 1.15.3. Please rename.")
    }

    if (length(method) == 1 && method == "patch") {
        if (is.null(patch_size)) {
            stop("When method = 'patch', please specify 'patch_size'.")
        }

        if (length(patch_size) != 1 | !is.numeric(patch_size)) {
            stop("'patch_size' must be a single numeric.")
        }
    }
}

.valid.testInteractions.input <- function(iter, p_threshold, return_samples, method,
                                          tolerance){
    if (length(iter) != 1 | !is.numeric(iter)) {
        stop("'iter' must be a single positive numeric.")
    }

    if (iter < 1) {
        stop("'iter' must be a single positive numeric.")
    }

    if (length(p_threshold) != 1 | !is.numeric(p_threshold)) {
        stop("'p_threshold' must be a single numeric between 0 and 1.")
    }

    if (p_threshold < 0 | p_threshold > 1) {
        stop("'p_threshold' must be a single numeric between 0 and 1.")
    }

    if (length(return_samples) != 1 | !is.logical(return_samples)) {
        stop("'return_samples' must be a single logical.")
    }

    if (length(tolerance) != 1 | !is.numeric(tolerance)) {
        stop("'tolerance' must be a single numeric.")
    }

    if (tolerance < 0) {
        stop("'tolerance' must be larger than 0.")
    }
}

.valid.findBorderCells.input <- function(object, img_id, border_dist, coords){
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(img_id) != 1 | !is.character(img_id)) {
        stop("'img_id' must be a single string.")
    }

    if (!img_id %in% names(colData(object))) {
        stop("'img_id' not in colData(object).")
    }

    if (length(coords) != 2 | !all(is.character(coords))) {
        stop("'coords' must be a character vector of length 2.")
    }

    if (is(object, "SpatialExperiment")) {
        if (!all(coords %in% spatialCoordsNames(object))) {
            stop("'coords' not in spatialCoords(object).")
        }
    } else {
        if (!all(coords %in% names(colData(object)))) {
            stop("'coords' not in colData(object).")
        }
    }

    if (length(border_dist) != 1 | !is.numeric(border_dist)) {
        stop("'border_dist' must be a single numeric.")
    }
}

.valid.patchDetection.input <- function(object, patch_cells, colPairName,
                                        min_patch_size, name, expand_by, coords,
                                        convex, img_id){
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (!all(is.logical(patch_cells))) {
        stop("'patch_cells' must all be logical.")
    }

    if (length(patch_cells) != ncol(object)) {
        stop("Length of 'patch_cells' must match the number of cells in 'object'.")
    }

    if (length(colPairName) != 1 | !is.character(colPairName)) {
        stop("'colPairName' must be a single string.")
    }

    if (! colPairName %in% colPairNames(object)) {
        stop("'colPairName' not in 'colPairNames(object)'.")
    }

    if (length(colPair(object, colPairName)) == 0) {
        stop("No interactions found.")
    }

    if (length(min_patch_size) != 1 | !is.numeric(min_patch_size)) {
        stop("'min_patch_size' must be a single numeric.")
    }

    if (length(coords) != 2 | !all(is.character(coords))) {
        stop("'coords' must be a character vector of length 2.")
    }

    if (is(object, "SpatialExperiment")) {
        if (!all(coords %in% spatialCoordsNames(object))) {
            stop("'coords' not in spatialCoords(object).")
        }
    } else {
        if (!all(coords %in% names(colData(object)))) {
            stop("'coords' not in colData(object).")
        }
    }

    if (length(name) != 1 | !is.character(name)) {
        stop("'name' must be a single string.")
    }

    if (length(expand_by) != 1 | !is.numeric(expand_by)) {
        stop("'expand_by' must be a single numeric.")
    }

    if (length(convex) != 1 | !is.logical(convex)) {
        stop("'convex' must be a single logical.")
    }

    if (expand_by > 0) {
        if (is.null(img_id)) {
            stop("'img_id' must be specified when patch expansion is performed.")
        }

        if (length(img_id) != 1 | !is.character(img_id)) {
            stop("'img_id' must be a single string.")
        }

        if (!img_id %in% names(colData(object))) {
            stop("'img_id' not in colData(object).")
        }
    }
}

.valid.distToCells.input <- function(object, x_cells, name, coords, statistics,
                                     img_id, return_neg){
  if(!is(object, "SingleCellExperiment")) {
    stop("'object' not of type 'SingleCellExperiment'.")
  }

  if(ncol(object) == 0) {
    stop("'object' must contain at least one cell")
  }

  if (!all(is.logical(x_cells))) {
    stop("'x_cells' must all be logical.")
  }

  if (length(x_cells) != ncol(object)) {
    stop("Length of 'x_cells' must match the number of cells in 'object'.")
  }

  if (length(name) != 1 | !is.character(name)) {
    stop("'name' must be a single string.")
  }

  if (!statistics %in% c("min", "max", "mean", "median")){
    stop("'statistics' not supported. Must be one of 'min', 'max', 'mean' or 'median'")
  }

  if (length(coords) != 2 | !all(is.character(coords))) {
    stop("'coords' must be a character vector of length 2.")
  }

  if (is(object, "SpatialExperiment")) {
    if (!all(coords %in% spatialCoordsNames(object))) {
      stop("'coords' not in spatialCoords(object).")
    }
  } else {
    if (!all(coords %in% names(colData(object)))) {
      stop("'coords' not in colData(object).")
    }
  }

  if (length(img_id) != 1 | !is.character(img_id)) {
    stop("'img_id' must be a single string.")
  }

  if (!img_id %in% names(colData(object))) {
    stop("'img_id' not in colData(object).")
  }

  if(!is.logical(return_neg)){
    stop("'return_neg' is not of type logical.")
  }
}

.valid.patchSize.input <- function(object, patch_name, coords, convex){
    if (!is(object, "SingleCellExperiment")) {
        stop("'object' not of type 'SingleCellExperiment'.")
    }

    if (length(patch_name) != 1 | !is.character(patch_name)) {
        stop("'patch_name' must be a single string.")
    }

    if (!patch_name %in% names(colData(object))) {
        stop("'patch_name' nor in 'colData(object)'.")
    }

    if (length(coords) != 2 | !all(is.character(coords))) {
        stop("'coords' must be a character vector of length 2.")
    }

    if (is(object, "SpatialExperiment")) {
        if (!all(coords %in% spatialCoordsNames(object))) {
            stop("'coords' not in spatialCoords(object).")
        }
    } else {
        if (!all(coords %in% names(colData(object)))) {
            stop("'coords' not in colData(object).")
        }
    }

    if (length(convex) != 1 | !is.logical(convex)) {
        stop("'convex' must be a single logical.")
    }
}

.valid.detectSpatialContext.input <- function(object,
                                              entry,
                                              threshold,
                                              name){
  if (!is(object, "SingleCellExperiment")) {
    stop("'object' needs to be a SingleCellExperiment object.")
  }

  if (!entry %in% names(colData(object))) {
    stop("'entry' not in 'colData(object)'.")
  }

  if (!is(colData(object)[,entry],"DFrame")) {
    stop("'colData(object)[,entry]' needs to be a DFrame object.")
  }

  if (!(is.numeric(threshold) & (0 <= threshold && threshold <= 1))){
    stop("'threshold' needs to be a single numeric between 0-1.")
  }

    if (length(name) != 1 | !is.character(name)) {
    stop("'name' has to be a single character'.")
  }
}

.valid.filterSpatialContext.input <- function(object,
                                              entry,
                                              group_by,
                                              group_threshold,
                                              cells_threshold,
                                              name){

  if (!is(object, "SingleCellExperiment")) {
    stop("'object' needs to be a SingleCellExperiment object.")
  }

  if (!entry %in% names(colData(object))) {
    stop("'entry' not in 'colData(object)'.")
  }

  if (!group_by %in% names(colData(object))) {
    stop("'group_by' not in 'colData(object)'.")
  }

  if (!is.null(group_threshold) &&
      (!is.numeric(group_threshold) | length(group_threshold) != 1)){
    stop("'group_threshold' needs to be a single numeric.")
  }

  if (!is.null(cells_threshold) &&
     (!is.numeric(cells_threshold) | length(cells_threshold) != 1)){
    stop("'cells_threshold' needs to be a single numeric.")
  }

  if (is.null(group_threshold) &&
     (is.null(cells_threshold))) {
    stop("One of 'group_threshold' and 'cells_threshold' ",
         "has to be defined.")
  }

  if (length(name) != 1 | !is.character(name)) {
    stop("'name' has to be a single character'.")
  }
}

.valid.plotSpatialContext.input <- function(object,
                                            entry,
                                            group_by,
                                            node_color_by,
                                            node_size_by,
                                            node_color_fix,
                                            node_size_fix,
                                            node_label_repel,
                                            node_label_color_by,
                                            node_label_color_fix,
                                            draw_edges,
                                            edge_color_fix,
                                            return_data){
  if (!is(object, "SingleCellExperiment")) {
    stop("'object' needs to be a SingleCellExperiment object.")
  }

  if (!entry %in% names(colData(object))) {
    stop("'entry' not in 'colData(object)'.")
  }
  
  if (all(is.na(colData(object)[[entry]]))) {
    stop("'entry' contains only NAs.")
  }

  if (!group_by %in% names(colData(object))) {
    stop("'group_by' not in 'colData(object)'.")
  }

  if (!is.null(node_color_by) &&
      (!node_color_by %in% c("name", "n_cells", "n_group"))){
    stop("'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.")
  }

  if (!is.null(node_size_by) &&
      (!node_size_by %in% c("n_cells", "n_group"))){
    stop("'node_size_by' has to be 'n_cells' or 'n_group'.")
  }

  if (!is.null(node_label_color_by) &&
      (!node_label_color_by %in% c("name","n_cells","n_group"))){
    stop("'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.")
  }

  if (!is.logical(node_label_repel)) {
    stop("'node_label_repel' has to be logical'.")
  }

  if(node_label_repel == FALSE){
    if(!is.null(node_label_color_by) | (!is.null(node_label_color_fix))){
    stop("'node_label_color_by' and 'node_label_color_fix' can not be defined ",
         "when node_label_repel == FALSE")
  }}

  if (!is.logical(draw_edges)) {
    stop("'draw_edges' has to be logical'.")
  }

  if (!is.null(node_color_fix) &&
      (!is.character(node_color_fix))){
    stop("'node_color_fix' has to be a character'.")
  }

  if (!is.null(node_size_fix) &&
      (!is.character(node_size_fix))){
    stop("'node_size_fix' has to be a character'.")
  }

  if (!is.null(node_label_color_fix) &&
      (!is.character(node_label_color_fix))){
    stop("'node_label_color_fix' has to be a character'.")
  }

  if (!is.null(edge_color_fix) &&
      (!is.character(edge_color_fix))){
    stop("'edge_color_fix' has to be a character'.")
  }

  if(!is.null(node_color_by) &&
     (!is.null(node_color_fix))){
    stop("'node_color_by' and 'node_color_fix' can not be defined ",
         "at the same time.")
  }

  if(!is.null(node_label_color_by) &&
     (!is.null(node_label_color_fix))){
    stop("'node_label_color_by' and 'node_label_color_fix' can not be defined ",
         "at the same time.")
  }

  if(!is.null(node_label_color_by) &&
     (!is.null(node_color_by)) &&
     (node_label_color_by != node_color_by)){
    stop("'node_label_color_by' and 'node_color_by' have to be identical.")
  }

  if(!is.null(node_size_by) &&
     (!is.null(node_size_fix))){
    stop("'node_size_by' and 'node_size_fix' can not be defined ",
         "at the same time.")
  }

  if (!is.logical(return_data)) {
    stop("'return_data' has to be logical'.")
  }
}

.valid.detectCommunity.input <- function(object,
                                         colPairName,
                                         size_threshold,
                                         group_by,
                                         name,
                                         cluster_fun){


  if (!is(object, "SingleCellExperiment")) {
    stop("'object' needs to be a SingleCellExperiment object.")
  }

  if (is.null(colnames(object)) |
      length(unique(colnames(object))) != length(colnames(object))) {
    stop("'colnames' of 'object' need to be specified and unique (e.g. as cell IDs).")
  }

  if (length(colPairName) != 1 | !is.character(colPairName)) {
    stop("'colPairName' must be a single string.")
  }

  if (! colPairName %in% colPairNames(object)) {
    stop("'colPairName' not in 'colPairNames(object)'.")
  }

  if (length(colPair(object, colPairName)) == 0) {
    stop("No interactions found.")
  }

  if (!is.numeric(size_threshold) | length(size_threshold) != 1
       | size_threshold < 0){
    stop("'size_threshold' needs to be a positive single numeric.")
  }

  if (!is.null(group_by) &&
      (!group_by %in% names(colData(object)))) {
    stop("'group_by' not in 'colData(object)'.")
  }

  if (length(name) != 1 | !is.character(name)) {
    stop("'name' has to be a single character.")
  }

  if (length(cluster_fun) != 1 | !is.character(cluster_fun)) {
    stop("'cluster_fun' has to be a single character.")
  }
}

.valid.plotInteractions.input <- function(out,
                                          object,
                                          label,
                                          group_by,
                                          node_color_by, 
                                          node_size_by,
                                          node_color_fix,
                                          node_size_fix,
                                          node_label_repel,
                                          node_label_color_by,
                                          node_label_color_fix,
                                          edge_color_by, 
                                          edge_color_fix,
                                          edge_width_by,
                                          edge_width_fix,
                                          draw_edges,
                                          graph_layout,
                                          return_data){
  
  if (!all(c("group_by", "from_label", "to_label") %in% colnames(out))){
    stop("'out' needs to contain columns 'group_by', 'from_label', 'to_label'.")
  }
  
  if (!is(object, "SingleCellExperiment")) {
    stop("'object' needs to be a SingleCellExperiment object.")
  }
  
  if (!label %in% names(colData(object))){
    stop("'label' not in 'colData(object)'.")
  }
  
  if (!group_by %in% names(colData(object))) { 
    stop("'group_by' not in 'colData(object)'.")
  }
  
  if (!is.null(node_color_by) &&
      (!node_color_by %in% c("name", "n_cells", "n_group"))){
    stop("'node_color_by' has to be one off 'name', 'n_cells' or 'n_group'.")
  }
  
  if (!is.null(node_size_by) &&
      (!node_size_by %in% c("n_cells", "n_group"))){
    stop("'node_size_by' has to be 'n_cells' or 'n_group'.")
  }
  
  if (!is.null(node_label_color_by) && 
      (!node_label_color_by %in% c("name","n_cells","n_group"))){
    stop("'node_label_color_by' has to be one off 'name', 'n_cells' or 'n_group'.")
  }
  
  if (!is.logical(node_label_repel)) {
    stop("'node_label_repel' has to be logical.")
  }
  
  if(node_label_repel == FALSE){
    if(!is.null(node_label_color_by) | (!is.null(node_label_color_fix))){
      stop("'node_label_color_by' and 'node_label_color_fix' can not be defined ", 
           "when node_label_repel == FALSE")
    }} 
  
  if (!is.logical(draw_edges)) {
    stop("'draw_edges' has to be logical.")
  }
  
  if (!is.null(node_color_fix) && 
      (!is.character(node_color_fix))){
    stop("'node_color_fix' has to be a character.")
  }
  
  if (!is.null(node_size_fix) &&
      (!is.numeric(node_size_fix))){
    stop("'node_size_fix' has to be numeric.")
  }
  
  if (!is.null(node_label_color_fix) &&
      (!is.character(node_label_color_fix))){
    stop("'node_label_color_fix' has to be a character.")
  }
  
  if(!is.null(node_color_by) &&
     (!is.null(node_color_fix))){
    stop("'node_color_by' and 'node_color_fix' can not be defined ", 
         "at the same time.")
  }
  
  if(!is.null(node_label_color_by) &&
     (!is.null(node_label_color_fix))){
    stop("'node_label_color_by' and 'node_label_color_fix' can not be defined ", 
         "at the same time.")
  }  
  
  if(!is.null(node_label_color_by) &&
     (!is.null(node_color_by)) && 
     (node_label_color_by != node_color_by)){
    stop("'node_label_color_by' and 'node_color_by' have to be identical.")
  }
  
  if(!is.null(node_size_by) &&
     (!is.null(node_size_fix))){
    stop("'node_size_by' and 'node_size_fix' can not be defined ", 
         "at the same time.")
  } 
  
  if (!is.logical(return_data)) {
    stop("'return_data' has to be logical.")
  }
  
  
  # edge_color_by
  if (!is.null(edge_color_by)){
    
    if (any(is.na(out[[edge_color_by]]))){
      stop("'edge_color_by' contains NA values.")
    }
    
    if (!edge_color_by %in% names(out)) {
      stop("'edge_color_by' needs to be contained in 'out'.")
    }
    
    test <- out %>% group_by(from_label, to_label) %>% summarise(n_unique = n_distinct(.data[[edge_color_by]]))
    if (any(test$n_unique > 1)) {
      stop("'edge_color_by' needs to be unique for all 'from_label'-'to_label' pairs.")
    }
  }
  
  # edge_color_fix
  if (!is.null(edge_color_fix) && 
      (!is.character(edge_color_fix))){
    stop("'edge_color_fix' has to be a character.")
  }
  
  if (!is.null(edge_color_by) &&
     (!is.null(edge_color_fix))){
    stop("'edge_color_by' and 'edge_color_fix' can not be defined ", 
         "at the same time.")
  }
  
  # edge_width_by
  if (!is.null(edge_width_by)){
    
    if (!is.character(edge_width_by)){
      stop("'edge_width_by' has to be a character.")
    }
    
    if (!edge_width_by %in% names(out)) {
      stop("'edge_width_by' needs to be contained in 'out'.")
    }
    
    if (!is.numeric(out[[edge_width_by]])){
      stop("'edge_width_by' entries need to be numeric.")
    }
    
    test <- out %>% as.data.frame() %>% group_by(from_label, to_label) %>% summarise(mean = mean(.data[[edge_width_by]], na.rm = TRUE))
    if (anyNA(test$mean)) {
      missing <- test %>% filter(is.na(mean))
      stop("Missing weights for some 'from_label'-'to_label' pairs:\n", 
           paste(capture.output(print(missing)), collapse = "\n"))
    }
  }
  
  if (!is.null(edge_width_fix) &&
      (!is.numeric(edge_width_fix))){
    stop("'edge_width_fix' has to be numeric.")
  }
  
  if(!is.null(edge_width_by) &&
     (!is.null(edge_width_fix))){
    stop("'edge_width_by' and 'edge_width_fix' can not be defined ", 
         "at the same time.")
  }
  
  if (!is.null(graph_layout)) {
    if (!is.character(graph_layout)) {
      stop("'graph_layout' has to be a character.")
    }
    
    allowed_layouts <- c("nicely", "kk", "drl", "tree", "circle", "linear", 
                         "manual", "fr", "lgl", "chord", "stress", "graphopt",
                         "sugiyama", "star", "dh", "gem", "grid", "mds", "sphere",
                         "randomly")
    
    if (!graph_layout %in% allowed_layouts) {
      stop(paste0("Layout '", graph_layout, "' not in supported list. Refer to: ",
                     "https://cran.r-project.org/web/packages/ggraph/vignettes/Layouts.html"))
    }
  }
  }

#' @title Plot interaction graph
#'
#' @description Function to plot directed interaction graphs based on symbolic 
#' edge-lists and vertex metadata.
#' The user can specify node, node_label and edge aesthetics using dedicated
#' arguments. The resulting plot can be further refined with `ggplot2` for node 
#' styling and `ggraph` for edge-specific customization.
#'
#' @param out a data frame, usually the output from \code{countInteractions} or 
#' \code{testInteractions}, representing an edge list with columns \code{"group_by",
#' "from_label" and "to_label"}. Additional columns may be included to specify 
#' edge attributes (weight or color). 
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object.
#' @param label single character specifying the \code{colData(object)} entry
#' which stores the cell labels. These can be cell-types labels or other
#' metadata entries.
#' @param group_by a single character indicating the \code{colData(object)}
#' entry by which interactions are grouped. This is usually the image or patient ID. 
#' a single character indicating the \code{colData(object)}
#' @param node_color_by single character either
#' \code{NULL, "name","n_cells", "n_group"} by which the nodes should be
#' colored.
#' @param node_size_by single character either \code{NULL, "n_cells","n_group"} 
#' by which the size of the nodes are defined.
#' @param node_color_fix single character specifying the color of all nodes.
#' @param node_size_fix single numeric specifying the size of all nodes.
#' @param node_label_repel should nodes be labelled? Defaults to TRUE.
#' @param node_label_color_by single character either
#' \code{NULL, "name","n_cells","n_group"} by which the node labels should be
#' colored.
#' @param node_label_color_fix single character specifying the color of all node
#' labels.
#' @param edge_color_by single character indicating the name of the column of \code{"out"} 
#' used represent edge colors. This column is usually newly added by the user and must assign a 
#' unique value to each 'from_label'–'to_label' pair. Typically, these values could encode 
#' the direction of significantly interacting cell type pairs. 
#' @param edge_color_fix single character specifying the color of all edges.
#' @param edge_width_by single character indicating the name of the column of \code{"out"} 
#' used to scale edge widths. The values in this column are averaged for each 
#' 'from_label'–'to_label' pair. Typically, this could be the 'ct' column from 
#' of \code{"out"} or a newly added column representing an interaction feature. 
#' @param edge_width_fix single numeric specifying the width of all edges.
#' @param draw_edges should edges be drawn between nodes? Defaults to TRUE.
#' @param graph_layout single character of
#' \code{"circle", "chord", "linear", "fr", "kk", "drl", "stress", "graphopt", 
#' "lgl", "tree", "sugiyama", "star", "nicely", "manual", "grid", "mds", "sphere", 
#' "randomly", "gem", "dh"} which defines the graph layout.
#' Defaults to \code{"circle"}. For more information, see \link[ggraph]{ggraph}.
#' @param return_data should the edge list and vertex metadata for graph
#' construction be returned as a \code{list} of two \code{data.frames}?
#' 
#' @return returns a \code{ggplot} object or a \code{list} of two
#' \code{data.frames}.
#' 
#' @examples 
#' set.seed(22)
#' library(cytomapper)
#' library(BiocParallel)
#' data(pancreasSCE)
#'
#' ## 1. countInteractions or testInteractions
#' sce  <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn", k = 3)
#' 
#' count_out <- countInteractions(sce,
#'                                group_by = "ImageNb",
#'                                label = "CellType",
#'                                method = "classic", # choose from c("classic", "histocat", "patch", "interaction")
#'                                colPairName = "knn_interaction_graph")
#' 
#' test_out <- testInteractions(sce, 
#'                              group_by = "ImageNb",
#'                              label = "CellType", 
#'                              method = "classic", # choose from c("classic", "histocat", "patch", "interaction")
#'                              colPairName = "knn_interaction_graph", 
#'                              iter = 100, 
#'                              p_threshold = 0.5, 
#'                              BPPARAM = SerialParam(RNGseed = 123))
#' 
#' ## 2. Plot interactions 
#' 
#' # default                
#' plotInteractions(count_out, sce, "CellType", "ImageNb")
#' 
#' # adjust node aesthetics
#' plotInteractions(count_out, sce, "CellType", "ImageNb",
#'                  node_color_by = "name",
#'                  node_size_by = "n_cells")
#'                  
#' # adjust edge aesthetics
#' plotInteractions(test_out, sce, "CellType", "ImageNb", 
#'                  edge_width_by = "ct")
#'                    
#' # Plot interactions - return data
#' plotInteractions(test_out, sce, "CellType", "ImageNb",
#'                  return_data = TRUE)          
#'                   
#' @seealso 
#' \code{\link{countInteractions}} for counting (but not testing) cell-cell
#' interactions per grouping level.
#' \code{\link{testInteractions}} for testing cell-cell 
#' interactions per grouping level.
#' 
#' @author Marlene Lutz (\email{marlene.lutz@@uzh.ch})
#' 
#' @importFrom SingleCellExperiment colData
#' @importFrom dplyr group_by summarise filter mutate select n count across group_by_at
#' @importFrom tidyselect all_of
#' @importFrom igraph graph_from_data_frame
#' @importFrom stats na.omit
#' @export

plotInteractions <- function(out,
                             object,
                             label,
                             group_by,
                             node_color_by = NULL,
                             node_size_by = NULL,
                             node_color_fix = NULL,
                             node_size_fix = NULL,
                             node_label_repel = TRUE,
                             node_label_color_by = NULL, 
                             node_label_color_fix = NULL,
                             edge_color_by = NULL,
                             edge_color_fix = NULL,
                             edge_width_by = NULL,
                             edge_width_fix = NULL,
                             draw_edges = TRUE,
                             return_data = FALSE,
                             graph_layout = "circle") {
  
  .valid.plotInteractions.input(out, object, label, group_by, node_color_by, node_size_by,
                                node_color_fix, node_size_fix, node_label_repel,
                                node_label_color_by, node_label_color_fix,
                                edge_color_by, edge_color_fix, edge_width_by, edge_width_fix,
                                draw_edges, graph_layout, return_data)
  
  # Edge attributes
  if (is.null(edge_width_by)) {
    edges <- out %>% as.data.frame() %>%
      select(from_label, to_label, color = all_of(edge_color_by)) %>%
      mutate(weight = 1)
  } else {
    edges <- out %>% as.data.frame() %>%
      select(from_label, to_label, color = all_of(edge_color_by), weight = all_of(edge_width_by)) %>%
      group_by(from_label, to_label) %>%
      mutate(weight = mean(weight, na.rm = TRUE))
  }
  
  # Node attributes
  cur_dat <- colData(object) %>%
    as.data.frame() %>%
    select(all_of(label), all_of(group_by)) %>%
    group_by(across(everything())) %>%
    count() %>%
    na.omit() %>%
    as.data.frame()
  
  anno <- cur_dat %>%
    group_by_at(label) %>%
    summarise(n_cells = sum(n), n_group = n(), .groups = "drop") %>%
    filter(.data[[label]] %in% c(edges$from_label, edges$to_label)) %>%
    as.data.frame
  
  # Create graph object
  graph <- graph_from_data_frame(d = edges, directed = TRUE, vertices = anno)
  
  # Generate plot
  plot <- .generateInteractionsPlot(graph = graph,
                                    node_color_by = node_color_by,
                                    node_size_by = node_size_by,
                                    node_color_fix = node_color_fix,
                                    node_size_fix = node_size_fix,
                                    node_label_repel = node_label_repel,
                                    node_label_color_by = node_label_color_by,
                                    node_label_color_fix = node_label_color_fix,
                                    edge_color_by = edge_color_by,
                                    edge_color_fix = edge_color_fix,
                                    edge_width_by = edge_width_by,
                                    edge_width_fix = edge_width_fix,
                                    draw_edges = draw_edges,
                                    graph_layout = graph_layout)
  
  # Return data or plot
  if (return_data) {
    return(list(edges = edges, vertices = anno))
  } else {
    return(plot)
  }
}

#' @rdname countInteractions
#' @title Summarizes cell-cell interactions within grouping levels (e.g. images)
#'
#' @description Function to calculate the average number of neighbors B that
#' a cell of type A has using different approaches. 
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object .
#' @param group_by a single character indicating the \code{colData(object)}
#' entry by which interactions are grouped. This is usually the image ID or
#' patient ID.
#' @param label single character specifying the \code{colData(object)} entry
#' which stores the cell labels. These can be cell-types labels or other
#' metadata. 
#' @param method which cell-cell interaction counting method to use 
#' (see details)
#' @param patch_size if \code{method = "patch"}, a single numeric specifying
#' the minimum number of neighbors of the same type to be considered a patch
#' (see details)
#' @param colPairName single character indicating the \code{colPair(object)}
#' entry containing cell-cell interactions in form of an edge list.
#'
#' @section Counting and summarizing cell-cell interactions:
#' In principle, the \code{countInteractions} function counts the number
#' of edges (interactions) between each set of unique entries in 
#' \code{colData(object)[[label]]}. Simplified, it counts for each cell of
#' type A the number of neighbors of type B.
#' This count is averaged within each unique entry 
#' \code{colData(object)[[group_by]]} in four different ways:
#' 
#' 1. \code{method = "classic"}: The count is divided by the total number of 
#' cells of type A. The final count can be interpreted as "How many neighbors 
#' of type B does a cell of type A have on average?" 
#' 
#' 2. \code{method = "conditional"}: Formerly named "histocat". The count is divided 
#' by the number of cells of type A that have at least one neighbor of type B. The 
#' final count can be interpreted as "How many neighbors of type B has a cell of 
#' type A on average, given it has at least one neighbor of type B?".
#' 
#' 3. \code{method = "patch"}: For each cell, the count is binarized to 0 
#' (less than \code{patch_size} neighbors of type B) or 1 (more or equal to 
#' \code{patch_size} neighbors of type B). The binarized counts are averaged 
#' across all cells of type A. The final count can be interpreted as "What 
#' fraction of cells of type A have at least a given number of neighbors of 
#' type B?"
#' 
#' 4. \code{method = "interaction"}: The count is divided by the total number of 
#' interactions from cell type A. The final count can be interpreted as "What 
#' fraction of interactions of cell type A occur with cell type B."
#' 
#' @return a DataFrame containing one row per \code{group_by} entry and unique
#' \code{label} entry combination (\code{from_label}, \code{to_label}). The
#' \code{ct} entry stores the interaction count as described in the details.
#' \code{NA} is returned if a certain label is not present in this grouping
#' level.
#'   
#' @examples 
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                                   type = "knn", k = 3)
#'                                
#' # Classic style calculation
#' (out <- countInteractions(pancreasSCE, 
#'                                 group_by = "ImageNb",
#'                                 label = "CellType", 
#'                                 method = "classic",
#'                                 colPairName = "knn_interaction_graph"))
#'                                 
#' # Conditional style calculation
#' (out <- countInteractions(pancreasSCE, 
#'                                 group_by = "ImageNb",
#'                                 label = "CellType", 
#'                                 method = "conditional",
#'                                 colPairName = "knn_interaction_graph"))
#'                                 
#' # Patch style calculation
#' (out <- countInteractions(pancreasSCE, 
#'                                 group_by = "ImageNb",
#'                                 label = "CellType", 
#'                                 method = "patch",
#'                                 patch_size = 3,
#'                                 colPairName = "knn_interaction_graph"))
#'
#' # Interaction style calculation
#' (out <- countInteractions(pancreasSCE, 
#'                                 group_by = "ImageNb",
#'                                 label = "CellType", 
#'                                 method = "interaction",
#'                                 colPairName = "knn_interaction_graph"))
#'                                 
#' @seealso 
#' \code{\link{testInteractions}} for testing cell-cell
#' interactions per grouping level.
#'
#' @author Vito Zanotelli
#' @author Jana Fischer
#' @author adapted by Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' @author adapted by Marlene Lutz (\email{marlene.lutz@@uzh.ch})
#' 
#' @references
#' \href{https://www.sciencedirect.com/science/article/pii/S2405471217305434}{
#' Schulz, D. et al., Simultaneous Multiplexed Imaging of mRNA and Proteins with 
#' Subcellular Resolution in Breast Cancer Tissue Samples by Mass Cytometry., 
#' Cell Systems 2018 6(1):25-36.e5}
#' 
#' \href{https://www.nature.com/articles/nmeth.4391}{
#' Schapiro, D. et al., histoCAT: analysis of cell phenotypes and interactions in 
#' multiplex image cytometry data, Nature Methods 2017 14, p. 873–876}
#' 
#' @importFrom data.table setorder
#'
#' @export
countInteractions <- function(object, 
                                 group_by,
                                 label,
                                 colPairName,
                                 method = c("classic", "conditional", "patch", "interaction"),
                                 patch_size = NULL){
    
    # Input check
    .valid.countInteractions.input(object, group_by, label, method,
                                    patch_size, colPairName)
    method <- match.arg(method)
    
    # Re-level group_by label
    if(is.factor(colData(object)[[group_by]])) {
        colData(object)[[group_by]] <- as.factor(as.character(colData(object)[[group_by]]))
    }
    
    cur_label <- factor(colData(object)[[label]])
    cur_table <- .prepare_table(object, group_by, cur_label, colPairName)
    
    # Count interactions
    if (method == "classic") {
        cur_count <- .aggregate_classic(cur_table, object, group_by, label)
    } else if (method == "conditional") {
        cur_count <- .aggregate_conditional(cur_table, object, group_by, label)
    } else if (method == "patch") {
        cur_count <- .aggregate_classic_patch(cur_table, 
                                                patch_size = patch_size,
                                                object, group_by, label)
    } else if (method == "interaction") {
        cur_count <- .aggregate_interaction(cur_table, object, group_by, label)
    }
    
    setorder(cur_count, "group_by", "from_label", "to_label")
    cur_count <- as(cur_count, "DataFrame")
    
    return(cur_count)
}

test_that("countInteractions function works", {
    library(cytomapper)
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    ########################### classic ############################

    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "classic",
                                                   colPairName = "knn_interaction_graph")) 
    cur_out <- as.data.frame(cur_out)
    cur_out <- cur_out[order(cur_out$group_by, cur_out$from_label, cur_out$to_label),]
    
    # Check against manual calculations
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    test <- as.data.frame(test)
    test <- test[order(test$image, test$from_label, test$`as.factor(to_label)`),]
    
    cur_out_2 <- cur_out
    cur_out_2 <- cur_out_2[match(paste(test$image, test$from_label, test$`as.factor(to_label)`),
                                 paste(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label)),]

    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)])   

    # As factor
    pancreasSCE$CellType <- as.factor(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "classic",
                                                   colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
        
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As character
    pancreasSCE$CellType <- as.character(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "classic",
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2, cur_out)
    
    # As numeric
    pancreasSCE$CellType <- as.numeric(as.factor(pancreasSCE$CellType))
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "classic",
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # Logical
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "Pattern", method = "classic",
                                                   colPairName = "knn_interaction_graph")) 

    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["Pattern"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["Pattern"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)]) 
    
    # One image only contains one cell type
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    pancreasSCE$test <- pancreasSCE$CellType
    pancreasSCE$test[pancreasSCE$ImageNb == 3] <- "test" 
    expect_silent(cur_out_3 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "test", method = "classic",
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_out_3 <- as.data.frame(cur_out_3)
    cur_out_3 <- cur_out_3[order(cur_out_3$group_by, cur_out_3$from_label, cur_out_3$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["test"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["test"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    cur_out_4 <- cur_out_3
    cur_out_4 <- cur_out_4[match(paste(test$image, test$from_label, test$`as.factor(to_label)`),
                                 paste(cur_out_4$group_by, cur_out_4$from_label, cur_out_4$to_label)),]
    
    expect_equal(cur_out_4$ct[!is.na(cur_out_4$ct)], test$ct[!is.na(cur_out_4$ct)]) 
    expect_equal(cur_out_3$ct[!is.na(cur_out_3$ct) & cur_out_3$group_by != 3], cur_out$ct[!is.na(cur_out$ct) & cur_out$group_by != 3]) 
    
    data(pancreasSCE)
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    pancreasSCE$ImageName <- "test"
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageName",
                                                   label = "CellType", method = "classic",
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageName"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    expect_equal(cur_out$ct, test$ct)
    
    ########################### conditional ############################
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "conditional",
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_out <- as.data.frame(cur_out)
    cur_out <- cur_out[order(cur_out$group_by, cur_out$from_label, cur_out$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label)) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    test <- as.data.frame(test)
    test <- test[order(test$image, test$from_label, test$`as.factor(to_label)`),]
    
    expect_equal(cur_out$ct[!is.na(cur_out$ct)], test$ct)
    
    # As factor
    pancreasSCE$CellType <- as.factor(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "conditional",
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As character
    pancreasSCE$CellType <- as.character(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "conditional",
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As numeric
    pancreasSCE$CellType <- as.numeric(as.factor(pancreasSCE$CellType))
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "conditional",
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # Logical
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "Pattern", method = "conditional",
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["Pattern"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["Pattern"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label)) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    expect_equal(cur_out_2$ct, test$ct) 
    
    # One image only contains one cell type
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    pancreasSCE$test <- pancreasSCE$CellType
    pancreasSCE$test[pancreasSCE$ImageNb == 3] <- "test" 
    expect_silent(cur_out_3 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "test", method = "conditional",
                                                     colPairName = "knn_interaction_graph")) 
    
    cur_out_3 <- as.data.frame(cur_out_3)
    cur_out_3 <- cur_out_3[order(cur_out_3$group_by, cur_out_3$from_label, cur_out_3$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["test"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["test"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label)) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    expect_equal(cur_out_3$ct[!is.na(cur_out_3$ct)], test$ct) 
    expect_equal(cur_out_3$ct[cur_out_3$group_by != 3 & !is.na(cur_out_3$ct)], 
                 cur_out$ct[cur_out$group_by != 3]) 
    
    data(pancreasSCE)
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    pancreasSCE$ImageName <- "test"
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageName",
                                                   label = "CellType", method = "conditional",
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageName"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label)) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(n))
    
    expect_equal(cur_out$ct, test$ct)
    
    ########################### patch ############################
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "patch",
                                                   patch_size = 3,
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_out <- as.data.frame(cur_out)
    cur_out <- cur_out[order(cur_out$group_by, cur_out$from_label, cur_out$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% ungroup() %>% 
        mutate(ct = n >= 3) %>%
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(ct))
    
    test <- as.data.frame(test)
    test <- test[order(test$image, test$from_label, test$`as.factor(to_label)`),]
    
    cur_out_2 <- cur_out
    cur_out_2 <- cur_out_2[match(paste(test$image, test$from_label, test$`as.factor(to_label)`),
                                 paste(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label)),]
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)])
    
    # As factor
    pancreasSCE$CellType <- as.factor(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "patch",
                                                     patch_size = 3,
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As character
    pancreasSCE$CellType <- as.character(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "patch",
                                                     patch_size = 3,
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As numeric
    pancreasSCE$CellType <- as.numeric(as.factor(pancreasSCE$CellType))
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "CellType", method = "patch",
                                                     patch_size = 3,
                                                     colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # Logical
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "Pattern", method = "patch",
                                                     patch_size = 3,
                                                     colPairName = "knn_interaction_graph")) 
    
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["Pattern"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["Pattern"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>%
        mutate(ct = n >= 3) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(ct))
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)]) 
    
    # One image only contains one cell type
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    pancreasSCE$test <- pancreasSCE$CellType
    pancreasSCE$test[pancreasSCE$ImageNb == 3] <- "test" 
    expect_silent(cur_out_3 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                     label = "test", method = "patch",
                                                     patch_size = 3,
                                                     colPairName = "knn_interaction_graph")) 
    
    cur_out_3 <- as.data.frame(cur_out_3)
    cur_out_3 <- cur_out_3[order(cur_out_3$group_by, cur_out_3$from_label, cur_out_3$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["test"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["test"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% 
        mutate(ct = n >= 3) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(ct))
    
    cur_out_4 <- cur_out_3
    cur_out_4 <- cur_out_4[match(paste(test$image, test$from_label, test$`as.factor(to_label)`),
                                 paste(cur_out_4$group_by, cur_out_4$from_label, cur_out_4$to_label)),]
    
    expect_equal(cur_out_4$ct[!is.na(cur_out_4$ct)], test$ct[!is.na(cur_out_4$ct)]) 
    expect_equal(cur_out_3$ct[!is.na(cur_out_3$ct) & cur_out_3$group_by != 3], cur_out$ct[!is.na(cur_out$ct) & cur_out$group_by != 3]) 
    
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "patch",
                                                   patch_size = 4,
                                                   colPairName = "knn_interaction_graph")) 
    
    expect_equal(cur_out$ct[!is.na(cur_out$ct)], rep(0, 22))
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "patch",
                                                   patch_size = 0,
                                                   colPairName = "knn_interaction_graph")) 
    
    expect_equal(cur_out$ct[!is.na(cur_out$ct)], rep(1, 22))
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                   label = "CellType", method = "patch",
                                                   patch_size = 1,
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% 
        mutate(ct = n >= 1) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(ct))
    
    cur_out_2 <- cur_out
    cur_out_2 <- cur_out_2[match(paste(test$image, test$from_label, test$`as.factor(to_label)`),
                                 paste(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label)),]
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)]) 
    
    data(pancreasSCE)
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    pancreasSCE$ImageName <- "test"
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageName",
                                                   label = "CellType", method = "patch",
                                                   patch_size = 3,
                                                   colPairName = "knn_interaction_graph")) 
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageName"]][cur_table$from]
    
    test <- cur_table %>% group_by(from, image, from_label) %>%
        count(as.factor(to_label), .drop = FALSE) %>% 
        mutate(ct = n >= 3) %>% ungroup() %>% 
        group_by(image, from_label, `as.factor(to_label)`) %>% summarize(ct = mean(ct))
    
    expect_equal(cur_out$ct, test$ct)
    
    data(pancreasSCE)
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    ############################ interaction ############################
    
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                               label = "CellType", method = "interaction",
                                               colPairName = "knn_interaction_graph")) 
    cur_out <- as.data.frame(cur_out)
    cur_out <- cur_out[order(cur_out$group_by, cur_out$from_label, cur_out$to_label),]
    
    # Check against manual calculations
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(image, from_label, to_label) %>%
      summarize(N = n(), .groups = "drop") %>%
      group_by(image, from_label) %>% mutate(n_tot_int = sum(N)) %>%
      ungroup() %>% mutate(ct = N / n_tot_int)
    
    test <- as.data.frame(test)
    test <- test[order(test$image, test$from_label, test$to_label),]
    
    cur_out_2 <- cur_out
    cur_out_2 <- cur_out_2[match(paste(test$image, test$from_label, test$to_label),
                                 paste(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label)),]
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)]) 
    
    # As factor
    pancreasSCE$CellType <- as.factor(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                 label = "CellType", method = "interaction",
                                                 colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # As character
    pancreasSCE$CellType <- as.character(pancreasSCE$CellType)
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                 label = "CellType", method = "interaction",
                                                 colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2, cur_out)
    
    # As numeric
    pancreasSCE$CellType <- as.numeric(as.factor(pancreasSCE$CellType))
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                 label = "CellType", method = "interaction",
                                                 colPairName = "knn_interaction_graph")) 
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    expect_equal(cur_out_2$ct, cur_out$ct)
    
    # Logical
    expect_silent(cur_out_2 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                 label = "Pattern", method = "interaction",
                                                 colPairName = "knn_interaction_graph")) 
    
    cur_out_2 <- as.data.frame(cur_out_2)
    cur_out_2 <- cur_out_2[order(cur_out_2$group_by, cur_out_2$from_label, cur_out_2$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["Pattern"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["Pattern"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(image, from_label, to_label) %>%
      summarize(N = n(), .groups = "drop") %>%
      group_by(image, from_label) %>% mutate(n_tot_int = sum(N)) %>%
      ungroup() %>% mutate(ct = N / n_tot_int)
    
    expect_equal(cur_out_2$ct[!is.na(cur_out_2$ct)], test$ct[!is.na(cur_out_2$ct)])
    
    # ct values sum up to 1 for the "from_label" cell-type per grouping level
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                               label = "CellType", method = "interaction",
                                               colPairName = "knn_interaction_graph")) 
    
    test <- cur_out %>% as.data.frame() %>% filter(!is.na(ct)) %>% group_by(group_by, from_label) %>% summarise(sum_ct = sum(ct))
    
    expect_equal(sum(test$sum_ct)/nrow(test), 1)
    
    # One image only contains one cell type
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    pancreasSCE$test <- pancreasSCE$CellType
    pancreasSCE$test[pancreasSCE$ImageNb == 3] <- "test" 
    expect_silent(cur_out_3 <- countInteractions(pancreasSCE, group_by = "ImageNb",
                                                 label = "test", method = "interaction",
                                                 colPairName = "knn_interaction_graph")) 
    
    cur_out_3 <- as.data.frame(cur_out_3)
    cur_out_3 <- cur_out_3[order(cur_out_3$group_by, cur_out_3$from_label, cur_out_3$to_label),]
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["test"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["test"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageNb"]][cur_table$from]
    
    test <- cur_table %>% group_by(image, from_label, to_label) %>%
      summarize(N = n(), .groups = "drop") %>%
      group_by(image, from_label) %>% mutate(n_tot_int = sum(N)) %>%
      ungroup() %>% mutate(ct = N / n_tot_int)
    
    cur_out_4 <- cur_out_3
    cur_out_4 <- cur_out_4[match(paste(test$image, test$from_label, test$to_label),
                                 paste(cur_out_4$group_by, cur_out_4$from_label, cur_out_4$to_label)),]
    
    expect_equal(cur_out_4$ct[!is.na(cur_out_4$ct)], test$ct[!is.na(cur_out_4$ct)]) 
    expect_equal(cur_out_3$ct[!is.na(cur_out_3$ct) & cur_out_3$group_by != 3], cur_out$ct[!is.na(cur_out$ct) & cur_out$group_by != 3]) 
    
    data(pancreasSCE)
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    pancreasSCE$ImageName <- "test"
    
    expect_silent(cur_out <- countInteractions(pancreasSCE, group_by = "ImageName",
                                               label = "CellType", method = "interaction",
                                               colPairName = "knn_interaction_graph")) 
    
    cur_table <- as.data.frame(colPair(pancreasSCE, "knn_interaction_graph"))
    cur_table$from_label <- colData(pancreasSCE)[["CellType"]][cur_table$from]
    cur_table$to_label <- colData(pancreasSCE)[["CellType"]][cur_table$to]
    cur_table$image <- colData(pancreasSCE)[["ImageName"]][cur_table$from]
    
    test <- cur_table %>% group_by(image, from_label, to_label) %>%
      summarize(N = n(), .groups = "drop") %>%
      group_by(image, from_label) %>% mutate(n_tot_int = sum(N)) %>%
      ungroup() %>% mutate(ct = N / n_tot_int)
    
    expect_equal(cur_out$ct, test$ct)
    
    # Fail
    expect_error(countInteractions("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "test_test", label = "CellType", colPairName = "knn_interaction_graph"),
                 regexp = "'group_by' not in colData(object).",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = 1, label = "CellType", colPairName = "knn_interaction_graph"),
                 regexp = "'group_by' must be a single string.",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = "test_test", colPairName = "knn_interaction_graph"),
                 regexp = "'label' not in colData(object).",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = 1, colPairName = "knn_interaction_graph"),
                 regexp = "'label' must be a single string.",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", colPairName = "test"),
                 regexp = "'colPairName' not in colPairNames(object).",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", colPairName = 1),
                 regexp = "'colPairName' must be a single string.",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", colPairName = "knn_interaction_graph",
                                       method = "patch"),
                 regexp = "When method = 'patch', please specify 'patch_size'.",
                 fixed = TRUE)
    expect_error(countInteractions(pancreasSCE, group_by = "ImageNb", label = "CellType", colPairName = "knn_interaction_graph",
                                       method = "patch", patch_size = "test"),
                 regexp = "'patch_size' must be a single numeric.",
                 fixed = TRUE)
})

#' @title Reads in single-cell data generated by the steinbock pipeline
#'
#' @description Reader function to generate a
#' \code{\linkS4class{SpatialExperiment}} or
#' \code{\linkS4class{SingleCellExperiment}} object from single-cell data
#' obtained by the 
#' \href{https://github.com/BodenmillerGroup/steinbock}{steinbock}
#' pipeline.
#'
#' @param path full path to the steinbock output folder
#' @param intensities_folder name of the folder containing the intensity 
#' measurements per image
#' @param regionprops_folder name of the folder containing the cell-specific
#' morphology and spatial measurements per image. Can be set to \code{NULL} to 
#' exclude reading in morphology measures.
#' @param graphs_folder name of the folder containing the spatial connectivity
#' graphs per image. Can be set to \code{NULL} to exclude reading in graphs.
#' @param pattern regular expression specifying a subset of files that should 
#' be read in.
#' @param extract_cellid_from single character indicating which column entry in 
#' the intensity files contains the integer cell id.
#' @param extract_coords_from character vector indicating which column entries 
#' in the regionprops files contain the x (first entry) and y (second entry) 
#' coordinates.
#' @param image_file single character indicating the file name storing meta data
#' per image (can be \code{NULL}).
#' @param extract_imagemetadata_from character vector indicating which
#' additional image specific metadata to extract from the \code{image_file}.
#' These will be stored in the \code{colData(x)} slot as object/cell-specific
#' entries.
#' @param panel_file single character containing the name of the panel file. 
#' This can either be inside the steinbock path (recommended) or located 
#' somewhere else.
#' @param extract_names_from single character indicating the column of the panel
#' file containing the channel names.
#' @param return_as should the object be returned as 
#' \code{\linkS4class{SpatialExperiment}} (\code{return_as = "spe"}) or
#' \code{\linkS4class{SingleCellExperiment}} (\code{return_as = "sce"}). 
#' @param BPPARAM parameters for parallelised processing. 
#' 
#' @return returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
#' object markers in rows and cells in columns. 
#'
#' @section The returned data container:
#' In the case of both containers \code{x}, intensity features are stored in
#' the \code{counts(x)} slot. Morphological features are stored in the
#' \code{colData(x)} slot. The graphs are stored as 
#' \code{\link[S4Vectors]{SelfHits}} object in the 
#' \code{colPair(x, "neighborhood")} slot.
#' 
#' In the case of a returned \code{SpatialExperiment} object, the cell 
#' coordinates are stored in the \code{spatialCoords(x)} slot.
#' 
#' In the case of a returned \code{SingleCellExperiment} object, the cell 
#' coordinates are stored in the \code{colData(x)} slot named as \code{Pos_X}
#' and \code{Pos_Y}.
#'
#' @examples
#' path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
#' 
#' # Read in as SpatialExperiment object
#' x <- read_steinbock(path)
#' x
#' 
#' # Read in as SingleCellExperiment object
#' x <- read_steinbock(path, return_as = "sce")
#' x
#' 
#' # Read in a subset of files
#' x <- read_steinbock(path, pattern = "mockData1")
#' x
#' 
#' # Only read in intensities
#' x <- read_steinbock(path, graphs_folder = NULL, regionprops_folder = NULL)
#' x
#' 
#' # Parallelisation
#' x <- read_steinbock(path, BPPARAM = BiocParallel::bpparam())
#' 
#' @seealso 
#' \url{https://github.com/BodenmillerGroup/steinbock} for the pipeline
#' 
#' \code{\link{read_cpout}} for reading in single-cell data as produced by the
#' ImcSegmentationPipeline
#' 
#' \code{\link[SingleCellExperiment]{SingleCellExperiment}} and 
#' \code{\link[SpatialExperiment]{SpatialExperiment}} for the constructor 
#' functions.
#' 
#' \code{\link[SingleCellExperiment]{colPair}} for information on how to work
#' with the cell-cell interaction graphs
#' 
#' \code{\link[BiocParallel]{bpparam}} for the parallelised backend
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @importFrom SpatialExperiment SpatialExperiment
#' @export
read_steinbock <- function(path,
                            intensities_folder = "intensities",
                            regionprops_folder = "regionprops",
                            graphs_folder = "neighbors",
                            pattern = NULL,
                            extract_cellid_from = "Object",
                            extract_coords_from = c("centroid-1", "centroid-0"),
                            image_file = "images.csv",
                            extract_imagemetadata_from = c("width_px", 
                                                    "height_px"),
                            panel_file = "panel.csv",
                            extract_names_from = "name",
                            return_as = c("spe", "sce"),
                            BPPARAM = SerialParam()){
    
    .valid.read_steinbock.input(path, intensities_folder, graphs_folder,
                                regionprops_folder, extract_cellid_from, 
                                extract_coords_from, image_file,
                                extract_imagemetadata_from, panel_file, 
                                extract_names_from, pattern)
    
    return_as <- match.arg(return_as)
    
    # Read intensities
    int_file_names <- list.files(file.path(path, intensities_folder),
                                pattern = pattern, full.names = TRUE)
    object <- .steinbock_read_intensities(x = int_file_names,
                                cell_id = extract_cellid_from,
                                return_as = return_as,
                                BPPARAM = BPPARAM)
    
    # Read regionprops
    if (!is.null(regionprops_folder)) {
        object <- .steinbock_read_regionprops(x = object,
                                    cur_path = file.path(path, 
                                                    regionprops_folder),
                                    cell_id = extract_cellid_from, 
                                    coords = extract_coords_from,
                                    return_as = return_as,
                                    BPPARAM = BPPARAM)
    }
    
    # Read graphs
    if (!is.null(graphs_folder)) {
        object <- .steinbock_read_graphs(x = object,
                                cur_path = file.path(path, graphs_folder),
                                return_as = return_as,
                                BPPARAM = BPPARAM)
    }
    
    # Merge objects
    cur_intmeta <- int_metadata(object[[1]])
    object <- do.call("cbind", object)
    int_metadata(object) <- cur_intmeta
    
    # Add image metadata
    if (!is.null(image_file)) {
        object <- .steinbock_add_image_metadata(object, 
                        image_file = file.path(path, image_file),
                        extract_imagemetadata_from = extract_imagemetadata_from)
    }
    
    # Add panel data
    object <- .add_panel(object, path, panel_file, extract_names_from)
    
    # Add colnames
    colnames(object) <- paste0(object$sample_id, "_", object$ObjectNumber)
    
    return(object)
}

test_that("read_steinbock function works", {
    path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
  
    # SpatialExperiment
    cur_spe <- read_steinbock(path)
    
    expect_equal(colnames(cur_spe), paste0(cur_spe$sample_id, "_", cur_spe$ObjectNumber))
    
    expect_s4_class(cur_spe, "SpatialExperiment")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 404))
    expect_equal(names(rowData(cur_spe)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", 
                   "Tube.Number"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    expect_equal(counts(cur_spe)[1:10], c(0.0909090909090909, 0.181818181818182, 0.0909090909090909, 
                                          0.0909090909090909, 0.938306353308938, 0.181163804871695, 0, 
                                          0.142857142857143, 0.501448290688651, 1.00346943310329))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_spe$area, cur_morph$area)
    expect_equal(cur_spe$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_spe$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_spe$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), cur_morph$`centroid-1`)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_spe)$name, cur_panel$name)
    expect_equal(rowData(cur_spe)$channel, cur_panel$channel)
    expect_equal(rowData(cur_spe)$keep, cur_panel$keep)
    expect_equal(rowData(cur_spe)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    
    cur_images <- readr::read_csv(file.path(path, "images.csv"), show_col_types = FALSE)
    cur_images <- cur_images[order(cur_images$image, decreasing = FALSE),]
    
    cur_test <- unique(colData(cur_spe)[,c("sample_id", "width_px", "height_px")])
    
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(cur_images$width_px, cur_test$width_px)
    expect_equal(cur_images$height_px, cur_test$height_px)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_spe, "neighborhood"))
    
    for (i in unique(cur_spe$sample_id)) {
        cur_dat <- cur_spe[,cur_spe$sample_id == i]
        
        cur_test <- readr::read_csv(file.path(path, "neighbors", paste0(i, ".csv")), show_col_types = FALSE)
        
        expect_equal(cur_test$Object, from(colPair(cur_dat, "neighborhood")))
        expect_equal(cur_test$Neighbor, to(colPair(cur_dat, "neighborhood")))
    }
    
    # SingleCellExperiment
    cur_sce <- read_steinbock(path, return_as = "sce")
    
    expect_equal(colnames(cur_sce), paste0(cur_sce$sample_id, "_", cur_sce$ObjectNumber)) 
    
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 404))
    expect_equal(names(rowData(cur_sce)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", 
                                            "Pos_Y", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    expect_equal(counts(cur_sce)[1:10], c(0.0909090909090909, 0.181818181818182, 0.0909090909090909, 
                                         0.0909090909090909, 0.938306353308938, 0.181163804871695, 0, 
                                         0.142857142857143, 0.501448290688651, 1.00346943310329))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_sce$area, cur_morph$area)
    expect_equal(cur_sce$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_sce$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_sce$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(cur_sce$Pos_X), cur_morph$`centroid-1`)
    expect_equal(as.numeric(cur_sce$Pos_Y), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_sce)$name, cur_panel$name)
    expect_equal(rowData(cur_sce)$channel, cur_panel$channel)
    expect_equal(rowData(cur_sce)$keep, cur_panel$keep)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$deepcell, cur_panel$deepcell)    
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(colPairNames(cur_sce), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_sce, "neighborhood"))
    
    for (i in unique(cur_sce$sample_id)) {
        cur_dat <- cur_sce[,cur_sce$sample_id == i]
        
        cur_test <- readr::read_csv(file.path(path, "neighbors", paste0(i, ".csv")), show_col_types = FALSE)
        
        expect_equal(cur_test$Object, from(colPair(cur_dat, "neighborhood")))
        expect_equal(cur_test$Neighbor, to(colPair(cur_dat, "neighborhood")))
    }
    
    cur_test <- unique(colData(cur_sce)[,c("sample_id", "width_px", "height_px")])
    
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(cur_images$width_px, cur_test$width_px)
    expect_equal(cur_images$height_px, cur_test$height_px)
    
    # Test other import settings
    cur_spe <- read_steinbock(path, regionprops_folder = NULL)
    
    expect_equal(rownames(cur_spe), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 404))
    expect_equal(names(rowData(cur_spe)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", 
                                            "width_px", "height_px"))
    expect_null(spatialCoordsNames(cur_spe))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_spe)$name, cur_panel$name)
    expect_equal(rowData(cur_spe)$channel, cur_panel$channel)
    expect_equal(rowData(cur_spe)$keep, cur_panel$keep)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_spe, "neighborhood"))
    
    for (i in unique(cur_spe$sample_id)) {
        cur_dat <- cur_spe[,cur_spe$sample_id == i]
        
        cur_test <- readr::read_csv(file.path(path, "neighbors", paste0(i, ".csv")), show_col_types = FALSE)
        
        expect_equal(cur_test$Object, from(colPair(cur_dat, "neighborhood")))
        expect_equal(cur_test$Neighbor, to(colPair(cur_dat, "neighborhood")))
    }
    
    expect_equal(length(colPair(cur_spe)), 1674)
    
    cur_test <- unique(colData(cur_spe)[,c("sample_id", "width_px", "height_px")])
    
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(cur_images$width_px, cur_test$width_px)
    expect_equal(cur_images$height_px, cur_test$height_px)
    
    cur_sce <- read_steinbock(path, return_as = "sce", regionprops_folder = NULL)
    
    expect_equal(rownames(cur_sce), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 404))
    expect_equal(names(rowData(cur_sce)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_sce)$name, cur_panel$name)
    expect_equal(rowData(cur_sce)$channel, cur_panel$channel)
    expect_equal(rowData(cur_sce)$keep, cur_panel$keep)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(colPairNames(cur_sce), "neighborhood")
    
    expect_equal(length(colPair(cur_sce)), 1674)
    
    cur_spe <- read_steinbock(path, graphs_folder = NULL)
    
    expect_equal(rownames(cur_spe), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 404))
    expect_equal(names(rowData(cur_spe)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_spe$area, cur_morph$area)
    expect_equal(cur_spe$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_spe$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_spe$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), cur_morph$`centroid-1`)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_spe)$name, cur_panel$name)
    expect_equal(rowData(cur_spe)$channel, cur_panel$channel)
    expect_equal(rowData(cur_spe)$keep, cur_panel$keep)
    expect_equal(rowData(cur_spe)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(length(colPairs(cur_spe)), 0)
    
    cur_sce <- read_steinbock(path, return_as = "sce", graphs_folder = NULL)
    
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 404))
    expect_equal(names(rowData(cur_sce)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", 
                                            "Pos_Y", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_sce$area, cur_morph$area)
    expect_equal(cur_sce$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_sce$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_sce$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(cur_sce$Pos_X), cur_morph$`centroid-1`)
    expect_equal(as.numeric(cur_sce$Pos_Y), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_sce)$name, cur_panel$name)
    expect_equal(rowData(cur_sce)$channel, cur_panel$channel)
    expect_equal(rowData(cur_sce)$keep, cur_panel$keep)
    expect_equal(rowData(cur_sce)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(length(colPairs(cur_sce)), 0)
    
    cur_spe <- read_steinbock(path, graphs_folder = NULL, regionprops_folder = NULL)
    
    expect_equal(rownames(cur_spe), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 404))
    expect_equal(names(rowData(cur_spe)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber",
                                            "width_px", "height_px"))
    expect_null(spatialCoordsNames(cur_spe))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    expect_equal(cur_spe$ObjectNumber, cur_counts$Object)
    
    cur_test <- unique(colData(cur_spe)[,c("sample_id", "width_px", "height_px")])
    
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images$image), cur_test$sample_id)
    expect_equal(cur_images$width_px, cur_test$width_px)
    expect_equal(cur_images$height_px, cur_test$height_px)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_spe)$name, cur_panel$name)
    expect_equal(rowData(cur_spe)$channel, cur_panel$channel)
    expect_equal(rowData(cur_spe)$keep, cur_panel$keep)
    expect_equal(rowData(cur_spe)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(length(colPairs(cur_spe)), 0)
    
    cur_sce <- read_steinbock(path, return_as = "sce", graphs_folder = NULL, regionprops_folder = NULL)
    
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 404))
    expect_equal(names(rowData(cur_sce)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE)
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"), show_col_types = FALSE)
    expect_equal(rowData(cur_sce)$name, cur_panel$name)
    expect_equal(rowData(cur_sce)$channel, cur_panel$channel)
    expect_equal(rowData(cur_sce)$keep, cur_panel$keep)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(length(colPairs(cur_sce)), 0)
    
    cur_spe <- read_steinbock(path, pattern = "mockData2")
    
    expect_equal(colnames(cur_spe), paste0(cur_spe$sample_id, "_", cur_spe$ObjectNumber))
    
    expect_s4_class(cur_spe, "SpatialExperiment")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 106))
    expect_equal(names(rowData(cur_spe)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE, pattern = "mockData2")
    cur_counts <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    expect_equal(counts(cur_spe)[1:10], c(0.399655099572807, 0.0344827586206896, 4.64201253035973, 6.50705560733532, 
                                          3.57779644892133, 0.428760413080454, 0.0945868939161301, 1.56471130624413, 
                                          8.0167475938797, 1.46797196567059))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE, pattern = "mockData2")
    cur_morph <- lapply(cur_files, readr::read_csv, show_col_types = FALSE)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_spe$area, cur_morph$area)
    expect_equal(cur_spe$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_spe$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_spe$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), cur_morph$`centroid-1`)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"))
    expect_equal(rowData(cur_spe)$name, cur_panel$name)
    expect_equal(rowData(cur_spe)$channel, cur_panel$channel)
    expect_equal(rowData(cur_spe)$keep, cur_panel$keep)
    expect_equal(rowData(cur_spe)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    for (i in unique(cur_spe$sample_id)) {
        cur_dat <- cur_spe[,cur_spe$sample_id == i]
        
        cur_test <- readr::read_csv(file.path(path, "neighbors", paste0(i, ".csv")), show_col_types = FALSE)
        
        expect_equal(cur_test$Object, from(colPair(cur_dat, "neighborhood")))
        expect_equal(cur_test$Neighbor, to(colPair(cur_dat, "neighborhood")))
    }
    
    cur_test <- unique(colData(cur_spe)[,c("sample_id", "width_px", "height_px")])
    
    cur_images_2 <- cur_images[grepl("mockData2", cur_images$image),]
    
    expect_equal(sub(".tiff$", "", cur_images_2$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images_2$image), cur_test$sample_id)
    expect_equal(cur_images_2$width_px, cur_test$width_px)
    expect_equal(cur_images_2$height_px, cur_test$height_px)
    
    cur_sce <- read_steinbock(path, pattern = "mockData2", return_as = "sce")
    
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Cytokeratin 5", "Laminin", 
                                      "YBX1", "H3K27Ac"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 106))
    expect_equal(names(rowData(cur_sce)), 
                 c("channel", "name", "keep", "ilastik", "deepcell", "cellpose", "Tube.Number"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", 
                                            "Pos_Y", "area", 
                                            "axis_major_length", 
                                            "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "intensities"), full.names = TRUE, pattern = "mockData2")
    cur_counts <- lapply(cur_files, readr::read_csv)
    cur_counts <- do.call("rbind", cur_counts)
    
    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, t(cur_counts[,-1]))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE, pattern = "mockData2")
    cur_morph <- lapply(cur_files, readr::read_csv)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_sce$area, cur_morph$area)
    expect_equal(cur_sce$axis_major_length, cur_morph$axis_major_length)
    expect_equal(cur_sce$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_sce$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(cur_sce$Pos_X), cur_morph$`centroid-1`)
    expect_equal(as.numeric(cur_sce$Pos_Y), cur_morph$`centroid-0`)
    
    cur_panel <- readr::read_csv(file.path(path, "panel.csv"))
    expect_equal(rowData(cur_sce)$name, cur_panel$name)
    expect_equal(rowData(cur_sce)$channel, cur_panel$channel)
    expect_equal(rowData(cur_sce)$keep, cur_panel$keep)
    expect_equal(rowData(cur_sce)$deepcell, cur_panel$deepcell)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    
    expect_equal(colPairNames(cur_sce), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_sce, "neighborhood"))

    for (i in unique(cur_sce$sample_id)) {
        cur_dat <- cur_sce[,cur_sce$sample_id == i]
        
        cur_test <- readr::read_csv(file.path(path, "neighbors", paste0(i, ".csv")), show_col_types = FALSE)
        
        expect_equal(cur_test$Object, from(colPair(cur_dat, "neighborhood")))
        expect_equal(cur_test$Neighbor, to(colPair(cur_dat, "neighborhood")))
    }
    
    cur_test <- unique(colData(cur_sce)[,c("sample_id", "width_px", "height_px")])
    
    expect_equal(sub(".tiff$", "", cur_images_2$image), cur_test$sample_id)
    expect_equal(sub(".tiff$", "", cur_images_2$image), cur_test$sample_id)
    expect_equal(cur_images_2$width_px, cur_test$width_px)
    expect_equal(cur_images_2$height_px, cur_test$height_px)
    
    cur_spe <- read_steinbock(path, panel = NULL)
    
    expect_equal(length(rowData(cur_spe)), 0)
    
    cur_sce <- read_steinbock(path, panel = NULL, return_as = "sce")
    
    expect_equal(length(rowData(cur_sce)), 0)
    
    cur_spe <- read_steinbock(path, extract_coords_from = c("area", "axis_major_length"))
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "centroid.0",
                                            "centroid.1", "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_spe$`centroid.1`, cur_morph$`centroid-1`)
    expect_equal(cur_spe$`centroid.0`, cur_morph$`centroid-0`)
    expect_equal(cur_spe$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_spe$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), cur_morph$area)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), cur_morph$axis_major_length)
    
    cur_sce <- read_steinbock(path, return_as = "sce", extract_coords_from = c("area", "axis_major_length"))
    
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", "Pos_Y", "centroid.0",
                                            "centroid.1", "axis_minor_length", "eccentricity",
                                            "width_px", "height_px"))
    
    cur_files <- list.files(file.path(path, "regionprops"), full.names = TRUE)
    cur_morph <- lapply(cur_files, readr::read_csv)
    cur_morph <- do.call("rbind", cur_morph)
    
    expect_equal(cur_sce$`centroid.0`, cur_morph$`centroid-0`)
    expect_equal(cur_sce$`centroid.1`, cur_morph$`centroid-1`)
    expect_equal(cur_sce$axis_minor_length, cur_morph$axis_minor_length)
    expect_equal(cur_sce$eccentricity, cur_morph$eccentricity)
    expect_equal(as.numeric(cur_sce$Pos_X), cur_morph$area)
    expect_equal(as.numeric(cur_sce$Pos_Y), cur_morph$axis_major_length)
    
    # This test doesn't make sense anymore
    #cur_spe <- read_steinbock(path, extract_names_from = "channel")
    
    #expect_true(all(is.na(rowData(cur_spe)["Laminin",])))
    #expect_equal(as.character(as.matrix(rowData(cur_spe)["Ag107",])), 
    #             c("Ag107", "Ag107", "1", "1", NA, NA))  
    
    cur_spe <- read_steinbock(path, image_file = NULL)
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "area", 
                                            "axis_major_length", "axis_minor_length", "eccentricity"))
    
    cur_sce <- read_steinbock(path, image_file = NULL, return_as = "sce")
    
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", "Pos_Y", "area", 
                                            "axis_major_length", "axis_minor_length", "eccentricity"))
    
    cur_spe <- read_steinbock(path)
    cur_images_file <- readr::read_csv(file.path(path, "images.csv"), show_col_types = FALSE)
    cur_images_file <- cur_images_file[order(cur_images_file$image, decreasing = FALSE),]
    
    cur_df <- unique(colData(cur_spe)[,c("sample_id", "width_px", "height_px")])
    expect_equal(cur_images_file$image, paste0(cur_df$sample_id, ".tiff"))
    expect_equal(cur_images_file$width_px, cur_df$width_px)
    expect_equal(cur_images_file$height_px, cur_df$height_px)
    
    cur_spe <- read_steinbock(path, extract_imagemetadata_from = c("recovered", "acquisition_description"))
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "area", 
                                            "axis_major_length", "axis_minor_length", 
                                            "eccentricity", "recovered", "acquisition_description"))
    
    cur_df <- unique(colData(cur_spe)[,c("sample_id", "recovered", "acquisition_description")])
    expect_equal(cur_images_file$image, paste0(cur_df$sample_id, ".tiff"))
    expect_equal(cur_images_file$recovered, cur_df$recovered)
    expect_equal(cur_images_file$acquisition_description, cur_df$acquisition_description)
    
    
    # Parallelisation
    #cur_spe <- read_steinbock(path, BPPARAM = BiocParallel::bpparam())
    
    # Error
    expect_error(cur_spe <- read_steinbock(path = "test"),
                 "'path' doesn't exist.", 
                 fixed = TRUE) 
    expect_error(cur_spe <- read_steinbock(path = c("test", "test2")),
                 "'path' must be a single string.", 
                 fixed = TRUE) 
    expect_error(cur_spe <- read_steinbock(path = 1),
                 "'path' must be a single string.", 
                 fixed = TRUE) 
    
    expect_error(cur_spe <- read_steinbock(path, intensities_folder = NULL),
                 "'intensities_folder' must be specified.", 
                 fixed = TRUE)
    expect_error(cur_spe <- read_steinbock(path, intensities_folder = "test"),
                 "'intensities_folder' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, intensities_folder = c("test", "test2")),
                 "'intensities_folder' must be a single string.", 
                 fixed = TRUE)
    expect_error(cur_spe <- read_steinbock(path, intensities_folder = 1),
                 "'intensities_folder' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, regionprops_folder = "test"),
                 "'regionprops_folder' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, regionprops_folder = c("test", "test2")),
                 "'regionprops_folder' must be a single string.", 
                 fixed = TRUE)
    expect_error(cur_spe <- read_steinbock(path, regionprops_folder = 1),
                 "'regionprops_folder' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, graphs_folder = "test"),
                 "'graphs_folder' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, graphs_folder = c("test", "test2")),
                 "'graphs_folder' must be a single string.", 
                 fixed = TRUE)
    expect_error(cur_spe <- read_steinbock(path, graphs_folder = 1),
                 "'graphs_folder' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, pattern = "test"),
                 "No files were read in.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_cellid_from = "test"),
                 "'extract_cellid_from' not in intensities files.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_cellid_from = c("test", "test2")),
                 "'extract_cellid_from' must be a single string.", 
                 fixed = TRUE)
    expect_error(cur_spe <- read_steinbock(path, extract_cellid_from = 1),
                 "'extract_cellid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_coords_from =  "test"),
                 "'coords' not in regionprops files.", 
                 fixed = TRUE)
    expect_silent(cur_spe <- read_steinbock(path, extract_coords_from =  "test", regionprops_folder = NULL))
    
    expect_error(cur_spe <- read_steinbock(path, extract_coords_from =  1),
                 "'extract_coords_from' must be characters.", 
                 fixed = TRUE)
    
    expect_warning(cur_spe <- read_steinbock(path, panel = "test"),
                   "'panel_file' does not exist.", 
                   fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, panel = c("test", "test2")),
                 "'panel_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, panel = 1),
                 "'panel_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_names_from = "test"),
                 "'extract_names_from' not in panel file.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_names_from = c("test", "test2")),
                 "'extract_names_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_names_from = 1),
                 "'extract_names_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, image_file = 1),
                 "'image_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, image_file = "test"),
                 "'image_file' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_imagemetadata_from = 1),
                 "'extract_imagemetadata_from' should only contain characters.", 
                 fixed = TRUE)
    
    expect_error(cur_spe <- read_steinbock(path, extract_imagemetadata_from = c(1, "test")),
                 "'extract_imagemetadata_from' not in images file.", 
                 fixed = TRUE)
})

test_that("read_steinbock function works when files are missing", {
    skip_on_os(os = "windows")
    path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
    
    # Move files to tmp location
    cur_path <- tempdir()
    file.copy(path, cur_path, recursive = TRUE)
    
    # Remove regionprobs folder
    file.remove(list.files(paste0(cur_path, "/steinbock/regionprops"), 
                           full.names = TRUE))
    
    expect_error(cur_spe <- read_steinbock(paste0(cur_path, "/steinbock/")),
                            "File names in 'intensities' and 'regionprops' do not match.", 
                            fixed = TRUE)
    

    # Remove graphs folder
    file.remove(list.files(paste0(cur_path, "/steinbock/neighbors"), 
                           full.names = TRUE))
    
    expect_error(cur_spe <- read_steinbock(paste0(cur_path, "/steinbock/")),
                 "File names in 'intensities' and 'neighbors' do not match.", 
                 fixed = TRUE)

})

############################# Reader helpers ###################################

#### read_steinbock helpers ####

# Helper functions for reading in steinbock data
#' @importFrom vroom vroom
#' @importFrom BiocParallel bplapply
#' @importFrom magrittr %>%
#' @importFrom dplyr select all_of
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom SpatialExperiment SpatialExperiment
#' @importFrom readr cols
.steinbock_read_intensities <- function(x, cell_id, return_as, BPPARAM){

    cur_out <-  bplapply(seq_along(x),
                         function(y){
                             cur_int <- vroom(x[y], progress = FALSE,
                                              show_col_types = FALSE)
                             
                             if (nrow(cur_int) == 0) {
                                 stop("No cells detected in ", basename(x[y]))
                             }
                             
                             cur_counts <- cur_int %>% select(-all_of(cell_id))

                             cur_name <- sub("\\.[^.]*$", "", basename(x[y]))

                             if (return_as == "spe") {
                                 object <- SpatialExperiment(
                                     assays = list(counts = t(as.matrix(cur_counts))),
                                     sample_id = cur_name)
                                 object$ObjectNumber <- cur_int[[cell_id]]
                             } else {
                                 object <- SingleCellExperiment(
                                     assays = list(counts = t(as.matrix(cur_counts))))
                                 object$sample_id <- cur_name
                                 object$ObjectNumber <- cur_int[[cell_id]]
                             }

                             return(object)

                         }, BPPARAM = BPPARAM)

    return(cur_out)
}

.steinbock_read_regionprops <- function(x, cur_path, cell_id, coords,
                                        return_as, BPPARAM){

    cur_out <-  bplapply(x,
                         function(y){
                             cur_sample <- unique(y$sample_id)

                             cur_file <- list.files(cur_path,
                                                    pattern = paste0("^", cur_sample, ".csv", "$"),
                                                    full.names = TRUE)

                             cur_props <- vroom(cur_file,
                                                progress = FALSE,
                                                show_col_types = FALSE) %>%
                                 as.data.frame()
                             
                             if (!identical(cur_props[[cell_id]], y$ObjectNumber)) {
                                 stop("Object IDs do not match between intensities ",
                                      "and regionprobs for file '", basename(cur_file), 
                                      "'.")
                             }

                             if (return_as == "spe") {
                                 spatialCoords(y) <- matrix(c(cur_props[[coords[1]]],
                                                              cur_props[[coords[2]]]),
                                                            ncol = 2, byrow = FALSE,
                                                            dimnames = list(NULL,
                                                                            c("Pos_X", "Pos_Y")))
                                 colData(y) <- cbind(colData(y),
                                                     cur_props[,!colnames(cur_props) %in%
                                                                   c(cell_id, coords)])
                             } else {
                                 colData(y)$Pos_X <- cur_props[[coords[1]]]
                                 colData(y)$Pos_Y <- cur_props[[coords[2]]]
                                 colData(y) <- cbind(colData(y),
                                                     cur_props[,!colnames(cur_props) %in%
                                                                   c(cell_id, coords)])
                             }

                             return(y)

                         }, BPPARAM = BPPARAM)
    return(cur_out)
}

#' @importFrom S4Vectors SelfHits
#' @importFrom SpatialExperiment spatialCoords<-
.steinbock_read_graphs <- function(x, cur_path, return_as, BPPARAM){

    cur_out <-  bplapply(x,
                         function(y){
                             cur_sample <- unique(y$sample_id)

                             cur_file <- list.files(cur_path,
                                                    pattern = paste0("^", cur_sample, ".csv", "$"),
                                                    full.names = TRUE)

                             cur_graphs <- vroom(cur_file,
                                                 progress = FALSE,
                                                 show_col_types = FALSE) %>%
                                 as.data.frame()
                             
                             if (any(!cur_graphs[,1] %in% y$ObjectNumber)) {
                                 stop("Object IDs do not match between intensities ",
                                      "and graphs for file '", basename(cur_file), 
                                      "'.")
                             }
                             
                             if (any(!cur_graphs[,2] %in% y$ObjectNumber)) {
                                 stop("Object IDs do not match between intensities ",
                                      "and graphs for file '", basename(cur_file), 
                                      "'.")
                             }

                             cur_hits <- SelfHits(from = match(cur_graphs[,1],
                                                                y$ObjectNumber),
                                                  to = match(cur_graphs[,2],
                                                                y$ObjectNumber),
                                                  nnode = ncol(y))

                             colPair(y, "neighborhood") <- cur_hits

                             return(y)
                         }, BPPARAM = BPPARAM)

    return(cur_out)
}

#' @importFrom methods as
#' @importFrom dplyr left_join
.steinbock_add_image_metadata <- function(object, image_file,
                                          extract_imagemetadata_from) {

    cur_img_meta <- vroom(image_file,
                          col_select = all_of(c("image",
                                                extract_imagemetadata_from)),
                          show_col_types = FALSE)
    cur_img_meta$sample_id <- sub("\\.[^.]*$", "", cur_img_meta$image)
    
    cur_df <- as(left_join(x = as.data.frame(colData(object)), 
                           y = cur_img_meta[,-1],
                           by = "sample_id"), "DataFrame")
    
    if (!all.equal(paste(cur_df[["sample_id"]], cur_df[["ObjectNumber"]]),
                   paste(object[["sample_id"]], object[["ObjectNumber"]]))) {
        stop("Order of cells do not match")    
    }

    colData(object) <- cur_df

    return(object)
}

.add_panel <- function(x, path, panel, extract_names_from) {

    if (!is.null(panel)) {
        if (file.exists(file.path(path, panel))) {
            cur_panel <- vroom(file.path(path, panel),
                               progress = FALSE,
                               show_col_types = FALSE)
        } else if (file.exists(panel)) {
            cur_panel <- vroom(panel,
                               progress = FALSE,
                               show_col_types = FALSE)
        } else {
            warning("'panel_file' does not exist.")
            return(x)
        }

        cur_panel <- as.data.frame(cur_panel)

        cur_ind <- match(rownames(x), cur_panel[,extract_names_from])

        cur_panel <- cur_panel[cur_ind,]
        
        stopifnot(identical(rownames(x), cur_panel[,extract_names_from]))

        rowData(x) <- cur_panel
    }

    return(x)

}

#### read_cpout helpers ####

# Helper functions for reading in ImcSegmentationPipeline data
#' @importFrom vroom vroom
#' @importFrom dplyr contains mutate across
.cpout_create_object <- function(path, object_file, image_file,
                                 object_feature_file,
                                 intensities, extract_imgid_from,
                                 extract_cellid_from, extract_coords_from,
                                 extract_cellmetadata_from,
                                 extract_sampleid_from,
                                 scale_intensities, extract_scalingfactor_from,
                                 return_as) {

    cur_counts <- vroom(file.path(path, object_file),
                        col_select = c(contains(intensities),
                                       all_of(c(extract_imgid_from,
                                                extract_cellid_from,
                                                extract_coords_from,
                                                extract_cellmetadata_from))),
                        show_col_types = FALSE)

    scaling_factor <- as.data.frame(vroom(file.path(path, image_file),
                                          col_select = all_of(c(extract_imgid_from,
                                                                extract_scalingfactor_from)),
                                          show_col_types = FALSE))
    rownames(scaling_factor) <-
        as.character(scaling_factor[[extract_imgid_from]])

    # Scale counts
    if (scale_intensities) {
        cur_counts <- split(cur_counts, cur_counts[[extract_imgid_from]])
        scaling_factor <- scaling_factor[names(cur_counts),]

        cur_counts <- mapply(function(cells, s_factor) {
            cells %>% mutate(across(contains(intensities),
                                    function(x){x * s_factor}))
        }, cur_counts, as.list(scaling_factor[[extract_scalingfactor_from]]),
        SIMPLIFY = FALSE)

        cur_counts <- do.call(rbind, cur_counts)
    }

    # Order channels
    cur_channels <- colnames(cur_counts)[grepl(intensities,
                                               colnames(cur_counts))]
    cur_channels_id <- as.numeric(str_extract(cur_channels, "[0-9]{1,3}$"))

    cur_channels <- cur_channels[order(cur_channels_id, decreasing = FALSE)]

    if (return_as == "spe") {
        object <- SpatialExperiment(
            assays = list(counts = t(as.matrix(cur_counts[,cur_channels]))),
            sample_id = as.character(cur_counts[[extract_imgid_from]]))
        object$ObjectNumber <- cur_counts[[extract_cellid_from]]
    } else {
        object <- SingleCellExperiment(
            assays = list(counts = t(as.matrix(cur_counts[,cur_channels]))))
        object$sample_id <- as.character(cur_counts[[extract_imgid_from]])
        object$ObjectNumber <- cur_counts[[extract_cellid_from]]
    }

    # Build colData
    if (return_as == "spe") {
        if (!is.null(extract_coords_from)) {
            spatialCoords(object) <- matrix(c(
                cur_counts[[extract_coords_from[1]]],
                cur_counts[[extract_coords_from[2]]]),
                ncol = 2, byrow = FALSE,
                dimnames = list(NULL,
                                c("Pos_X", "Pos_Y")))
        }

        colData(object) <- cbind(colData(object),
                                 cur_counts[,extract_cellmetadata_from])
    } else {
        if (!is.null(extract_coords_from)) {
            object$Pos_X <- cur_counts[[extract_coords_from[1]]]
            object$Pos_Y <- cur_counts[[extract_coords_from[2]]]
        }

        colData(object) <- cbind(colData(object),
                                 cur_counts[,extract_cellmetadata_from])
    }

    # Set correct metal names
    cur_channels <- vroom(file.path(path, object_feature_file),
                          col_select = c("channel", "channel_id"),
                          show_col_types = FALSE)
    cur_channels <- unique(cur_channels)
    cur_channels <- cur_channels[grepl("[a-zA-Z]{1,2}[0-9]{2,3}",
                                       cur_channels[["channel_id"]]),]
    cur_channels <- cur_channels[order(cur_channels[["channel"]],
                                       decreasing = FALSE),]

    rownames(object) <- cur_channels[["channel_id"]]

    return(object)
}

#' @importFrom methods as
#' @importFrom dplyr join_by
.cpout_add_image_metadata <- function(object, path, image_file,
                                      extract_imgid_from,
                                      extract_imagemetadata_from,
                                      extract_cellid_from) {

    cur_img_meta <- vroom(file.path(path, image_file),
                          col_select = all_of(c(extract_imgid_from,
                                                extract_imagemetadata_from)),
                          show_col_types = FALSE)
    cur_img_meta$sample_id <- as.character(cur_img_meta[[extract_imgid_from]])
    
    cur_df <- as(left_join(x = as.data.frame(colData(object)), 
                           y = cur_img_meta,
                           by = "sample_id"), "DataFrame")
    
    if (!all.equal(paste(cur_df[["sample_id"]], cur_df[[extract_cellid_from]]),
                   paste(object[["sample_id"]], object[[extract_cellid_from]]))) {
        stop("Order of cells do not match")    
    }
    
    colData(object) <- cur_df

    return(object)
}

.cpout_add_graph <- function(object, path, graph_file,
                             extract_graphimageid_from,
                             extract_graphcellids_from) {
    cur_graph <- vroom(file.path(path, graph_file),
                       col_select = all_of(c(extract_graphimageid_from,
                                             extract_graphcellids_from)),
                       show_col_types = FALSE)

    cur_graph$firstid <- paste0(cur_graph[[extract_graphimageid_from]], "_",
                                cur_graph[[extract_graphcellids_from[1]]])
    cur_graph$secondid <- paste0(cur_graph[[extract_graphimageid_from]], "_",
                                 cur_graph[[extract_graphcellids_from[2]]])

    cur_objectids <- paste0(object$sample_id, "_", object$ObjectNumber)

    colPair(object, "neighborhood") <- SelfHits(from = match(cur_graph$firstid,
                                                             cur_objectids),
                                                to = match(cur_graph$secondid,
                                                           cur_objectids),
                                                nnode = length(cur_objectids))

    return(object)
}



############################# Spatial helpers ##################################

#### plotSpatial helpers ####
.makeNodes <- function(object, node_color_by, img_id, node_shape_by,
                       node_size_by, assay_type){
    if (is.null(node_color_by)) {
        nodes <- colData(object)[,c(img_id, node_shape_by,
                                    node_size_by),
                                 drop=FALSE]
    } else if (node_color_by %in% names(colData(object))) {
        nodes <- colData(object)[,c(img_id, node_color_by, node_shape_by,
                                    node_size_by),
                                 drop=FALSE]
    } else {
        nodes <- colData(object)[,c(img_id, node_shape_by,
                                    node_size_by),
                                 drop=FALSE]
        nodes <- cbind(nodes, t(assay(object, assay_type)[node_color_by,,
                                                          drop = FALSE]))
    }

    if (!is.null(node_shape_by)) {
        nodes[,node_shape_by] <- as.character(nodes[,node_shape_by])
    }
    
    nodes <- nodes[,unique(colnames(nodes)), drop = FALSE]

    return(nodes)
}

# Function to generate the tidygraph
#' @importFrom S4Vectors isRedundantHit
.generateGraph <- function(object, nodes, colPairName, draw_edges,
                           edge_color_by, edge_width_by, directed){
    if (draw_edges) {

        if (!directed) {
            cur_SH <- colPair(object, colPairName)
            cur_SH <- cur_SH[!isRedundantHit(cur_SH)]
        } else {
            cur_SH <- colPair(object, colPairName)
        }

        edges <- as.data.frame(as(cur_SH, "DataFrame"))

        if (!is.null(edge_color_by) &&
            edge_color_by %in% colnames(colData(object))) {
            edges[,edge_color_by] <-
                colData(object)[[edge_color_by]][edges$from]
        }

        if (!is.null(edge_width_by) &&
            edge_width_by %in% colnames(colData(object))) {
            edges[,edge_width_by] <-
                colData(object)[[edge_width_by]][edges$from]
        }

        cur_graph <- tbl_graph(nodes = nodes,
                               edges = edges,
                               directed = directed)
    } else {
        cur_graph <- tbl_graph(nodes = nodes,
                               directed = directed)
    }

    return(cur_graph)

}

# Function to generate the base plot
.generatePlot <- function(layout, draw_edges, directed, arrow, end_cap,
                          node_color_by, node_size_by, node_shape_by,
                          node_color_fix, node_size_fix, node_shape_fix,
                          edge_color_by, edge_width_by, edge_color_fix,
                          edge_width_fix, nodes_first){
    
    node_mapping <- aes(colour = .data[[node_color_by]],
                        size = .data[[node_size_by]],
                        shape = .data[[node_shape_by]])
    if (is.null(node_color_by)) {node_mapping$colour <- NULL}
    if (is.null(node_size_by)) {node_mapping$size <- NULL}
    if (is.null(node_shape_by)) {node_mapping$shape <- NULL}
    if (!is.null(node_color_fix)) {node_mapping$colour <- as.character(node_color_fix)}
    if (!is.null(node_size_fix)) {node_mapping$size <- as.character(node_size_fix)}
    if (!is.null(node_shape_fix)) {node_mapping$shape <- as.character(node_shape_fix)}

    if (draw_edges) {
        
        edge_mapping <- aes(edge_colour = .data[[edge_color_by]],
                            edge_width = .data[[edge_width_by]])
        if (is.null(edge_color_by)) {edge_mapping$edge_colour <- NULL}
        if (is.null(edge_width_by)) {edge_mapping$edge_width <- NULL}
        if (!is.null(edge_color_fix)) {edge_mapping$edge_colour <- as.character(edge_color_fix)}
        if (!is.null(edge_width_fix)) {edge_mapping$edge_width <- as.character(edge_width_fix)}
        
        if (!is.null(arrow)) {

            if (is.null(end_cap)) {
                end_cap <- circle(0.1, 'cm')
            }

            if (directed) {
                cur_geom_edge <- geom_edge_fan(edge_mapping,
                                               end_cap = end_cap,
                                               arrow = arrow)
            } else {
                cur_geom_edge <- geom_edge_link(edge_mapping,
                    end_cap = end_cap,
                    arrow = arrow)
            }
        } else {
            if (directed) {
                cur_geom_edge <- geom_edge_fan0(edge_mapping)
            } else {
                cur_geom_edge <- geom_edge_link0(edge_mapping)
            }
        }

        if (nodes_first) {
            p <- ggraph(layout) +
                geom_node_point(node_mapping) +
                cur_geom_edge
        } else {
            p <- ggraph(layout) +
                cur_geom_edge +
                geom_node_point(node_mapping)
        }
    } else {
        p <- ggraph(layout) +
            geom_node_point(node_mapping)
    }

    return(p)
}

# Post process the plots
#' @importFrom ggplot2 ggtitle scale_x_reverse scale_y_reverse coord_fixed
#' @importFrom viridis scale_color_viridis
.postProcessPlot <- function(p, object, img_id, nrows, ncols, node_color_by,
                             node_color_fix,
                             node_shape_fix, node_size_fix, edge_color_fix,
                             edge_width_fix, scales, flip_x, flip_y,
                             aspect_ratio){

    if (!is.null(node_color_fix)) {
        names(node_color_fix) <- as.character(node_color_fix)
        p <- p + scale_color_manual(values = node_color_fix,
                                    guide = "none")
    }
    if (!is.null(node_shape_fix)) {
        names(node_shape_fix) <- as.character(node_shape_fix)
        p <- p + scale_shape_manual(values = node_shape_fix,
                                    guide = "none")
    }
    if (!is.null(node_size_fix)) {
        names(node_size_fix) <- as.character(node_size_fix)
        p <- p + scale_size_manual(values = node_size_fix,
                                   guide = "none")
    }
    if (!is.null(edge_color_fix)) {
        names(edge_color_fix) <- as.character(edge_color_fix)
        p <- p + scale_edge_color_manual(values = edge_color_fix,
                                         guide = "none")
    }
    if (!is.null(edge_width_fix)) {
        names(edge_width_fix) <- as.character(edge_width_fix)
        p <- p + scale_edge_width_manual(values = edge_width_fix,
                                         guide = "none")
    }
    if (!is.null(node_color_by) && node_color_by %in% rownames(object)) {
        p <- p + scale_color_viridis()
    }

    if (length(unique(colData(object)[[img_id]])) > 1) {
        p <- p + facet_nodes(img_id, scales = scales,
                             nrow = nrows, ncol = ncols) +
            theme(axis.text = element_text(),
                  panel.background = element_blank())
    } else {
        p <- p + theme(axis.text = element_text(),
                       panel.background = element_blank()) +
            ggtitle(unique(colData(object))[[img_id]])
    }

    if (flip_x) {
        p <- p + scale_x_reverse()
    }

    if (flip_y) {
        p <- p + scale_y_reverse()
    }
    
    # Fix the aspect ratio to match the physical dimensions of the image
    if (!is.null(aspect_ratio)) {
        if (scales == "fixed") {
            if (aspect_ratio == "auto") {
                p <- p + coord_fixed()
            } else {
                p <- p + coord_fixed(ratio = aspect_ratio)
            }
        } else {
            if (aspect_ratio == "auto") {
                p <- p + theme(aspect.ratio = 1)
            } else {
                p <- p + theme(aspect.ratio = aspect_ratio)
            }
        }
    }

    return(p)
}

#### patchDetection helpers ####
# Helper function for the patch detection method
#' @importFrom sf st_multipoint st_cast st_sfc st_distance
#' @importFrom dplyr as_tibble filter sym nest_by summarize
#' @importFrom S4Vectors metadata
.expand_patch <- function(object,
                          name,
                          expand_by,
                          coords,
                          convex,
                          img_id,
                          BPPARAM){

    cur_meta <- metadata(object)
    metadata(object) <- list()
    
    cur_intmeta <- int_metadata(object)

    cur_out <- bplapply(
        unique(colData(object)[[img_id]]),
        function(x){

            cur_obj <- object[,as.character(colData(object)[[img_id]]) == x]

            if (is(cur_obj, "SpatialExperiment")) {
                cur_coords <- spatialCoords(cur_obj)[,coords]
            } else {
                cur_coords <- colData(cur_obj)[,coords]
            }

            cells <- st_multipoint(as.matrix(cur_coords))
            cells_sfc <- st_cast(st_sfc(cells), "POINT")

            if (sum(!is.na(colData(cur_obj)[[name]])) == 0) {
                return(cur_obj)
            }

            data <- polygon <- NULL

            if (is(cur_obj, "SpatialExperiment")) {
                cur_out <- cbind(colData(cur_obj), cur_coords) %>% as_tibble %>%
                    filter(!is.na(!!sym(name))) %>%
                    nest_by(!!sym(name)) %>%
                    summarize(
                        polygon = list(.polygon_function(x = data,
                                                     coords = coords,
                                                     convex = convex)),
                        cells = list(.milieu_function(x = polygon,
                                                  distance = expand_by,
                                                  cells = cells_sfc)))
            } else {
                cur_out <- colData(cur_obj) %>% as_tibble %>%
                    filter(!is.na(!!sym(name))) %>%
                    nest_by(!!sym(name)) %>%
                    summarize(
                        polygon = list(.polygon_function(x = data,
                                                    coords = coords,
                                                    convex = convex)),
                        cells = list(.milieu_function(x = polygon,
                                                    distance = expand_by,
                                                    cells = cells_sfc)))
            }

            # Find cells that are not unique in extended patches
            cur_cells <- do.call(c, cur_out$cells)
            cur_cells <- cur_cells[duplicated(cur_cells)]
            cur_cells <- cur_cells[!is.na(cur_cells)]

            if (length(cur_cells) > 0) {
                cur_dists <- mapply(function(y, patch_name){
                    if (is.na(y)) {return(NULL)}
                    cur_mat <- st_distance(cells_sfc[cur_cells], y)
                    colnames(cur_mat) <- patch_name
                    return(cur_mat)
                }, cur_out$polygon, cur_out[[name]], SIMPLIFY = FALSE)
                cur_dists <- do.call("cbind", cur_dists)
                cur_patch_id <- apply(cur_dists, 1, function(y){
                    return(colnames(cur_dists)[which.min(y)])
                })
            }

            cur_patch <- colData(cur_obj)[[name]]
            for (i in seq_len(nrow(cur_out))) {
                if (all(!is.na(cur_out$cells[[i]]))) {
                    cur_patch[cur_out$cells[[i]]] <- cur_out[[name]][i]
                }
            }

            if (length(cur_cells) > 0) {
                cur_patch[cur_cells] <- cur_patch_id
            }

            cur_obj[[name]] <- cur_patch

            return(cur_obj)

        }, BPPARAM = BPPARAM)

    cur_out <- do.call("cbind", cur_out)
    metadata(cur_out) <- cur_meta
    int_metadata(cur_out) <- cur_intmeta
    
    return(cur_out)


}
#' @importFrom concaveman concaveman
#' @importFrom grDevices chull
#' @importFrom sf st_polygon
.polygon_function <- function(x, coords, convex){
    if (nrow(x) <= 2) {
        return(NA)
    }

    if (convex) {
        hull <- chull(x = x[[coords[1]]], y = x[[coords[2]]])

        # cells that build the border of a patch
        border_cells <- x[hull,]
        coordinates <- as.matrix(border_cells[,coords])
        coordinates <- rbind(coordinates, coordinates[1,])

        polygon <- st_polygon(list(coordinates))

        return(polygon)
    } else {
        cur_coords <- as.matrix(cbind(x[[coords[1]]], x[[coords[2]]]))
        hull <- data.frame(concaveman(cur_coords, concavity = 1))

        polygon <- st_polygon(list(as.matrix(hull)))

        return(polygon)
    }
}

#' @importFrom sf st_buffer st_sfc st_intersects
.milieu_function <- function(x, distance, cells){

    if (is.na(x)) {
        return(NA)
    }

    polygon_buff <- st_buffer(x, distance)
    polygon_buff_sfc <- st_sfc(polygon_buff)

    intersect_cells <- st_intersects(polygon_buff_sfc, cells)

    return(intersect_cells[[1]])
}

#### testInteractions and countInteractions helpers ####
# Helper functions for the neighbourhood permutation test
#' @importFrom data.table as.data.table
.prepare_table <- function(object, group_by, cur_label, colPairName) {
    cur_tab <- as.data.table(colPair(object, colPairName))
    cur_tab$group_by <- colData(object)[[group_by]][cur_tab$from]
    cur_tab$from_label <- cur_label[cur_tab$from]
    cur_tab$to_label <- cur_label[cur_tab$to]
    cur_tab$ct <- 1

    . <- .N <- NULL

    cur_tab_2 <- data.table(group_by = colData(object)[[group_by]],
                            from_label = cur_label)
    cur_tab_2 <- cur_tab_2[,.(total = .N), by = c("group_by", "from_label")]
    cur_tab <- merge(cur_tab, cur_tab_2, by = c("group_by", "from_label"),
                     sort = FALSE)

    return(cur_tab)
}

#' @importFrom data.table CJ
.aggregate_conditional <- function(dat_table, object, group_by, label,
                             check_missing = TRUE) {
    . <- ct <- .N <- NULL
    dat_temp <- dat_table[, .(ct=.N), by = c("group_by", "from_label",
                                             "to_label", "from")]
    dat_temp <- dat_temp[, .(ct=mean(ct)), by = c("group_by", "from_label",
                                                  "to_label")]

    if (check_missing) {
        dat_temp <- dat_temp[CJ(group_by = unique(dat_table$group_by),
                                from_label = as.factor(levels(dat_table$from_label)),
                                to_label = as.factor(levels(dat_table$to_label))),
                             on = c("group_by", "from_label", "to_label")]
        ct <- from_label <- to_label <- NULL
        dat_temp[is.na(dat_temp$ct), ct := 0]

        # Set all cells that are not contained in specific groups to NA
        cur_dat <- unclass(table(colData(object)[[group_by]],
                                 colData(object)[[label]]))
        cur_ind <- which(cur_dat == 0, arr.ind = TRUE)

        if (nrow(cur_ind) > 0) {
            apply(cur_ind, 1 , function(x){
                dat_temp[group_by == rownames(cur_dat)[x[1]] &
                             (from_label == colnames(cur_dat)[x[2]] |
                                  to_label == colnames(cur_dat)[x[2]]),
                         ct := NA]
            })
        }

    }
    return(dat_temp)
}

#' @importFrom data.table dcast.data.table melt.data.table
.aggregate_classic <- function(dat_table, object, group_by, label,
                               check_missing = TRUE){
    dat_temp <- dcast.data.table(dat_table,
                                 "group_by + from_label + total + from ~ to_label",
                                 value.var = "ct", fun.aggregate = sum,
                                 fill = 0)
    dat_temp <- melt.data.table(dat_temp, id.vars = c("group_by", "from_label",
                                                      "from", "total"),
                                variable.name = "to_label",
                                value.name = "ct")

    total <- NULL

    dat_temp[,ct := ct/total]

    dat_temp <- dcast.data.table(dat_temp, "group_by + from_label ~ to_label",
                                 value.var = "ct",
                                 fun.aggregate = sum,
                                 fill = 0, drop = FALSE)

    dat_temp <- melt.data.table(dat_temp, id.vars = c("group_by", "from_label"),
                                variable.name = "to_label",
                                value.name = "ct")

    if (check_missing) {
        dat_temp <- dat_temp[CJ(group_by = unique(dat_table$group_by),
                                from_label = as.factor(levels(dat_table$from_label)),
                                to_label = as.factor(levels(dat_table$to_label))),
                             on = c("group_by", "from_label", "to_label")]
        ct <- from_label <- to_label <- NULL
        dat_temp[is.na(dat_temp$ct), ct := 0]

        # Set all cells that are not contained in specific groups to NA
        cur_dat <- unclass(table(colData(object)[[group_by]],
                                 colData(object)[[label]]))
        cur_ind <- which(cur_dat == 0, arr.ind = TRUE)

        if (nrow(cur_ind) > 0) {
            apply(cur_ind, 1 , function(x){
                dat_temp[group_by == rownames(cur_dat)[x[1]] &
                             (from_label == colnames(cur_dat)[x[2]] |
                                  to_label == colnames(cur_dat)[x[2]]),
                         ct := NA]
            })
        }
    }

    return(dat_temp)
}

.aggregate_classic_patch <- function(dat_table, patch_size, object, group_by,
                                     label, check_missing = TRUE){
    dat_temp <- dcast.data.table(dat_table,
                                 "group_by + from_label + total + from ~ to_label",
                                 value.var = "ct", fun.aggregate = sum,
                                 fill = 0)
    dat_temp <- melt.data.table(dat_temp, id.vars = c("group_by", "from_label",
                                                      "from", "total"),
                                variable.name = "to_label",
                                value.name = "ct")

    total <- NULL

    dat_temp[, ct := patch_size <= ct ]
    dat_temp[, ct := ct/total]

    dat_temp <- dcast.data.table(dat_temp, "group_by + from_label ~ to_label",
                                 value.var = "ct",
                                 fun.aggregate = sum, fill = 0, drop = FALSE)
    dat_temp <- melt.data.table(dat_temp, id.vars = c("group_by", "from_label"),
                                variable.name = "to_label",
                                value.name = "ct")

    if (check_missing) {
        dat_temp <- dat_temp[CJ(group_by = unique(dat_table$group_by),
                                from_label = as.factor(levels(dat_table$from_label)),
                                to_label = as.factor(levels(dat_table$to_label))),
                             on = c("group_by", "from_label", "to_label")]
        ct <- from_label <- to_label <- NULL
        dat_temp[is.na(dat_temp$ct), ct := 0]

        # Set all cells that are not contained in specific groups to NA
        cur_dat <- unclass(table(colData(object)[[group_by]],
                                 colData(object)[[label]]))
        cur_ind <- which(cur_dat == 0, arr.ind = TRUE)

        if (nrow(cur_ind) > 0) {
            apply(cur_ind, 1 , function(x){
                dat_temp[group_by == rownames(cur_dat)[x[1]] &
                             (from_label == colnames(cur_dat)[x[2]] |
                                  to_label == colnames(cur_dat)[x[2]]),
                         ct := NA]
            })
        }
    }

    return(dat_temp)
}

.aggregate_interaction <- function(dat_table, object, group_by, label,
                                             check_missing = TRUE) {
  
  . <- ct <- .N <- N <- n_tot_int <- NULL
  
  dat_temp <- dat_table[, .N, by = .(group_by, from_label, to_label)
  ][, n_tot_int := sum(N), by = .(group_by, from_label)
  ][, ct := N / n_tot_int]
  
  if (check_missing) {
    dat_temp <- dat_temp[CJ(group_by = unique(dat_table$group_by),
                            from_label = as.factor(levels(dat_table$from_label)),
                            to_label = as.factor(levels(dat_table$to_label))),
                         on = c("group_by", "from_label", "to_label")]
    ct <- from_label <- to_label <- NULL
    dat_temp[is.na(dat_temp$ct), ct := 0]
    
    # Set all cells that are not contained in specific groups to NA
    cur_dat <- unclass(table(colData(object)[[group_by]],
                             colData(object)[[label]]))
    cur_ind <- which(cur_dat == 0, arr.ind = TRUE)
    
    if (nrow(cur_ind) > 0) {
      apply(cur_ind, 1 , function(x){
        dat_temp[group_by == rownames(cur_dat)[x[1]] &
                   (from_label == colnames(cur_dat)[x[2]] |
                      to_label == colnames(cur_dat)[x[2]]),
                 ct := NA]
      })
    }
  }
  
  dat_temp <- dat_temp[, .(group_by, from_label, to_label, ct)]
  return(dat_temp)
}

#' @importFrom data.table data.table
.permute_labels <- function(object, group_by, label, iter, patch_size,
                            colPairName, method, BPPARAM) {

    cur_lab_table <- data.table(label = as.factor(colData(object)[[label]]),
                                group_by = colData(object)[[group_by]],
                                index = seq_len(ncol(object)))

    . <- index <- label <- NULL

    cur_out <- bplapply(seq_len(iter),
                        function(x){

                            label_perm <- cur_lab_table[ ,
                                                         .(label=sample(label), 
                                                           index = index), by=group_by]
                            
                            setorder(label_perm, "index")
                            
                            cur_perm <- .prepare_table(object, group_by,
                                                       label_perm$label, colPairName)

                            if (method == "classic") {
                                cur_perm <- .aggregate_classic(cur_perm, object,
                                                               group_by, label,
                                                               check_missing = FALSE)
                            } else if (method == "conditional") {
                                cur_perm <- .aggregate_conditional(cur_perm, object,
                                                             group_by, label,
                                                             check_missing = FALSE)
                            } else if (method == "patch") {
                                cur_perm <- .aggregate_classic_patch(cur_perm,
                                                                     patch_size = patch_size,
                                                                     object, group_by, label,
                                                                     check_missing = FALSE)
                            } else if (method == "interaction") {
                                cur_perm <- .aggregate_interaction(cur_perm,
                                                                     object, group_by, label,
                                                                     check_missing = FALSE)
                            }
                            cur_perm$iter <- x

                            return(cur_perm)

                        }, BPPARAM = BPPARAM)

    cur_out <- do.call("rbind", cur_out)

    return(cur_out)
}

.calc_p_vals<- function(dat_baseline, dat_perm, n_perm, p_thres, return_samples,
                        tolerance){
    dat_perm <- merge(dat_perm,
                      dat_baseline[, c("from_label", "to_label",
                                       "group_by", "ct")],
                      by = c("from_label", "to_label", "group_by"),
                      suffixes = c("_perm", "_obs"), all = TRUE)
    
    # dat_perm <- as.data.table(as.data.frame(dat_perm))

    . <- ct_perm <- ct_obs <- p_gt <- p_lt <- NULL
    direction <- sig <- sigval <- p <- zscore <- NULL

    dat_perm[, ':='(ct_perm = replace(ct_perm, is.na(ct_perm), 0),
                    ct_obs = replace(ct_obs, is.na(ct_obs), 0))]

    # We introduced a more lenient way of checking equality to avoid issues
    # with machine precision
    dat_stat <- dat_perm[ , .(ct = mean(ct_obs),
                              p_gt = ifelse(max(ct_obs) == 0, 1,
                                            (sum((ct_perm - ct_obs) > -tolerance) + 1) / (n_perm + 1)),
                              p_lt = (n_perm - sum((ct_perm - ct_obs) > tolerance) + 1) / (n_perm + 1),
                              zscore = (mean(ct_obs) - mean(ct_perm)) / sd(ct_perm)),
                          by=c("group_by", "from_label", "to_label")]

    dat_stat[, interaction := p_gt < p_lt]
    dat_stat[, p := p_gt * interaction + p_lt * (!interaction)]
    dat_stat[, sig := p < p_thres]
    dat_stat[, sigval := as.integer(sig) * sign(interaction - 0.5)]
    
    # In corner cases, the levels of the factors can be different and the 
    # ordering is incorrect
    dat_baseline$group_by <- as.character(dat_baseline$group_by)
    dat_baseline$from_label <- as.character(dat_baseline$from_label)
    dat_baseline$to_label <- as.character(dat_baseline$to_label)

    dat_stat$group_by <- as.character(dat_stat$group_by)
    dat_stat$from_label <- as.character(dat_stat$from_label)
    dat_stat$to_label <- as.character(dat_stat$to_label)
    dat_stat[is.infinite(zscore), zscore := NA]
    
    setorder(dat_stat, "group_by", "from_label", "to_label")
    setorder(dat_baseline, "group_by", "from_label", "to_label")
    
    stopifnot(all.equal(paste(dat_stat$group_by, dat_stat$from_label, dat_stat$to_label),
                        paste(dat_baseline$group_by, dat_baseline$from_label, dat_baseline$to_label)))
    
    if (return_samples) {
        dat_perm <- dcast.data.table(dat_perm[,c("from_label", "to_label", "group_by", "iter", "ct_perm")], 
                          from_label + to_label + group_by ~ iter, value.var = "ct_perm")
        
        dat_perm$group_by <- as.character(dat_perm$group_by)
        dat_perm$from_label <- as.character(dat_perm$from_label)
        dat_perm$to_label <- as.character(dat_perm$to_label)
        
        setorder(dat_perm, "group_by", "from_label", "to_label")
    
        stopifnot(all.equal(paste(dat_perm$group_by, dat_perm$from_label, dat_perm$to_label),
                            paste(dat_baseline$group_by, dat_baseline$from_label, dat_baseline$to_label))) 
        cols <- as.character(seq_len(n_perm))
        dat_perm <- dat_perm[,cols,with=FALSE]
        colnames(dat_perm) <- paste0("iter_", colnames(dat_perm))
        dat_stat <- cbind(dat_stat, dat_perm)
    }

    dat_stat[is.na(dat_baseline$ct),
             c("p_gt", "p_lt", "ct", "interaction",
               "p", "sig", "sigval", "zscore") := NA]

    return(dat_stat)
}

#### SpatialContext helpers ####

.createEdgeList <- function(list, list_length){
  
  out <- lapply(list, function(x){
    list_options <- list[length(x) + 1 == list_length]
    
    if (length(list_options) != 0) {
      list_select <- list_options[vapply(list_options,
                                         function(y){length(intersect(y,x)) == length(x)},
                                         logical(1))]  
      
      if (length(list_select) != 0) { 
        out <- data.frame("from" = paste(x, collapse = "_"),
                          "to" = vapply(list_select, 
                                        paste, collapse = "_",
                                        character(1)), 
                          row.names = NULL)
        return(out)
      } else {
        return(NULL)
      }
    } else {
      return(NULL)
    }
  })
  
  edges <- do.call(rbind, out)
  
  return(edges)
}

#' @importFrom ggplot2 guide_legend guide_colorbar guides scale_size_manual
#' @importFrom ggraph geom_edge_link geom_node_label geom_node_point ggraph
#' @importFrom igraph layout.sugiyama vertex_attr

.generateSpatialContextPlot <- function(graph,
                                        node_color_by,
                                        node_size_by,
                                        node_color_fix,
                                        node_size_fix,
                                        node_label_repel,
                                        node_label_color_by, 
                                        node_label_color_fix,  
                                        draw_edges,
                                        edge_color_fix){
  
  node_color_by <- if (is.null(node_color_by)) NULL else node_color_by
  node_size_by <- if (is.null(node_size_by)) NULL else node_size_by
  node_label_color_by <- if (is.null(node_label_color_by)) NULL else node_label_color_by
  
  edge_color_fix <- if (is.null(edge_color_fix)) "black" else edge_color_fix 
  node_color_fix <- if (is.null(node_color_fix)) "darkgrey" else node_color_fix 
  node_size_fix <- if (is.null(node_size_fix)) "3" else node_size_fix 
  node_label_color_fix <- if (is.null(node_label_color_fix)) "black" else node_label_color_fix
  
  ## edge geom  
  if (draw_edges) {
      cur_geom_edge <- geom_edge_link(color = edge_color_fix)
  } else {
      cur_geom_edge <- NULL
  }
  
  ## node geom
  if (!is.null(node_color_by)){
      color <- vertex_attr(graph, node_color_by) 
  } else {
      color <- as.character(node_color_fix)
  }
  
  if (!is.null(node_size_by)) {
      size <- vertex_attr(graph, node_size_by) 
  } else {
      size <- as.character(node_size_fix)
  }
  
  if (!is.null(node_color_by)) {
      cur_geom_node <- geom_node_point(aes(color = color, size = size))
  } else {
      cur_geom_node <- geom_node_point(aes(size = size), color = color)
  }
  
  ## node geom label
  if (!is.null(node_label_color_by)) {
    color_label <- vertex_attr(graph, node_label_color_by) 
  } else {
    color_label <- as.character(node_label_color_fix)
  }
  
  if(node_label_repel){
    if (!is.null(node_label_color_by)) {
      cur_geom_node_label <- geom_node_label(aes(color = color_label, 
                                             label = vertex_attr(graph, "name")), 
                                             repel = TRUE, show.legend = FALSE)
    } else {
      cur_geom_node_label <- geom_node_label(aes(label = vertex_attr(graph, "name")), 
                                             color = color_label, 
                                             repel = TRUE, show.legend = FALSE)
    }
  } else {
    cur_geom_node_label <- NULL
  }  
  
  # specify vertical layout with sugiyama
  LO <- layout.sugiyama(graph, vertex_attr(graph,"length"))
  
  p <- ggraph(graph, layout = LO$layout) +
      cur_geom_edge +
      cur_geom_node +
      cur_geom_node_label +
      theme_graph(base_family = "")
  
  # legend post-processing
  if (!is.null(node_color_by)) {
    if (node_color_by %in% c("n_cells","n_group")) {
      p <- p + guides(color = guide_colorbar(node_color_by), 
                      size = guide_legend(node_size_by))
    } else {
      if (node_label_repel == FALSE) {
        p <- p + guides(color = guide_legend(node_color_by), 
                        size = guide_legend(node_size_by))
        } else {
        p <- p + guides(color = "none", size = guide_legend(as.character(node_size_by)))
      }
    }
  } else {
    p <- p + guides(color = "none", size = guide_legend(as.character(node_size_by)))
  }
  
  # node size post-processing
  if (is.null(node_size_by)) {
    p <- p + guides(size = "none") + scale_size_manual(values = as.numeric(node_size_fix))
  }
  
  return(p)
}

#### plotInteractions helpers ####

#' @importFrom grid arrow unit
#' @importFrom ggplot2 labs
#' @importFrom igraph edge_attr

.generateInteractionsPlot <- function(graph,
                                      node_color_by,
                                      node_size_by,
                                      node_color_fix,
                                      node_size_fix,
                                      node_color_palette,
                                      node_label_repel,
                                      node_label_color_by, 
                                      node_label_color_fix,
                                      edge_color_by,
                                      edge_color_fix,
                                      edge_width_by,
                                      edge_width_fix,
                                      draw_edges,
                                      graph_layout){
  
  node_color_by <- if (is.null(node_color_by)) NULL else node_color_by
  node_size_by <- if (is.null(node_size_by)) NULL else node_size_by
  node_label_color_by <- if (is.null(node_label_color_by)) NULL else node_label_color_by
  edge_color_by <- if (is.null(edge_color_by)) NULL else edge_color_by
  edge_width_by <- if (is.null(edge_width_by)) NULL else edge_width_by
  
  edge_color_fix <- if (is.null(edge_color_fix)) "black" else edge_color_fix
  edge_width_fix <- if (is.null(edge_width_fix)) 1 else edge_width_fix
  node_color_fix <- if (is.null(node_color_fix)) "darkgrey" else node_color_fix 
  node_size_fix <- if (is.null(node_size_fix)) 3 else node_size_fix 
  node_label_color_fix <- if (is.null(node_label_color_fix)) "black" else node_label_color_fix
  
  if (draw_edges) {
    
    if (!is.null(edge_color_by) && !is.null(edge_width_by)) {
      
      cur_geom_edge <- geom_edge_arc(
        aes(edge_colour = as.factor(color), width = weight),
        show.legend = FALSE,
        arrow   = arrow(length = unit(4, 'mm')),
        end_cap = circle(3, 'mm')
      )
      cur_geom_loop <- geom_edge_loop(
        aes(edge_colour = as.factor(color), width = weight),
        show.legend = FALSE,
        arrow   = arrow(length = unit(4, 'mm')),
        end_cap = circle(3, 'mm')
      )
      
      # without arrows for legend
      cur_geom_edge_legend <- geom_edge_arc(
        aes(edge_colour = as.factor(color), width = weight),
        show.legend = TRUE
      )
      cur_geom_loop_legend <- geom_edge_loop(
        aes(edge_colour = as.factor(color), width = weight),
        show.legend = TRUE
      )
      
    } else if (!is.null(edge_color_by)) {
      
      cur_geom_edge <- geom_edge_arc(
        aes(edge_colour = as.factor(color)),
        width      = edge_width_fix,
        show.legend= FALSE,
        arrow      = arrow(length = unit(4, 'mm')),
        end_cap    = circle(3, 'mm')
      )
      cur_geom_loop <- geom_edge_loop(
        aes(edge_colour = as.factor(color)),
        width       = edge_width_fix,
        show.legend = FALSE,
        arrow       = arrow(length = unit(4, 'mm')),
        end_cap     = circle(3, 'mm')
      )
      
      # without arrows for legend
      cur_geom_edge_legend <- geom_edge_arc(
        aes(edge_colour = as.factor(color)),
        width      = edge_width_fix,
        show.legend = TRUE
      )
      cur_geom_loop_legend <- geom_edge_loop(
        aes(edge_colour = as.factor(color)),
        width      = edge_width_fix,
        show.legend = TRUE
      )
      
    } else if (!is.null(edge_width_by)) {
      
      cur_geom_edge <- geom_edge_arc(
        aes(width = weight),
        edge_colour = edge_color_fix,
        show.legend = FALSE,
        arrow       = arrow(length = unit(4, 'mm')),
        end_cap     = circle(3, 'mm')
      )
      cur_geom_loop <- geom_edge_loop(
        aes(width = weight),
        edge_colour = edge_color_fix,
        show.legend = FALSE,
        arrow       = arrow(length = unit(4, 'mm')),
        end_cap     = circle(3, 'mm')
      )
      
      # without arrows for legend
      cur_geom_edge_legend <- geom_edge_arc(
        aes(width = weight),
        edge_colour = edge_color_fix,
        show.legend = TRUE
      )
      cur_geom_loop_legend <- geom_edge_loop(
        aes(width = weight),
        edge_colour = edge_color_fix,
        show.legend = TRUE
      )
      
    } else {
      
      cur_geom_edge <- geom_edge_arc(
        edge_colour = edge_color_fix,
        width       = edge_width_fix,
        show.legend = FALSE,
        arrow       = arrow(length = unit(4, 'mm')),
        end_cap     = circle(3, 'mm')
      )
      cur_geom_loop <- geom_edge_loop(
        edge_colour = edge_color_fix,
        width       = edge_width_fix,
        show.legend = FALSE,
        arrow       = arrow(length = unit(4, 'mm')),
        end_cap     = circle(3, 'mm')
      )
      
      # without arrows for legend
      cur_geom_edge_legend <- geom_edge_arc(
        edge_colour = edge_color_fix,
        width       = edge_width_fix,
        show.legend = TRUE
      )
      cur_geom_loop_legend <- geom_edge_loop(
        edge_colour = edge_color_fix,
        width       = edge_width_fix,
        show.legend = TRUE
      )
      
    }
    
  } else {
    cur_geom_edge <- NULL
    cur_geom_loop <- NULL
    cur_geom_edge_legend <- NULL
    cur_geom_loop_legend <- NULL
  }
  
  ## node geom
  if (!is.null(node_color_by)){
    color <- vertex_attr(graph, node_color_by) 
  } else {
    color <- as.character(node_color_fix)
  }
  
  if (!is.null(node_size_by)) {
    size <- vertex_attr(graph, node_size_by) 
  } else {
    size <- as.character(node_size_fix)
  }
  
  if (!is.null(node_color_by)) {
    cur_geom_node <- geom_node_point(aes(color = color, size = size))
  } else {
    cur_geom_node <- geom_node_point(aes(size = size), color = color)
  }
  
  ## node geom label
  if (!is.null(node_label_color_by)) {
    color_label <- vertex_attr(graph, node_label_color_by) 
  } else {
    color_label <- as.character(node_label_color_fix)
  }
  
  if(node_label_repel){
    if (!is.null(node_label_color_by)) {
      cur_geom_node_label <- geom_node_label(aes(color = color_label, 
                                                 label = vertex_attr(graph, "name")), 
                                             repel = TRUE, show.legend = FALSE)
    } else {
      cur_geom_node_label <- geom_node_label(aes(label = vertex_attr(graph, "name")), 
                                             color = color_label, 
                                             repel = TRUE, show.legend = FALSE)
    }
  } else {
    cur_geom_node_label <- NULL
  }  
  
  ## layout
  if (graph_layout == "chord"){
    graph_layout <- "linear"
    circular <- TRUE
  } else {
    circular <- FALSE
  }

  p <- ggraph(graph, layout = graph_layout, circular = circular) +
    cur_geom_edge +
    cur_geom_loop +
    cur_geom_edge_legend +
    cur_geom_loop_legend +
    cur_geom_node +
    cur_geom_node_label +
    theme_graph(base_family = "")+
    labs(
      edge_colour = if (!is.null(edge_color_by)) edge_color_by else NULL,
      edge_width = if (!is.null(edge_width_by)) edge_width_by else NULL
    )
  
  # legend post-processing
  ## node color
  if (!is.null(node_color_by)) {
    if (node_color_by %in% c("n_cells","n_group")) {
      p <- p + guides(color = guide_colorbar(node_color_by), 
                      size = guide_legend(node_size_by))
    } else {
      if (node_label_repel == FALSE) {
        p <- p + guides(color = guide_legend(node_color_by), 
                        size = guide_legend(node_size_by))
      } else {
        p <- p + guides(color = "none", size = guide_legend(as.character(node_size_by)))
      }
    }
  } else {
    p <- p + guides(color = "none", size = guide_legend(as.character(node_size_by)))
  }
  
  
  # node size post-processing
  if (is.null(node_size_by)) {
    p <- p + guides(size = "none") + scale_size_manual(values = as.numeric(node_size_fix))
  }
  
  return(p)
}

#### SpatialCommunity helpers ####

#' @importFrom igraph cluster_louvain graph_from_data_frame
#' @importFrom utils getFromNamespace
#' @importFrom SingleCellExperiment colPair


.detectCommunity_function <- function(cur_object,
                                      colPairName, 
                                      cluster_fun){
  
  gr <- graph_from_data_frame(as.data.frame(colPair(cur_object, colPairName)), 
                              directed = FALSE, 
                              vertices = data.frame(index = seq_len(ncol(cur_object))))
  
  cluster_function <- getFromNamespace(paste0("cluster_",cluster_fun), ns = "igraph")
  
  cl_comm <- cluster_function(gr)
  
  return(cl_comm)
}

# Define the original neighbouRhood functions here
IMGNR = 'ImageNumber'
OBJNR = 'ObjectNumber'
OBJNAME = 'ObjectName'
OBJID = 'ObjectID'
GROUP = 'group'
LABEL = 'label'

FIRSTOBJNAME = 'First Object Name'
FIRSTIMAGENUMBER = 'First Image Number'
FIRSTOBJNUMBER = 'First Object Number'
FIRSTOBJID = 'First Object ID'

FIRSTLABEL = 'FirstLabel'

SECONDOBJNAME = 'Second Object Name'
SECONDIMAGENUMBER = 'Second Image Number'
SECONDOBJNUMBER = 'Second Object Number'
SECONDOBJID = 'Second Object ID'
SECONDLABEL = 'SecondLabel'

RELATIONSHIP = 'Relationship'
DEFAULTRELATIONSHIP = 'Neighbors'
DEFAULTOBJNAME = 'cell'

COUNTVAR = 'ct'

prepare_tables <- function(dat_obj, dat_rel, objname=DEFAULTOBJNAME,
                           relationship = DEFAULTRELATIONSHIP,
                           col_imnr=IMGNR,
                           col_objnr=OBJNR,
                           col_label=LABEL,
                           col_group=NULL,
                           col_relationship=RELATIONSHIP,
                           col_objname=OBJNAME
){
    
    cols = c(col_imnr, col_objnr, col_label)
    
    has_objname = FALSE
    if (col_objname %in% colnames(dat_obj)){
        cols = c(cols, col_objname)
        has_objname = TRUE
    }
    
    has_group = FALSE
    if (!is.null(col_group)){
        cols = c(cols, col_group)
        has_group = TRUE
    }
    
    # subset and copy the relevant part of the data
    dat_obj <- copy(dat_obj[,cols, with=FALSE])
    
    # set the objectname if needed
    if (has_objname == FALSE){
        dat_obj[,(col_objname) := objname]
    } else{
        dat_obj = dat_obj[get(col_objname) == objname]
        
    }
    
    # set the group if needed
    if (has_group == FALSE){
        col_group = GROUP
        dat_obj[,(col_group):=get(col_imnr)]
    }
    
    # rename all the columns
    setnames(dat_obj,
             c(col_imnr, col_objnr, col_label, col_group,
               col_objname),
             c(IMGNR, OBJNR, LABEL, GROUP,
               OBJNAME)
    )
    
    dat_obj[, label:=as.factor(label)]
    
    # same for the relationship table
    
    dat_rel = copy(dat_rel[(get(RELATIONSHIP) == relationship) &
                               (get(FIRSTOBJNAME) == objname)&
                               (get(SECONDOBJNAME) == objname), ][, c(FIRSTOBJNAME, FIRSTIMAGENUMBER, FIRSTOBJNUMBER,
                                                                      SECONDOBJNAME,SECONDIMAGENUMBER,  SECONDOBJNUMBER,
                                                                      RELATIONSHIP), with=FALSE])
    
    
    
    # give new ids
    dat_obj[, (OBJID) := 1:.N]
    
    dat_rel <- merge(dat_rel, dat_obj[, c(IMGNR, OBJNR, OBJID, GROUP), with=FALSE],
                     by.x=c(FIRSTIMAGENUMBER, FIRSTOBJNUMBER),
                     by.y=c(IMGNR, OBJNR)
    )
    setnames(dat_rel, OBJID, FIRSTOBJID)
    dat_rel <- merge(dat_rel, dat_obj[, c(IMGNR, OBJNR, OBJID), with=FALSE],
                     by.x=c(SECONDIMAGENUMBER, SECONDOBJNUMBER),
                     by.y=c(IMGNR, OBJNR)
    )
    
    setnames(dat_rel, OBJID, SECONDOBJID)
    dat_rel[, (COUNTVAR) := 1]
    dat_rel <- dat_rel[, c(GROUP, FIRSTOBJID, SECONDOBJID, COUNTVAR), with=FALSE]
    return(list(dat_obj, dat_rel))
}

shuffle_labels <- function(dat_labels){
    return(dat_labels[ , .(label=sample(label), ObjectID=ObjectID), by=group])
}

apply_labels <- function(dat_labels, dat_rel){
    labels = dat_labels[, get(LABEL)]
    objid = dat_labels[, get(OBJID)]
    labvec = rep(labels[1], max(objid))
    labvec[objid] = labels
    
    dat_rel[, (FIRSTLABEL) := labvec[get(FIRSTOBJID)]]
    dat_rel[, (SECONDLABEL) := labvec[get(SECONDOBJID)]]
    dat_rel
}


aggregate_classic<- function(dat_nb){
    dcast.data.table(dat_nb, paste0(GROUP, '+', FIRSTLABEL, '+`', FIRSTOBJID, '`~', SECONDLABEL),
                     value.var = COUNTVAR,
                     fun.aggregate=sum, fill=0) %>%
        melt.data.table(id.vars=c(GROUP, FIRSTLABEL, FIRSTOBJID),
                        variable.name=SECONDLABEL,
                        value.name=COUNTVAR) %>%
        dcast.data.table(paste0(GROUP, '+', FIRSTLABEL, '~', SECONDLABEL),
                         value.var = COUNTVAR,
                         fun.aggregate=mean, fill=0) %>%
        melt.data.table(id.vars=c(GROUP, FIRSTLABEL),
                        variable.name=SECONDLABEL,
                        value.name=COUNTVAR)
}

aggregate_conditional <- function(dat_nb){
    dat_temp = dat_nb[, .(ct=.N), by=.(group, FirstLabel, SecondLabel, `First Object ID`)]
    dat_temp[, .(ct=mean(ct)), by=.(group, FirstLabel, SecondLabel)]
}

aggregate_classic_patch<- function(dat_nb, patch_size){
    dat_temp = dcast.data.table(dat_nb, paste0(GROUP, '+', FIRSTLABEL, '+`', FIRSTOBJID, '`~', SECONDLABEL),
                                value.var = COUNTVAR,
                                fun.aggregate=sum, fill=0) %>%
        melt.data.table(id.vars=c(GROUP, FIRSTLABEL, FIRSTOBJID),
                        variable.name=SECONDLABEL,
                        value.name=COUNTVAR)
    
    # Addition patch detection
    dat_temp[, (COUNTVAR) := patch_size <= ct ]
    
    dcast.data.table(dat_temp,paste0(GROUP, '+', FIRSTLABEL, '~', SECONDLABEL),
                     value.var = COUNTVAR,
                     fun.aggregate=mean, fill=0) %>%
        melt.data.table(id.vars=c(GROUP, FIRSTLABEL),
                        variable.name=SECONDLABEL,
                        value.name=COUNTVAR)
}

calc_p_vals<- function(dat_baseline, dat_perm, n_perm, p_tresh=0.01){
    dat_perm <-
        merge(dat_perm, dat_baseline[, c(FIRSTLABEL, SECONDLABEL, GROUP, COUNTVAR), with=FALSE], by=c(FIRSTLABEL, SECONDLABEL, GROUP),
              suffixes = c("_perm", "_obs"),all=TRUE)
    dat_perm[, ':='(ct_perm=replace(ct_perm, is.na(ct_perm), 0),
                    ct_obs=replace(ct_obs, is.na(ct_obs), 0)
    )]
    # We introduced a more lenient way of checking equality to avoid issues
    # with machine precision
    tolerance <- sqrt(.Machine$double.eps)
    dat_stat <- dat_perm[ , .(p_gt = ifelse(max(ct_obs) == 0, 1, (sum((ct_perm - ct_obs) > -tolerance) + 1) / (n_perm + 1)),
                              p_lt = (n_perm - sum((ct_perm - ct_obs) > tolerance) + 1) / (n_perm + 1)),
                          by=.(group, FirstLabel, SecondLabel)]
    
    dat_stat[, direction := p_gt < p_lt]
    dat_stat[, p := p_gt * direction + p_lt * (direction == FALSE)]
    dat_stat[, sig := p < p_tresh]
    dat_stat[, sigval := as.integer(sig)*sign((direction-0.5))]
    dat_stat
}


test_that("testInteractions gives same results as neighbouRhood", {
    library(data.table)
    
    # Test neighbouRhood results
    fn_cells <- system.file("extdata/mockData/cpout", "cell.csv", package = "imcRtools")
    fn_relationship <- system.file("extdata/mockData/cpout", "Object_relationships.csv", package = "imcRtools")

    dat_cells <- fread(fn_cells)
    dat_relation <- fread(fn_relationship)
    
    set.seed(1234)
    cur_label <- sample.int(10, size=nrow(dat_cells), replace = TRUE)
    dat_cells[, label := cur_label]
    dat_cells[, group := ImageNumber]
    
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    # Compare to imcRtools
    cur_path <- system.file("extdata/mockData/cpout", package = "imcRtools")
    cur_spe <- read_cpout(cur_path, graph_file = "Object_relationships.csv")
    
    cur_colpair <- as.data.frame(colPair(cur_spe, "neighborhood"))
    cur_colpair <- cur_colpair[order(paste(cur_colpair[,1], cur_colpair[,2])),]
    cur_d <- as.data.frame(d[[2]][,c("First Object ID", "Second Object ID")])
    cur_d <- cur_d[order(paste(cur_d[,1], cur_d[,2])),]
    
    expect_equal(cur_colpair, cur_d, check.attributes = FALSE)
    
    cur_spe$label <- as.factor(cur_label)
    
    cur_table <- .prepare_table(cur_spe, group_by = "sample_id", 
                                cur_label  = as.factor(colData(cur_spe)[["label"]]), 
                                colPairName = "neighborhood")
    
    labels_applied <- as.data.frame(labels_applied)
    labels_applied <- labels_applied[order(paste(labels_applied[,"First Object ID"], labels_applied[,"Second Object ID"])),]
    cur_table <- as.data.frame(cur_table)
    cur_table <- cur_table[order(paste(cur_table[,"from"], cur_table[,"to"])),]
    
    expect_equal(labels_applied$group, as.numeric(cur_table$group_by))
    expect_equal(labels_applied$`First Object ID`, cur_table$from)
    expect_equal(labels_applied$`Second Object ID`, cur_table$to)
    expect_equal(labels_applied$FirstLabel, cur_table$from_label)
    expect_equal(labels_applied$SecondLabel, cur_table$to_label)
    
    cur_table <- .prepare_table(cur_spe, group_by = "sample_id", 
                                cur_label  = as.factor(colData(cur_spe)[["label"]]), 
                                colPairName = "neighborhood")

    cur_conditional <- .aggregate_conditional(cur_table, object = cur_spe, group_by = "sample_id", label = "label")
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    conditional_aggregation <- aggregate_conditional(labels_applied)
    
    setorder(conditional_aggregation, "group", "FirstLabel", "SecondLabel")
    cur_conditional$group_by <- as.numeric(cur_conditional$group_by)
    cur_conditional <- cur_conditional[conditional_aggregation,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(cur_conditional, "group_by", "from_label", "to_label")
    
    expect_equal(cur_conditional$group_by, conditional_aggregation$group)
    expect_equal(cur_conditional$from_label, conditional_aggregation$FirstLabel)
    expect_equal(cur_conditional$to_label, conditional_aggregation$SecondLabel)
    expect_equal(cur_conditional$ct, conditional_aggregation$ct)
    
    classic_aggregation <- aggregate_classic(labels_applied)
    cur_classic <- .aggregate_classic(cur_table, object = cur_spe, group_by = "sample_id", label = "label")
    
    setorder(classic_aggregation, "group", "FirstLabel", "SecondLabel")
    cur_classic$group_by <- as.numeric(cur_classic$group_by)
    cur_classic <- cur_classic[classic_aggregation,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(cur_classic, "group_by", "from_label", "to_label")
    
    expect_equal(cur_classic$group_by, classic_aggregation$group)
    expect_equal(cur_classic$from_label, classic_aggregation$FirstLabel)
    expect_equal(cur_classic$to_label, classic_aggregation$SecondLabel)
    
    # There is one image where one cell is not connected to other cells
    tmp_classic <- cur_classic[cur_classic$group_by != "1",]
    tmp_aggregation <- classic_aggregation[classic_aggregation$group != "1",]
    
    expect_equal(tmp_classic$ct[!is.na(tmp_classic$ct)], tmp_aggregation$ct[!is.na(tmp_classic$ct)])
    expect_true(all(classic_aggregation$ct[is.na(cur_classic$ct)] == 0))
    
    patch_aggregation <- aggregate_classic_patch(labels_applied, patch_size = 3)
    cur_patch <- .aggregate_classic_patch(cur_table, patch_size = 3, object = cur_spe, group_by = "sample_id", label = "label")
    
    setorder(patch_aggregation, "group", "FirstLabel", "SecondLabel")
    cur_patch$group_by <- as.numeric(cur_patch$group_by)
    cur_patch <- cur_patch[patch_aggregation,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(cur_patch, "group_by", "from_label", "to_label")
    
    expect_equal(cur_patch$group_by, patch_aggregation$group)
    expect_equal(cur_patch$from_label, patch_aggregation$FirstLabel)
    expect_equal(cur_patch$to_label, patch_aggregation$SecondLabel)
    expect_equal(cur_patch$ct[!is.na(cur_patch$ct)], patch_aggregation$ct[!is.na(cur_patch$ct)])
    expect_true(all(patch_aggregation$ct[is.na(cur_patch$ct)] == 0))
    
    # With cytomapper data
    ###################################### classic #############################
    library(cytomapper)
    data(pancreasSCE)

    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    dat_cells <- as.data.table(colData(pancreasSCE))
    dat_relation <- as.data.table(colPair(pancreasSCE))
    dat_cells[, label := CellType]
    dat_cells[, group := ImageNb]
    dat_cells[, ImageNumber := ImageNb]
    dat_cells[, ObjectNumber := CellNb]
    dat_relation[, Relationship := "Neighbors"]
    dat_relation[, "First Image Number" := colData(pancreasSCE)[["ImageNb"]][from]]
    dat_relation[, "First Object Number" := colData(pancreasSCE)[["CellNb"]][from]]
    dat_relation[, "Second Image Number" := colData(pancreasSCE)[["ImageNb"]][to]]
    dat_relation[, "Second Object Number" := colData(pancreasSCE)[["CellNb"]][to]]
    dat_relation[, "First Object Name" := "cell"]
    dat_relation[, "Second Object Name" := "cell"]
    
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_classic <- aggregate_classic(labels_applied)
    setorder(cur_classic, group, FirstLabel, SecondLabel)
    
    imcRtools_classic <- countInteractions(pancreasSCE, 
                                               group_by = "ImageNb", 
                                               label = "CellType",
                                               colPairName = "knn_interaction_graph")
    
    imcRtools_classic <- as.data.table(imcRtools_classic)[cur_classic,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic, "group_by", "from_label", "to_label")
    
    expect_equal(cur_classic$group, imcRtools_classic$group_by)
    expect_equal(cur_classic$FirstLabel, imcRtools_classic$from_label)
    expect_equal(cur_classic$SecondLabel, imcRtools_classic$to_label)
    expect_equal(cur_classic$ct[!is.na(imcRtools_classic$ct)], imcRtools_classic$ct[!is.na(imcRtools_classic$ct)])

    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_classic, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_classic_perm <- testInteractions(pancreasSCE, 
                                                   group_by = "ImageNb", 
                                                   label = "CellType",
                                                   colPairName = "knn_interaction_graph",
                                                   iter = 100,
                                               BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_classic_perm <- as.data.table(imcRtools_classic_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_classic_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_classic_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_classic_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p_gt[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p_lt[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$interaction[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$sig[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$sigval[!is.na(imcRtools_classic_perm$ct)])
    
    ###################################### conditional #############################
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_conditional <- aggregate_conditional(labels_applied)
    setorder(cur_conditional, group, FirstLabel, SecondLabel)
    
    imcRtools_conditional <- countInteractions(pancreasSCE, 
                                               group_by = "ImageNb", 
                                               label = "CellType",
                                               colPairName = "knn_interaction_graph",
                                               method = "conditional")
    
    imcRtools_conditional <- as.data.table(imcRtools_conditional)[cur_conditional,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional, "group_by", "from_label", "to_label")
    
    expect_equal(cur_conditional$group, imcRtools_conditional$group_by)
    expect_equal(cur_conditional$FirstLabel, imcRtools_conditional$from_label)
    expect_equal(cur_conditional$SecondLabel, imcRtools_conditional$to_label)
    expect_equal(cur_conditional$ct, imcRtools_conditional$ct)
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_conditional()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_conditional, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_conditional_perm <- testInteractions(pancreasSCE, 
                                            group_by = "ImageNb", 
                                            label = "CellType",
                                            colPairName = "knn_interaction_graph",
                                            iter = 100,
                                            method = "conditional", 
                                            BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_conditional_perm <- as.data.table(imcRtools_conditional_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_conditional_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_conditional_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_conditional_perm$to_label)
    expect_equal(dat_p$p_gt, imcRtools_conditional_perm$p_gt)
    expect_equal(dat_p$p_lt, imcRtools_conditional_perm$p_lt)
    expect_equal(dat_p$direction, imcRtools_conditional_perm$interaction)
    expect_equal(dat_p$p, imcRtools_conditional_perm$p)
    expect_equal(dat_p$sig, imcRtools_conditional_perm$sig)
    expect_equal(dat_p$sigval, imcRtools_conditional_perm$sigval)
    
    ###################################### patch #############################
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_patch <- aggregate_classic_patch(labels_applied, patch_size = 3)
    setorder(cur_patch, group, FirstLabel, SecondLabel)
    
    imcRtools_patch <- countInteractions(pancreasSCE, 
                                             group_by = "ImageNb", 
                                             label = "CellType",
                                             colPairName = "knn_interaction_graph",
                                             method = "patch",
                                             patch_size = 3)
    
    imcRtools_patch <- as.data.table(imcRtools_patch)[cur_patch,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_patch, "group_by", "from_label", "to_label")
    
    expect_equal(cur_patch$group, imcRtools_patch$group_by)
    expect_equal(cur_patch$FirstLabel, imcRtools_patch$from_label)
    expect_equal(cur_patch$SecondLabel, imcRtools_patch$to_label)
    expect_equal(cur_patch$ct[!is.na(imcRtools_patch$ct)], imcRtools_patch$ct[!is.na(imcRtools_patch$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic_patch(patch_size = 3)
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_patch, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_patch_perm <- testInteractions(pancreasSCE, 
                                                 group_by = "ImageNb", 
                                                 label = "CellType",
                                                 colPairName = "knn_interaction_graph",
                                                 iter = 100,
                                                 method = "patch",
                                                 patch_size = 3,
                                             BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_patch_perm <- as.data.table(imcRtools_patch_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_patch_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_patch_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_patch_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_patch_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p_gt[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p_lt[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$interaction[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$sig[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$sigval[!is.na(imcRtools_patch_perm$ct)])
    
    # Corner case
    cur_sce <- pancreasSCE
    cur_sce$CellType[123] <- "test"
    cur_sce <- buildSpatialGraph(cur_sce, img_id = "ImageNb", 
                                 type = "expansion", threshold = 7)
    
    plotSpatial(cur_sce, node_color_by = "CellType", img_id = "ImageNb", 
                draw_edges = TRUE, colPairName = "expansion_interaction_graph")
    
    dat_cells <- as.data.table(colData(cur_sce))
    dat_relation <- as.data.table(colPair(cur_sce, "expansion_interaction_graph"))
    dat_cells[, label := CellType]
    dat_cells[, group := ImageNb]
    dat_cells[, ImageNumber := ImageNb]
    dat_cells[, ObjectNumber := CellNb]
    dat_relation[, Relationship := "Neighbors"]
    dat_relation[, "First Image Number" := colData(cur_sce)[["ImageNb"]][from]]
    dat_relation[, "First Object Number" := colData(cur_sce)[["CellNb"]][from]]
    dat_relation[, "Second Image Number" := colData(cur_sce)[["ImageNb"]][to]]
    dat_relation[, "Second Object Number" := colData(cur_sce)[["CellNb"]][to]]
    dat_relation[, "First Object Name" := "cell"]
    dat_relation[, "Second Object Name" := "cell"]
    
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_classic <- aggregate_classic(labels_applied)
    setorder(cur_classic, group, FirstLabel, SecondLabel)
    
    imcRtools_classic <- countInteractions(cur_sce, 
                                           group_by = "ImageNb", 
                                           label = "CellType",
                                           colPairName = "expansion_interaction_graph")
    
    imcRtools_classic <- as.data.table(imcRtools_classic)[cur_classic,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic, "group_by", "from_label", "to_label")
    
    expect_equal(cur_classic$group, imcRtools_classic$group_by)
    expect_equal(cur_classic$FirstLabel, imcRtools_classic$from_label)
    expect_equal(cur_classic$SecondLabel, imcRtools_classic$to_label)
    #expect_equal(cur_classic$ct[!is.na(imcRtools_classic$ct)], imcRtools_classic$ct[!is.na(imcRtools_classic$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_classic, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_classic_perm <- testInteractions(cur_sce, 
                                               group_by = "ImageNb", 
                                               label = "CellType",
                                               colPairName = "expansion_interaction_graph",
                                               iter = 100,
                                               BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_classic_perm <- as.data.table(imcRtools_classic_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_classic_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_classic_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_classic_perm$to_label)
    #expect_equal(dat_p$p_gt[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$p_gt[!is.na(imcRtools_classic_perm$ct)])
    #expect_equal(dat_p$p_lt[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$p_lt[!is.na(imcRtools_classic_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$interaction[!is.na(imcRtools_classic_perm$ct)])
    #expect_equal(dat_p$p[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$p[!is.na(imcRtools_classic_perm$ct)])
    #expect_equal(dat_p$sig[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$sig[!is.na(imcRtools_classic_perm$ct)])
    #expect_equal(dat_p$sigval[!is.na(imcRtools_classic_perm$ct)], imcRtools_classic_perm$sigval[!is.na(imcRtools_classic_perm$ct)])
    
    # conditional
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_conditional <- aggregate_conditional(labels_applied)
    setorder(cur_conditional, group, FirstLabel, SecondLabel)
    
    imcRtools_conditional <- countInteractions(cur_sce, 
                                           group_by = "ImageNb", 
                                           label = "CellType",
                                           method = "conditional",
                                           colPairName = "expansion_interaction_graph")
    
    imcRtools_conditional <- as.data.table(imcRtools_conditional)[cur_conditional,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional, "group_by", "from_label", "to_label")
    
    expect_equal(cur_conditional$group, imcRtools_conditional$group_by)
    expect_equal(cur_conditional$FirstLabel, imcRtools_conditional$from_label)
    expect_equal(cur_conditional$SecondLabel, imcRtools_conditional$to_label)
    expect_equal(cur_conditional$ct[!is.na(imcRtools_conditional$ct)], imcRtools_conditional$ct[!is.na(imcRtools_conditional$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_conditional()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_conditional, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_conditional_perm <- testInteractions(cur_sce, 
                                               group_by = "ImageNb", 
                                               label = "CellType",
                                               method = "conditional",
                                               colPairName = "expansion_interaction_graph",
                                               iter = 100,
                                               BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_conditional_perm <- as.data.table(imcRtools_conditional_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_conditional_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_conditional_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_conditional_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p_gt[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p_lt[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$interaction[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$sig[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$sigval[!is.na(imcRtools_conditional_perm$ct)])
    
    ###################################### patch ##############################
    d <- prepare_tables(dat_cells, dat_relation)
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_classic_patch <- aggregate_classic_patch(labels_applied, patch_size = 1)
    setorder(cur_classic_patch, group, FirstLabel, SecondLabel)
    
    imcRtools_classic_patch <- countInteractions(cur_sce, 
                                           group_by = "ImageNb", 
                                           label = "CellType",
                                           method = "patch",
                                           patch_size = 1,
                                           colPairName = "expansion_interaction_graph")
    
    imcRtools_classic_patch <- as.data.table(imcRtools_classic_patch)[cur_classic_patch,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic_patch, "group_by", "from_label", "to_label")
    
    expect_equal(cur_classic_patch$group, imcRtools_classic_patch$group_by)
    expect_equal(cur_classic_patch$FirstLabel, imcRtools_classic_patch$from_label)
    expect_equal(cur_classic_patch$SecondLabel, imcRtools_classic_patch$to_label)
    #expect_equal(cur_classic_patch$ct[!is.na(imcRtools_classic_patch$ct)], imcRtools_classic_patch$ct[!is.na(imcRtools_classic_patch$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic_patch(patch_size = 1)
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_classic_patch, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_classic_patch_perm <- testInteractions(cur_sce, 
                                               group_by = "ImageNb", 
                                               label = "CellType",
                                               colPairName = "expansion_interaction_graph",
                                               iter = 100,
                                               method = "patch",
                                               patch_size = 1,
                                               BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_classic_patch_perm <- as.data.table(imcRtools_classic_patch_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic_patch_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_classic_patch_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_classic_patch_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_classic_patch_perm$to_label)
    #expect_equal(dat_p$p_gt[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$p_gt[!is.na(imcRtools_classic_patch_perm$ct)])
    #expect_equal(dat_p$p_lt[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$p_lt[!is.na(imcRtools_classic_patch_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$interaction[!is.na(imcRtools_classic_patch_perm$ct)])
    #expect_equal(dat_p$p[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$p[!is.na(imcRtools_classic_patch_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$sig[!is.na(imcRtools_classic_patch_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_classic_patch_perm$ct)], imcRtools_classic_patch_perm$sigval[!is.na(imcRtools_classic_patch_perm$ct)])
    
})

test_that("testInteractions gives same results as neighbouRhood when using different grouping", {
    library(data.table)
    library(cytomapper)
    data(pancreasSCE)
    
    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn",
                                     k = 3)
    
    dat_cells <- as.data.table(colData(pancreasSCE))
    dat_relation <- as.data.table(colPair(pancreasSCE))
    dat_cells[, label := CellType]
    dat_cells[, group := Pattern]
    dat_cells[, ImageNumber := ImageNb]
    dat_cells[, ObjectNumber := CellNb]
    dat_relation[, Relationship := "Neighbors"]
    dat_relation[, "First Image Number" := colData(pancreasSCE)[["ImageNb"]][from]]
    dat_relation[, "First Object Number" := colData(pancreasSCE)[["CellNb"]][from]]
    dat_relation[, "Second Image Number" := colData(pancreasSCE)[["ImageNb"]][to]]
    dat_relation[, "Second Object Number" := colData(pancreasSCE)[["CellNb"]][to]]
    dat_relation[, "First Object Name" := "cell"]
    dat_relation[, "Second Object Name" := "cell"]
    
    d <- prepare_tables(dat_cells, dat_relation, col_group = "Pattern")
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_classic <- aggregate_classic(labels_applied)
    setorder(cur_classic, group, FirstLabel, SecondLabel)
    
    imcRtools_classic <- countInteractions(pancreasSCE, 
                                           group_by = "Pattern", 
                                           label = "CellType",
                                           colPairName = "knn_interaction_graph")
    
    imcRtools_classic <- as.data.table(imcRtools_classic)[cur_classic,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic, "group_by", "from_label", "to_label")
    
    expect_equal(cur_classic$group, imcRtools_classic$group_by)
    expect_equal(cur_classic$FirstLabel, imcRtools_classic$from_label)
    expect_equal(cur_classic$SecondLabel, imcRtools_classic$to_label)
    expect_equal(cur_classic$ct[!is.na(imcRtools_classic$ct)], imcRtools_classic$ct[!is.na(imcRtools_classic$ct)])
    
    # Comment: if the to cell is located outside of the group it's still being counted
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_classic, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_classic_perm <- testInteractions(pancreasSCE, 
                                               group_by = "Pattern", 
                                               label = "CellType",
                                               colPairName = "knn_interaction_graph",
                                               iter = 100,
                                               BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_classic_perm <- as.data.table(imcRtools_classic_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_classic_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_classic_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_classic_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_classic_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p_gt[!is.na(imcRtools_classic$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p_lt[!is.na(imcRtools_classic$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$interaction[!is.na(imcRtools_classic$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$p[!is.na(imcRtools_classic$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$sig[!is.na(imcRtools_classic$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_classic$ct)], imcRtools_classic_perm$sigval[!is.na(imcRtools_classic$ct)])
    
    ###################################### conditional #############################
    d <- prepare_tables(dat_cells, dat_relation, col_group = "Pattern")
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_conditional <- aggregate_conditional(labels_applied)
    setorder(cur_conditional, group, FirstLabel, SecondLabel)
    
    imcRtools_conditional <- countInteractions(pancreasSCE, 
                                         group_by = "Pattern", 
                                         label = "CellType",
                                         colPairName = "knn_interaction_graph",
                                         method = "conditional")
    
    imcRtools_conditional <- as.data.table(imcRtools_conditional)[cur_conditional,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional, "group_by", "from_label", "to_label")
    
    expect_equal(cur_conditional$group, imcRtools_conditional$group_by)
    expect_equal(cur_conditional$FirstLabel, imcRtools_conditional$from_label)
    expect_equal(cur_conditional$SecondLabel, imcRtools_conditional$to_label)
    expect_equal(cur_conditional$ct[!is.na(imcRtools_conditional$ct)], imcRtools_conditional$ct[!is.na(imcRtools_conditional$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_conditional()
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_conditional, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_conditional_perm <- testInteractions(pancreasSCE, 
                                             group_by = "Pattern", 
                                             label = "CellType",
                                             colPairName = "knn_interaction_graph",
                                             iter = 100,
                                             method = "conditional", 
                                             BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_conditional_perm <- as.data.table(imcRtools_conditional_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_conditional_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_conditional_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_conditional_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_conditional_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p_gt[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p_lt[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$interaction[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$p[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$sig[!is.na(imcRtools_conditional_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_conditional_perm$ct)], imcRtools_conditional_perm$sigval[!is.na(imcRtools_conditional_perm$ct)])
    
    ###################################### patch #############################
    d <- prepare_tables(dat_cells, dat_relation, col_group = "Pattern")
    
    labels_applied <- apply_labels(d[[1]], d[[2]])
    
    cur_patch <- aggregate_classic_patch(labels_applied, patch_size = 3)
    setorder(cur_patch, group, FirstLabel, SecondLabel)
    
    imcRtools_patch <- countInteractions(pancreasSCE, 
                                         group_by = "Pattern", 
                                         label = "CellType",
                                         colPairName = "knn_interaction_graph",
                                         method = "patch",
                                         patch_size = 3)
    
    imcRtools_patch <- as.data.table(imcRtools_patch)[cur_patch,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_patch, "group_by", "from_label", "to_label")
    
    expect_equal(cur_patch$group, imcRtools_patch$group_by)
    expect_equal(cur_patch$FirstLabel, imcRtools_patch$from_label)
    expect_equal(cur_patch$SecondLabel, imcRtools_patch$to_label)
    expect_equal(cur_patch$ct[!is.na(imcRtools_patch$ct)], imcRtools_patch$ct[!is.na(imcRtools_patch$ct)])
    
    # Perturbation
    n_perm <- 100
    
    dat_perm <- bplapply(1:n_perm, function(x){
        dat_labels = shuffle_labels(d[[1]])
        apply_labels(dat_labels, d[[2]]) %>%
            aggregate_classic_patch(patch_size = 3)
    }, BPPARAM = SerialParam(RNGseed = 123))
    dat_perm <- rbindlist(dat_perm, idcol = 'run')
    
    dat_p <- calc_p_vals(cur_patch, dat_perm, n_perm = n_perm, p_tresh = 0.01) 
    setorder(dat_p, group, FirstLabel, SecondLabel)
    dat_p$group <- as.character(dat_p$group)
    
    imcRtools_patch_perm <- testInteractions(pancreasSCE, 
                                             group_by = "Pattern", 
                                             label = "CellType",
                                             colPairName = "knn_interaction_graph",
                                             iter = 100,
                                             method = "patch",
                                             patch_size = 3,
                                             BPPARAM = SerialParam(RNGseed = 123))
    
    imcRtools_patch_perm <- as.data.table(imcRtools_patch_perm)[dat_p,, on = c("group_by==group", "from_label==FirstLabel", "to_label==SecondLabel")]
    setorder(imcRtools_patch_perm, "group_by", "from_label", "to_label")
    
    expect_equal(dat_p$group, imcRtools_patch_perm$group_by)
    expect_equal(as.character(dat_p$FirstLabel), imcRtools_patch_perm$from_label)
    expect_equal(as.character(dat_p$SecondLabel), imcRtools_patch_perm$to_label)
    expect_equal(dat_p$p_gt[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p_gt[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$p_lt[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p_lt[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$direction[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$interaction[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$p[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$p[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$sig[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$sig[!is.na(imcRtools_patch_perm$ct)])
    expect_equal(dat_p$sigval[!is.na(imcRtools_patch_perm$ct)], imcRtools_patch_perm$sigval[!is.na(imcRtools_patch_perm$ct)])
    
    
})

#' @title Display all features measured by CellProfiler.
#' 
#' @description Searchable datatable object of cell and image features as 
#' extracted by CellProfiler.
#'
#' @param path full path to the CellProfiler output folder
#' @param display single character indicating which features to display.
#' Accepted entries are \code{cell_features} to display extracted single-cell
#' features or \code{image_features} to display extracted image-level features.
#' @param cell_features single character indicating the name of the file storing
#' the extracted cell features.
#' @param image_features single character indicating the name of the file 
#' storing the extracted image features.
#' 
#' @return a \code{\link[DT]{datatable}} object
#'
#' @examples
#' path <- system.file("extdata/mockData/cpout", package = "imcRtools")
#' 
#' # Display cell features 
#' show_cpout_features(path)
#' 
#' # Display image features 
#' show_cpout_features(path, display = "image_features")
#' 
#' @seealso \code{\link{read_cpout}} for the CellProfiler reader function
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @importFrom DT datatable
#' @importFrom vroom vroom
#' @export
show_cpout_features <- function(path,
                                display = c("cell_features", "image_features"),
                                cell_features = "var_cell.csv",
                                image_features = "var_Image.csv"){
    
    display <- match.arg(display)
    
    if (!file.exists(file.path(path, eval(parse(text = display))))){
        cur_text <- paste0("'", eval(parse(text = display)), 
                            "' does not exist in ", path)
        stop(cur_text)
    }
    
    cur_features <- vroom(file.path(path, eval(parse(text = display))), 
                          show_col_types = FALSE, progress = FALSE)
    
    datatable(cur_features)
}

test_that("show_cpout_features function works", {
    path <- system.file("extdata/mockData/cpout", package = "imcRtools")
    
    # Works
    expect_silent(show_cpout_features(path))
    expect_silent(cur_tab <- show_cpout_features(path))
    expect_s3_class(cur_tab, "datatables")
    
    cur_df <- cur_tab$x$data
    expect_equal(colnames(cur_df), c(" ", "column_name", "category", "image_name", "object_name", "feature_name", "channel", 
                                     "parameters", "channel_id", "data_type"))
    expect_equal(unique(cur_df$channel_id), c(NA, "Ag107", "Pr141", "Sm147", "Eu153", "Yb172", "CellCenter", 
                                              "CellBorder", "Background"))
    expect_equal(head(cur_df$column_name), c("Location_Center_X", "Location_Center_Y", "Location_Center_Z",
                                             "Number_Object_Number", "Neighbors_NumberOfNeighbors_8",
                                             "Neighbors_PercentTouching_8"))
    
    expect_silent(show_cpout_features(path, display = "image_features"))
    expect_silent(cur_tab <- show_cpout_features(path, display = "image_features"))
    expect_s3_class(cur_tab, "datatables")
    
    cur_df <- cur_tab$x$data
    expect_equal(colnames(cur_df), c(" ", "column_name", "category", "image_name", "object_name", "feature_name", "channel", 
                                     "parameters", "channel_id", "data_type"))
    expect_equal(unique(cur_df$channel_id), c(NA, "Ag107", "Pr141", "Sm147", "Eu153", "Yb172", "CellCenter", 
                                              "CellBorder", "Background"))
    expect_equal(head(cur_df$column_name), c("Group_Number", "Group_Index", "ModuleError_01Images", "ExecutionTime_01Images", 
                                             "Metadata_", "Metadata_template"))
    
    
    # Error
    expect_error(show_cpout_features("test"),
                 regexp = "'var_cell.csv' does not exist in test",
                 fixed = TRUE)
    expect_error(show_cpout_features(path, cell_features = "test"),
                 regexp = paste0("'test' does not exist in ", path),
                 fixed = TRUE)
    expect_error(show_cpout_features("test", display = "image_features"),
                 regexp = "'var_Image.csv' does not exist in test",
                 fixed = TRUE)
    expect_error(show_cpout_features(path, image_features = "test", display = "image_features"),
                 regexp = paste0("'test' does not exist in ", path),
                 fixed = TRUE)
    expect_error(show_cpout_features(path, display = "test"))
})

#' @title Reads in single-cell data generated by the ImcSegmentationPipeline
#' 
#' @description Reader function to generate a
#' \code{\linkS4class{SpatialExperiment}} or
#' \code{\linkS4class{SingleCellExperiment}} object from single-cell data
#' obtained by the 
#' \href{https://github.com/BodenmillerGroup/ImcSegmentationPipeline}{ImcSegmentationPipeline}
#' pipeline.
#'
#' @param path full path to the CellProfiler output folder.
#' @param object_file single character indicating the file name storing the
#' object/cell-specific intensities and metadata.
#' @param image_file single character indicating the file name storing meta data
#' per image (can be \code{NULL}).
#' @param panel_file single character indicating the file name storing the panel
#' information (can be \code{NULL}).
#' @param graph_file single character indicating the file name storing the
#' object/cell interaction information (can be \code{NULL}).
#' @param object_feature_file single character indicating the file name storing
#' object/cell feature information.
#' @param intensities single character indicating which column entries of the
#' \code{object_file} contain the intensity features of interest. See details.
#' @param extract_imgid_from single character indicating which column entries of
#' the \code{object_file} and \code{image_file} contain the image integer ID.
#' @param extract_cellid_from single character indicating which column entry
#' of the \code{object_file} contains the object/cell integer ID.
#' @param extract_coords_from character vector indicating which column entries
#' of the \code{object_file} contain the x and y location of the
#' objects/cells.
#' @param extract_cellmetadata_from character vector indicating which additional
#' object/cell specific metadata to extract from the \code{object_file}.
#' @param extract_imagemetadata_from character vector indicating which
#' additional image specific metadata to extract from the \code{image_file}.
#' These will be stored in the \code{colData(x)} slot as object/cell-specific
#' entries.
#' @param extract_graphimageid_from single character indicating  which column
#' entries of the \code{graph_file} contain the image integer ID.
#' @param extract_graphcellids_from character vector indicating which column
#' entries of the \code{graph_file} contain the first and second object/cell
#' integer IDs. These will be stored as the \code{from} and \code{to} entry of
#' the \code{SelfHits} object in colPair(x, "neighborhood").
#' @param extract_metal_from single character indicating which column entry of
#' the \code{panel_file} contains the metal isotopes of the used antibodies.
#' This entry is used to match the panel information to the acquired channel
#' information.
#' @param scale_intensities single logical. Should the measured intensity
#' features be scaled by \code{extract_scalingfactor_from}.
#' @param extract_scalingfactor_from single character indicating which column
#' entries of the \code{image_file} contain the image specific scaling factor.
#' @param return_as should the object be returned as
#' \code{\linkS4class{SpatialExperiment}} (\code{return_as = "spe"}) or
#' \code{\linkS4class{SingleCellExperiment}} (\code{return_as = "sce"}).
#' 
#' @return returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
#' object with markers in rows and cells in columns.
#' 
#' @section The returned data container:
#' In the case of both containers \code{x}, intensity features (as selected
#' by the \code{intensities} parameter) are stored in the \code{counts(x)} slot.
#' Cell metadata (e.g morphological features) are stored in the
#' \code{colData(x)} slot. The interaction graphs are stored as
#' \code{\link[S4Vectors]{SelfHits}} object in the 
#' \code{colPair(x, "neighborhood")} slot.
#' 
#' Intensity features are extracted via partial string matching. Internally, the 
#' \code{read_cpout} function checks if per channel a single intensity feature
#' is read in (by checking the \code{_cXY} ending where \code{XY} is the 
#' channel number).
#' 
#' In the case of a returned \code{SpatialExperiment} object, the cell 
#' coordinates are stored in the \code{spatialCoords(x)} slot.
#' 
#' In the case of a returned \code{SingleCellExperiment} object, the cell 
#' coordinates are stored in the \code{colData(x)} slot named as \code{Pos_X}
#' and \code{Pos_Y}.
#'
#' @examples
#' path <- system.file("extdata/mockData/cpout", package = "imcRtools")
#' 
#' # Read in as SpatialExperiment object
#' x <- read_cpout(path, graph_file = "Object_relationships.csv")
#' x
#' 
#' # Read in as SingleCellExperiment object
#' x <- read_cpout(path, graph_file = "Object_relationships.csv", 
#'                 return_as = "sce")
#' x
#' 
#' @seealso 
#' \url{https://github.com/BodenmillerGroup/ImcSegmentationPipeline} for the 
#' pipeline
#' 
#' \code{\link{read_steinbock}} for reading in single-cell data as produced by 
#' the steinbock pipeline
#' 
#' \code{\link[SingleCellExperiment]{colPair}} for information on how to work
#' with the cell-cell interaction graphs
#' 
#' @author Tobias Hoch
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @import SingleCellExperiment
#' @importFrom S4Vectors DataFrame
#' @importFrom SummarizedExperiment colData<- rowData<- metadata<-
#' @export
read_cpout <- function(path,
            object_file = "cell.csv",
            image_file = "Image.csv",
            panel_file = "panel.csv",
            graph_file = "Object relationships.csv",
            object_feature_file = "var_cell.csv",
            intensities = "Intensity_MeanIntensity_FullStack",
            extract_imgid_from = "ImageNumber",
            extract_cellid_from = "ObjectNumber",
            extract_coords_from = c("Location_Center_X", "Location_Center_Y"),
            extract_cellmetadata_from = c("AreaShape_Area", 
                                          "Neighbors_NumberOfNeighbors_8",
                                          "AreaShape_Eccentricity",
                                          "AreaShape_MajorAxisLength",
                                          "AreaShape_MinorAxisLength",
                                          "AreaShape_MeanRadius"),
            extract_imagemetadata_from = c("Metadata_acname", "Metadata_acid", 
                                            "Metadata_description"),
            extract_graphimageid_from = "First Image Number",
            extract_graphcellids_from = c("First Object Number",
                                            "Second Object Number"),
            extract_metal_from = "Metal Tag",
            scale_intensities = TRUE,
            extract_scalingfactor_from = "Scaling_FullStack",
            return_as = c("spe", "sce")){
    
    .valid.read_cpout.input(path, object_file, image_file,
                            panel_file, graph_file, object_feature_file,
                            intensities, 
                            extract_imgid_from, extract_cellid_from, 
                            extract_coords_from,
                            extract_cellmetadata_from, 
                            extract_imagemetadata_from,
                            extract_graphimageid_from, 
                            extract_graphcellids_from,
                            extract_metal_from, scale_intensities,
                            extract_scalingfactor_from)
    
    return_as <- match.arg(return_as)
    
    object <- .cpout_create_object(path = path, 
                        object_file = object_file, 
                        image_file = image_file, 
                        object_feature_file = object_feature_file,
                        intensities = intensities, 
                        extract_imgid_from = extract_imgid_from,
                        extract_cellid_from = extract_cellid_from, 
                        extract_coords_from = extract_coords_from,
                        extract_cellmetadata_from = extract_cellmetadata_from, 
                        scale_intensities = scale_intensities, 
                        extract_scalingfactor_from = extract_scalingfactor_from,
                        return_as = return_as)
    
    if (!is.null(image_file)) {
        object <- .cpout_add_image_metadata(object, path, image_file, 
                                        extract_imgid_from, 
                                        extract_imagemetadata_from,
                                        extract_cellid_from)
    }
    
    if (!is.null(graph_file)){
        object <- .cpout_add_graph(object, path, graph_file, 
                                  extract_graphimageid_from, 
                                  extract_graphcellids_from)   
    }
    
    object <- .add_panel(object, path, panel_file, extract_metal_from)
    
    # Add colnames
    colnames(object) <- paste0(object$sample_id, "_", object$ObjectNumber)
    
    return(object)
}

test_that("read_cpout function works.", {

    path <- system.file("extdata/mockData/cpout", package = "imcRtools")

    # SpatialExperiment
    cur_spe <- read_cpout(path, graph_file = "Object_relationships.csv")
    
    expect_equal(colnames(cur_spe), paste0(cur_spe$sample_id, "_", cur_spe$ObjectNumber))
    
    expect_s4_class(cur_spe, "SpatialExperiment")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(names(rowData(cur_spe)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- dplyr::left_join(object_file, image_file, by = "ImageNumber")
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts * (2^16 - 1))
    expect_equal(counts(cur_spe)[1:10], c(0.108695652148605, 0.0217391304297211, 0, 0.0434782608594421, 
                                          0.739130434610516, 0, 0, 0, 0, 1.1999999997206))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_spe$Metadata_acname, object_file$Metadata_acname)
    expect_equal(cur_spe$Metadata_acid, object_file$Metadata_acid)
    expect_equal(cur_spe$Metadata_description, object_file$Metadata_description)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_spe)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_spe)$Target, cur_panel$Target)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_spe, "neighborhood"))
    cur_test <- vroom::vroom(file.path(path, "Object_relationships.csv"))
    
    for (i in unique(cur_test$`First Image Number`)) {
        cur_dat <- cur_spe[,cur_spe$sample_id == i]
        
        cur_test_dat <- cur_test[cur_test$`First Image Number` == i,]
        
        expect_equal(from(colPair(cur_dat, "neighborhood")), cur_test_dat$`First Object Number`)
        expect_equal(to(colPair(cur_dat, "neighborhood")), cur_test_dat$`Second Object Number`)
    }
    
    cur_dat <- unique(colData(cur_spe)[,c("sample_id", "Metadata_acname", "Metadata_acid", "Metadata_description")])
    expect_equal(as.numeric(cur_dat$sample_id), image_file$ImageNumber)
    expect_equal(cur_dat$Metadata_acname, image_file$Metadata_acname)
    expect_equal(cur_dat$Metadata_acid, image_file$Metadata_acid)
    expect_equal(cur_dat$Metadata_description, image_file$Metadata_description)
    
    # SingleCellExperiment
    cur_sce <- read_cpout(path, return_as = "sce", graph_file = "Object_relationships.csv")
    expect_equal(colnames(cur_sce), paste0(cur_sce$sample_id, "_", cur_sce$ObjectNumber))
    
    expect_s4_class(cur_sce, "SingleCellExperiment")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 239))
    expect_equal(names(rowData(cur_sce)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", "Pos_Y", "AreaShape_Area", 
                                            "Neighbors_NumberOfNeighbors_8", "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", 
                                            "AreaShape_MinorAxisLength", "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", 
                                            "Metadata_acid", "Metadata_description"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_sce)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- dplyr::left_join(object_file, image_file, by = "ImageNumber")
    
    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts * (2^16 - 1))
    expect_equal(counts(cur_sce)[1:10], c(0.108695652148605, 0.0217391304297211, 0, 0.0434782608594421, 
                                          0.739130434610516, 0, 0, 0, 0, 1.1999999997206))
    
    expect_equal(cur_sce$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_sce$Metadata_acname, object_file$Metadata_acname)
    expect_equal(cur_sce$Metadata_acid, object_file$Metadata_acid)
    expect_equal(cur_sce$Metadata_description, object_file$Metadata_description)
    expect_equal(cur_sce$Pos_X, object_file$Location_Center_X)
    expect_equal(cur_sce$Pos_Y, object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_sce)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_sce)$Target, cur_panel$Target)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_sce), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_sce, "neighborhood"))
    cur_test <- vroom::vroom(file.path(path, "Object_relationships.csv"))

    for (i in unique(cur_test$`First Image Number`)) {
        cur_dat <- cur_sce[,cur_sce$sample_id == i]
        
        cur_test_dat <- cur_test[cur_test$`First Image Number` == i,]
        
        expect_equal(from(colPair(cur_dat, "neighborhood")), cur_test_dat$`First Object Number`)
        expect_equal(to(colPair(cur_dat, "neighborhood")), cur_test_dat$`Second Object Number`)
    }
    
    # Test other inputs
    cur_spe <- read_cpout(path, graph_file = "Object_relationships.csv",
                          panel_file = paste0(path, "/panel.csv"))
    
    cur_spe <- read_cpout(path, image_file = NULL, scale_intensities = FALSE, 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(names(rowData(cur_spe)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts)
    expect_equal(counts(cur_spe)[1:10], c(1.65858933621127e-06, 3.31717867242253e-07, 0, 6.63435734484507e-07, 
                                          1.12784074862366e-05, 0, 0, 0, 0, 1.83108262717724e-05))
    
    expect_equal(counts(cur_spe)[1:10] * (2^16 - 1), c(0.108695652148605, 0.0217391304297211, 0, 0.0434782608594421, 
                                                       0.739130434610516, 0, 0, 0, 0, 1.1999999997206))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_spe)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_spe)$Target, cur_panel$Target)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_silent(cur_graphs <- colPair(cur_spe, "neighborhood"))
    cur_test <- vroom::vroom(file.path(path, "Object_relationships.csv"))
    
    for (i in unique(cur_test$`First Image Number`)) {
        cur_dat <- cur_spe[,cur_spe$sample_id == i]
        
        cur_test_dat <- cur_test[cur_test$`First Image Number` == i,]
        
        expect_equal(from(colPair(cur_dat, "neighborhood")), cur_test_dat$`First Object Number`)
        expect_equal(to(colPair(cur_dat, "neighborhood")), cur_test_dat$`Second Object Number`)
    }
    
    expect_equal(length(colPair(cur_spe, "neighborhood")), 1484)
    
    cur_sce <- read_cpout(path, return_as = "sce", image_file = NULL, 
                          scale_intensities = FALSE, graph_file = "Object_relationships.csv")
    
    expect_equal(rownames(cur_sce), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_sce), "counts")
    expect_equal(dim(cur_sce), c(5, 239))
    expect_equal(names(rowData(cur_sce)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "Pos_X", "Pos_Y", "AreaShape_Area", 
                                            "Neighbors_NumberOfNeighbors_8", "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", 
                                            "AreaShape_MinorAxisLength", "AreaShape_MeanRadius"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_sce)

    test1 <- counts(cur_sce)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts)
    expect_equal(counts(cur_sce)[1:10], c(1.65858933621127e-06, 3.31717867242253e-07, 0, 6.63435734484507e-07, 
                                          1.12784074862366e-05, 0, 0, 0, 0, 1.83108262717724e-05))
    
    expect_equal(cur_sce$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_sce$Pos_X, object_file$Location_Center_X)
    expect_equal(cur_sce$Pos_Y, object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))    
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_sce)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_sce)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_sce)$Target, cur_panel$Target)
    expect_equal(rowData(cur_sce)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_sce)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_sce), "neighborhood")
    
    expect_equal(length(colPair(cur_sce, "neighborhood")), 1484)
    
    cur_spe <- read_cpout(path, scale_intensities = FALSE, graph_file = "Object_relationships.csv")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(names(rowData(cur_spe)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts)
    expect_equal(counts(cur_spe)[1:10], c(1.65858933621127e-06, 3.31717867242253e-07, 0, 6.63435734484507e-07, 
                                          1.12784074862366e-05, 0, 0, 0, 0, 1.83108262717724e-05))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_spe)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_spe)$Target, cur_panel$Target)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_equal(length(colPair(cur_spe, "neighborhood")), 1484)
    
    cur_spe <- read_cpout(path, graph_file = NULL)
    
    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(names(rowData(cur_spe)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- dplyr::left_join(object_file, image_file, by = "ImageNumber")
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts * (2^16 - 1))
    expect_equal(counts(cur_spe)[1:10], c(0.108695652148605, 0.0217391304297211, 0, 0.0434782608594421, 
                                          0.739130434610516, 0, 0, 0, 0, 1.1999999997206))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_spe$Metadata_acname, object_file$Metadata_acname)
    expect_equal(cur_spe$Metadata_acid, object_file$Metadata_acid)
    expect_equal(cur_spe$Metadata_description, object_file$Metadata_description)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_spe)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_spe)$Target, cur_panel$Target)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$full, cur_panel$full)
    
    expect_equal(length(colPairNames(cur_spe)), 0)
    
    cur_spe <- read_cpout(path, panel_file = NULL, graph_file = "Object_relationships.csv")
    
    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(length(names(rowData(cur_spe))), 0) 
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- dplyr::left_join(object_file, image_file, by = "ImageNumber")
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts * (2^16 - 1))
    expect_equal(counts(cur_spe)[1:10], c(0.108695652148605, 0.0217391304297211, 0, 0.0434782608594421, 
                                          0.739130434610516, 0, 0, 0, 0, 1.1999999997206))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_spe$Metadata_acname, object_file$Metadata_acname)
    expect_equal(cur_spe$Metadata_acid, object_file$Metadata_acid)
    expect_equal(cur_spe$Metadata_description, object_file$Metadata_description)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_equal(length(colPair(cur_spe, "neighborhood")), 1484)
    
    cur_spe <- read_cpout(path, intensities = "MedianIntensity_FullStack_", graph_file = "Object_relationships.csv")

    expect_equal(rownames(cur_spe), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(assayNames(cur_spe), "counts")
    expect_equal(dim(cur_spe), c(5, 239))
    expect_equal(names(rowData(cur_spe)), 
                 c("Tube.Number", "Metal.Tag", "Target", "ilastik", "full", "deepcell", 
                   "cellpose"))
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MedianIntensity_FullStack_", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- merge(object_file, image_file, by = "ImageNumber", order = FALSE)
    
    test1 <- counts(cur_spe)
    colnames(test1) <- NULL
    
    expect_equal(test1, cur_counts * (2^16 - 1))
    expect_equal(counts(cur_spe)[1:10], c(0, 0, 0, 0, 0,
                                          0, 0, 0, 0, 1))
    
    expect_equal(cur_spe$Neighbors_NumberOfNeighbors_8, object_file$Neighbors_NumberOfNeighbors_8)
    expect_equal(cur_spe$Metadata_acname, object_file$Metadata_acname)
    expect_equal(cur_spe$Metadata_acid, object_file$Metadata_acid)
    expect_equal(cur_spe$Metadata_description, object_file$Metadata_description)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,1]), object_file$Location_Center_X)
    expect_equal(as.numeric(spatialCoords(cur_spe)[,2]), object_file$Location_Center_Y)
    
    cur_panel <- vroom::vroom(file.path(path, "panel.csv"))
    mass <- as.numeric(stringr::str_extract(cur_panel$`Metal Tag`, "[0-9]{2,3}"))
    cur_panel <- cur_panel[order(as.numeric(mass), decreasing = FALSE),]
    
    expect_equal(rowData(cur_spe)$Tube.Number, cur_panel$`Tube Number`)
    expect_equal(rowData(cur_spe)$Metal.Tag, cur_panel$`Metal Tag`)
    expect_equal(rowData(cur_spe)$Target, cur_panel$Target)
    expect_equal(rowData(cur_spe)$ilastik, cur_panel$ilastik)
    expect_equal(rowData(cur_spe)$full, cur_panel$full)
    
    expect_equal(colPairNames(cur_spe), "neighborhood")
    
    expect_equal(length(colPair(cur_spe, "neighborhood")), 1484)
    
    cur_spe <- read_cpout(path, extract_cellmetadata_from = "Location_MaxIntensity_Y_FullStack_c1", 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "Location_MaxIntensity_Y_FullStack_c1",
                                            "ImageNumber",
                                            "Metadata_acname", 
                                            "Metadata_acid", "Metadata_description"))
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    
    expect_equal(cur_spe$Location_MaxIntensity_Y_FullStack_c1, object_file$Location_MaxIntensity_Y_FullStack_c1)

    cur_spe <- read_cpout(path, extract_imagemetadata_from = "Metadata_end_timestamp", 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius","ImageNumber", "Metadata_end_timestamp"))
    
    expect_equal(spatialCoordsNames(cur_spe), c("Pos_X", "Pos_Y"))
    
    object_file <- vroom::vroom(file.path(path, "cell.csv"))
    cur_counts <- t(object_file[,grepl("MeanIntensity_FullStack", colnames(object_file))])
    rownames(cur_counts) <- rownames(cur_spe)
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    object_file <- merge(object_file, image_file, by = "ImageNumber", order = FALSE)
    
    expect_equal(cur_spe$Metadata_end_timestamp, object_file$Metadata_end_timestamp)
    
    cur_spe <- read_cpout(path, extract_coords_from = NULL, 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(length(spatialCoordsNames(cur_spe)), 0)
    
    cur_sce <- read_cpout(path, extract_coords_from = NULL, return_as = "sce", 
                          graph_file = "Object_relationships.csv")   
    
    expect_equal(names(colData(cur_sce)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber", "Metadata_acname", "Metadata_acid", "Metadata_description"
    ))
    
    cur_spe <- read_cpout(path, extract_cellmetadata_from = NULL, 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "ImageNumber",
                                            "Metadata_acname", "Metadata_acid", "Metadata_description"))
    
    cur_spe <- read_cpout(path, extract_imagemetadata_from = NULL, 
                          graph_file = "Object_relationships.csv")
    
    expect_equal(names(colData(cur_spe)), c("sample_id", "ObjectNumber", "AreaShape_Area", "Neighbors_NumberOfNeighbors_8", 
                                            "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength", 
                                            "AreaShape_MeanRadius", "ImageNumber"))
    
    # Test other Images.csv entries
    cur_spe <- read_cpout(path, graph_file = "Object_relationships.csv", 
                          extract_imagemetadata_from = c("Intensity_PercentMaximal_FullStack_c1", 
                                                         "Intensity_MeanIntensity_FullStack_c5",
                                                         "Metadata_max_x"))
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    cur_test <- unique(colData(cur_spe)[,c("ImageNumber", "Intensity_PercentMaximal_FullStack_c1", 
                                           "Intensity_MeanIntensity_FullStack_c5",
                                           "Metadata_max_x")])
    
    expect_equal(image_file$ImageNumber, cur_test$ImageNumber)
    expect_equal(image_file$Intensity_PercentMaximal_FullStack_c1, cur_test$Intensity_PercentMaximal_FullStack_c1)
    expect_equal(image_file$Intensity_MeanIntensity_FullStack_c5, cur_test$Intensity_MeanIntensity_FullStack_c5)
    expect_equal(image_file$Metadata_max_x, cur_test$Metadata_max_x)
    
    cur_sce <- read_cpout(path, graph_file = "Object_relationships.csv", 
                          extract_imagemetadata_from = c("Intensity_PercentMaximal_FullStack_c1", 
                                                         "Intensity_MeanIntensity_FullStack_c5",
                                                         "Metadata_max_x"), return_as = "sce")
    
    image_file <- vroom::vroom(file.path(path, "Image.csv"))
    cur_test <- unique(colData(cur_sce)[,c("ImageNumber", "Intensity_PercentMaximal_FullStack_c1", 
                                           "Intensity_MeanIntensity_FullStack_c5",
                                           "Metadata_max_x")])
    
    expect_equal(image_file$ImageNumber, cur_test$ImageNumber)
    expect_equal(image_file$Intensity_PercentMaximal_FullStack_c1, cur_test$Intensity_PercentMaximal_FullStack_c1)
    expect_equal(image_file$Intensity_MeanIntensity_FullStack_c5, cur_test$Intensity_MeanIntensity_FullStack_c5)
    expect_equal(image_file$Metadata_max_x, cur_test$Metadata_max_x)
    
    # Fail
    expect_error(read_cpout("test", 
                            graph_file = "Object_relationships.csv"), 
                 regexp = "'path' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(1, 
                            graph_file = "Object_relationships.csv"), 
                 regexp = "'path' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(c("test", "test"), 
                            graph_file = "Object_relationships.csv"), 
                 regexp = "'path' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_file = NULL), 
                 regexp = "'object_file' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_file = "test"), 
                 regexp = "'object_file' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_file = 1), 
                 regexp = "'object_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_file = c("test", "test")), 
                 regexp = "'object_file' must be a single string.", 
                 fixed = TRUE)

    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_feature_file = NULL), 
                 regexp = "'object_feature_file' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_feature_file = "test"), 
                 regexp = "'object_feature_file' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_feature_file = 1), 
                 regexp = "'object_feature_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            object_feature_file = c("test", "test")), 
                 regexp = "'object_feature_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            image_file = NULL), 
                 regexp = "When scaling the summarized object intensities, please supply the 'image_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            image_file = "test"), 
                 regexp = "'image_file' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            image_file = 1), 
                 regexp = "'image_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            image_file = c("test", "test")), 
                 regexp = "'image_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, graph_file = "test"), 
                 regexp = "'graph_file' doesn't exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, graph_file = 1), 
                 regexp = "'graph_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, graph_file = c("test", "test")), 
                 regexp = "'graph_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_warning(read_cpout(path, panel_file = "test", 
                              graph_file = "Object_relationships.csv"), 
                 regexp = "'panel_file' does not exist.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            panel_file = 1), 
                 regexp = "'panel_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            panel_file = c("test", "test")), 
                 regexp = "'panel_file' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_metal_from = NULL), 
                 regexp = "'extract_metal_from' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_metal_from = "test"), 
                 regexp = "'extract_metal_from' not in panel file.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_metal_from = 1), 
                 regexp = "'extract_metal_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_metal_from = c("test", "test")), 
                 regexp = "'extract_metal_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            intensities =  NULL), 
                 regexp = "'intensities' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            intensities =  "test"), 
                 regexp = "No intensity features were read in. Please check the 'intensities' parameter.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            intensities =  "MeanIntensity"), 
                 regexp = "Some of the features set via 'intensities' cannot be uniquely accessed.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            intensities =  c("MeanIntensity", "MedianIntensity")), 
                 regexp = "'intensities' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            intensities =  1), 
                 regexp = "'intensities' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_imgid_from = NULL), 
                 regexp = "'extract_imgid_from' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_imgid_from = 1), 
                 regexp = "'extract_imgid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_imgid_from = c("test", "test")), 
                 regexp = "'extract_imgid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_imgid_from = "test"), 
                 regexp = "'extract_imgid_from' not in 'object_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellid_from = NULL), 
                 regexp = "'extract_cellid_from' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellid_from = 1), 
                 regexp = "'extract_cellid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellid_from = c("test", "test")), 
                 regexp = "'extract_cellid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellid_from = "test"), 
                 regexp = "'extract_cellid_from' not in 'object_file'.", 
                 fixed = TRUE)

    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_coords_from = 1), 
                 regexp = "'extract_coords_from' not in 'object_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_coords_from = c("test1", "Location_X")), 
                 regexp = "'extract_coords_from' not in 'object_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellmetadata_from = 1), 
                 regexp = "'extract_cellmetadata_from' not in 'object_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_cellmetadata_from = c("test1", "Location_X")), 
                 regexp = "'extract_cellmetadata_from' not in 'object_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            scale_intensities = NULL), 
                 regexp = "'scale_intensities' needs to be logical.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            scale_intensities = c(1,2)), 
                 regexp = "'scale_intensities' needs to be of length 1.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            scale_intensities = "test"), 
                 regexp = "'scale_intensities' needs to be logical.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            image_file = NULL), 
                 regexp = "When scaling the summarized object intensities, please supply the 'image_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_imagemetadata_from = "test"), 
                 regexp = "'extract_imagemetadata_from' not in 'image_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_scalingfactor_from = c(1,2)), 
                 regexp = "'extract_scalingfactor_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_scalingfactor_from = "test"), 
                 regexp = "'extract_scalingfactor_from' not in 'image_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_graphimageid_from = NULL), 
                 regexp = "'extract_graphimageid_from' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_graphimageid_from = c(1,2)), 
                 regexp = "'extract_graphimageid_from' must be a single string.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_graphimageid_from = "test"), 
                 regexp = "'extract_graphimageid_from' not in 'graph_file'.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_graphcellids_from = NULL), 
                 regexp = "'extract_graphcellids_from' must be specified.", 
                 fixed = TRUE)
    
    expect_error(read_cpout(path, 
                            graph_file = "Object_relationships.csv",
                            extract_graphcellids_from = c("test", "Second Object Number")), 
                 regexp = "'extract_graphcellids_from' not in 'graph_file'.", 
                 fixed = TRUE)
})

#' @title Function to detect patches containing defined cell types
#'
#' @description Function to detect spatial clusters of defined types of cells.
#' By defining a certain distance threshold, all cells within the vicinity
#' of these clusters are detected as well.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param patch_cells logical vector of length equal to the number of cells
#' contained in \code{object}. \code{TRUE} entries define the cells to consider
#' for patch detection (see Details).
#' @param colPairName single character indicating the \code{colPair(object)}
#' entry containing the neighbor information.
#' @param min_patch_size single integer indicating the minimum number of 
#' connected cells that make up a patch before expansion.
#' @param name single character specifying the \code{colData} entry storing
#' the patch IDs in the returned object.
#' @param expand_by single numeric indicating in which vicinity range cells
#' should be considered as belonging to the patch (see Details).
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries of the cells' x and y locations.
#' @param convex should the convex hull be computed before expansion? Default:
#' the concave hull is computed.
#' @param img_id single character indicating the \code{colData(object)} entry
#' containing the unique image identifiers.
#' @param BPPARAM a \code{\link[BiocParallel]{BiocParallelParam-class}} object
#' defining how to parallelize computations.
#' 
#' @section Detecting patches of defined cell types:
#' This function works as follows:
#' 
#' 1. Only cells defined by \code{patch_cells} are considered for patch 
#' detection.
#' 
#' 2. Patches of connected cells are detected. Here, cell-to-cell connections
#' are defined by the interaction graph stored in 
#' \code{colPair(object, colPairName)}. At this point, patches that contain 
#' fewer than \code{min_patch_size} cells are removed.
#' 
#' 3. If \code{expand_by > 0}, a concave (default) or convex hull is constructed
#' around each patch. This is is then expanded by \code{expand_by} and cells
#' within the expanded hull are detected and assigned to the patch. This 
#' expansion only works if a patch contains at least 3 cells.
#' 
#' The returned object contains an additional entry 
#' \code{colData(object)[[name]]}, which stores the patch ID per cell. \code{NA}
#' indicate cells that are not part of a patch. 
#' 
#' @section Ordering of the output object:
#' If \code{expand_by > 0}, the \code{patchDetection} function operates on individual images.
#' Therefore the returned object is grouped by entries in \code{img_id}. 
#' This means all cells of a given image are grouped together in the object.
#' The ordering of cells within each individual image is the same as the ordering
#' of these cells in the input object.
#' 
#' If \code{expand_by = 0}, the ordering of cells in the output object is the same as
#' in the input object.
#' 
#' @return An object of \code{class(object)} containing a patch ID for each 
#' cell in \code{colData(object)[[name]]}. If \code{expand_by > 0},  cells in the 
#' output object are grouped by entries in \code{img_id}.
#' 
#' @examples
#' library(cytomapper)
#' data(pancreasSCE)
#' 
#' # Visualize cell types
#' plotSpatial(pancreasSCE, 
#'             img_id = "ImageNb", 
#'             node_color_by = "CellType",
#'             scales = "free")
#'
#' # Build interaction graph
#' pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                                  type = "expansion", threshold = 20)
#' 
#' # Detect patches of "celltype_B" cells
#' pancreasSCE <- patchDetection(pancreasSCE, 
#'                               patch_cells = pancreasSCE$CellType == "celltype_B",
#'                               colPairName = "expansion_interaction_graph")
#'                               
#' plotSpatial(pancreasSCE, 
#'             img_id = "ImageNb", 
#'             node_color_by = "patch_id",
#'             scales = "free")
#' 
#' # Include cells in vicinity
#' pancreasSCE <- patchDetection(pancreasSCE, 
#'                               patch_cells = pancreasSCE$CellType == "celltype_B",
#'                               colPairName = "expansion_interaction_graph",
#'                               expand_by = 20, 
#'                               img_id = "ImageNb")
#' 
#' plotSpatial(pancreasSCE, 
#'             img_id = "ImageNb", 
#'             node_color_by = "patch_id",
#'             scales = "free")
#'   
#' @author Tobias Hoch 
#' @author adapted by Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @references
#' \href{https://www.biorxiv.org/content/10.1101/2021.07.29.454093v1}{
#' Hoch, T. et al., Multiplexed Imaging Mass Cytometry of Chemokine Milieus in 
#' Metastatic Melanoma Characterizes Features of Response to Immunotherapy., 
#' bioRxiv 2021}
#' 
#' @importFrom igraph graph_from_data_frame components 
#' @export
patchDetection <- function(object, 
                           patch_cells,
                           colPairName,
                           min_patch_size = 1,
                           name = "patch_id",
                           expand_by = 0,
                           coords = c("Pos_X", "Pos_Y"),
                           convex = FALSE,
                           img_id = NULL,
                           BPPARAM = SerialParam()){
    
    .valid.patchDetection.input(object, patch_cells, colPairName, 
                                min_patch_size, name, expand_by, coords,
                                convex, img_id)
    node_id <- seq_len(sum(patch_cells))
    
    cur_graph <- graph_from_data_frame(colPair(object[,patch_cells], 
                                                       colPairName),
                                       vertices = data.frame(row.names = node_id,
                                                             id = node_id))
    cur_components <- components(cur_graph)
    
    if (length(cur_components$membership) == 0) {
        stop("No connected components found.")
    }
    
    cur_clusters <- cur_components$membership
    
    if (min_patch_size > 1) {
        cur_clusters[!(cur_clusters %in% 
                           which(cur_components$csize >= min_patch_size))] <- NA
    } 
    
    cur_out <- vector(mode = "character", length = ncol(object))
    cur_out[!patch_cells] <- NA
    cur_out[patch_cells] <- cur_clusters
    colData(object)[[name]] <- cur_out
    
    if (expand_by > 0) {
        object <- .expand_patch(object, name = name, 
                                expand_by = expand_by, 
                                coords = coords,
                                convex = convex,
                                img_id = img_id,
                                BPPARAM = BPPARAM)
        
        message("The returned object is ordered by the '", img_id, "' entry.")
    }
    
    return(object)
}

test_that("patchSize function works", {
    library(cytomapper)
    data(pancreasSCE)

    pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                    type = "expansion", threshold = 20)

    expect_silent(cur_sce <- patchDetection(pancreasSCE, 
                                   patch_cells = pancreasSCE$CellType == "celltype_B",
                                   colPairName = "expansion_interaction_graph"))
    
    expect_silent(cur_out_1 <- patchSize(cur_sce))
    expect_s4_class(cur_out_1, "DataFrame")
    expect_equal(cur_out_1$size, c(NA, NA, 32.6362638000003, NA, NA, 2028.226120055, 169.684533615001, 
                                   3778.12476426999))
    expect_equal(cur_out_1$polygon[3][[1]], structure(list(structure(c(195.8023, 175.9615, 181.2143, 195.8023, 
                                                                       286.2442, 266.8654, 275.2857, 286.2442), dim = c(4L, 2L), dimnames = list(
                                                                           NULL, c("V1", "V2")))), class = c("XY", "POLYGON", "sfg")))
    
    # SpatialExperiment
    cur_spe <- SpatialExperiment:::.sce_to_spe(cur_sce, sample_id = as.character(cur_sce$ImageNb))
    spatialCoords(cur_spe) <- as.matrix(colData(cur_sce)[,c("Pos_X", "Pos_Y")])
    colData(cur_spe)[c("Pos_X", "Pos_Y")] <- NULL
    
    expect_silent(cur_out_2 <- patchSize(cur_spe))
    expect_s4_class(cur_out_2, "DataFrame")
    
    expect_equal(cur_out_1, cur_out_2)
    
    # Check for sparse graphs
    cur_sce_2 <- pancreasSCE
    cur_sce_2 <- buildSpatialGraph(cur_sce_2, img_id = "ImageNb", 
                                     type = "expansion", threshold = 10)
    
    expect_silent(cur_sce_2 <- patchDetection(cur_sce_2, 
                                            patch_cells = cur_sce$CellType == "celltype_C",
                                            colPairName = "expansion_interaction_graph"))
    
    expect_silent(cur_out <- patchSize(cur_sce_2))
    expect_equal(cur_out$size, c(NA, NA, NA, NA, NA, 14.1314614, NA, NA, 512.378910555, NA, 
                                 NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, NA, 1301.014577695, 
                                 NA, NA, NA, 37.3505263149999, 255.10388471, NA, NA, NA, 21.2789770099999, 
                                 NA, 55.1865428500002, 71.2887023200001, NA, NA, 4.99787407499997, 
                                 NA, NA, 180.80620656, NA, NA, NA, 52.6575400250001, NA, NA, NA, 
                                 NA, NA, 644.063649344998, NA, NA, 186.640773035, NA, 31.75246717, 
                                 NA, NA, 119.468629760002, 208.93155685, NA, NA, NA, NA, NA, NA, 
                                 NA, NA, NA))
    
    # Convex
    expect_silent(cur_out_3 <- patchSize(cur_sce, convex = TRUE))
    expect_false(identical(cur_out_1$size, cur_out_3$size))
    expect_s4_class(cur_out_3, "DataFrame")
    expect_equal(cur_out_3$size, c(NA, NA, 32.6370112445557, NA, NA, 4786.46867623013, 195.870087122285, 
                                   7075.35257151764))
    expect_equal(cur_out_3$polygon[3][[1]], structure(list(structure(c(175.961538461538, 181.214285714286, 
                                                                       195.802325581395, 175.961538461538, 266.865384615385, 275.285714285714, 
                                                                       286.244186046512, 266.865384615385), dim = c(4L, 2L), dimnames = list(
                                                                           NULL, c("Pos_X", "Pos_Y")))), class = c("XY", "POLYGON", 
                                                                                                                   "sfg")))
    
    # Expansion setting
    expect_message(cur_sce <- patchDetection(pancreasSCE, 
                                            patch_cells = pancreasSCE$CellType == "celltype_B",
                                            colPairName = "expansion_interaction_graph",
                                            expand_by = 10,
                                            img_id = "ImageNb"),
                  regex = "The returned object is ordered by the 'ImageNb' entry.")
    
    expect_silent(cur_out_4 <- patchSize(cur_sce))
    expect_false(identical(cur_out_1$size, cur_out_3$size))
    expect_s4_class(cur_out_4, "DataFrame")
    expect_equal(cur_out_4$size, c(NA, NA, 95.8792097900002, NA, NA, 2818.688752595, 621.836906870001, 
                                   4742.921943955))
    expect_equal(cur_out_4$polygon[3][[1]], structure(list(structure(c(186.1754, 175.9615, 181.2143, 189.2317, 
                                                                       195.8023, 186.1754, 268.8947, 266.8654, 275.2857, 279.1707, 286.2442, 
                                                                       268.8947), dim = c(6L, 2L), dimnames = list(NULL, c("V1", "V2"
                                                                       )))), class = c("XY", "POLYGON", "sfg")))
    
    # Error
    expect_error(patchSize("test"),
                 regexp = "'object' not of type 'SingleCellExperiment'.",
                 fixed = TRUE)
    expect_error(patchSize(pancreasSCE, patch_name = "test"),
                 regexp = "'patch_name' nor in 'colData(object)'.",
                 fixed = TRUE)
    expect_error(patchSize(pancreasSCE, patch_name = c("test", "test2")),
                 regexp = "'patch_name' must be a single string.",
                 fixed = TRUE)
    expect_error(patchSize(cur_sce, coords = "test"),
                 regexp = "'coords' must be a character vector of length 2.",
                 fixed = TRUE)
    expect_error(patchSize(cur_sce, coords = c("test1", "test2")),
                 regexp = "'coords' not in colData(object).",
                 fixed = TRUE)
    expect_error(patchSize(cur_spe, coords = c("test1", "test2")),
                 regexp = "'coords' not in spatialCoords(object).",
                 fixed = TRUE)
    expect_error(patchSize(cur_sce, convex = "test"),
                 regexp = "'convex' must be a single logical.",
                 fixed = TRUE)
})

#' @title Plot spatial context graph
#'
#' @description Function to plot directed spatial context graphs based on
#' symbolic edge-lists and vertex metadata, which operates on the cohort-level.
#' The user can specify node, node_label and edge aesthetics.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object.
#' @param entry single character specifying the \code{colData(object)} entry
#' containing the \code{\link[imcRtools]{detectSpatialContext}} output.
#' Defaults to "spatial_context".
#' @param group_by a single character indicating the \code{colData(object)}
#' entry by which SCs are grouped. This is usually the image or patient ID. 
#' Defaults to "sample_id".
#' @param node_color_by single character either
#' \code{NULL, "name","n_cells", "n_group"} by which the nodes should be
#' colored.
#' @param node_size_by single character either \code{NULL, "n_cells","n_group"} 
#' by which the size of the nodes are defined.
#' @param node_color_fix single character specifying the color of all nodes.
#' @param node_size_fix single numeric specifying the size of all nodes.
#' @param node_label_repel should nodes be labelled? Defaults to TRUE.
#' @param node_label_color_by single character either
#' \code{NULL, "name","n_cells","n_group"} by which the node labels should be
#' colored.
#' @param node_label_color_fix single character specifying the color of all node
#' labels.
#' @param draw_edges should edges be drawn between nodes? Defaults to TRUE.
#' @param edge_color_fix single character specifying the color of all edges.
#' @param return_data should the edge list and vertex metadata for graph
#' construction be returned as a \code{list} of two \code{data.frames}?
#' 
#' @return returns a \code{ggplot} object or a \code{list} of two
#' \code{data.frames}.
#' 
#' @examples 
#' set.seed(22)
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' ## 1. Cellular neighborhood (CN)
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_cn_graph",
#'                         k = 5)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "CellType",
#'                          name = "aggregatedCellTypes")
#'
#' cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
#' sce$cellular_neighborhood <- factor(cur_cluster$cluster)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_cn_graph",
#'            node_color_by = "cellular_neighborhood",
#'            scales = "free")
#'
#' ## 2. Spatial context (SC)
#' sce <- buildSpatialGraph(sce, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_sc_graph",
#'                         k = 15)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "cellular_neighborhood",
#'                          name = "aggregatedNeighborhood")
#'
#' # Detect spatial context
#' sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
#'                            threshold = 0.9)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_sc_graph",
#'            node_color_by = "spatial_context",
#'            scales = "free")
#'             
#' # Plot spatial context - default
#' plotSpatialContext(sce, group_by = "ImageNb")
#' 
#' # Plot spatial context - adjust aesthetics
#' plotSpatialContext(sce, group_by = "ImageNb",
#'                    node_color_by = "name",
#'                    node_size_by = "n_cells",
#'                    node_label_color_by = "name")
#'                    
#' plotSpatialContext(sce, group_by = "ImageNb",
#'                    node_color_by = "n_cells",
#'                    node_size_by = "n_group")
#'                    
#' # Plot spatial context - return data
#' plotSpatialContext(sce, group_by = "ImageNb",
#'                   return_data = TRUE)          
#'                   
#' @seealso 
#' \code{\link[imcRtools]{detectSpatialContext}} for the function to detect
#' spatial contexts
#'
#' \code{\link[imcRtools]{filterSpatialContext}} for the function to filter 
#' spatial contexts
#' 
#' @author Lasse Meyer (\email{lasse.meyer@@uzh.ch})
#' 
#' @references
#' \href{https://doi.org/10.1016/j.cels.2021.09.012}{
#' Bhate S. et al., Tissue schematics map the specialization of immune tissue 
#' motifs and their appropriation by tumors, Cell Systems, 2022}
#' 
#' @importFrom SingleCellExperiment colData
#' @importFrom stringr str_split
#' @importFrom dplyr count group_by_all group_by_at n select summarise
#' @importFrom tidyselect all_of
#' @importFrom igraph graph_from_data_frame
#' @importFrom stats na.omit
#' @export

plotSpatialContext <- function(object,
                               entry = "spatial_context",
                               group_by = "sample_id",
                               node_color_by = NULL,
                               node_size_by = NULL,
                               node_color_fix = NULL,
                               node_size_fix = NULL,
                               node_label_repel = TRUE,
                               node_label_color_by = NULL,
                               node_label_color_fix = NULL,
                               draw_edges = TRUE,
                               edge_color_fix = NULL,
                               return_data = FALSE){
  
 .valid.plotSpatialContext.input(object, entry, group_by, node_color_by, 
                                  node_size_by, node_color_fix, node_size_fix, 
                                  node_label_repel, node_label_color_by, 
                                  node_label_color_fix, draw_edges, 
                                  edge_color_fix, return_data)
  
 cur_dat <- colData(object) %>% 
   as.data.frame %>% 
   select(all_of(entry), all_of(group_by)) %>% 
   group_by_all() %>% 
   count() %>%
   na.omit() %>%
   as.data.frame
  
  list <- str_split(unique(cur_dat[,entry]), "_")
  list_length <- vapply(list, length, numeric(1))
  edges <- .createEdgeList(list, list_length)
  
  anno <- cur_dat %>% 
    group_by_at(entry) %>% 
    summarise(n_cells = sum(n), n_group = n()) %>% 
    as.data.frame
  
  anno$length <- vapply(str_split(anno[,entry],"_"), length, numeric(1))
  
  graph <- graph_from_data_frame(d = edges, directed = TRUE, vertices = anno)
    
  plot <- .generateSpatialContextPlot(graph = graph, node_color_by, 
                                      node_size_by, node_color_fix, 
                                      node_size_fix, node_label_repel, 
                                      node_label_color_by, node_label_color_fix,
                                      draw_edges, edge_color_fix) 
  
  if (return_data == TRUE) {
      return_data <- list(edges = edges, vertices = anno)
      return(return_data)
  } else { 
      return(plot)
  }  
}

#' @title Aggregate consecutive pixels per single-metal spot
#'
#' @description Helper function for estimating the spillover matrix. Per metal 
#' spot, consecutive pixels a aggregated (default: summed).
#'
#' @param object a \code{SingleCellExperiment} object containing pixel
#' intensities for all channels. Individual pixels are stored as columns and
#' channels are stored as rows.
#' @param bin_size single numeric indicating how many consecutive pixels per
#' spot should be aggregated.
#' @param spot_id character string indicating which \code{colData(object)} entry
#' stores the isotope names of the spotted metal. 
#' @param assay_type character string indicating which assay to use.
#' @param statistic character string indicating the statistic to use for
#' aggregating consecutive pixels.
#' @param ... additional arguments passed to \code{aggregateAcrossCells}
#'
#' @return returns the binned pixel intensities in form of a 
#' \code{SingleCellExperiment} object
#'
#' @examples
#' path <- system.file("extdata/spillover", package = "imcRtools")
#' # Read in .txt files
#' sce <- readSCEfromTXT(path)
#' dim(sce)
#' 
#' # Visualizes heatmap before aggregation
#' plotSpotHeatmap(sce)
#' 
#' # Sum consecutive pixels
#' sce <- binAcrossPixels(sce, bin_size = 10)
#' dim(sce)
#' 
#' # Visualizes heatmap after aggregation
#' plotSpotHeatmap(sce)
#' 
#' @seealso \code{\link[scrapper]{aggregateAcrossCells}} for the aggregation
#' function
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @importFrom scrapper aggregateAcrossCells
#' @importFrom scrapper aggregateAcrossCells.se
#' @export
binAcrossPixels <- function(object, 
                            bin_size,
                            spot_id = "sample_id",
                            assay_type = "counts",
                            statistic = "sum",
                            ...){
    
    .valid.binAcrossPixels.input(object, bin_size, spot_id, assay_type)
    
    if (!statistic %in% c("sum", "mean", "median")) {
        stop("'statistic' must be 'sum', 'mean' or 'median'.")
    }
    
    cur_split_tmp <- split(object[[spot_id]], f = object[[spot_id]])
    cur_split <- lapply(cur_split_tmp, function(x){ceiling(seq_along(x)/bin_size)})
    
    if (!isTRUE(all.equal(as.vector(unlist(cur_split_tmp)), object[[spot_id]]))) {
        stop("Spot IDs of pixels within 'object' are not ordered alphabetically.")
    }
    
    cur_df <- DataFrame(spot_id = object[[spot_id]],
                        bin = unlist(cur_split))
    
    cur_out <- aggregateAcrossCells.se(object, cur_df,
                                       assay.type = assay_type,
                                       ...)
    
    if (statistic == "mean") {
      cur_counts <- t(assay(cur_out, "sums"))/cur_out$counts
      assay(cur_out, "counts") <- t(cur_counts)
    } else if (statistic == "sum") {
      assay(cur_out, "counts") <- assay(cur_out, "sums")
    } else if (statistic == "median") {
      cur_counts <- aggregateAcrossCells(assay(object, assay_type),factors = cur_df,compute.median = TRUE)
      assay(cur_out, "counts") <- cur_counts$medians
    }
    cur_out <- as(cur_out,"SingleCellExperiment")
    cur_out$spot_id <- cur_out$factor.spot_id
    cur_out$bin <- cur_out$factor.bin
    cur_out$ncells <- cur_out$counts
    
    return(cur_out)
    
}

#' @title Filter spatial contexts
#'
#' @description Function to filter detected spatial contexts (SCs) based on a
#' user-defined threshold for number of group entries and/or cells.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param entry a single character specifying the \code{colData(object)} entry 
#' containing the \code{detectSpatialContext} output. Defaults to 
#' "spatial_context".
#' @param group_by a single character indicating the \code{colData(object)}
#' entry by which SCs are grouped. This is usually the image or patient ID. 
#' Defaults to "sample_id".
#' @param group_threshold a single numeric specifying the minimum number of
#' group entries in which a SC is detected.
#' @param cells_threshold a single numeric specifying the minimum total number
#' of cells in a SC.
#' @param name a single character specifying the name of the output saved in 
#'  \code{colData(object)}. Defaults to "spatial_context_filtered".
#' 
#' @return returns an object of \code{class(object)} containing a new column
#' entry to \code{colData(object)[[name]]} and a new \code{data.frame} entry to
#' \code{metadata(object)[["filterSpatialContext"]]} containing the group and
#' cell counts per SC.
#' 
#' @examples 
#' set.seed(22)
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' ## 1. Cellular neighborhood (CN)
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_cn_graph",
#'                         k = 5)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "CellType",
#'                          name = "aggregatedCellTypes")
#'
#' cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
#' sce$cellular_neighborhood <- factor(cur_cluster$cluster)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_cn_graph",
#'            node_color_by = "cellular_neighborhood",
#'            scales = "free")
#'
#' ## 2. Spatial context (SC)
#' sce <- buildSpatialGraph(sce, img_id = "ImageNb",
#'                         type = "knn",
#'                         name = "knn_sc_graph",
#'                         k = 15)
#'
#' sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
#'                          aggregate_by = "metadata",
#'                          count_by = "cellular_neighborhood",
#'                          name = "aggregatedNeighborhood")
#'
#' # Detect spatial context
#' sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
#'                            threshold = 0.9)
#'
#' plotSpatial(sce, img_id = "ImageNb",
#'            colPairName = "knn_sc_graph",
#'            node_color_by = "spatial_context",
#'            scales = "free")
#'             
#' # Filter spatial context
#' # By group
#' sce <- filterSpatialContext(sce, group_by = "ImageNb", 
#'                             group_threshold = 2)
#' 
#' plotSpatial(sce, img_id = "ImageNb", 
#'             colPairName = "knn_sc_graph", 
#'             node_color_by = "spatial_context_filtered",
#'             scales = "free")
#'
#' # By cells
#' sce <- filterSpatialContext(sce, group_by = "ImageNb", 
#'                             cells_threshold = 15)
#'
#' plotSpatial(sce, img_id = "ImageNb", 
#'            colPairName = "knn_sc_graph", 
#'            node_color_by = "spatial_context_filtered",
#'            scales = "free")
#'            
#' @seealso 
#' \code{\link[imcRtools]{detectSpatialContext}} for the function to detect
#' spatial contexts
#'
#' \code{\link[imcRtools]{plotSpatialContext}} for the function to plot 
#' spatial context graphs
#' 
#' @author Lasse Meyer (\email{lasse.meyer@@uzh.ch})
#' 
#' @references
#' \href{https://doi.org/10.1016/j.cels.2021.09.012}{
#' Bhate S. et al., Tissue schematics map the specialization of immune tissue 
#' motifs and their appropriation by tumors, Cell Systems, 2022}
#' 
#' @importFrom SingleCellExperiment colData
#' @importFrom dplyr all_of count n filter group_by_at group_by_all pull summarise
#' @importFrom tidyselect all_of
#' @importFrom S4Vectors metadata
#' 
#' @export

filterSpatialContext <- function(object,
                               entry = "spatial_context",
                               group_by = "sample_id",
                               group_threshold = NULL,
                               cells_threshold = NULL,
                               name = "spatial_context_filtered"
                               ){
  
  .valid.filterSpatialContext.input(object, entry, group_by, group_threshold,
                                    cells_threshold, name)
  
  anno <- colData(object) %>% 
    as.data.frame %>% 
    select(all_of(entry), all_of(group_by)) %>% 
    group_by_all() %>% 
    count() %>% 
    group_by_at(entry) %>% 
    summarise(n_cells = sum(n), n_group = n()) %>%
    as.data.frame
  
  if (!is.null(group_threshold)) {
    anno <- anno[anno$n_group >= group_threshold,]
  }
  
  if (!is.null(cells_threshold)) {
      anno <- anno[anno$n_cells >= cells_threshold,]
  }
  
  selected <- anno %>% pull(entry)
  
  out_dat <- colData(object)[[entry]]
  out_dat[!out_dat %in% selected] <- NA 
  
  colData(object)[[name]] <- out_dat
  metadata(object)[["filterSpatialContext"]] <- anno
  
  return(object)
}

#' @title Builds an interaction graph based on the cells' locations
#'
#' @description Function to define cell-cell interactions via distance-based
#' expansion, delaunay triangulation or k nearest neighbor detection.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param img_id single character indicating the \code{colData(object)} entry
#' containing the unique image identifiers.
#' @param type single character specifying the type of graph to be build.
#' Supported entries are \code{"expansion"} (default) to find interacting
#' cells via distance thresholding; \code{"delaunay"} to find interactions via
#' delaunay triangulation; \code{"knn"} to find the k nearest neighboring
#' cells.
#' @param threshold (when \code{type = "expansion"}) single numeric specifying
#' the maximum distance for considering neighbors
#' @param k (when \code{type = "knn"}) single numeric integer defining the
#' number of nearest neighbors to search for.
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries of the cells' x and y locations.
#' @param name single character specifying the name of the graph.
#' @param directed (when \code{type = "knn"}) should the returned graph be
#' directed? (see details).
#' @param max_dist (when \code{type = "knn"} or \code{type = "delaunay"}) the
#' maximum distance at which to consider neighboring cells. All neighbors
#' within a distance larger than \code{max_dist} will be excluded from graph
#' construction.
#' @param BNPARAM a \code{\link[BiocNeighbors]{BiocNeighborParam}} object
#' defining the algorithm to use.
#' @param BPPARAM a \code{\link[BiocParallel]{BiocParallelParam-class}} object
#' defining how to parallelize computations.
#' @param ... additional parameters passed to the
#' \code{\link[BiocNeighbors]{findNeighbors}} function (\code{type =
#' "expansion"}), the \code{\link[RTriangle]{triangulate}} function
#' (\code{type = "delaunay"}) or the \code{\link[BiocNeighbors]{findKNN}}
#' function (\code{type = "knn"})).
#'
#' @return returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
#' containing the graph in form of a \code{SelfHits} object in
#' \code{colPair(object, name)}. The object is grouped by entries in the 
#' \code{img_id} slot.
#'
#' @section Building an interaction graph:
#' This function defines interacting cells in different ways. They are based
#' on the cells' centroids and do not incorporate cell shape or area.
#'
#' 1. When \code{type = "expansion"}, all cells within the radius
#' \code{threshold} are considered interacting cells.
#'
#' 2. When \code{type = "delaunay"}, interacting cells are found via a delaunay
#' triangulation of the cells' centroids.
#'
#' 3. When \code{type = "knn"}, interacting cells are defined as the \code{k}
#' nearest neighbors in the 2D spatial plane.
#'
#' The \code{directed} parameter only affects graph construction via k nearest
#' neighbor search. For \code{directed = FALSE}, each interaction will be
#' stored as mutual edge (e.g. node 2 is connected to node 10 and vise versa).
#' For \code{type = "expansion"} and \code{type = "delaunay"}, each edge is
#' stored as mutual edge by default.
#'
#' The graph is stored in form of a \code{SelfHits} object in
#' \code{colPair(object, name)}. This object can be regarded as an edgelist
#' and coerced to an \code{igraph} object via
#' \code{graph_from_edgelist(as.matrix(colPair(object, name)))}.
#'
#' @section Choosing the graph construction method:
#' When finding interactions via \code{expansion} or \code{knn}, the
#' \code{\link[BiocNeighbors]{findNeighbors}} or
#' \code{\link[BiocNeighbors]{findKNN}} functions are used, respectively. Both
#' functions accept the \code{BNPARAM} parameter via which the graph
#' construction method can be defined (default
#' \code{\link[BiocNeighbors]{KmknnParam}}). For an overview on the different
#' algorithms, see
#' \code{\link[BiocNeighbors]{BiocNeighborParam}}. Within the
#' \code{BiocNeighborParam} object, \code{distance} can be set to
#' \code{"Euclidean"} (default), \code{"Manhattan"} or \code{"Cosine"}.
#' 
#' @section Ordering of the output object:
#' The \code{buildSpatialGraph} function operates on individual images.
#' Therefore the returned object is grouped by entries in \code{img_id}. 
#' This means all cells of a given image are grouped together in the object.
#' The ordering of cells within each individual image is the same as the ordering
#' of these cells in the input object.
#'
#' @examples
#' path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
#' spe <- read_steinbock(path)
#'
#' # Constructing a graph via expansion
#' spe <- buildSpatialGraph(spe, img_id = "sample_id",
#'                          type = "expansion", threshold = 10)
#' colPair(spe, "expansion_interaction_graph")
#'
#' # Constructing a graph via delaunay triangulation
#' spe <- buildSpatialGraph(spe, img_id = "sample_id",
#'                          type = "delaunay")
#' colPair(spe, "delaunay_interaction_graph")
#'
#' # Constructing a graph via k nearest neighbor search
#' spe <- buildSpatialGraph(spe, img_id = "sample_id",
#'                          type = "knn", k = 5)
#' colPair(spe, "knn_interaction_graph")
#'
#' @seealso
#' \code{\link[BiocNeighbors]{findNeighbors}} for the function finding
#' interactions via expansion
#'
#' \code{\link[BiocNeighbors]{findKNN}} for the function finding interactions
#' via nearest neighbor search
#'
#' \code{\link[RTriangle]{triangulate}} for the function finding interactions
#' via delaunay triangulation
#'
#' \code{\link{plotSpatial}} for visualizing spatial graphs
#'
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @importFrom BiocNeighbors findNeighbors findKNN KmknnParam
#' @importFrom SpatialExperiment spatialCoords
#' @importFrom igraph graph_from_adj_list graph_from_edgelist as.undirected
#' simplify as_edgelist as.directed
#' @importFrom RTriangle triangulate pslg
#' @importFrom stats dist
#' @export
buildSpatialGraph <- function(object,
                                img_id,
                                type = c("expansion", "knn", "delaunay"),
                                k = NULL,
                                directed = TRUE,
                                max_dist = NULL,
                                threshold = NULL,
                                coords = c("Pos_X", "Pos_Y"),
                                name = NULL,
                                BNPARAM = KmknnParam(),
                                BPPARAM = SerialParam(),
                                ...){
    type <- match.arg(type)

    .valid.buildSpatialGraph.input(object, type, img_id, k, threshold, coords,
                                    name, directed, max_dist)

    name <- ifelse(is.null(name), paste0(type, "_interaction_graph"), name)

    cur_ind <- unique(as.character(colData(object)[[img_id]]))

    cur_meta <- metadata(object)
    metadata(object) <- list()
    
    cur_intmeta <- int_metadata(object)

    cur_out <- bplapply(cur_ind,
                        function(x){

                            cur_obj <- object[,
                                as.character(colData(object)[[img_id]]) == x]

                            # Create coords matrix
                            if (is(cur_obj, "SpatialExperiment")) {
                                cur_coords <- spatialCoords(cur_obj)[,coords]
                            } else {
                                cur_coords <- colData(cur_obj)[,coords]
                            }

                            if (type == "expansion") {
                                cur_graph <- findNeighbors(as.matrix(cur_coords),
                                                    threshold = threshold,
                                                get.distance = FALSE,
                                                            BNPARAM = BNPARAM,
                                                            ...)
                                cur_graph <- graph_from_adj_list(
                                    cur_graph$index)
                            } else if (type == "delaunay") {
                                cur_graph <- triangulate(pslg(P = cur_coords),
                                                    ...)

                                cur_edges <- cur_graph$E

                                if (!is.null(max_dist)) {
                                    cur_dist <- apply(cur_edges, 1, function(y){
                                        dist(cur_coords[y,])
                                    })
                                    cur_edges <- cur_edges[cur_dist <= max_dist,]
                                }

                                cur_graph <- graph_from_edgelist(cur_edges,
                                                            directed = FALSE)
                                cur_graph <- as.directed(cur_graph,
                                                        mode = "mutual")

                            } else {
                                if (is.null(max_dist)) {
                                    cur_graph <- findKNN(as.matrix(cur_coords),
                                                    k = k,
                                                    BNPARAM = BNPARAM,
                                                    get.distance = FALSE,
                                                    ...)
                                    cur_graph <- as.list(as.data.frame(
                                        t(cur_graph$index)))
                                    cur_graph <- graph_from_adj_list(cur_graph)
                                } else {
                                    cur_graph <- findKNN(as.matrix(cur_coords),
                                                        k = k,
                                                        BNPARAM = BNPARAM,
                                                        get.distance = TRUE,
                                                        ...)
                                    cur_graph <- lapply(
                                        seq_len(nrow(cur_graph$index)),
                                            function(i){
                                                cur_graph$index[i,
                                        cur_graph$distance[i,] <= max_dist]
                                            })
                                    cur_graph <- graph_from_adj_list(cur_graph)
                                }

                                if (!directed) {
                                    cur_graph <- as.undirected(cur_graph,
                                                            mode = "collapse")
                                    cur_graph <- as.directed(cur_graph,
                                                            mode = "mutual")
                                }
                            }

                            cur_graph <- simplify(cur_graph)

                            cur_graph <- as_edgelist(cur_graph)
                            cur_graph <- SelfHits(from = cur_graph[,1],
                                                    to = cur_graph[,2],
                                                    nnode = nrow(cur_coords))
                            colPair(cur_obj, name) <- cur_graph

                            return(cur_obj)

                        }, BPPARAM = BPPARAM)

    cur_out <- do.call("cbind", cur_out)

    metadata(cur_out) <- cur_meta
    int_metadata(cur_out) <- cur_intmeta
    
    message("The returned object is ordered by the '", img_id, "' entry.")

    return(cur_out)
}

test_that("detectCommunity function works", {
  set.seed(22)
  library(cytomapper)
  data(pancreasSCE)
  
  cur_sce1 <- pancreasSCE[,pancreasSCE$ImageNb == 1]
  cur_sce2 <- pancreasSCE[,pancreasSCE$ImageNb == 2]
  cur_sce3 <- pancreasSCE[,pancreasSCE$ImageNb == 3]
  
  cur_sce1$Pos_X <- cur_sce1$Pos_X - min(cur_sce1$Pos_X)
  cur_sce1$Pos_Y <- cur_sce1$Pos_Y - min(cur_sce1$Pos_Y)
  cur_sce2$Pos_X <- cur_sce2$Pos_X - min(cur_sce2$Pos_X)
  cur_sce2$Pos_Y <- cur_sce2$Pos_Y - min(cur_sce2$Pos_Y)
  cur_sce3$Pos_X <- cur_sce3$Pos_X - min(cur_sce3$Pos_X)
  cur_sce3$Pos_Y <- cur_sce3$Pos_Y - min(cur_sce3$Pos_Y)
  
  pancreasSCE <- cbind(cur_sce1, cur_sce2, cur_sce3)
  
  sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                         type = "expansion",
                         name = "neighborhood",
                         threshold = 20)
  
  ## Detect spatial community - tests
  # basics
  expect_silent(cur_sce <- detectCommunity(sce, 
                      colPairName = "neighborhood"))
  expect_equal(names(colData(cur_sce)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb", 
                 "CellNb", "MaskName", "Pattern", "spatial_community"))
  expect_s4_class(cur_sce , class = "SingleCellExperiment")
  expect_type(cur_sce$spatial_community, "character")
  expect_equal(cur_sce$spatial_community[1:10], c(E34_824 = "1", E34_835 = "2", E34_839 = "1", E34_844 = "1", 
                                                  E34_847 = "2", E34_853 = "1", E34_859 = "1", E34_864 = "1", E34_865 = "1", 
                                                  E34_872 = "1"))
  
  # check that changing size_threshold works
  set.seed(22)
  expect_silent(cur_sce_2 <- detectCommunity(sce, 
                                           colPairName = "neighborhood",
                                           size_threshold = 40))
  expect_false(identical(cur_sce$spatial_community, cur_sce_2$spatial_community))
  expect_equal(cur_sce_2$spatial_community[1:10], c(E34_824 = "1", E34_835 = NA, E34_839 = "1", E34_844 = "1", 
                                                  E34_847 = NA, E34_853 = "1", E34_859 = "1", E34_864 = "1", E34_865 = "1", 
                                                  E34_872 = "1"))
  
  # check that changing name works 
  expect_silent(cur_sce_3 <- detectCommunity(sce, 
                                             colPairName = "neighborhood",
                                             name = "spatial_comm"))
  expect_equal(names(colData(cur_sce_3)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb", 
                 "CellNb", "MaskName", "Pattern", "spatial_comm"))
  
  # check that group_by works 
  set.seed(22)
  expect_silent(cur_sce_4 <- detectCommunity(sce, 
                                             colPairName = "neighborhood",
                                             group_by = "CellType",
                                             BPPARAM = SerialParam(RNGseed = 123)
                                             ))
  expect_false(identical(cur_sce_4$spatial_community, cur_sce$spatial_community))
  dat <- as.data.frame(unclass(table(cur_sce_4$spatial_community,cur_sce_4$CellType)))
  expect_true(all.equal(unique(rowSums(dat != 0)),1, check.attributes = FALSE))

  
  # manual coding spatial communities gives the same result
  set.seed(22)
  gr <- graph_from_data_frame(as.data.frame(colPair(sce, "neighborhood")), 
                              directed = FALSE, 
                              vertices = data.frame(index = seq_len(ncol(sce))))
  
  clus_comm <- cluster_louvain(gr)
  cl_comm <- as.character(membership(clus_comm))
  cl_comm[membership(clus_comm) %in% which(sizes(clus_comm) < 10)] <- NA
  cur_sce$spatial_community_manual <- cl_comm
  
  expect_equal(unname(cur_sce$spatial_community), cur_sce$spatial_community_manual)
  
  # Different cluster_fun 
  expect_silent(cur_sce <- detectCommunity(cur_sce, 
                                           colPairName = "neighborhood", 
                                           name = "spatial_comm_wt", 
                                           cluster_fun = "walktrap"))
  expect_equal(names(colData(cur_sce)), 
               c("ImageName", "Pos_X", "Pos_Y", "Area", "CellType", "ImageNb", 
                 "CellNb", "MaskName", "Pattern", "spatial_community", 
                 "spatial_community_manual","spatial_comm_wt"))
  
  expect_false(identical(cur_sce$spatial_community, cur_sce$spatial_comm_wt))
  
  # Use different seed for SerialParam()
  set.seed(22)
  expect_silent(cur_sce_5 <- detectCommunity(sce, 
                                             colPairName = "neighborhood",
                                             group_by = "CellType", 
                                             BPPARAM = SerialParam(RNGseed = 22)
                                             ))
  
  expect_false(identical(cur_sce_5$spatial_community, cur_sce_4$spatial_community))
  
  # Errors 
  expect_error(detectCommunity(colData(sce)),
               regexp = "'object' needs to be a SingleCellExperiment object.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = 10),
               regexp = "'colPairName' must be a single string.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = "neighbors"),
               regexp = "'colPairName' not in 'colPairNames(object)'.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = "neighborhood", size_threshold = "10"),
               regexp = "'size_threshold' needs to be a positive single numeric.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = "neighborhood", group_by = "celltype"),
               regexp = "'group_by' not in 'colData(object)'.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = "neighborhood", name = c("cool","name")),
               regexp = "'name' has to be a single character.",
               fixed = TRUE)
  
  expect_error(detectCommunity(sce, colPairName = "neighborhood", cluster_fun = c("cool","function")),
               regexp = "'cluster_fun' has to be a single character.",
               fixed = TRUE)
  
  cur_sce_5 <- sce
  colPair(cur_sce_5, "neighborhood") <- colPair(cur_sce_5, "neighborhood")[0,0]
  expect_error(detectCommunity(cur_sce_5, colPairName = "neighborhood"),
               regexp = "No interactions found.",
               fixed = TRUE)
  
  colnames(sce) <- NULL
  expect_error(detectCommunity(sce, colPairName = "neighborhood"),
               regexp = "'colnames' of 'object' need to be specified and unique (e.g. as cell IDs).",
               fixed = TRUE)
}
)

#' @title Generates a SingleCellExperiment from .tiff files
#'
#' @description Helper function to process .tiff files created with the 
#' steinbock pipeline \href{https://bodenmillergroup.github.io/steinbock/latest/} 
#' into a \code{\linkS4class{SingleCellExperiment}}
#' object. This function is mainly used to read-in data generated from a
#' "spillover slide" from the new XTi generation of IMC machines. 
#' Here, each .tiff file contains the measurements of
#' multiple pixels for a single stain across all open channels.
#'
#' @param x has to be a path to a folder containing .tiff files.
#' @param image_df_path has to be a path to a images.csv file, 
#' generated with the steinbock pipeline.
#' @param panel_df_path has to be a path to a panel.csv file, 
#' generated with the steinbock pipeline.
#' @param verbose logical indicating if additional information regarding the
#' spotted and acquired masses should be shown.
#' 
#' @return returns a SCE object where pixels are stored as columns and acquired
#' channels are stored as rows.
#' 
#' @section Reading in .tiff files for spillover correction:
#' 
#' As described in the original publication, single metal spots are acquired
#' using the Hyperion imaging system. Each acquisition corresponds to one spot.
#' All acquisitions are stored in a single .mcd file and individual acquisitions
#' are stored in single .tiff files after extraction with the steinbock pipeline.
#' 
#' This function aggregates these measurements into a single
#' \code{SingleCellExperiment} object:
#' 
#' \code{x} is a path:
#' All .tiff files are read in from the specified path. Here, the path
#' should indicate the location of the spillover slide measurement. Additionally,
#' the images.csv and panel.csv files generated with the steinbock pipeline 
#' must be passed. The column \code{acquisition_description} in images.csv 
#' as well as the column \code{channel} in panel.csv must contain the 
#' spotted metal isotope name in the format \code{(mt)(mass)} 
#' (e.g. \code{Sm152} for Samarium isotope with the atomic mass 152). 
#'
#' @examples
#' # Read files from path
#' path <- system.file("extdata/spillover_tiff/img", package = "imcRtools")
#' image_df_path <- system.file("extdata/spillover_tiff/images.csv", package = "imcRtools")
#' panel_df_path <- system.file("extdata/spillover_tiff/panel.csv", package = "imcRtools")
#' 
#' sce <- readSCEfromTIFF(path, image_df_path, panel_df_path) 
#' sce
#' 
#' 
#' @author Victor Ibañez (\email{victor.ibanez@@uzh.ch})
#' 
#' @references
#' \href{https://www.sciencedirect.com/science/article/pii/S1550413118306910}{Chevrier,
#' S. et al. 2017. “Compensation of Signal Spillover in Suspension and Imaging
#' Mass Cytometry.” Cell Systems 6: 612–20.}
#' \href{https://www.nature.com/articles/s41596-023-00881-0}{Windhager,
#' J. et al. 2023. “An end-to-end workflow for multiplexed image processing and analysis.” 
#' Nature Protocols 18: 3565–3613.}
#' 
#' @importFrom SingleCellExperiment SingleCellExperiment
#' @importFrom S4Vectors DataFrame
#' @importFrom EBImage readImage
#' @importFrom SummarizedExperiment colData<- rowData<-
#' @importFrom stringr str_extract str_split
#' @export
readSCEfromTIFF <- function(x, 
                            image_df_path,
                            panel_df_path,
                            verbose = TRUE) {
  if (!dir.exists(x)) {
    stop("Image folder path does not exist.")
  }
  if (!file.exists(image_df_path)) {
    stop("Image dataframe path does not exist.")
  }
  if (!file.exists(panel_df_path)) {
    stop("Panel dataframe path does not exist.")
  }
  
  img_df   <- read.csv(image_df_path, stringsAsFactors = FALSE)
  img_df <- img_df[order(img_df$acquisition_description), ]
  panel_df <- read.csv(panel_df_path, stringsAsFactors = FALSE)
  tiff_files <- file.path(x, img_df$image)

  if (!all(file.exists(tiff_files))) {
    stop("Some TIFF files listed in img_df$image do not exist in the folder.")
  }
  
  tiff_list <- lapply(seq_along(tiff_files), function(i) {
    img <- readImage(tiff_files[i])
    dims <- dim(img)
    
    mat <- matrix(img, nrow = dims[1]*dims[2], ncol = dims[3])
    
    rownames(mat) <- paste0(basename(img_df$acquisition_description[i]), "_", seq_len(nrow(mat)))
    colnames(mat) <- panel_df$channel
    
    return(mat)
  })
  
  .valid.readSCEfromTIFF.input(img_df, panel_df, verbose)
  
  cur_counts <- do.call(rbind, tiff_list)
  cell_meta <- DataFrame(cell_id = rownames(cur_counts))
  cell_meta$sample_id <- str_split(cell_meta$cell_id, "\\_", 
                                   simplify = TRUE)[,1]
  cell_meta$sample_metal <- str_extract(cell_meta$sample_id, 
                                        "^[A-Z]{1}[a-z]{0,1}")
  cell_meta$sample_mass <- str_extract(cell_meta$sample_id, "[0-9]{2,3}$")
  
  cur_counts <- t(cur_counts)
  
  channel_meta <- DataFrame(
    channel_name = paste0(panel_df$channel, "Di"),
    marker_name  = panel_df$channel
  )
  
  sce <- SingleCellExperiment(assays = list(counts = cur_counts))
  rowData(sce) <- channel_meta
  colData(sce) <- cell_meta
  
  return(sce)
}

#' @title Detect the spatial community of each cell
#'
#' @description Function to detect the spatial community of each cell as 
#' proposed by \href{https://www.nature.com/articles/s41586-019-1876-x}{
#' Jackson et al., The single-cell pathology landscape of breast cancer, Nature, 
#' 2020}. Each cell is clustered based on its interactions as defined by a 
#' spatial object graph.
#' 
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param colPairName single character indicating the \code{colPair(object)}
#' entry containing the neighbor information. 
#' @param size_threshold single positive numeric that specifies the minimum 
#' number of cells per community. Defaults to 0.
#' @param group_by single character indicating that spatial community 
#' detection will be performed separately for all unique entries to 
#' \code{colData(object)[,group_by]}.
#' @param name single character specifying the name of the output saved in 
#'  \code{colData(object)}. Defaults to "spatial_community".
#' @param cluster_fun single character specifying the function to use for 
#' community detection. Options are all strings that contain the suffix of an 
#' \code{igraph} community detection algorithm (e.g. "walktrap"). 
#' Defaults to "louvain".
#' @param BPPARAM a \code{\link[BiocParallel]{BiocParallelParam-class}} object
#' defining how to parallelize computations. Applicable when \code{group_by} is 
#' specified and defaults to \code{SerialParam()}. 
#' For reproducibility between runs, we recommend defining \code{RNGseed} in the
#'  \code{\link[BiocParallel]{BiocParallelParam-class}} object.
#'
#' @section Spatial community detection procedure:
#' 1. Create an igraph object from the edge list stored in 
#' \code{colPair(object, colPairName)}.  
#' 
#' 2. Perform community detection using the specified \code{cluster_fun} algorithm.  
#'   
#' 3. Store the community IDs in a vector and replace all communities with 
#' a size smaller than \code{size_threshold} by NA.   
#' 
#' Optional steps: Specify \code{group_by} to perform spatial community 
#' detection separately for all unique entries to \code{colData(object)[,group_by]} 
#' e.g. for tumor and non-tumor cells.
#' 
#' @return returns an object of \code{class(object)} containing a new column 
#' entry to \code{colData(object)[[name]]}.
#' 
#' @examples 
#' library(cytomapper)
#' library(BiocParallel)
#' data(pancreasSCE)
#'
#' sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
#'                         type = "expansion",
#'                         name = "neighborhood",
#'                         threshold = 20)
#'
#' ## Detect spatial community 
#' set.seed(22)
#' sce <- detectCommunity(sce, 
#'                       colPairName = "neighborhood", 
#'                       size_threshold = 10)
#'
#' plotSpatial(sce,
#'             img_id = "ImageNb",
#'             node_color_by = "spatial_community",
#'             scales = "free")
#'             
#' ## Detect spatial community - specify group_by
#' sce <- detectCommunity(sce, 
#'                        colPairName = "neighborhood", 
#'                        group_by = "CellType", 
#'                        size_threshold = 10,
#'                        BPPARAM = SerialParam(RNGseed = 22)) 
#'
#' plotSpatial(sce,
#'             img_id = "ImageNb",
#'             node_color_by = "spatial_community",
#'             scales = "free")
#'            
#' @author Lasse Meyer (\email{lasse.meyer@@uzh.ch})
#' 
#' @references
#' \href{https://www.nature.com/articles/s41586-019-1876-x}{
#' Jackson et al., The single-cell pathology landscape of breast cancer, 
#' Nature, 2020}
#' 
#' @importFrom SingleCellExperiment colData
#' @importFrom BiocParallel bplapply
#' @importFrom igraph membership sizes
#' @export


detectCommunity <- function(object,
                            colPairName,
                            size_threshold = 0,
                            group_by = NULL,
                            name = "spatial_community",
                            cluster_fun = "louvain",
                            BPPARAM = SerialParam()){
  
.valid.detectCommunity.input(object, colPairName, size_threshold, group_by, name, cluster_fun) 

  if (!is.null(group_by)) {
    cur_list <- bplapply(unique(colData(object)[,group_by]), function(x){
      cur_object  <- object[,colData(object)[,group_by] == x]
      cl_comm <- .detectCommunity_function(cur_object, colPairName, cluster_fun)
      comm <- paste0(x,"_",membership(cl_comm))  
      names(comm) <- colnames(cur_object)
      
      if (size_threshold != 0){
        comm[membership(cl_comm) %in% which(sizes(cl_comm) < size_threshold)] <- NA
      }
      
      return(comm)
  }, BPPARAM = BPPARAM)
    comm <- unlist(cur_list, use.names = TRUE)
  
  } else {
    cur_object <- object
    cl_comm <- .detectCommunity_function(cur_object, colPairName, cluster_fun)
    comm <- as.character(membership(cl_comm))  
    names(comm) <- colnames(object)
    
    if (size_threshold != 0){
      comm[membership(cl_comm) %in% which(sizes(cl_comm) < size_threshold)] <- NA
    }
  }
  
  colData(object)[[name]] <- comm[colnames(object)] 
  
  return(object)
}

#' @title Function to compute the area of c3ll patches
#'
#' @description This function constructs polygons around patch cells and
#' computes their area.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param patch_name single character indicating the \code{colData(object)} entry
#' containing the patch cell identifiers.
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries of the cells' x and y locations.
#' @param convex should the convex hull be computed to construct the polygon?
#'   Default: the concave hull is computed.
#' 
#' @return A DataFrame object containing the patch identifier, the constructed
#' polygon and the polygon size.
#' 
#' @examples
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' # Build interaction graph
#' pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
#'                                  type = "expansion", threshold = 20)
#' 
#' # Detect patches of "celltype_B" cells
#' pancreasSCE <- patchDetection(pancreasSCE, 
#'                               patch_cells = pancreasSCE$CellType == "celltype_B",
#'                               expand_by = 5, img_id = "ImageNb",
#'                               colPairName = "expansion_interaction_graph")
#'                               
#' # Compute the patch area
#' patchSize(pancreasSCE)
#'   
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @importFrom sf st_area
#' @export
patchSize <- function(object, 
                      patch_name = "patch_id",
                      coords = c("Pos_X", "Pos_Y"),
                      convex = FALSE){
    
    .valid.patchSize.input(object, patch_name, coords, convex)
    
    data <- polygon <- NULL
    
    if (is(object, "SpatialExperiment")) {
        out <- cbind(colData(object), spatialCoords(object)) %>% 
            as_tibble %>%
            filter(!is.na(!!sym(patch_name))) %>%
            nest_by(!!sym(patch_name)) %>%
            summarize(
                polygon = list(.polygon_function(x = data,
                                                 coords = coords,
                                                 convex = convex)),
                size = ifelse(is.na(polygon), NA, st_area(polygon)))
    } else {
        out <- colData(object) %>% as_tibble %>%
            filter(!is.na(!!sym(patch_name))) %>%
            nest_by(!!sym(patch_name)) %>%
            summarize(polygon = list(.polygon_function(x = data,
                                                       coords = coords,
                                                       convex = convex)),
                      size = ifelse(is.na(polygon), NA, st_area(polygon)))
    }
    
    return(as(out, "DataFrame"))
}

#' @title Reads one or multiple .txt files into a CytoImageList object
#'
#' @description Reader function to generate \code{\linkS4class{Image}} objects
#' in form of a \code{\linkS4class{CytoImageList}} container from .txt files.
#'
#' @param path Full path to where the individual .txt files are located. This is
#' usualy the path where the .mcd file is located.
#' @param pattern pattern to select which files should be read in (default
#' \code{".txt$"}). 
#' @param channel_pattern regular expression to select the channel names from
#' the files.
#' @param index_names exact names of the columns storing the x and y coordinates 
#' of the image
#' @param BPPARAM parameters for parallelized reading in of images. 
#' This is only recommended for very large images. 
#' 
#' @return returns a \code{\linkS4class{CytoImageList}} object containing one
#' \code{\linkS4class{Image}} object per .txt file.
#' 
#' @section Imaging mass cytometry .txt files:
#' As part of the raw data folder, the Hyperion imaging system writes out
#' one .txt file per acquisition. These files store the ion counts per
#' pixel and channel. 
#' 
#' This function reads these .txt files into a single
#' \code{\linkS4class{CytoImageList}} object for downstream analysis. The
#' \code{pattern} argument allows selection of all .txt files or a specific
#' subset of files. The \code{\link[cytomapper]{channelNames}} of the
#' \code{CytoImageList} object are determined by the \code{channel_pattern}
#' argument.
#'
#' @examples
#' path <- system.file("extdata/mockData/raw", package = "imcRtools")
#' 
#' # Read in all images
#' x <- readImagefromTXT(path)
#' x
#' 
#' # Read in specific files
#' y <- readImagefromTXT(path, pattern = "ROI_002")
#' y
#' 
#' # Read in other channelNames
#' z <- readImagefromTXT(path, channel_pattern = "[A-Za-z]{2}[0-9]{3}")
#' z
#' 
#' @seealso 
#' \code{\linkS4class{CytoImageList}} for the container
#' 
#' \code{\link[BiocParallel]{MulticoreParam}} for parallelized processing
#' 
#' \code{\linkS4class{Image}} for the multi-channel image object
#' 
#' \code{vignette("cytomapper")} for visualization of multi-channel images
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#' 
#' @importFrom cytomapper CytoImageList channelNames<- channelNames
#' @importFrom abind abind
#' @importFrom BiocParallel bplapply SerialParam
#' @importFrom EBImage Image
#' @importFrom stringr str_extract
#' @importFrom readr read_delim
#' @export
readImagefromTXT <- function(path, 
                            pattern = ".txt$",
                            channel_pattern = "[A-Za-z]{1,2}[0-9]{2,3}Di",
                            index_names = c("X", "Y"),
                            BPPARAM = SerialParam()){
    
    # Validity checks
    .valid.readImagefromTXT.input(path, pattern)
    
    cur_files <- list.files(path, pattern = pattern, full.names = TRUE)
    cur_names <- list.files(path, pattern = pattern, full.names = FALSE)
    
    cur_dat <- lapply(cur_files, read_delim, delim = "\t", 
                        show_col_types = FALSE)
    cur_dat <- bplapply(cur_dat, function(x){
        
        if (sum(grepl(channel_pattern, colnames(x))) == 0) {
            stop("'channel_pattern' does not match", 
                    " any entries in the .txt files.")
        }
        
        cur_mat <- x[,grepl(channel_pattern, colnames(x))]
        
        if (!all(index_names %in% colnames(x))) {
            stop("'index_names' not in the names of the .txt files.")
        }
        
        cur_ind <- x[,index_names]
        
        n_row <- max(cur_ind[,index_names[1]]) + 1
        n_col <- max(cur_ind[,index_names[2]]) + 1
        
        cur_mat <- lapply(cur_mat, function(y){
            matrix(y, nrow = n_row, ncol = n_col, byrow = FALSE)
        })
        
        cur_mat <- do.call(abind, list(cur_mat, along = 3))
        
        Image(cur_mat)
    }, BPPARAM = BPPARAM)
    
    cur_dat <- CytoImageList(cur_dat)
    names(cur_dat) <- sub("\\.[^.]*$", "", basename(cur_names))
    
    channelNames(cur_dat) <- str_extract(channelNames(cur_dat), channel_pattern)
    
    return(cur_dat)
}

test_that("readImagefromTXT function works.", {
    path <- system.file("extdata/mockData/raw", package = "imcRtools")
    
    # Works
    cur_cil <- readImagefromTXT(path)
    expect_s4_class(cur_cil, "CytoImageList")
    
    expect_equal(length(cur_cil), 3)
    expect_equal(channelNames(cur_cil), c("Ag107Di", "Pr141Di", "Sm147Di", "Eu153Di", "Yb172Di"))
    expect_equal(names(cur_cil), c("20210305_NE_mockData2_ROI_001_1",  
                                   "20210305_NE_mockData2_ROI_002_2", 
                                   "20210305_NE_mockData2_ROI_003_3"))
    
    # Test for numerical correctness
    cur_tiff <- system.file("extdata/mockData/tiffs/20210305_NE_mockData2_s0_a1_ac_fullFiltered.tiff", package = "imcRtools")
    test_cil <- cytomapper::loadImages(cur_tiff, as.is = TRUE)
    
    expect_equal(dim(cur_cil[[1]]), dim(test_cil[[1]]))
    test_1 <- floor(as.array(cur_cil[[1]][,,1]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,1])
    expect_equal(test_1,
                 test_2)
    
    test_1 <- floor(as.array(cur_cil[[1]][,,2]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,2])
    expect_equal(test_1,
                 test_2)
    
    test_1 <- floor(as.array(cur_cil[[1]][,,2]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,2])
    expect_equal(test_1,
                 test_2)
    
    test_1 <- floor(as.array(cur_cil[[1]][,,2]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,2])
    expect_equal(test_1,
                 test_2)
    
    test_1 <- floor(as.array(cur_cil[[1]][,,2]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,2])
    expect_equal(test_1,
                 test_2)
    
    # Read in individual files
    cur_cil <- readImagefromTXT(path, pattern = "ROI_002")
    expect_s4_class(cur_cil, "CytoImageList")
    
    expect_equal(length(cur_cil), 1)
    expect_equal(channelNames(cur_cil), c("Ag107Di", "Pr141Di", "Sm147Di", "Eu153Di", "Yb172Di"))
    expect_equal(names(cur_cil), c("20210305_NE_mockData2_ROI_002_2"))
    
    # Read in different channelNames
    cur_cil <- readImagefromTXT(path, channel_pattern = "[A-Za-z]{2}[0-9]{3}")
    expect_s4_class(cur_cil, "CytoImageList")
    expect_equal(length(cur_cil), 3)
    expect_equal(channelNames(cur_cil), c("Ag107", "Pr141", "Sm147", "Eu153", "Yb172"))
    expect_equal(names(cur_cil), c("20210305_NE_mockData2_ROI_001_1",  
                                   "20210305_NE_mockData2_ROI_002_2", 
                                   "20210305_NE_mockData2_ROI_003_3"))
    
    # Read in single channel
    cur_cil <- readImagefromTXT(path, channel_pattern = "Ag107")
    expect_s4_class(cur_cil, "CytoImageList")
    expect_equal(length(cur_cil), 3)
    expect_equal(channelNames(cur_cil), c("Ag107"))
    expect_equal(names(cur_cil), c("20210305_NE_mockData2_ROI_001_1",  
                                   "20210305_NE_mockData2_ROI_002_2", 
                                   "20210305_NE_mockData2_ROI_003_3"))
    
    test_1 <- floor(as.array(cur_cil[[1]][,,1]))
    dimnames(test_1) <- NULL
    test_2 <- as.array(test_cil[[1]][,,1])
    expect_equal(test_1,
                 test_2)
    
    # parallelisation
    cur_cil <- readImagefromTXT(path,BPPARAM = BiocParallel::bpparam())
    expect_s4_class(cur_cil, "CytoImageList")
    expect_equal(length(cur_cil), 3)
    expect_equal(channelNames(cur_cil), c("Ag107Di", "Pr141Di", "Sm147Di", "Eu153Di", "Yb172Di"))
    expect_equal(names(cur_cil), c("20210305_NE_mockData2_ROI_001_1",  
                                   "20210305_NE_mockData2_ROI_002_2", 
                                   "20210305_NE_mockData2_ROI_003_3"))
    
    # Error
    expect_error(cur_cil <- readImagefromTXT("test"),
                 regexp = "The indicated path does not exist",
                 fixed = TRUE)
    
    expect_error(cur_cil <- readImagefromTXT(1),
                 regexp = "Please provide a string input indicating a path.",
                 fixed = TRUE)
    
    expect_error(cur_cil <- readImagefromTXT(path, pattern = 1),
                 regexp = "'pattern' must be indicated as single character",
                 fixed = TRUE)
    
    expect_error(cur_cil <- readImagefromTXT(path, pattern = "test"),
                 regexp = "The pattern does not match any\nof the files in the provided directory.",
                 fixed = TRUE)
    
    expect_error(cur_cil <- readImagefromTXT(path, index_names = c("test", "test2")),
                 regexp = "'index_names' not in the names of the .txt files.",
                 fixed = TRUE)
    
    expect_error(cur_cil <- readImagefromTXT(path, channel_pattern = "test"),
                 regexp = "'channel_pattern' does not match any entries in the .txt files.",
                 fixed = TRUE)
    
})

#' @title Function to calculate distance to cells of interest
#'
#' @description Function to return the min, max, mean or median distance to the cells of interest
#' for each cell in the data. In the case of patched/clustered cells negative
#' distances are returned by default which indicate the distance of the cells
#' of interest to the cells that are not of the type of cells of
#' interest.
#'
#' @param object a \code{SingleCellExperiment} or \code{SpatialExperiment}
#' object
#' @param x_cells logical vector of length equal to the number of cells
#' contained in \code{object}. \code{TRUE} entries define the cells to which
#' distances will be calculated.
#' @param name character specifying the name of the \code{colData} entry to safe
#' the distances in.
#' @param statistics one of "min", "max", "mean" or "meadian" specifying the distance statistics to use when computing
#' the distances.
#' @param coords character vector of length 2 specifying the names of the
#' \code{colData} (for a \code{SingleCellExperiment} object) or the
#' \code{spatialCoords} entries of the cells' x and y locations.
#' @param img_id single character indicating the \code{colData(object)} entry
#' containing the unique image identifiers.
#' @param return_neg logical indicating whether negative distances are to be
#' returned for the distances of patched/spatially clustered cells.
#' @param BPPARAM a \code{\link[BiocParallel]{BiocParallelParam-class}} object
#' defining how to parallelize computations.
#'
#' @section Ordering of the output object:
#' The \code{minDistToCells} function operates on individual images.
#' Therefore the returned object is grouped by entries in \code{img_id}.
#' This means all cells of a given image are grouped together in the object.
#' The ordering of cells within each individual image is the same as the ordering
#' of these cells in the input object.
#'
#' @return returns an object of \code{class(object)} containing a new column
#' entry to \code{colData(object)[[name]]}. Cells in the object are grouped
#' by entries in \code{img_id}.
#'
#' @examples
#' library(cytomapper)
#' data(pancreasSCE)
#'
#' # Build interaction graph
#' pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
#' type = "expansion",threshold = 20)
#'
#' # Detect patches of "celltype_B" cells
#' pancreasSCE <- patchDetection(pancreasSCE,
#'                              img_id = "ImageNb",
#'                              patch_cells = pancreasSCE$CellType == "celltype_B",
#'                              colPairName = "expansion_interaction_graph",
#'                              min_patch_size = 20,
#'                              expand_by = 1)
#'
#' plotSpatial(pancreasSCE,
#'             img_id = "ImageNb",
#'             node_color_by = "patch_id",
#'             scales = "free")
#'
#' # Distance to celltype_B patches
#' pancreasSCE <- distToCells(pancreasSCE,
#'                              x_cells = !is.na(pancreasSCE$patch_id),
#'                              coords = c("Pos_X","Pos_Y"),
#'                              statistics = "min",
#'                              img_id = "ImageNb")
#'
#' plotSpatial(pancreasSCE,
#'             img_id = "ImageNb",
#'             node_color_by = "distToCells",
#'             scales = "free")
#'
#' @author Daniel Schulz & Bruno Palau (\email{daniel.schulz@@uzh.ch})
#' @importFrom distances distances distance_columns
#' @importFrom MatrixGenerics rowMins rowMaxs rowMeans rowMedians
#' @export
distToCells <- function (object,
                        x_cells,
                        img_id,
                        name = "distToCells",
                        coords = c("Pos_X","Pos_Y"),
                        statistics = "min",
                        return_neg = TRUE,
                        BPPARAM = SerialParam()){
  .valid.distToCells.input(object, x_cells, name, coords, statistics,
                              img_id, return_neg)
  cur_meta <- metadata(object)
  metadata(object) <- list()
  cur_intmeta <- int_metadata(object)
  object$x_cells <- x_cells
  cur_out <- bplapply(
    unique(colData(object)[[img_id]]),
    function(x) {
      cur_obj <- object[, as.character(colData(object)[[img_id]]) == x]
      cur_obj[[name]] <- NA
      if (sum(cur_obj$x_cells) == 0 | sum(cur_obj$x_cells) ==
          ncol(cur_obj)) {
        return(cur_obj)
      }
      patch_cells <- which(cur_obj$x_cells)
      non_patch_cells <- which(!cur_obj$x_cells)
      if (is(object, "SpatialExperiment")) {
        dist_mat <- distances(spatialCoords(cur_obj))
      }
      else {
        dist_mat <- distances(as.matrix(colData(cur_obj)[, coords]))
      }
      pos_dist <- distance_columns(dist_mat, column_indices = patch_cells)
      neg_dist <- distance_columns(dist_mat, column_indices = non_patch_cells)
      dist_to_patch <- switch(statistics,
                              mean = rowMeans(pos_dist),
                              median = rowMedians(pos_dist),
                              min = rowMins(pos_dist),
                              max = rowMaxs(pos_dist))


      if (return_neg == TRUE) {
        dist_from_patch <- switch(statistics,
                                  mean = rowMeans(neg_dist),
                                  median = rowMedians(neg_dist),
                                  min = rowMins(neg_dist),
                                  max = rowMaxs(neg_dist))

        dist_to_patch[cur_obj$x_cells] <- -dist_from_patch[cur_obj$x_cells]
      }
      cur_obj[[name]] <- dist_to_patch
      return(cur_obj)
    }, BPPARAM = BPPARAM)
  cur_out <- do.call("cbind", cur_out)
  cur_out$x_cells <- NULL
  metadata(cur_out) <- cur_meta
  int_metadata(cur_out) <- cur_intmeta
  message("The returned object is ordered by the '", img_id,
          "' entry.")
  return(cur_out)
}

## ----echo=FALSE, results="hide"-----------------------------------------------
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE, crop = NULL)
library(BiocStyle)
library(data.table)

## ----library, echo=FALSE------------------------------------------------------
library(imcRtools)

## ----access-spillover-files---------------------------------------------------
path <- system.file("extdata/spillover", package = "imcRtools")

list.files(path, recursive = TRUE)

## ----access-txt-files---------------------------------------------------------
txt_files <- list.files(system.file("extdata/mockData/raw", 
                                    package = "imcRtools"))
txt_files

## ----imcsegmentationpipeline-data---------------------------------------------
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

list.files(path, recursive = TRUE)

## ----steinbock-data-----------------------------------------------------------
path <- system.file("extdata/mockData/steinbock", package = "imcRtools")

list.files(path, recursive = TRUE)

## ----show_cpout_features------------------------------------------------------
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

show_cpout_features(path)

## ----read_cpout---------------------------------------------------------------
cur_path <- system.file("extdata/mockData/cpout", package = "imcRtools")

# Read as SpatialExperiment
(spe <- read_cpout(cur_path, graph_file = "Object_relationships.csv"))

# Read as SingleCellExperiment
(sce <- read_cpout(cur_path, graph_file = "Object_relationships.csv", 
                   return_as = "sce"))

## ----read_steinbock-----------------------------------------------------------
cur_path <- system.file("extdata/mockData/steinbock", package = "imcRtools")

# Read as SpatialExperiment
(spe <- read_steinbock(cur_path))

# Read as SingleCellExperiment
(sce <- read_steinbock(cur_path, return_as = "sce"))

## ----read-txt-1---------------------------------------------------------------
path <- system.file("extdata/mockData/raw", package = "imcRtools")

cur_CytoImageList <- readImagefromTXT(path)
cur_CytoImageList

## ----read-single-metals txt---------------------------------------------------
path <- system.file("extdata/spillover", package = "imcRtools")
sce <- readSCEfromTXT(path) 
sce

## ----read-single-metals tiff--------------------------------------------------
path <- system.file("extdata/spillover_tiff/img", package = "imcRtools")
image_df_path <- system.file("extdata/spillover_tiff/images.csv", package = "imcRtools")
panel_df_path <- system.file("extdata/spillover_tiff/panel.csv", package = "imcRtools")
sce <- readSCEfromTIFF(path, image_df_path, panel_df_path)
sce

## ----plotSpotHeatmap, fig.width=5, fig.height=5-------------------------------
plotSpotHeatmap(sce)

## ----plotSpotHeatmap-2, fig.width=5, fig.height=5-----------------------------
plotSpotHeatmap(sce, log = FALSE, threshold = 200)

## ----pixel-binning, fig.width=5, fig.height=5---------------------------------
sce2 <- binAcrossPixels(sce, bin_size = 5)

plotSpotHeatmap(sce2, log = FALSE, threshold = 200)

## ----assign-pixels------------------------------------------------------------
library(CATALYST)

bc_key <- as.numeric(unique(sce$sample_mass))
assay(sce, "exprs") <- asinh(counts(sce)/5)
sce <- assignPrelim(sce, bc_key = bc_key)
sce <- estCutoffs(sce)
sce <- applyCutoffs(sce)

# Filter out mislabeled pixels
sce <- filterPixels(sce)

table(sce$bc_id, sce$sample_mass)

## ----estimate-spillover-------------------------------------------------------
sce <- computeSpillmat(sce)
metadata(sce)$spillover_matrix

## ----buildSpatialGraph, message=FALSE-----------------------------------------
library(cytomapper)
data("pancreasSCE")

pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "expansion",
                                 threshold = 20)
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "knn",
                                 k = 5)
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "delaunay")

colPairNames(pancreasSCE)

## ----plotSpatial--------------------------------------------------------------
library(ggplot2)
library(ggraph)

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_shape_by = "ImageNb",
            node_size_by = "Area",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            scales = "free")

# Colored by expression and with arrows
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "PIN",
            assay_type = "exprs",
            node_size_fix = 3,
            edge_width_fix = 0.2,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = TRUE,
            arrow = grid::arrow(length = grid::unit(0.1, "inch")),
            end_cap = ggraph::circle(0.05, "cm"),
            scales = "free")

# Subsetting the SingleCellExperiment
plotSpatial(pancreasSCE[,pancreasSCE$Pattern],
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = TRUE) 

## ----aggregateNeigbors--------------------------------------------------------
pancreasSCE <- aggregateNeighbors(pancreasSCE,
                                  colPairName = "knn_interaction_graph",
                                  aggregate_by = "metadata",
                                  count_by = "CellType")
head(pancreasSCE$aggregatedNeighbors)

pancreasSCE <- aggregateNeighbors(pancreasSCE,
                                  colPairName = "knn_interaction_graph",
                                  aggregate_by = "expression",
                                  assay_type =  "exprs")
head(pancreasSCE$mean_aggregatedExpression)

## ----aggregateNeigbors-clustering---------------------------------------------
set.seed(22)
cur_cluster <- kmeans(pancreasSCE$aggregatedNeighbors, centers = 3)
pancreasSCE$clustered_neighbors <- factor(cur_cluster$cluster)

# Visualize CellType and clustered_neighbors
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 4,
            edge_width_fix = 2,
            edge_color_by = "clustered_neighbors",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_brewer(palette = "Set2") +
    scale_edge_color_brewer(palette = "Set1")

# Visualize clustered_neighbors
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "clustered_neighbors",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")+
    scale_color_brewer(palette = "Set1")

## ----detectSpatialContext-----------------------------------------------------
# Generate k-nearest neighbor graph
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "knn",
                                 name = "knn_spatialcontext_graph",
                                 k = 15)
colPairNames(pancreasSCE)

# Aggregate based on clustered_neighbors
pancreasSCE <- aggregateNeighbors(pancreasSCE, 
                                  colPairName = "knn_spatialcontext_graph",
                                  aggregate_by = "metadata",
                                  count_by = "clustered_neighbors",
                                  name = "aggregatedNeighborhood")

# Detect spatial contexts
pancreasSCE <- detectSpatialContext(pancreasSCE, 
                                    entry = "aggregatedNeighborhood",
                                    threshold = 0.9,
                                    name = "spatial_context")
# Define SC color scheme
col_SC <- setNames(c("#A6CEE3", "#1F78B4", "#B2DF8A", "#33A02C", "#FB9A99", "#E31A1C", "#FDBF6F"), 
                   sort(unique(pancreasSCE$spatial_context)))

# Visualize spatial contexts on images
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)

## ----filterSpatialContext-----------------------------------------------------
# Filter spatial contexts
# By number of group entries
pancreasSCE <- filterSpatialContext(pancreasSCE, 
                            entry = "spatial_context",
                            group_by = "ImageNb", 
                            group_threshold = 2,
                            name = "spatial_context_filtered_group")

metadata(pancreasSCE)$filterSpatialContext

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context_filtered_group",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)

# By total number of cells
pancreasSCE <- filterSpatialContext(pancreasSCE, 
                            entry = "spatial_context",
                            group_by = "ImageNb", 
                            cells_threshold = 15,
                            name = "spatial_context_filtered_cells")

metadata(pancreasSCE)$filterSpatialContext

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context_filtered_cells",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)

## ----plotSpatialContext-------------------------------------------------------
## Plot spatial context graph 
# Default
plotSpatialContext(pancreasSCE,
                   entry = "spatial_context", 
                   group_by = "ImageNb")

# Colored by name and size by n_cells
plotSpatialContext(pancreasSCE, 
                   entry = "spatial_context",
                   group_by = "ImageNb",
                   node_color_by = "name",
                   node_size_by = "n_cells",
                   node_label_color_by = "name")

# Colored by n_cells and size by n_group                   
plotSpatialContext(pancreasSCE, 
                   entry = "spatial_context",
                   group_by = "ImageNb",
                   node_color_by = "n_cells",
                   node_size_by = "n_group",
                   node_label_color_by = "n_cells")+
  scale_color_viridis()

## ----plotSpatialContext - return data-----------------------------------------
# Return data
plotSpatialContext(pancreasSCE,
                   entry = "spatial_context", 
                   group_by = "ImageNb",
                   return_data = TRUE)

## ----detectCommunity----------------------------------------------------------
## Detect spatial community 
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")

## Detect spatial community - specify size_threshold
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               size_threshold = 20)

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")

## ----detectCommunity-walktrap-------------------------------------------------
## Detect spatial community - walktrap community detection
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               cluster_fun = "walktrap")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")

## ----detectCommunity-bygroup--------------------------------------------------
## Detect spatial community - specify group_by
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               group_by = "CellType", 
                               size_threshold = 10,
                               BPPARAM = BiocParallel::SerialParam(RNGseed = 22)) 

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")

## ----findBorderCells----------------------------------------------------------
pancreasSCE <- findBorderCells(pancreasSCE,
                               img_id = "ImageNb",
                               border_dist = 10)

plotSpatial(pancreasSCE[,!pancreasSCE$border_cells],
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 4,
            edge_width_fix = 2,
            edge_color_by = "clustered_neighbors",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_brewer(palette = "Set2") +
    scale_edge_color_brewer(palette = "Set1")

## ----patchDetection-----------------------------------------------------------
pancreasSCE <- patchDetection(pancreasSCE, 
                              patch_cells = pancreasSCE$CellType == "celltype_B",
                              colPairName = "expansion_interaction_graph",
                              expand_by = 20, 
                              img_id = "ImageNb")
 
plotSpatial(pancreasSCE, 
            img_id = "ImageNb", 
            node_color_by = "patch_id",
            scales = "free")

## ----patchSize----------------------------------------------------------------
patchSize(pancreasSCE)

## ----distToCells--------------------------------------------------------------
pancreasSCE <- distToCells(pancreasSCE,
                              x_cells = pancreasSCE$CellType == "celltype_B",
                              coords = c("Pos_X","Pos_Y"),
                              statistics = "min",
                              name = "minDist",
                              img_id = "ImageNb")

pancreasSCE <- distToCells(pancreasSCE,
                              x_cells = pancreasSCE$CellType == "celltype_B",
                              coords = c("Pos_X","Pos_Y"),
                              statistics = "mean",
                              name = "meanDist",
                              img_id = "ImageNb")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "minDist",
            scales = "free") +
    scale_color_viridis()

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "meanDist",
            scales = "free") +
    scale_color_viridis()

## ----countInteractions--------------------------------------------------------
out <- countInteractions(pancreasSCE,
                         group_by = "ImageNb",
                         label = "CellType",
                         method = "classic",
                         colPairName = "knn_interaction_graph")
out

## ----testInteractions---------------------------------------------------------
out <- testInteractions(pancreasSCE,
                        group_by = "ImageNb",
                        label = "CellType",
                        method = "classic",
                        colPairName = "knn_interaction_graph",
                        BPPARAM = BiocParallel::SerialParam(RNGseed = 123))
out

## ----plotInteractions---------------------------------------------------------
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")

## ----plotInteractions-filter data---------------------------------------------
library(dplyr)

out <- out %>% as.data.frame() %>% mutate(pair_id = paste(from_label, to_label, sep = "__"),
                                          is_sig = !is.na(sig))
summary_df <- out %>%
  group_by(pair_id) %>%
  summarise(
    sum_sigval = sum(sigval, na.rm = TRUE),
    total_count = sum(is_sig),
    .groups = "drop"
  ) %>%
  mutate(
    fraction_sig = sum_sigval / total_count,
    int_type = case_when(
      fraction_sig > 0.75 ~ "attraction",
      fraction_sig < -0.75 ~ "repulsion",
      TRUE ~ NA_character_
    )
  ) %>%
  filter(!is.na(int_type))

subset_out <- out %>%
  semi_join(summary_df, by = "pair_id") %>%
  left_join(summary_df %>% select(pair_id, int_type), by = "pair_id")

# Now we can visualise only these filtered edges
plotInteractions(subset_out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")

## ----plotInteractions-edge aesthetics-----------------------------------------
library(ggraph)

edge_color <- setNames(c("blue", "red"),c("attraction", "repulsion"))

plotInteractions(subset_out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 edge_color_by = "int_type",
                 edge_width_by = "ct") +
                 scale_edge_colour_manual(values = edge_color)

## ----plotInteractions-node aesthetics-----------------------------------------
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 node_color_by = "name",
                 node_label_color_by = "name",
                 node_size_by = "n_cells")

# Define custom colors for node and node_label
node_color <- setNames(c("red", "blue", "green"), c("celltype_A", "celltype_B", "celltype_C"))
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 node_color_by = "name",
                 node_label_color_by = "name",
                 node_size_by = "n_cells")+
  scale_color_manual(values = node_color)

## ----plotInteractions-layout--------------------------------------------------
# Default is "circle"
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")

# Chord diagram layout
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 graph_layout = "chord")

# Linear layout
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 graph_layout = "linear")

## ----plotInteractions-return data---------------------------------------------
# return data
plotInteractions(out, pancreasSCE, "CellType", "ImageNb",
                return_data = TRUE)

## ----run-cozi-----------------------------------------------------------------
out <- testInteractions(pancreasSCE,
                        group_by = "ImageNb",
                        label = "CellType",
                        method = "conditional",
                        colPairName = "knn_interaction_graph",
                        BPPARAM = BiocParallel::SerialParam(RNGseed = 123))

## -----------------------------------------------------------------------------
cd <- as.data.table(colData(pancreasSCE))

cond_ratio_df <- as.data.table(colPair(pancreasSCE, "knn_interaction_graph"))[
  , .(from_label = cd$CellType[from],
      to_label   = cd$CellType[to],
      group_by   = cd$ImageNb[from],
      from)
][, .(N = uniqueN(from)), by = .(group_by, from_label, to_label)
][cd[, .(total_from_type = .N), by = .(group_by = ImageNb, from_label = CellType)], 
  on = .(group_by, from_label)
][, .(group_by, from_label, to_label, cond_ratio = N / total_from_type)]

out_cr <- merge(
  as.data.table(out)[, `:=`(
    group_by   = as.integer(group_by),
    from_label = as.character(from_label),
    to_label   = as.character(to_label)
  )],
  cond_ratio_df,
  by = c("group_by", "from_label", "to_label"),
  all.x = TRUE
)

## -----------------------------------------------------------------------------
library(RColorBrewer)

p <- out_cr %>%
  filter(!is.na(zscore), !is.na(cond_ratio), sig) %>%
  ggplot(aes(from_label, to_label, size = cond_ratio, color = zscore)) +
  geom_point() +
  theme_bw() +
  scale_size(range = c(1,10)) +
  scale_color_gradient2(low = brewer.pal(11,"RdBu")[10], mid = "white", high = brewer.pal(11,"RdBu")[2], midpoint = 0) +
  facet_wrap(~group_by)

p

## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' @title Summarizes and visualizes the pixel intensities per spot and channel
#'
#' @description Helper function for estimating the spillover matrix. This
#' function visualizes the median pixel intensities per spot (rows) and per
#' channel (columns) in form of a heatmap.
#'
#' @param object a \code{SingleCellExperiment} object containing pixel
#' intensities per channel. Individual pixels are stored as columns and
#' channels are stored as rows.
#' @param spot_id character string indicating which \code{colData(object)} entry
#' stores the isotope names of the spotted metal. Entries should be of the 
#' form (mt)(mass) (e.g. Sm152 for Samarium isotope with the atomic mass 152).
#' @param channel_id character string indicating which \code{rowData(object)} 
#' entry contains the isotope names of the acquired channels. 
#' @param assay_type character string indicating which assay to use (default
#' \code{counts}).
#' @param statistic the statistic to use when aggregating channels per spot
#' (default \code{median})
#' @param log should the aggregated pixel intensities be \code{log10(x + 1)} 
#' transformed?
#' @param threshold single numeric indicating a threshold after pixel
#' aggregation. All aggregated values larger than \code{threshold} will be
#' labeled as \code{1}.
#' @param order_metals should the metals be ordered based on spotted mass?
#' @param color see parameter in \code{\link[pheatmap]{pheatmap}}
#' @param breaks see parameter in \code{\link[pheatmap]{pheatmap}}
#' @param legend_breaks see parameter in \code{\link[pheatmap]{pheatmap}}
#' @param cluster_cols see parameter in \code{\link[pheatmap]{pheatmap}}
#' @param cluster_rows see parameter in \code{\link[pheatmap]{pheatmap}}
#' @param ... other arguments passed to \code{pheatmap}.
#' 
#' @section Quality control for spillover estimation:
#' Visualizing the aggregated pixel intensities serves two purposes:
#' 
#' \enumerate{
#' \item Small median pixel intensities (< 200 counts) might hinder the robust
#' estimation of the channel spillover. In that case, consecutive pixels can be
#' summed (see \code{\link{binAcrossPixels}}).
#' \item Each spotted metal (row) should show the highest median pixel intensity
#' in its corresponding channel (column). If this is not the case, either the
#' naming of the .txt files was incorrect or the incorrect metal was spotted.
#' }
#' 
#' By setting the \code{threshold} parameter, the user can easily identify spots
#' where pixel intensities are too low for robust spillover estimation. 
#' 
#' @return a \code{\link[pheatmap]{pheatmap}} object
#'
#' @examples
#' path <- system.file("extdata/spillover", package = "imcRtools")
#' # Read in .txt files
#' sce <- readSCEfromTXT(path)
#' 
#' # Visualizes heatmap
#' plotSpotHeatmap(sce)
#' 
#' # Visualizes thresholding results
#' plotSpotHeatmap(sce, log = FALSE, threshold = 200)
#' 
#' @seealso \code{\link[pheatmap]{pheatmap}} for visual modifications
#' @seealso \code{\link[scrapper]{aggregateAcrossCells}} for the aggregation
#' function
#' 
#' @author Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @importFrom pheatmap pheatmap
#' @importFrom scrapper aggregateAcrossCells
#' @importFrom viridis viridis
#' @importFrom stringr str_extract
#' @importFrom SummarizedExperiment assay
#' @export
plotSpotHeatmap <- function(object, 
                            spot_id = "sample_id",
                            channel_id = "channel_name",
                            assay_type = "counts",
                            statistic = "median",
                            log = TRUE,
                            threshold = NULL,
                            order_metals = TRUE,
                            color = viridis(100),
                            breaks = NA,
                            legend_breaks = NA,
                            cluster_cols = FALSE,
                            cluster_rows = FALSE,
                            ...){
    
    .valid.plotSpotHeatmap.input(object, spot_id, channel_id, assay_type, 
                            log, threshold, order_metals)
    
    if (!statistic %in% c("median", "mean", "sum")) {
        stop("'statistic' must be either 'median', 'mean' or 'sum'")
    }
    
  cur_out <- aggregateAcrossCells(assay(object,assay_type),
                                  factors = list(spot_id = object[[spot_id]]),
                                  compute.median = TRUE)
  
  spot_names <- cur_out$combinations
  #### check here
  if (statistic == "mean") {
    cur_out <- t(cur_out$sums)/cur_out$counts
  } else if (statistic == "sum") {
    cur_out <- cur_out$sums
  } else if (statistic == "median") {
    cur_out <- cur_out$medians
  }
  
  if (log) {
    cur_mat <- log10(cur_out+1)
  } else {
    cur_mat <- cur_out
  }
  
  if (!is.null(threshold)) {
    cur_mat <- (cur_mat > threshold) * 1
    
    if (is.na(breaks)) { 
      breaks <- c(0, 0.5, 1)
    }
    
    if (is.na(legend_breaks)) { 
      legend_breaks <- c(0, 1)
    }
    
    color <- c(color[1], color[length(color)])
  }
  
  colnames(cur_mat) <- rowData(object)$marker_name
  rownames(cur_mat) <- rowData(object)[[channel_id]]
  
  # Order rows and cols based on spot metal
  if (order_metals) {
    cur_spots <- colnames(cur_mat)
    cur_mass <- as.numeric(str_extract(cur_spots, "[0-9]{2,3}$"))
    cur_spots <- cur_spots[order(cur_mass)]
    
    cur_channels <- rownames(cur_mat)
    cur_mass <- as.numeric(str_extract(cur_channels, "[0-9]{2,3}"))
    cur_channels <- cur_channels[order(cur_mass)]
    cur_isotope <- str_extract(cur_channels, "[A-Za-z]{1,2}[0-9]{2,3}")
    cur_rownames <- c(cur_channels[cur_isotope %in% cur_spots],
                      cur_channels[!cur_isotope %in% cur_spots])
    
    cur_mat <- cur_mat[cur_rownames,cur_spots]
    
    cluster_cols <- FALSE
    cluster_rows <- FALSE
  }
  
  # Transposed to match the CATALYST visualization
  pheatmap(t(cur_mat), color = color, 
           cluster_cols = cluster_cols,
           cluster_rows = cluster_rows, 
           breaks = breaks, legend_breaks = legend_breaks,
           ...)
}

#' @title Filter pixels based on their assigned masses
#'
#' @description Helper function for estimating the spillover matrix. After
#' assigning each pixel to a spotted mass, this function will filter 
#' incorrectly assigned pixels and remove small pixel sets.
#'
#' @param object a \code{SingleCellExperiment} object containing pixel
#' intensities per channel. Individual pixels are stored as columns and
#' channels are stored as rows.
#' @param bc_id character string indicating which \code{colData(object)} entry
#' stores the estimated mass 
#' @param spot_mass character string indicating which \code{colData(object)} 
#' entry stores the true isotope mass of the spotted metal. 
#' @param minevents single numeric indicating the threshold under which pixel
#' sets are excluded from spillover estimation.
#' @param correct_pixels logical indicating if incorrectly assigned pixels 
#' should be excluded from spillover estimation.
#'
#' @return returns a SingleCellExperiment object in which
#' \code{colData(object)$bc_id} has been adjusted based on the filter
#' criteria.
#'
#' @examples
#' path <- system.file("extdata/spillover", package = "imcRtools")
#' sce <- readSCEfromTXT(path)
#' assay(sce, "exprs") <- asinh(counts(sce)/5)
#' 
#' # Pre-process via CATALYST
#' library(CATALYST)
#' 
#' bc_key <- as.numeric(unique(sce$sample_mass))
#' sce <- assignPrelim(sce, bc_key = bc_key)
#' sce <- estCutoffs(sce)
#' sce <- applyCutoffs(sce)
#' 
#' sce <- filterPixels(sce)
#' 
#' table(sce$sample_mass, sce$bc_id)
#' 
#' @author Vito Zanotelli, adapted by 
#' Nils Eling (\email{nils.eling@@dqbm.uzh.ch})
#'
#' @importFrom SummarizedExperiment colData<-
#' @export
filterPixels <- function(object, 
                            bc_id = "bc_id",
                            spot_mass = "sample_mass",
                            minevents = 40,
                            correct_pixels = TRUE){
    
    .valid.filterPixels.input(object, bc_id, spot_mass, minevents, 
                                correct_pixels)

    cur_bcs <- as.character(colData(object)[[bc_id]])    
    cur_mass <- as.character(colData(object)[[spot_mass]])   

    if (correct_pixels) {
        cur_bcs[cur_bcs != "0" & cur_bcs != cur_mass] <- "0"
    }
    
    cur_stats <- table(cur_bcs)
    nonfreq <- names(cur_stats)[cur_stats < minevents]
    cur_bcs[cur_bcs %in% nonfreq] <- "0"
    
    colData(object)[[bc_id]] <- cur_bcs
    
    return(object)
}

#!/usr/bin/env bash

base_dir=$(cd -- "$(dirname "${BASH_SOURCE[0]}")" && pwd -P)
steinbock="docker run -v ${base_dir}:/data -v /tmp/.X11-unix:/tmp/.X11-unix -v ${HOME}/.Xauthority:/home/steinbock/.Xauthority:ro -e DISPLAY ghcr.io/bodenmillergroup/steinbock:0.16.1"

cd "${base_dir}"

cp -r ../raw .
cp ../panel.csv raw
$steinbock preprocess imc panel
$steinbock preprocess imc images --hpf 50

$steinbock classify ilastik prepare --cropsize 50 --seed 123
cp ../ilastik.ilp pixel_classifier.ilp
rm -r ilastik_crops && mkdir ilastik_crops && cp -r ../analysis/ilastik/*.h5 ilastik_crops
$steinbock classify ilastik fix --no-backup
$steinbock classify ilastik run

$steinbock segment cellprofiler prepare
$steinbock segment cellprofiler run -o masks_ilastik

$steinbock measure intensities --masks masks_ilastik -o intensities_ilastik
$steinbock measure regionprops --masks masks_ilastik -o regionprops_ilastik
$steinbock measure neighbors --type expansion --dmax 4 --masks masks_ilastik -o neighbors_ilastik
$steinbock measure cellprofiler prepare --masks masks_ilastik
$steinbock measure cellprofiler run

# deep learning-based segmentation
$steinbock segment deepcell --minmax -o masks_deepcell

# measurement
$steinbock measure intensities --masks masks_deepcell -o intensities_deepcell
$steinbock measure regionprops --masks masks_deepcell -o regionprops_deepcell
$steinbock measure neighbors --masks masks_deepcell --type expansion --dmax 4 -o neighbors_deepcell

$steinbock export ome
$steinbock export csv intensities_deepcell regionprops_deepcell -o cells.csv
$steinbock export fcs intensities_deepcell regionprops_deepcell -o cells.fcs
$steinbock export anndata --intensities intensities_deepcell --data regionprops_deepcell --neighbors neighbors_deepcell -o cells.h5ad
$steinbock export graphs --data intensities_deepcell --data regionprops_deepcell --neighbors neighbors_deepcell

---
title: "Download test  IMC data - steinbock"
author: "Nils Eling"
date: "`r Sys.Date()`"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

This script downloads the steinbock output of a small test dataset.
The Github repository containing this data can be accessed [here](https://github.com/BodenmillerGroup/TestData).

More specifically, we will use the `210308_ImcTestData` dataset.

## Download the steinbock output

Here, we will first download the output of the [steinbock](https://github.com/BodenmillerGroup/steinbock).
For this, we an use the automatically generated Github assets.

```{r download-cpout}
cur_url <- "https://github.com/BodenmillerGroup/TestData/releases/download/v1.0.10/210308_ImcTestData_steinbock.tar.gz"

download.file(cur_url, "210308_ImcTestData_steinbock.tar.gz")
untar("210308_ImcTestData_steinbock.tar.gz")
unlink("210308_ImcTestData_steinbock.tar.gz")
```

## Only copy the needed files

For reading in the single-cell features, we will only need to copy the .csv files and the folders containing the individual measurements.

```{r copy-files, message=FALSE}
files_of_interest <- c("panel.csv", "steinbock.sh", "images.csv")

folders_of_interest <- c("neighbors", "intensities", "regionprops")

lapply(folders_of_interest, function(x){
    dir.create(paste0("../extdata/mockData/steinbock/", x))
    file.copy(list.files(paste0("datasets/210308_ImcTestData/steinbock/", x, "_deepcell"), 
                         full.names = TRUE),
          paste0("../extdata/mockData/steinbock/", x), 
          overwrite = TRUE)
})

file.copy(paste0("datasets/210308_ImcTestData/steinbock/", files_of_interest),
          "../extdata/mockData/steinbock/", 
          overwrite = TRUE)
unlink("datasets/", recursive = TRUE)
```

---
title: "Download test  IMC data - cp out"
author: "Nils Eling"
date: "`r Sys.Date()`"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

This script downloads the CellProfiler output of a small test dataset.
The Github repository containing this data can be accessed [here](https://github.com/BodenmillerGroup/TestData).

More specifically, we will use the `210308_ImcTestData` dataset.

## Download the CellProfiler output

Here, we will first download the output of the standard [ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline).
For this, we an use the automatically generated Github assets.

```{r download-cpout}
cur_url <- "https://github.com/BodenmillerGroup/TestData/releases/download/v1.0.10/210308_ImcTestData_analysis_cpout.tar.gz"

download.file(cur_url, "210308_ImcTestData_analysis_cpout.tar.gz")
untar("210308_ImcTestData_analysis_cpout.tar.gz")
unlink("210308_ImcTestData_analysis_cpout.tar.gz")
```

## Only copy the .csv files

For reading in the single-cell features, we will only need to copy the .csv files of the output folder. 

```{r copy-csv, message=FALSE}
file.copy(list.files("datasets/210308_ImcTestData/analysis/cpout/", pattern = ".csv$", full.names = TRUE),
          "../extdata/mockData/cpout", overwrite = TRUE)
unlink("datasets/", recursive = TRUE)
```

## Rename object relationship file

This needs to be done to avoid an R CMD check warning indicating an invalid file
name.

```{r rename-object-relationship}
file.rename("../extdata/mockData/cpout/Object relationships.csv",
            "../extdata/mockData/cpout/Object_relationships.csv")
```

---
title: "Download test  IMC data"
author: "Nils Eling"
date: "`r Sys.Date()`"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

This script downloads and subsets test IMC data that were acquired for general purpose testing.
The Github repository containing this data can be accessed [here](https://github.com/BodenmillerGroup/TestData).

More specifically, we will use the `210308_ImcTestData` dataset.

## Download the .txt files

Here, we will first download the raw data in form of .txt files.
For this, we an use the automatically generated Github assets.

```{r download-txt}
cur_url <- "https://github.com/BodenmillerGroup/TestData/releases/download/v1.0.2/210308_ImcTestData_raw.tar.gz"

download.file(cur_url, "210308_ImcTestData_raw.tar.gz")
untar("210308_ImcTestData_raw.tar.gz")
unlink("210308_ImcTestData_raw.tar.gz")
```

## Subset and move the data

Here, we will move the .txt files of one raw data file to the `mockData` folder

```{r subset-txt, message=FALSE}
file.copy(list.files("datasets/210308_ImcTestData/raw/20210305_NE_mockData2/", pattern = ".txt$", full.names = TRUE),
          "../extdata/mockData/raw", overwrite = TRUE)
unlink("datasets/", recursive = TRUE)
```

## Download the corresponding tiff files

Here, we will download the `.tiff` files asset.

```{r download-tiff}
cur_url <- "https://github.com/BodenmillerGroup/TestData/releases/download/v1.0.2/210308_ImcTestData_analysis_cpout_images.tar.gz"

download.file(cur_url, "210308_ImcTestData_analysis_cpout_images.tar.gz")
untar("210308_ImcTestData_analysis_cpout_images.tar.gz")
unlink("210308_ImcTestData_analysis_cpout_images.tar.gz")
```

And copy them to the right location.

```{r move-tiff}
file.copy("datasets/210308_ImcTestData/analysis/cpout/images/20210305_NE_mockData2_s0_a1_ac_fullFiltered.tiff",
          "../extdata/mockData/tiffs/", overwrite = TRUE)
unlink("datasets/", recursive = TRUE)
```

---
title: "Download example spillover data"
author: "Nils Eling"
date: "`r Sys.Date()`"
output: html_document
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
```

This script downloads and re-formats example data for spillover correction.
As test data, we use the files that are provided by the following publication:

[Chevrier, Stéphane, Helena L. Crowell, Vito R. T. Zanotelli, Stefanie Engler, Mark D. Robinson, and Bernd Bodenmiller. 2017. “Compensation of Signal Spillover in Suspension and Imaging Mass Cytometry.” Cell Systems 6: 612–20.](https://www.cell.com/cell-systems/fulltext/S2405-4712(18)30063-2)

They can be accessed from [https://data.mendeley.com/datasets/v58yj49pfr/1](https://data.mendeley.com/datasets/v58yj49pfr/1).

More specificaly, the spillover files are part of `Figure S5`.

## Download the data

Here, we will first download the data.

```{r download-data}
sm_url <- "https://data.mendeley.com/public-files/datasets/v58yj49pfr/files/b39223d2-2825-4e79-9875-86fa0e1c55d2/file_downloaded?dl=1"

download.file(sm_url, "Figure_S5.zip")
unzip("Figure_S5.zip", overwrite=TRUE)
unlink("Figure_S5.zip")
```

## Read in and subset the data

We will now prepare a subsample of the data for testing purposes:

```{r subset-data, message=FALSE}
library(readr)
library(stringr)
full_txt <- list.files("Figure_S5/Spillover_Matrix_1/", pattern = "Dy161|Dy162|Dy163|Dy164", full.names = TRUE)
full_txt_names <- list.files("Figure_S5/Spillover_Matrix_1/", pattern = "Dy161|Dy162|Dy163|Dy164")
full_txt_names <- str_extract(full_txt_names, "^Dy[1-9]{3}")

full_txt <- lapply(full_txt, read_delim, delim = "\t")

## Subset to first 100 rows
full_txt <- lapply(full_txt, function(x){x[seq_len(100),]})

## Subset to specific channels
full_txt <- lapply(full_txt, function(x){x[,colnames(x) %in% 
                                               c("Start_push", "End_push", "Pushes_duration",
                                                 "X", "Y", "Z", "161Dy(Dy161Di)", 
                                                 "162Dy(Dy162Di)", "163Dy(Dy163Di)", "164Dy(Dy164Di)")]})
```

## Write out files

We will now save the processed files.

```{r save-files}
dir.create("../extdata/spillover")
for (i in seq_len(length(full_txt))) {
    write_delim(full_txt[[i]], 
                file = paste0("../extdata/spillover/", full_txt_names[i], ".txt"),
                delim = "\t")
}
```

## Remove unnecessary files

Finally, we remove all unneeded files:

```{r remove-files}
unlink("Figure_S5/", recursive = TRUE)
```

---
title: "Tools for IMC data analysis"
date: "`r BiocStyle::doc_date()`"
package: "`r BiocStyle::pkg_ver('imcRtools')`"
author:
- name: Nils Eling
  affiliation: 
  - Department for Quantitative Biomedicine, University of Zurich
  - Institute for Molecular Health Sciences, ETH Zurich
  email: nils.eling@dqbm.uzh.ch
- name: Lasse Meyer
  affiliation: 
  - Department for Quantitative Biomedicine, University of Zurich
  - Institute for Molecular Health Sciences, ETH Zurich
  email: lasse.meyer@@uzh.ch
- name: Daniel Schulz
  affiliation: 
  - Department for Quantitative Biomedicine, University of Zurich
  - Institute for Molecular Health Sciences, ETH Zurich
  email: daniel.schulz@@uzh.ch
output:
    BiocStyle::html_document:
        toc_float: yes
bibliography: library.bib
abstract: |
    This R package supports the handling and analysis of imaging mass cytometry 
    and other highly multiplexed imaging data. The main functionality includes 
    reading in single-cell data after image segmentation and measurement, data 
    formatting to perform channel spillover correction and a number of spatial 
    analysis approaches. First, cell-cell interactions are detected via spatial 
    graph construction; these graphs can be visualized with cells representing 
    nodes and interactions representing edges. Furthermore, per cell, its direct 
    neighbours are summarized to allow spatial clustering. Per image/grouping 
    level, interactions between types of cells are counted, averaged and 
    compared against random permutations. In that way, types of cells that 
    interact more (attraction) or less (avoidance) frequently than expected by 
    chance are detected. 
vignette: |
    %\VignetteIndexEntry{"Tools for IMC data analysis"}
    %\VignetteEncoding{UTF-8}
    %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  markdown: 
    wrap: 72
  chunk_output_type: console
---

```{r, echo=FALSE, results="hide"}
knitr::opts_chunk$set(error=FALSE, warning=FALSE, message=FALSE, crop = NULL)
library(BiocStyle)
library(data.table)
```

```{r library, echo=FALSE}
library(imcRtools)
```

# Introduction

This vignette gives an introduction to handling and analyzing imaging
mass cytometry (IMC) and other highly-multiplexed imaging data in R. The
`imcRtools` package relies on expression and morphological features
extracted from multi-channel images using corresponding segmentation
masks. A description of data types and segmentation approaches can be
found below ([data types](#dataTypes), [segmentation](#segmentation)).
However, due to shared data structures, the functionalities of the
`imcRtools` package are applicable to most highly multiplexed imaging
modalities.

## Overview

The `imcRtools` package exports functions and example data to perform
the following analyses:

1.  [Read in pre-processed data](#read-in-data)
2.  [Perform spillover correction for IMC data](#spillover)
3.  [Build](#build-graph) and [visualize](#viz-cells) spatial graphs
4.  [Aggregate across neighbouring cells](#aggregate-neighbors) for
    spatial clustering
5.  [Detect spatial patches](#patch-detection) of similar cell-types
6.  [Test the attraction or avoidance between
    celltypes](#test-neighborhood)

To highlight the usability of these function, the `imcRtools` package
also exports a number of [test data files](#test-data).

## Highly multiplexed imaging

Highly multiplexed imaging techniques [@Bodenmiller2016] such as imaging
mass cytometry (IMC) [@Giesen2014], multiplexed ion beam imaging (MIBI)
[@Angelo2014] and cyclic immunofluorescence techniques [@Lin2018,
@Gut2018] acquire read-outs of the expression of tens of protein in a
spatially resolved manner. After technology-dependent data
pre-processing, the raw data files are comparable: multi-channel images
for the dimensions `x`, `y`, and `c`, where `x` and `y` define the
number of pixels (`x * y`) per image and `c` the number of proteins
(also refered to as "markers") measured per image. More info on the
[data types](#dataTypes) and [further pre-processing](#segmentation) can
be found below.

Increased multiplexity compared to epitope-based techniques is achieved
using single-cell resolved spatial transcriptomics techniques including
MERFISH [@Chen2015] and seqFISH [@Lubeck2014]. However, data produced by
these techniques required different pre-processing steps. Nevertheless,
analysis performed on the single-cell level is equally applicable.

### Imaging mass cytometry

IMC [@Giesen2014] is a highly multiplexed imaging approach to measure
spatial protein abundance. In IMC, tissue sections on slides are stained
with a mix of around 40 metal-conjugated antibodies prior to laser
ablation with $1\mu{}m$ resolution. The ablated material is transferred
to a mass cytometer for time-of-flight detection of the metal ions
[@Giesen2014]. At an ablation frequency of 200Hz, a 1mm x 1mm region can
be acquired within 1.5 hours.

### Data types {#dataTypes}

In the case of IMC, the raw data output are .mcd files containing all
acquired regions per slide. During image pre-prcoessing these files are
converted into individual multi-channel .tiff and
[OME-TIFF](https://docs.openmicroscopy.org/ome-model/5.6.3/ome-tiff/)
files. These file formats are supported by most open-source and
commercial image analysis software, such as
[Fiji](https://imagej.net/software/fiji/),
[QuPath](https://qupath.github.io/) or [napari](https://napari.org/).

In R, these .tiff files can be read into individual
[Image](https://bioconductor.org/packages/release/bioc/vignettes/EBImage/inst/doc/EBImage-introduction.html#3_Image_data_representation)
objects or combined into a
[CytoImageList](https://www.bioconductor.org/packages/release/bioc/vignettes/cytomapper/inst/doc/cytomapper.html#5_The_CytoImageList_object)
object supported by the
[cytomapper](https://www.bioconductor.org/packages/release/bioc/html/cytomapper.html)
package.

### Segmentation and feature extraction {#segmentation}

The pixel resolution of most highly multiplexed imaging technologies
including IMC support the detection of cellular structures. Therefore, a
common processing step using multi-channel images is object
segmentation. In this vignette, objects are defined as cells; however,
also larger scale structures could be segmented.

There are multiple different image segmentation approaches available.
However, `imcRtools` only supports direct reader functions for two
segmentation strategies developed for highly multiplexed imaging
technologies:

1.  The
    [ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline)
    has been developed to give the user flexibility in how to perform
    channel selection and image segmentation. The underlying principle
    is to train a pixel classifier (using
    [ilastik](https://www.ilastik.org/)) on a number of selected
    channels to perform probabilistic classification of each pixel into:
    background, cytoplasm and nucleus. Based on these classification
    probabilities a [CellProfiler](https://cellprofiler.org/) pipeline
    performs cell segmentation and feature extraction.

2.  A containerized version of this pipeline is implemented in
    [steinbock](https://github.com/BodenmillerGroup/steinbock).
    `steinbock` further supports segmentation via the use of `Mesmer`
    from the `DeepCell` library [@Greenwald2021].

While the output of both approaches is structured differently, the
exported features are comparable:

1.  per cell: channel intensity, morphology and location
2.  cell-cell interactions exported as graph

By combining these with availabel channel information, the data can be
read into a `r BiocStyle::Biocpkg("SpatialExperiment")` or
`r BiocStyle::Biocpkg("SingleCellExperiment")` object (see
[below](#read-in-data)).

# Example data {#test-data}

The `imcRtools` package contains a number of example data generated by
the Hyperion imaging system for different purposes. The following
section gives an overview of these files.

## For spillover correction

To highlight the use of the `imcRtools` package for spillover
correction, we provide four .txt files containing pixel intensities of
four spotted metals.

Please refer to the [spillover correction](#spillover) section for full
details.

These files are accessible via:

```{r access-spillover-files}
path <- system.file("extdata/spillover", package = "imcRtools")

list.files(path, recursive = TRUE)
```

## Raw data in form of .txt files

IMC generates .mcd files storing the raw data or all acquired regions of
interest (ROI). In addition, the raw pixel values are also stored in
individual .txt files per ROI.

To highlight reading in raw data in form of .txt files, the `imcRtools`
contains 3 sample acquisitions:

```{r access-txt-files}
txt_files <- list.files(system.file("extdata/mockData/raw", 
                                    package = "imcRtools"))
txt_files
```

## ImcSegmentationPipeline output data

IMC data preprocessing and segmentation can be performed using the
[ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline).
It generates a number of `.csv` files containing object/cell-specific
and image-specific metadata.

The `imcRtools` package exports the `read_cpout` function as convenient
reader function for outputs generated by the `ImcSegmentationPipeline`.
For demonstration purposes, `imcRtools` contains the output of running
the pipeline on a small example dataset:

```{r imcsegmentationpipeline-data}
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

list.files(path, recursive = TRUE)
```

## steinbock output data

The [steinbock](https://github.com/BodenmillerGroup/steinbock) pipeline
can be used to process, segment and extract features from IMC data. For
more information, please refer to its
[documentation](https://bodenmillergroup.github.io/steinbock/).

To highlight the functionality of `imcRtools` to read in single-cell
data generated by `steinbock`, we provide a small toy dataset available
at:

```{r steinbock-data}
path <- system.file("extdata/mockData/steinbock", package = "imcRtools")

list.files(path, recursive = TRUE)
```

The example data related to the `ImcSegmentationPipeline` and
`steinbock` can also be accessed
[online](https://github.com/BodenmillerGroup/TestData/tree/main/datasets/210308_ImcTestData).

# Read in IMC data {#read-in-data}

The `imcRtools` package supports reading in data generated by the
[ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline)
or [steinbock](https://github.com/BodenmillerGroup/steinbock) pipeline.

To read in the outpout data into a
`r BiocStyle::Biocpkg("SpatialExperiment")` or
`r BiocStyle::Biocpkg("SingleCellExperiment")`, the `imcRtools` package
exports the `read_cpout` function.

By default, the single-cell data is read into a
`r BiocStyle::Biocpkg("SpatialExperiment")` object. Here, the extracted
channel- and cell-specific intensities are stored in the `counts(spe)`
slot. All morphological features are stored in `colData(spe)` and the
spatial locations of the cells are stored in `spatialCoords(spe)`. The
interaction graph is stored in `colPair(spe, "neighbourhood")`.

Alternatively, the data can be read into a
`r BiocStyle::Biocpkg("SingleCellExperiment")` object. The only
difference is the lack of `spatialCoords(sce)`. Here, the spatial
coordinates are stored in `colData(spe)$Pos_X` and `colData(spe)$Pos_Y`.

## Read in CellProfiler output

The
[ImcSegmentationPipeline](https://github.com/BodenmillerGroup/ImcSegmentationPipeline)
produces a number of output files. By default, all single-cell features
are measured and exported. To browse and select the features of
interest, the `imcRtools` package provides the `show_cpout_features`
function:

```{r show_cpout_features}
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

show_cpout_features(path)
```

By default, `read_cpout` will read in the mean intensity per channel and
cell from "hot pixel" filtered image stacks specified via
`intensities = "Intensity_MeanIntensity_FullStackFiltered"`. Please
refer to `?read_cpout` for the full documentation.

```{r read_cpout}
cur_path <- system.file("extdata/mockData/cpout", package = "imcRtools")

# Read as SpatialExperiment
(spe <- read_cpout(cur_path, graph_file = "Object_relationships.csv"))

# Read as SingleCellExperiment
(sce <- read_cpout(cur_path, graph_file = "Object_relationships.csv", 
                   return_as = "sce"))
```

## Read in steinbock output

Single-cell data and all associated metadata (e.g. spatial location,
morphology and interaction graphs) as produced by the
[steinbock](https://github.com/BodenmillerGroup/steinbock) pipeline can
be read in using the `read_steinbock` function:

```{r read_steinbock}
cur_path <- system.file("extdata/mockData/steinbock", package = "imcRtools")

# Read as SpatialExperiment
(spe <- read_steinbock(cur_path))

# Read as SingleCellExperiment
(sce <- read_steinbock(cur_path, return_as = "sce"))
```

For more information, please refer to `?read_steinbock`.

## Read raw .txt files into Image objects

For reading in and visualization of multi-channel images and
segmentation masks, please refer to the
`r BiocStyle::Biocpkg("cytomapper")` package. The `imcRtools` package
however supports reading in raw .txt files generated by the Hyperion
imaging system into a `CytoImageList` object; a data container exported
by `cytomapper`.

The user needs to provide a path from which all .txt files will be read
in:

```{r read-txt-1}
path <- system.file("extdata/mockData/raw", package = "imcRtools")

cur_CytoImageList <- readImagefromTXT(path)
cur_CytoImageList
```

By specifying the `pattern` argument, individual or a subset of files
can be read in. For more information, please refer to
`?readImagefromTXT`.

# Spillover correction {#spillover}

When acquiring IMC images, pixel intensities can be influenced by
spillover from neighboring channels. To correct for this, Chevrier *et
al.* have developed a staining protocol to acquire individually spotted
metal isotopes [@Chevrier2017]. Based on these measurements, spillover
into neighboring channels can be quantified to correct pixel
intensities.

The `imcRtools` package provides helper functions that facilitate the
correction of spillover for IMC data. For a full tutorial, please refer
to the [IMC data analysis
book](https://bodenmillergroup.github.io/IMCDataAnalysis/spillover-correction.html).

## Read in the single-spot acquisitions

In the first step, the pixel intensities of individually spotted metals
need to be read into a `SingleCellExperiment` container for downstream
use with the `r BiocStyle::Biocpkg("CATALYST")` package. For this, the
`readSCEfromTXT` function can be used when txt files are available.
The latest generation of IMC machines - XTi - does not produce txt files
anymore. The `readSCEfromTIFF` function can be used to generate a 
`SingleCellExperiment` container from tiff files produced with the 
`steinbock` framework:

# From txt

```{r read-single-metals txt}
path <- system.file("extdata/spillover", package = "imcRtools")
sce <- readSCEfromTXT(path) 
sce
```

# From tiff

```{r read-single-metals tiff}
path <- system.file("extdata/spillover_tiff/img", package = "imcRtools")
image_df_path <- system.file("extdata/spillover_tiff/images.csv", package = "imcRtools")
panel_df_path <- system.file("extdata/spillover_tiff/panel.csv", package = "imcRtools")
sce <- readSCEfromTIFF(path, image_df_path, panel_df_path)
sce
```

Here, the example metal spot files are read in. The spot information are
stored in the `colData(sce)` slot and channel information are stored in
`rowData(sce)`. Each column represents a single pixel.

## Quality control on single-spot acquisitions

In the next step, it is crucial to identify potentially mislabeled spots
or spots with low pixel intensities. The `imcRtools` package exports the
`plotSpotHeatmap` function, which visualizes the aggregated (default
`median`) pixel intensities per spot and per metal:

```{r plotSpotHeatmap, fig.width=5, fig.height=5}
plotSpotHeatmap(sce)
```

Here, high median pixel intensities can be observed in each spot and
their corresponding channels (visualized on the `log10` scale by
default). To quickly identify spot/channel combinations with low signal,
the `threshold` parameter can be set:

```{r plotSpotHeatmap-2, fig.width=5, fig.height=5}
plotSpotHeatmap(sce, log = FALSE, threshold = 200)
```

## Consecutive pixel binning

If pixel intensities are low, spillover estimation might not be robust.
Therefore, the `binAcrossPixels` function can be used to sum consecutive
pixels and enhance the acquired signal. This step is optional for
spillover estimation.

```{r pixel-binning, fig.width=5, fig.height=5 }
sce2 <- binAcrossPixels(sce, bin_size = 5)

plotSpotHeatmap(sce2, log = FALSE, threshold = 200)
```

## Pixel filtering

Prior to spillover estimation, the `r BiocStyle::Biocpkg("CATALYST")`
package provides the `assignPrelim`, `estCutoffs` and `applyCutoffs`
functions to estimate the spotted mass for each pixel based on their
channel intensities. For more information on the spillover estimation
and correction, please refer to the [CATALYST
vignette](https://bioconductor.org/packages/release/bioc/vignettes/CATALYST/inst/doc/preprocessing.html#compensation).

This estimation can be used to identify pixels that cannot be easily
assigned to their spotted mass, potentially indicating pixels with weak
signal. To remove these pixels, the `filterPixels` function can be used.
This function further removes pixels assigned to masses, which only
contain very few pixels.

```{r assign-pixels}
library(CATALYST)

bc_key <- as.numeric(unique(sce$sample_mass))
assay(sce, "exprs") <- asinh(counts(sce)/5)
sce <- assignPrelim(sce, bc_key = bc_key)
sce <- estCutoffs(sce)
sce <- applyCutoffs(sce)

# Filter out mislabeled pixels
sce <- filterPixels(sce)

table(sce$bc_id, sce$sample_mass)
```

## Estimating the spillover matrix

Finally, the pre-processed `SiingleCellExperiment` object can be used to
generate the spillover matrix using the `CATALYST::computeSpillmat`
function:

```{r estimate-spillover}
sce <- computeSpillmat(sce)
metadata(sce)$spillover_matrix
```

This spillover matrix can be directly applied to compensate the
summarized pixel intensities per cell and per channel as described
[here](https://bioconductor.org/packages/release/bioc/vignettes/CATALYST/inst/doc/preprocessing.html#compcytof-compensation-of-mass-cytometry-data).

# Spatial analysis

The following section will highlight functions for spatial analyses of
the data.

## Constructing graphs {#build-graph}

When following the `ImcSegmentationPipeline` or `steinbock` and reading
in the data using the corresponding functions, the generated graphs are
automatically stored in the `colPair(spe, "neighborhood")` slot.
Alternatively, the `buildSpatialGraph` function in the `imcRtools`
package constructs interaction graphs using either (i) cell-centroid
expansion, (ii) k-nearest neighbor search or (iii) delaunay
triangulation.

```{r buildSpatialGraph, message=FALSE}
library(cytomapper)
data("pancreasSCE")

pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "expansion",
                                 threshold = 20)
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "knn",
                                 k = 5)
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "delaunay")

colPairNames(pancreasSCE)
```

When setting `type = "knn"`, by default a directional graph will be
build. Setting `directed = FALSE` will create bi-directional edges for
each pair of cells that are connected by at least one edge in the
directed setting.

## Graph/cell visualization {#viz-cells}

The cells' locations and constructed graphs can be visualized using the
`plotSpatial` function. Here, cells are referred to as "nodes" and
cell-cell interactions are referred to as "edges". All visual attributes
of the nodes and edges can be set. Either by specifying a variable in
`colData(spe)`, a marker name or a single entry using the `*_fix`
parameters. By default the `plotSpatial` function will visualize equal physical 
units on the x- and y-axis with an aspect ratio of 1. The example data are
located in different regions of an image and we therefore set `scales = "free"`
for simpler visualization.


```{r plotSpatial}
library(ggplot2)
library(ggraph)

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_shape_by = "ImageNb",
            node_size_by = "Area",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            scales = "free")

# Colored by expression and with arrows
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "PIN",
            assay_type = "exprs",
            node_size_fix = 3,
            edge_width_fix = 0.2,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = TRUE,
            arrow = grid::arrow(length = grid::unit(0.1, "inch")),
            end_cap = ggraph::circle(0.05, "cm"),
            scales = "free")

# Subsetting the SingleCellExperiment
plotSpatial(pancreasSCE[,pancreasSCE$Pattern],
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = TRUE) 
```

The returned object can be further modified using the `ggplot2` logic.
This includes changing the node color, shape and size using
`scale_color_*`, `scale_shape_*` and `scale_size_*`. Edge attributes can
be altered using the `scale_edge_*` function exported by `ggraph`,

## Neighborhood aggregation {#aggregate-neighbors}

The `aggregateNeighbors` function can be used to aggregate features of
all neighboring cells for each individual cell. This function operates
in two settings.

1.  `metadata`: when aggregating by cell-specific metadata, the function
    computes the relative frequencies of all entries to
    `colData(sce)[[count_by]]` within the direct neighborhood of each
    cell.\
2.  `expression`: the expression counts of neighboring cells are
    aggregated using the specified `statistic` (defaults to `mean`).

Each cell's neighborhood is defined as endpoints of edges stored in
`colPair(sce, colPairName)`.

```{r aggregateNeigbors}
pancreasSCE <- aggregateNeighbors(pancreasSCE,
                                  colPairName = "knn_interaction_graph",
                                  aggregate_by = "metadata",
                                  count_by = "CellType")
head(pancreasSCE$aggregatedNeighbors)

pancreasSCE <- aggregateNeighbors(pancreasSCE,
                                  colPairName = "knn_interaction_graph",
                                  aggregate_by = "expression",
                                  assay_type =  "exprs")
head(pancreasSCE$mean_aggregatedExpression)
```

The returned entries can now be used for clustering to group cells based
on their environment (either by aggregated categorical features or
expression).

```{r aggregateNeigbors-clustering}
set.seed(22)
cur_cluster <- kmeans(pancreasSCE$aggregatedNeighbors, centers = 3)
pancreasSCE$clustered_neighbors <- factor(cur_cluster$cluster)

# Visualize CellType and clustered_neighbors
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 4,
            edge_width_fix = 2,
            edge_color_by = "clustered_neighbors",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_brewer(palette = "Set2") +
    scale_edge_color_brewer(palette = "Set1")

# Visualize clustered_neighbors
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "clustered_neighbors",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")+
    scale_color_brewer(palette = "Set1")
```

## Spatial context analysis {#spatial-context}

The single cell assignments derived from clustering cells based on their
environment can be interpreted as **cellular neighborhoods (CNs)**, which can 
represent sites of unique local processes [@Schurch2020].

Downstream of CNs, imcRtools exports three functions to detect and
analyze the **spatial context (SC)** of each cell.

1.  `detectSpatialContext`: for the function to detect SCs
2.  `filterSpatialContext`: for the function to filter SCs
3.  `plotSpatialContext`: for the function to plot SC graphs

The term SC was coined by Bhate and colleagues [@Bhate2022] and
describes tissue regions in which distinct CNs may be interacting, 
which can lead to specialized local biological events.

The `detectSpatialContext` function relies on CN fractions for each cell in 
a spatial interaction graph (originally a k-nearest neighbor (KNN) graph).

We can retrieve the CN fractions using the above-described `buildSpatialGraph`
and `aggregateNeighbors` functions. The window size (k for KNN) for
`buildSpatialGraph` should reflect a length scale on which biological signals
can be exchanged and depends, among others, on cell density and tissue area. 
In view of their divergent functionality, we recommend to use a larger 
window size for SC (interaction between local processes) than for CN 
(local processes) detection.

Subsequently, the CN fractions are sorted from high-to-low and the SC of each
cell is assigned the minimal combination of SCs that additively surpass a
user-defined threshold. The default threshold of 0.9 aims to represent the
dominant CNs, hence the most prevalent signals, in a given window.

For more details, please refer to [@Bhate2022].

```{r detectSpatialContext}
# Generate k-nearest neighbor graph
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                                 type = "knn",
                                 name = "knn_spatialcontext_graph",
                                 k = 15)
colPairNames(pancreasSCE)

# Aggregate based on clustered_neighbors
pancreasSCE <- aggregateNeighbors(pancreasSCE, 
                                  colPairName = "knn_spatialcontext_graph",
                                  aggregate_by = "metadata",
                                  count_by = "clustered_neighbors",
                                  name = "aggregatedNeighborhood")

# Detect spatial contexts
pancreasSCE <- detectSpatialContext(pancreasSCE, 
                                    entry = "aggregatedNeighborhood",
                                    threshold = 0.9,
                                    name = "spatial_context")
# Define SC color scheme
col_SC <- setNames(c("#A6CEE3", "#1F78B4", "#B2DF8A", "#33A02C", "#FB9A99", "#E31A1C", "#FDBF6F"), 
                   sort(unique(pancreasSCE$spatial_context)))

# Visualize spatial contexts on images
plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)
```

After SC assignment for each individual cell, the `filterSpatialContext`
function allows to filter detected SCs based on user-defined thresholds
for number of group entries (usually image or patient ID) and/or total
number of cells per SC.

In addition to a new column entry to the `colData(object)`, the function
also returns a `data.frame` entry to `metadata(object)` containing filtered group
and cell counts per SC.

```{r filterSpatialContext}
# Filter spatial contexts
# By number of group entries
pancreasSCE <- filterSpatialContext(pancreasSCE, 
                            entry = "spatial_context",
                            group_by = "ImageNb", 
                            group_threshold = 2,
                            name = "spatial_context_filtered_group")

metadata(pancreasSCE)$filterSpatialContext

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context_filtered_group",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)

# By total number of cells
pancreasSCE <- filterSpatialContext(pancreasSCE, 
                            entry = "spatial_context",
                            group_by = "ImageNb", 
                            cells_threshold = 15,
                            name = "spatial_context_filtered_cells")

metadata(pancreasSCE)$filterSpatialContext

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_context_filtered_cells",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "knn_spatialcontext_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_manual(values = col_SC)
```

Lastly, the `plotSpatialContext` function plots directed *SC graphs*,
akin to *CN combination maps* in [@Bhate2022], based on symbolic
edge-lists and vertex metadata, which operates on cohort-level.

```{r plotSpatialContext}
## Plot spatial context graph 
# Default
plotSpatialContext(pancreasSCE,
                   entry = "spatial_context", 
                   group_by = "ImageNb")

# Colored by name and size by n_cells
plotSpatialContext(pancreasSCE, 
                   entry = "spatial_context",
                   group_by = "ImageNb",
                   node_color_by = "name",
                   node_size_by = "n_cells",
                   node_label_color_by = "name")

# Colored by n_cells and size by n_group                   
plotSpatialContext(pancreasSCE, 
                   entry = "spatial_context",
                   group_by = "ImageNb",
                   node_color_by = "n_cells",
                   node_size_by = "n_group",
                   node_label_color_by = "n_cells")+
  scale_color_viridis()
```

The returned object can be further modified using the `ggplot2` logic.
This includes changing the node color and size using `scale_color_*` and
`scale_size_*`. Edge attributes can be altered using the `scale_edge_*`
function exported by `ggraph`.

Furthermore, setting `return_data = TRUE` returns the symbolic edge-list
and vertex metadata used for graph construction in a `list` of two
`data.frames`.

```{r plotSpatialContext - return data}
# Return data
plotSpatialContext(pancreasSCE,
                   entry = "spatial_context", 
                   group_by = "ImageNb",
                   return_data = TRUE)
```

## Community detection 

In addition to cellular neighborhood and spatial context analysis, `imcRtools` exports 
the `detectCommunity` function to detect the spatial community of each cell as 
proposed by [@Jackson2020]. Here, each cell is clustered based on its interactions 
as defined by a spatial object graph.

In more detail, the spatial community detection procedure is as follows:

1. Create an igraph object from the edge list stored in 
\code{colPair(object, colPairName)}.  

2. Perform community detection using the specified \code{cluster_fun} algorithm 
(defaults to "louvain").

3. Store the community IDs in a vector and replace all communities 
with a size smaller than \code{size_threshold} by NA.   

```{r detectCommunity}
## Detect spatial community 
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")

## Detect spatial community - specify size_threshold
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               size_threshold = 20)

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")
```
It is also possible to use different community detection algorithms from the `igraph`package. 

```{r detectCommunity-walktrap}
## Detect spatial community - walktrap community detection
set.seed(22)
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               cluster_fun = "walktrap")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")
```

Moreover, the user can specify \code{group_by} to perform spatial community 
detection separately for all unique entries to \code{colData(object)[,group_by]} 
e.g. for tumor and non-tumor cells.

```{r detectCommunity-bygroup}
## Detect spatial community - specify group_by
pancreasSCE <- detectCommunity(pancreasSCE, 
                               colPairName = "expansion_interaction_graph", 
                               group_by = "CellType", 
                               size_threshold = 10,
                               BPPARAM = BiocParallel::SerialParam(RNGseed = 22)) 

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            node_size_fix = 4,
            edge_width_fix = 1,
            draw_edges = TRUE,
            colPairName = "expansion_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free")
```

## Border cells

To exclude cells that are close to the image border, the `imcRtools`
package exports the `findBorderCells` function.

```{r findBorderCells}
pancreasSCE <- findBorderCells(pancreasSCE,
                               img_id = "ImageNb",
                               border_dist = 10)

plotSpatial(pancreasSCE[,!pancreasSCE$border_cells],
            img_id = "ImageNb",
            node_color_by = "CellType",
            node_size_fix = 4,
            edge_width_fix = 2,
            edge_color_by = "clustered_neighbors",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            directed = FALSE,
            nodes_first = FALSE,
            scales = "free") +
    scale_color_brewer(palette = "Set2") +
    scale_edge_color_brewer(palette = "Set1")
```

Excluding border cells can be useful when incorrectly connected cells
are observed at image borders.

## Patch detection {#patch-detection}

An alternative and supervised way of detecting regions with similar
types of cells is available via the `patchDetection` function. Here, the
user defines which cells should be used for patch detection via the
`patch_cells` parameter. A patch is defined as a set of cells as defined
by `patch_cells` which are weakly connected in the graph in
`colPair(object, colPairname)`.

Below, the `patchDetection` function is demonstrated using the
previously computed `expansion` graph and defining cells of `celltype_B`
as the cells of interest. Here, the function additionally draws a
concave hull around the detected patch, expands the hull by 20$\mu{}m$
and defines all cells within this expanded hulls as patch cells.

```{r patchDetection}
pancreasSCE <- patchDetection(pancreasSCE, 
                              patch_cells = pancreasSCE$CellType == "celltype_B",
                              colPairName = "expansion_interaction_graph",
                              expand_by = 20, 
                              img_id = "ImageNb")
 
plotSpatial(pancreasSCE, 
            img_id = "ImageNb", 
            node_color_by = "patch_id",
            scales = "free")
```

Patches that only consist of 1 or 2 cells cannot be expanded.

For each patch larger than 2 cells, the spatial area can be computed using the
`patchSize` function:

```{r patchSize}
patchSize(pancreasSCE)
```

## Distance statistics to cells of interest

To calculate the min, max, mean or median distance for each cell to a given cell type or class of
cells of interest, the function `distToCells` is available. Cells of interest
are defined via the `x_cells` parameter as `logical` and distances to for all
cells to those cells will be reported in a new column in the `colData` of the
`SingleCellExperiment`.

If the cells of interest form patches (many cells of the same type next to each
other) or similarly if a patch detection has previously been performed the
positive distances reflect the distances from cells outside of patches (or non cells of interest) to the patch cells (or cells of interest) and the negative distances reflect the distances from cells
inside the patches to the cells outside the patches.
For `statistics` = "min" this corresponds to the distance from the cells outside to the closest point on the patch border and from the cells inside to the closest point on the patch border.
If `return_neg` is set to `FALSE`, distances from the cells of interest (or cells inside the patches) to non cells of interest are computed as positive distances.

```{r distToCells}
pancreasSCE <- distToCells(pancreasSCE,
                              x_cells = pancreasSCE$CellType == "celltype_B",
                              coords = c("Pos_X","Pos_Y"),
                              statistics = "min",
                              name = "minDist",
                              img_id = "ImageNb")

pancreasSCE <- distToCells(pancreasSCE,
                              x_cells = pancreasSCE$CellType == "celltype_B",
                              coords = c("Pos_X","Pos_Y"),
                              statistics = "mean",
                              name = "meanDist",
                              img_id = "ImageNb")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "minDist",
            scales = "free") +
    scale_color_viridis()

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "meanDist",
            scales = "free") +
    scale_color_viridis()
```

## Neighborhood permutation testing {#test-neighborhood}

The following section describes how to observe and test the average
number of interactions between cell labels (e.g. cell-types) within
grouping levels (e.g. images). For full descriptions of the testing
approaches, please refer to [Shapiro et al., Nature
Methods](https://www.nature.com/articles/nmeth.4391) [@Shapiro2017] and
[Schulz et al., Cell
Systems](https://www.sciencedirect.com/science/article/pii/S2405471217305434)
[@Schulz2018]

The `imcRtools` package exports the `countInteractions` and
`testInteractions` functions, which summarize all cell-cell interactions
per grouping level (e.g. image). As a result, a table is returned where
each row represents one of all possible cell-type/cell-type interactions
among all grouping levels. Missing entries or `NA`s indicate missing
cell-type labels for this grouping level. The next section gives details
on how interactions are summarized.

### Summarizing interactions

The `countInteractions` function counts the number of edges
(interactions) between each set of unique cell labels per grouping
level. Simplified, it counts for each cell of type A the number of
neighbors of type B. This count is averaged within each unique grouping
level (e.g. image) in four different ways:

1.  `method = "classic"`: The count is divided by the total number of
    cells of type A. The final count can be interpreted as "How many
    neighbors of type B does a cell of type A have on average?"

2.  `method = "conditional"`: Previously named "histocat". The count is 
    divided by the number of cells of type A that have at least one neighbor 
    of type B. The final count can be interpreted as "How many neighbors 
    of type B has a cell of type A on average, given it has at least one 
    neighbor of type B?".

3.  `method = "patch"`: For each cell, the count is binarized to 0 (less
    than `patch_size` neighbors of type B) or 1 (more or equal to
    `patch_size` neighbors of type B). The binarized counts are averaged
    across all cells of type A. The final count can be interpreted as
    "What fraction of cells of type A have at least a given number of
    neighbors of type B?"

4.  `method = "interaction"`: The count is divided by the total number of 
    interactions from cell type A. The final count can be interpreted as "What 
    fraction of interactions of cell type A occur with cell type B."

The `countInteractions` returns a `DataFrame` containing the summarized
counts (`ct`) for all combinations of `from_label`, `to_label` and
`group_by`.

```{r countInteractions}
out <- countInteractions(pancreasSCE,
                         group_by = "ImageNb",
                         label = "CellType",
                         method = "classic",
                         colPairName = "knn_interaction_graph")
out
```

### Testing for significance

In the next instance, one can test if the obtained count is larger or
smaller compared to what is expected from a random distribution of cell
labels. For this, the `testInteractions` function permutes the cell
labels `iter` times and counts interactions as described above. This
approach generates a distribution of the interaction count under a
random distribution of cell labels. The observed interaction count is
compared against this Null distribution to derive z-scores and empirical p-values:

`p_gt`: fraction of perturbations equal or greater than the observed
count

`p_lt`: fraction of perturbations equal or less than the observed count

`zscore`: (observed count - mean of permuted counts) / sd of permuted counts

Based on these empirical p-values, the `interaction` score (attraction
or avoidance), overall `p` value and significance by comparison to
`p_treshold` (`sig` and `sigval`) are derived. All results are returned
in form of a `DataFrame`.

We set the seed within the `SerialParam` (or `MulticoreParam`) function for
reproducibility.

```{r testInteractions}
out <- testInteractions(pancreasSCE,
                        group_by = "ImageNb",
                        label = "CellType",
                        method = "classic",
                        colPairName = "knn_interaction_graph",
                        BPPARAM = BiocParallel::SerialParam(RNGseed = 123))
out
```

### Visualizing interactions

The `plotInteractions` function is used to visualize interaction networks from an
edge list, typically the output of the `countInteractions`and `testInteractions`
functions. 

```{r plotInteractions}
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")
```

Before visualization, the edge list can be filtered to focus on relevant 
cell-cell interactions, groupings, and significance.

In the example below, we retain interactions whose fraction of significant pairs
(based on sigval) exceeds 75% and tag the edges as attraction or repulsion.

```{r plotInteractions-filter data}
library(dplyr)

out <- out %>% as.data.frame() %>% mutate(pair_id = paste(from_label, to_label, sep = "__"),
                                          is_sig = !is.na(sig))
summary_df <- out %>%
  group_by(pair_id) %>%
  summarise(
    sum_sigval = sum(sigval, na.rm = TRUE),
    total_count = sum(is_sig),
    .groups = "drop"
  ) %>%
  mutate(
    fraction_sig = sum_sigval / total_count,
    int_type = case_when(
      fraction_sig > 0.75 ~ "attraction",
      fraction_sig < -0.75 ~ "repulsion",
      TRUE ~ NA_character_
    )
  ) %>%
  filter(!is.na(int_type))

subset_out <- out %>%
  semi_join(summary_df, by = "pair_id") %>%
  left_join(summary_df %>% select(pair_id, int_type), by = "pair_id")

# Now we can visualise only these filtered edges
plotInteractions(subset_out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")
```

You can customize node and edge aesthetics directly using `plotInteractions`
arguments. The plot can also be modified further using `ggplot2` syntax.
Node properties such as color, shape, and size can be controlled using
`scale_color_*`, `scale_shape_*` and `scale_size_*`. Edge aesthetics can be 
modified using `scale_edge_*` functions from `ggraph`.

To color edges based on subsetted significant interaction type (attraction, repulsion), 
specify the `int_type` column via `edge_color_by`, and use `scale_edge_colour_manual()` 
for custom colors.

You can also control edge thickness via `edge_width_by`. For example, "ct" 
represents the summarized interaction count derived from `countInteractions` 
or `testInteractions`, averaged per cell-pair and grouping level. 
In our example, the "ct" value refers to the average neighboring cells of 
cell type B from cell type A averaged across all images.

```{r plotInteractions-edge aesthetics}
library(ggraph)

edge_color <- setNames(c("blue", "red"),c("attraction", "repulsion"))

plotInteractions(subset_out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 edge_color_by = "int_type",
                 edge_width_by = "ct") +
                 scale_edge_colour_manual(values = edge_color)
```

Control node properties via: `node_color_by`, `node_size_by`, `node_label_color_by`.

```{r plotInteractions-node aesthetics}
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 node_color_by = "name",
                 node_label_color_by = "name",
                 node_size_by = "n_cells")

# Define custom colors for node and node_label
node_color <- setNames(c("red", "blue", "green"), c("celltype_A", "celltype_B", "celltype_C"))
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 node_color_by = "name",
                 node_label_color_by = "name",
                 node_size_by = "n_cells")+
  scale_color_manual(values = node_color)
```

The layout of the graph can be customized using the `graph_layout` argument. 
For more information see [ggraph](https://ggraph.data-imaginist.com/reference/ggraph.html).

```{r plotInteractions-layout}
# Default is "circle"
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType")

# Chord diagram layout
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 graph_layout = "chord")

# Linear layout
plotInteractions(out,
                 pancreasSCE,
                 group_by = "ImageNb",
                 label = "CellType",
                 graph_layout = "linear")
```

Furthermore, setting `return_data = TRUE` returns the symbolic edge-list, 
along with any specified edge aesthetic parameters and vertex metadata used 
for graph construction, as a `list` of two `data.frames`.

```{r plotInteractions-return data}
# return data
plotInteractions(out, pancreasSCE, "CellType", "ImageNb",
                return_data = TRUE)
```

### Visualizing interactions when choosing method = "conditional"

We first run the testInteractions() functions with the "conditional" method. 

```{r run-cozi}
out <- testInteractions(pancreasSCE,
                        group_by = "ImageNb",
                        label = "CellType",
                        method = "conditional",
                        colPairName = "knn_interaction_graph",
                        BPPARAM = BiocParallel::SerialParam(RNGseed = 123))
```

Interaction z-scores from conditional normalization, described as COZI in [Schiller et al. 2025](https://www.biorxiv.org/content/10.1101/2025.03.31.646289v2), can be 
best interpreted by additionally considering the conditional cell ratio (CCR). The CCR is the ratio of cells of type A with at least one neighbor of type B in an image. 

We can calculate the CCR for the priorly chosen neighborhood size and append the output from the testInteractions() function as follows:
```{r}
cd <- as.data.table(colData(pancreasSCE))

cond_ratio_df <- as.data.table(colPair(pancreasSCE, "knn_interaction_graph"))[
  , .(from_label = cd$CellType[from],
      to_label   = cd$CellType[to],
      group_by   = cd$ImageNb[from],
      from)
][, .(N = uniqueN(from)), by = .(group_by, from_label, to_label)
][cd[, .(total_from_type = .N), by = .(group_by = ImageNb, from_label = CellType)], 
  on = .(group_by, from_label)
][, .(group_by, from_label, to_label, cond_ratio = N / total_from_type)]

out_cr <- merge(
  as.data.table(out)[, `:=`(
    group_by   = as.integer(group_by),
    from_label = as.character(from_label),
    to_label   = as.character(to_label)
  )],
  cond_ratio_df,
  by = c("group_by", "from_label", "to_label"),
  all.x = TRUE
)
```

We visualize both the z-score and the CCR simultaneously in a dotplot to help interpreting results. 
With that, you know how many cells of type A neighbor a cell of type B (CCR), and how strong this interaction is (z-score). 
For example, if the CCR is very low (small dot) but the z-score is very high, this means that a small amount of cells of type A are strongly 
surrounded by cells of type B. 
We show how to plot the results in the following:

```{r}
library(RColorBrewer)

p <- out_cr %>%
  filter(!is.na(zscore), !is.na(cond_ratio), sig) %>%
  ggplot(aes(from_label, to_label, size = cond_ratio, color = zscore)) +
  geom_point() +
  theme_bw() +
  scale_size(range = c(1,10)) +
  scale_color_gradient2(low = brewer.pal(11,"RdBu")[10], mid = "white", high = brewer.pal(11,"RdBu")[2], midpoint = 0) +
  facet_wrap(~group_by)

p
```

# Contributions

Large chunks of the code of the `imcRtools` package is based on the work
of [Vito Zanotelli](https://github.com/votti). Vito has co-developed the
spillover correction approach and translated the interaction testing
approach developed by [Denis Schapiro](https://github.com/DenisSch) and
[Jana Fischer](https://github.com/JanaFischer) into R (formerly known as
the [neighbouRhood](https://github.com/BodenmillerGroup/neighbouRhood) R
package). Jana has furthermore added the "patch" method for interaction
counting and testing. [Tobias Hoch](https://github.com/toobiwankenobi)
has written the first version of reading in the
`ImcSegmentationPipeline` output and the `patchDetection` function.
[Daniel Schulz](https://github.com/SchulzDan) has build the
`aggregateNeighbors` and `minDistToCells` functions and contributed to developing the spatial
clustering approach. [Lasse Meyer](https://github.com/lassedochreden) has 
implemented the functions for spatial context analysis and developed the 
`detectCommunity` function. [Marlene Lutz](https://github.com/marlene1) has 
contributed the "interaction" method for interaction counting and testing, and
implemented the `plotInteractions` function. [Chiara Schiller](https://github.com/chiarasch) has 
implemented the zscore calculation within the `testInteractions()` function and introduced the 
conditional cell ratio for interpreting results.

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterPixels.R
\name{filterPixels}
\alias{filterPixels}
\title{Filter pixels based on their assigned masses}
\usage{
filterPixels(
  object,
  bc_id = "bc_id",
  spot_mass = "sample_mass",
  minevents = 40,
  correct_pixels = TRUE
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} object containing pixel
intensities per channel. Individual pixels are stored as columns and
channels are stored as rows.}

\item{bc_id}{character string indicating which \code{colData(object)} entry
stores the estimated mass}

\item{spot_mass}{character string indicating which \code{colData(object)} 
entry stores the true isotope mass of the spotted metal.}

\item{minevents}{single numeric indicating the threshold under which pixel
sets are excluded from spillover estimation.}

\item{correct_pixels}{logical indicating if incorrectly assigned pixels 
should be excluded from spillover estimation.}
}
\value{
returns a SingleCellExperiment object in which
\code{colData(object)$bc_id} has been adjusted based on the filter
criteria.
}
\description{
Helper function for estimating the spillover matrix. After
assigning each pixel to a spotted mass, this function will filter 
incorrectly assigned pixels and remove small pixel sets.
}
\examples{
path <- system.file("extdata/spillover", package = "imcRtools")
sce <- readSCEfromTXT(path)
assay(sce, "exprs") <- asinh(counts(sce)/5)

# Pre-process via CATALYST
library(CATALYST)

bc_key <- as.numeric(unique(sce$sample_mass))
sce <- assignPrelim(sce, bc_key = bc_key)
sce <- estCutoffs(sce)
sce <- applyCutoffs(sce)

sce <- filterPixels(sce)

table(sce$sample_mass, sce$bc_id)

}
\author{
Vito Zanotelli, adapted by 
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countInteractions.R
\name{countInteractions}
\alias{countInteractions}
\title{Summarizes cell-cell interactions within grouping levels (e.g. images)}
\usage{
countInteractions(
  object,
  group_by,
  label,
  colPairName,
  method = c("classic", "conditional", "patch", "interaction"),
  patch_size = NULL
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object .}

\item{group_by}{a single character indicating the \code{colData(object)}
entry by which interactions are grouped. This is usually the image ID or
patient ID.}

\item{label}{single character specifying the \code{colData(object)} entry
which stores the cell labels. These can be cell-types labels or other
metadata.}

\item{colPairName}{single character indicating the \code{colPair(object)}
entry containing cell-cell interactions in form of an edge list.}

\item{method}{which cell-cell interaction counting method to use 
(see details)}

\item{patch_size}{if \code{method = "patch"}, a single numeric specifying
the minimum number of neighbors of the same type to be considered a patch
(see details)}
}
\value{
a DataFrame containing one row per \code{group_by} entry and unique
\code{label} entry combination (\code{from_label}, \code{to_label}). The
\code{ct} entry stores the interaction count as described in the details.
\code{NA} is returned if a certain label is not present in this grouping
level.
}
\description{
Function to calculate the average number of neighbors B that
a cell of type A has using different approaches.
}
\section{Counting and summarizing cell-cell interactions}{

In principle, the \code{countInteractions} function counts the number
of edges (interactions) between each set of unique entries in 
\code{colData(object)[[label]]}. Simplified, it counts for each cell of
type A the number of neighbors of type B.
This count is averaged within each unique entry 
\code{colData(object)[[group_by]]} in four different ways:

1. \code{method = "classic"}: The count is divided by the total number of 
cells of type A. The final count can be interpreted as "How many neighbors 
of type B does a cell of type A have on average?" 

2. \code{method = "conditional"}: Formerly named "histocat". The count is divided 
by the number of cells of type A that have at least one neighbor of type B. The 
final count can be interpreted as "How many neighbors of type B has a cell of 
type A on average, given it has at least one neighbor of type B?".

3. \code{method = "patch"}: For each cell, the count is binarized to 0 
(less than \code{patch_size} neighbors of type B) or 1 (more or equal to 
\code{patch_size} neighbors of type B). The binarized counts are averaged 
across all cells of type A. The final count can be interpreted as "What 
fraction of cells of type A have at least a given number of neighbors of 
type B?"

4. \code{method = "interaction"}: The count is divided by the total number of 
interactions from cell type A. The final count can be interpreted as "What 
fraction of interactions of cell type A occur with cell type B."
}

\examples{
library(cytomapper)
data(pancreasSCE)

pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                  type = "knn", k = 3)
                               
# Classic style calculation
(out <- countInteractions(pancreasSCE, 
                                group_by = "ImageNb",
                                label = "CellType", 
                                method = "classic",
                                colPairName = "knn_interaction_graph"))
                                
# Conditional style calculation
(out <- countInteractions(pancreasSCE, 
                                group_by = "ImageNb",
                                label = "CellType", 
                                method = "conditional",
                                colPairName = "knn_interaction_graph"))
                                
# Patch style calculation
(out <- countInteractions(pancreasSCE, 
                                group_by = "ImageNb",
                                label = "CellType", 
                                method = "patch",
                                patch_size = 3,
                                colPairName = "knn_interaction_graph"))

# Interaction style calculation
(out <- countInteractions(pancreasSCE, 
                                group_by = "ImageNb",
                                label = "CellType", 
                                method = "interaction",
                                colPairName = "knn_interaction_graph"))
                                
}
\references{
\href{https://www.sciencedirect.com/science/article/pii/S2405471217305434}{
Schulz, D. et al., Simultaneous Multiplexed Imaging of mRNA and Proteins with 
Subcellular Resolution in Breast Cancer Tissue Samples by Mass Cytometry., 
Cell Systems 2018 6(1):25-36.e5}

\href{https://www.nature.com/articles/nmeth.4391}{
Schapiro, D. et al., histoCAT: analysis of cell phenotypes and interactions in 
multiplex image cytometry data, Nature Methods 2017 14, p. 873–876}
}
\seealso{
\code{\link{testInteractions}} for testing cell-cell
interactions per grouping level.
}
\author{
Vito Zanotelli

Jana Fischer

adapted by Nils Eling (\email{nils.eling@dqbm.uzh.ch})

adapted by Marlene Lutz (\email{marlene.lutz@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readImagefromTXT.R
\name{readImagefromTXT}
\alias{readImagefromTXT}
\title{Reads one or multiple .txt files into a CytoImageList object}
\usage{
readImagefromTXT(
  path,
  pattern = ".txt$",
  channel_pattern = "[A-Za-z]{1,2}[0-9]{2,3}Di",
  index_names = c("X", "Y"),
  BPPARAM = SerialParam()
)
}
\arguments{
\item{path}{Full path to where the individual .txt files are located. This is
usualy the path where the .mcd file is located.}

\item{pattern}{pattern to select which files should be read in (default
\code{".txt$"}).}

\item{channel_pattern}{regular expression to select the channel names from
the files.}

\item{index_names}{exact names of the columns storing the x and y coordinates 
of the image}

\item{BPPARAM}{parameters for parallelized reading in of images. 
This is only recommended for very large images.}
}
\value{
returns a \code{\linkS4class{CytoImageList}} object containing one
\code{\linkS4class{Image}} object per .txt file.
}
\description{
Reader function to generate \code{\linkS4class{Image}} objects
in form of a \code{\linkS4class{CytoImageList}} container from .txt files.
}
\section{Imaging mass cytometry .txt files}{

As part of the raw data folder, the Hyperion imaging system writes out
one .txt file per acquisition. These files store the ion counts per
pixel and channel. 

This function reads these .txt files into a single
\code{\linkS4class{CytoImageList}} object for downstream analysis. The
\code{pattern} argument allows selection of all .txt files or a specific
subset of files. The \code{\link[cytomapper]{channelNames}} of the
\code{CytoImageList} object are determined by the \code{channel_pattern}
argument.
}

\examples{
path <- system.file("extdata/mockData/raw", package = "imcRtools")

# Read in all images
x <- readImagefromTXT(path)
x

# Read in specific files
y <- readImagefromTXT(path, pattern = "ROI_002")
y

# Read in other channelNames
z <- readImagefromTXT(path, channel_pattern = "[A-Za-z]{2}[0-9]{3}")
z

}
\seealso{
\code{\linkS4class{CytoImageList}} for the container

\code{\link[BiocParallel]{MulticoreParam}} for parallelized processing

\code{\linkS4class{Image}} for the multi-channel image object

\code{vignette("cytomapper")} for visualization of multi-channel images
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/findBorderCells.R
\name{findBorderCells}
\alias{findBorderCells}
\title{Find cells at the image border}
\usage{
findBorderCells(object, img_id, border_dist, coords = c("Pos_X", "Pos_Y"))
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object.}

\item{img_id}{single character indicating the \code{colData(object)} entry
containing the unique image identifiers.}

\item{border_dist}{single numeric defining the distance to the image border.
The image border here is defined as the minimum and maximum among the 
cells' x and y location.}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries indicating the cells' x and y locations.}
}
\value{
an object of \code{class(object)} containing the logical
\code{border_cells} entry in the \code{colData} slot.
}
\description{
Detection of cells close to the image border for subsequent exclusion from
downstream analyses.
}
\examples{
library(cytomapper)
data("pancreasSCE")

sce <- findBorderCells(pancreasSCE, img_id = "ImageNb", 
                       border_dist = 10)

plotSpatial(sce, 
            img_id = "ImageNb", 
            node_color_by = "border_cells",
            scales = "free")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readSCEfromTIFF.R
\name{readSCEfromTIFF}
\alias{readSCEfromTIFF}
\title{Generates a SingleCellExperiment from .tiff files}
\usage{
readSCEfromTIFF(x, image_df_path, panel_df_path, verbose = TRUE)
}
\arguments{
\item{x}{has to be a path to a folder containing .tiff files.}

\item{image_df_path}{has to be a path to a images.csv file, 
generated with the steinbock pipeline.}

\item{panel_df_path}{has to be a path to a panel.csv file, 
generated with the steinbock pipeline.}

\item{verbose}{logical indicating if additional information regarding the
spotted and acquired masses should be shown.}
}
\value{
returns a SCE object where pixels are stored as columns and acquired
channels are stored as rows.
}
\description{
Helper function to process .tiff files created with the 
steinbock pipeline \href{https://bodenmillergroup.github.io/steinbock/latest/} 
into a \code{\linkS4class{SingleCellExperiment}}
object. This function is mainly used to read-in data generated from a
"spillover slide" from the new XTi generation of IMC machines. 
Here, each .tiff file contains the measurements of
multiple pixels for a single stain across all open channels.
}
\section{Reading in .tiff files for spillover correction}{


As described in the original publication, single metal spots are acquired
using the Hyperion imaging system. Each acquisition corresponds to one spot.
All acquisitions are stored in a single .mcd file and individual acquisitions
are stored in single .tiff files after extraction with the steinbock pipeline.

This function aggregates these measurements into a single
\code{SingleCellExperiment} object:

\code{x} is a path:
All .tiff files are read in from the specified path. Here, the path
should indicate the location of the spillover slide measurement. Additionally,
the images.csv and panel.csv files generated with the steinbock pipeline 
must be passed. The column \code{acquisition_description} in images.csv 
as well as the column \code{channel} in panel.csv must contain the 
spotted metal isotope name in the format \code{(mt)(mass)} 
(e.g. \code{Sm152} for Samarium isotope with the atomic mass 152).
}

\examples{
# Read files from path
path <- system.file("extdata/spillover_tiff/img", package = "imcRtools")
image_df_path <- system.file("extdata/spillover_tiff/images.csv", package = "imcRtools")
panel_df_path <- system.file("extdata/spillover_tiff/panel.csv", package = "imcRtools")

sce <- readSCEfromTIFF(path, image_df_path, panel_df_path) 
sce


}
\references{
\href{https://www.sciencedirect.com/science/article/pii/S1550413118306910}{Chevrier,
S. et al. 2017. “Compensation of Signal Spillover in Suspension and Imaging
Mass Cytometry.” Cell Systems 6: 612–20.}
\href{https://www.nature.com/articles/s41596-023-00881-0}{Windhager,
J. et al. 2023. “An end-to-end workflow for multiplexed image processing and analysis.” 
Nature Protocols 18: 3565–3613.}
}
\author{
Victor Ibañez (\email{victor.ibanez@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSpatial.R
\name{plotSpatial}
\alias{plotSpatial}
\title{Visualizes the spatial locations and interactions of cells}
\usage{
plotSpatial(
  object,
  img_id,
  coords = c("Pos_X", "Pos_Y"),
  node_color_by = NULL,
  node_shape_by = NULL,
  node_size_by = NULL,
  node_color_fix = NULL,
  node_shape_fix = NULL,
  node_size_fix = NULL,
  assay_type = NULL,
  draw_edges = FALSE,
  directed = TRUE,
  edge_color_by = NULL,
  edge_width_by = NULL,
  edge_color_fix = NULL,
  edge_width_fix = NULL,
  arrow = NULL,
  end_cap = NULL,
  colPairName = NULL,
  nodes_first = TRUE,
  ncols = NULL,
  nrows = NULL,
  scales = "fixed",
  flip_x = FALSE,
  flip_y = TRUE,
  aspect_ratio = "auto"
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object.}

\item{img_id}{single character indicating the \code{colData(object)} entry
containing the unique image identifiers.}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries indicating the the cells' x and y locations.}

\item{node_color_by}{single character indicating the \code{colData(object)}
entry or marker name by which the nodes (cell locations) should be colored.}

\item{node_shape_by}{single character indicating the \code{colData(object)}
entry by which the shape of the nodes are defined.}

\item{node_size_by}{single character indicating the \code{colData(object)}
entry by which the size of the nodes are defined.}

\item{node_color_fix}{single character or numeric specifying the color of all 
nodes.}

\item{node_shape_fix}{single numeric or character specifying the shape of all 
nodes.}

\item{node_size_fix}{single numeric specifying the size of all nodes}

\item{assay_type}{single character indicating the assay slot from which
to extract the expression data when \code{node_color_by} is set to one of
\code{rownames(object)}.}

\item{draw_edges}{should cell-cell interactions be drawn as edges between
nodes?}

\item{directed}{should cell-cell interactions be handled as a directed graph?}

\item{edge_color_by}{single character indicating by which to color the edges.
See details for more information.}

\item{edge_width_by}{single character determining the size of the edges.
See details for more information.}

\item{edge_color_fix}{single character or numeric specifying the color of all 
edges.}

\item{edge_width_fix}{single numeric specifying the size of all edges.}

\item{arrow}{an \code{\link[grid]{arrow}} object specifying how to draw
arrows between cells.}

\item{end_cap}{a \code{\link[ggraph]{geometry}} object specifying how long
the edges are. This only takes effect when drawing arrows. Default:
\code{end_cap = circle(0.1, 'cm')}}

\item{colPairName}{single character specifying the 
\code{colPair(object)} slot to retrieve the cell-cell pairings.}

\item{nodes_first}{should the nodes be plotted first and then the edges?}

\item{ncols}{number of columns of the grid to arrange individual images.}

\item{nrows}{number of rows of the grid to arrange individual images.}

\item{scales}{one of \code{"free"}, \code{"fixed"}, \code{"free_x"} or 
\code{"free_y"} indicating if x- and y-axis ranges should be fixed across
all images. Defaults to "fixed" to match physical units on the x- and y-axis.}

\item{flip_x}{flip the x-axis?}

\item{flip_y}{flip the y-axis?}

\item{aspect_ratio}{single numeric, "auto" or NULL to define the relative
ratio between the physical units of the x and y axis. If \code{"auto"}
(default), the physical units match between the x and y axis if
\code{scales = "fixed"}. If \code{scales = "free"}, the default aspect
ratio is set to 1. Ignore setting the aspect ratio with \code{aspect_ratio
= NULL}.}
}
\value{
returns a \code{ggplot} object.
}
\description{
A general function to plot spatial locations of cells while 
specifying color, shape, size. Cell-cell interactions can be visualized
in form of edges between points.
}
\section{Visualizing cell locations and cell-cell interactions}{
 
By default, the cells' locations are visualized in form of points (here also
referred to as "nodes") on a 2-dimensional plane. The cells' coordinates are
extracted either from \code{colData(object)} slot (for a
\code{SingleCellExperiment} input object) or from the
\code{spatialCoords(object)} slot (for a \code{SpatialExperiment} input
object). Node aesthetics are controlled by setting \code{node_color_by}, 
\code{node_shape_by} and \code{node_size_by} for associating the aesthetics
with variables. If node aesthetics should be the same for all nodes,  
\code{node_color_fix}, \code{node_shape_fix} and \code{node_size_fix} can 
be set.

When \code{draw_edges = TRUE}, cell-cell interactions are visualized in form
of edges between nodes. For this, \code{object} needs to contain 
column pairings in \code{colPair(object, colPairName)}. Edge color and size
can be set by specifying either an entry in 
\code{mcols(colPair(object, colPairName))} (edge attributes) or in 
\code{colData(object)}. In the latter case, edges are colored by attributes 
associated to the "from" node. Variable aesthetics can be set using 
\code{edge_color_by} and \code{edge_width_by}. If all edges should have 
the same width or color, \code{edge_color_fix} and \code{edge_width_fix}
can be set.

Arrows for displaying directed graphs can be drawn by supplying a 
\code{\link[grid]{arrow}} object. Arrow attributes can be set within this 
class. To cap the edge before it reaches the next node, the \code{end_cap}
parameter can be used.
}

\examples{
library(cytomapper)
data(pancreasSCE)

sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                         type = "knn", k = 3, directed = FALSE)

# Only nodes
plotSpatial(sce, img_id = "ImageNb",
            node_color_by = "CellType",
            node_shape_by = "ImageNb",
            node_size_by = "Area",
            scales = "free")
  
# With edges and nodes colored by expression
plotSpatial(sce, img_id = "ImageNb",
            node_color_by = "PIN",
            assay_type = "exprs",
            node_shape_by = "ImageNb",
            node_size_by = "Area",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            edge_color_by = "Pattern",
            scales = "free")
            
# With arrows
plotSpatial(sce, img_id = "ImageNb",
            node_color_by = "CellType",
            node_shape_by = "ImageNb",
            node_size_by = "Area",
            draw_edges = TRUE,
            colPairName = "knn_interaction_graph",
            edge_color_fix = "green",
            arrow = grid::arrow(length = grid::unit(0.1, "inch")),
            end_cap = ggraph::circle(0.2, "cm"),
            scales = "free")
  
}
\seealso{
\code{\link{buildSpatialGraph}} for constructing interaction graphs

\code{\link{ggraph}} for handling graph aesthetics
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/distToCells.R
\name{distToCells}
\alias{distToCells}
\title{Function to calculate distance to cells of interest}
\usage{
distToCells(
  object,
  x_cells,
  img_id,
  name = "distToCells",
  coords = c("Pos_X", "Pos_Y"),
  statistics = "min",
  return_neg = TRUE,
  BPPARAM = SerialParam()
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{x_cells}{logical vector of length equal to the number of cells
contained in \code{object}. \code{TRUE} entries define the cells to which
distances will be calculated.}

\item{img_id}{single character indicating the \code{colData(object)} entry
containing the unique image identifiers.}

\item{name}{character specifying the name of the \code{colData} entry to safe
the distances in.}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries of the cells' x and y locations.}

\item{statistics}{one of "min", "max", "mean" or "meadian" specifying the distance statistics to use when computing
the distances.}

\item{return_neg}{logical indicating whether negative distances are to be
returned for the distances of patched/spatially clustered cells.}

\item{BPPARAM}{a \code{\link[BiocParallel]{BiocParallelParam-class}} object
defining how to parallelize computations.}
}
\value{
returns an object of \code{class(object)} containing a new column
entry to \code{colData(object)[[name]]}. Cells in the object are grouped
by entries in \code{img_id}.
}
\description{
Function to return the min, max, mean or median distance to the cells of interest
for each cell in the data. In the case of patched/clustered cells negative
distances are returned by default which indicate the distance of the cells
of interest to the cells that are not of the type of cells of
interest.
}
\section{Ordering of the output object}{

The \code{minDistToCells} function operates on individual images.
Therefore the returned object is grouped by entries in \code{img_id}.
This means all cells of a given image are grouped together in the object.
The ordering of cells within each individual image is the same as the ordering
of these cells in the input object.
}

\examples{
library(cytomapper)
data(pancreasSCE)

# Build interaction graph
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
type = "expansion",threshold = 20)

# Detect patches of "celltype_B" cells
pancreasSCE <- patchDetection(pancreasSCE,
                             img_id = "ImageNb",
                             patch_cells = pancreasSCE$CellType == "celltype_B",
                             colPairName = "expansion_interaction_graph",
                             min_patch_size = 20,
                             expand_by = 1)

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "patch_id",
            scales = "free")

# Distance to celltype_B patches
pancreasSCE <- distToCells(pancreasSCE,
                             x_cells = !is.na(pancreasSCE$patch_id),
                             coords = c("Pos_X","Pos_Y"),
                             statistics = "min",
                             img_id = "ImageNb")

plotSpatial(pancreasSCE,
            img_id = "ImageNb",
            node_color_by = "distToCells",
            scales = "free")

}
\author{
Daniel Schulz & Bruno Palau (\email{daniel.schulz@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/testInteractions.R
\name{testInteractions}
\alias{testInteractions}
\title{Tests if cell types interact more or less frequently than random}
\usage{
testInteractions(
  object,
  group_by,
  label,
  colPairName,
  method = c("classic", "conditional", "patch", "interaction"),
  patch_size = NULL,
  iter = 1000,
  p_threshold = 0.01,
  return_samples = FALSE,
  tolerance = sqrt(.Machine$double.eps),
  BPPARAM = SerialParam()
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object.}

\item{group_by}{a single character indicating the \code{colData(object)}
entry by which interactions are grouped. This is usually the image ID or
patient ID.}

\item{label}{single character specifying the \code{colData(object)} entry
which stores the cell labels. These can be cell-types labels or other
metadata entries.}

\item{colPairName}{single character indicating the \code{colPair(object)}
entry containing cell-cell interactions in form of an edge list.}

\item{method}{which cell-cell interaction counting method to use 
(see details)}

\item{patch_size}{if \code{method = "patch"}, a single numeric specifying
the minimum number of neighbors of the same type to be considered a patch
(see details)}

\item{iter}{single numeric specifying the number of permutations to perform}

\item{p_threshold}{single numeric indicating the empirical p-value 
threshold at which interactions are considered to be significantly 
enriched or depleted per group.}

\item{return_samples}{single logical indicating if the permuted interaction
counts of all iterations should be returned.}

\item{tolerance}{single numeric larger than 0. This parameter defines the
difference between the permuted count and the actual counts at which both
are regarded as equal. Default taken from \code{all.equal}.}

\item{BPPARAM}{parameters for parallelized processing.}
}
\value{

}
\description{
Cell-cell interactions are summarized in different ways and
the resulting count is compared to a distribution of counts arising 
from random permutations.
}
\section{Counting and summarizing cell-cell interactions}{

In principle, the \code{\link{countInteractions}} function counts the number
of edges (interactions) between each set of unique entries in 
\code{colData(object)[[label]]}. Simplified, it counts for each cell of
type A the number of neighbors of type B.
This count is averaged within each unique entry 
\code{colData(object)[[group_by]]} in four different ways:

1. \code{method = "classic"}: The count is divided by the total number of 
cells of type A. The final count can be interpreted as "How many neighbors 
of type B does a cell of type A have on average?" 

2. \code{method = "conditional"}: Formerly named "histocat". The count is divided 
by the number of cells of type A that have at least one neighbor of type B. The 
final count can be interpreted as "How many neighbors of type B has a cell of 
type A on average, given it has at least one neighbor of type B?".

3. \code{method = "patch"}: For each cell, the count is binarized to 0 
(less than \code{patch_size} neighbors of type B) or 1 (more or equal to 
\code{patch_size} neighbors of type B). The binarized counts are averaged 
across all cells of type A. The final count can be interpreted as "What 
fraction of cells of type A have at least a given number of neighbors of 
type B?"

4. \code{method = "interaction"}: The count is divided by the total number of 
interactions from cell type A. The final count can be interpreted as "What 
fraction of interactions of cell type A occur with cell type B."
}

\section{Testing for significance}{
 Within each unique entry to
\code{colData(object)[[group_by]]}, the entries of
\code{colData(object)[[label]]} are randomized \code{iter} times. For each
iteration, the interactions are counted as described above. The result is a
distribution of the interaction count under spatial randomness. The
observed interaction count is compared against this Null distribution to
derive empirical p-values:

\code{p_gt}: fraction of perturbations equal or greater than the observed 
count

\code{p_lt}: fraction of perturbations equal or less than the observed count

Based on these empirical p-values, the \code{interaction} score (attraction
or avoidance), overall \code{p} value and significance by comparison to
\code{p_treshold} (\code{sig} and \code{sigval}) are derived.
}

\examples{
library(cytomapper)
library(BiocParallel)
data(pancreasSCE)

pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "knn", k = 3)
                               
# Classic style calculation - setting the seed inside SerialParam for reproducibility
(out <- testInteractions(pancreasSCE, 
                         group_by = "ImageNb",
                         label = "CellType", 
                         method = "classic",
                         colPairName = "knn_interaction_graph",
                         iter = 1000,
                         BPPARAM = SerialParam(RNGseed = 123)))
                                
# Conditional style calculation
(out <- testInteractions(pancreasSCE, 
                         group_by = "ImageNb",
                         label = "CellType", 
                         method = "conditional",
                         colPairName = "knn_interaction_graph",
                         iter = 1000,
                         BPPARAM = SerialParam(RNGseed = 123)))
                                
# Patch style calculation
(out <- testInteractions(pancreasSCE, 
                         group_by = "ImageNb",
                         label = "CellType", 
                         method = "patch",
                         patch_size = 3,
                         colPairName = "knn_interaction_graph",
                         iter = 1000,
                         BPPARAM = SerialParam(RNGseed = 123)))
                         
# Interaction style calculation
(out <- testInteractions(pancreasSCE, 
                         group_by = "ImageNb",
                         label = "CellType", 
                         method = "interaction",
                         colPairName = "knn_interaction_graph"))

}
\references{
\href{https://www.sciencedirect.com/science/article/pii/S2405471217305434}{
Schulz, D. et al., Simultaneous Multiplexed Imaging of mRNA and Proteins with 
Subcellular Resolution in Breast Cancer Tissue Samples by Mass Cytometry., 
Cell Systems 2018 6(1):25-36.e5}

\href{https://www.nature.com/articles/nmeth.4391}{
Schapiro, D. et al., histoCAT: analysis of cell phenotypes and interactions in 
multiplex image cytometry data, Nature Methods 2017 14, p. 873–876}

\href{https://doi.org/10.1101/2025.03.31.646289}{
Schiller, C. et al., Comparison and Optimization of Cellular Neighbor Preference Methods 
for Quantitative Tissue Analysis, biorRxiv 2025.03.31.646289}
}
\seealso{
\code{\link{countInteractions}} for counting (but not testing) cell-cell
interactions per grouping level.
  
\code{\link[BiocParallel]{bpparam}} for the parallelised backend
}
\author{
Vito Zanotelli

Jana Fischer

adapted by Nils Eling (\email{nils.eling@dqbm.uzh.ch})

adapted by Marlene Lutz (\email{marlene.lutz@uzh.ch})

adapted by Chiara Schiller (\email{chiara.schiller@uni-heidelberg.de})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/show_cpout_features.R
\name{show_cpout_features}
\alias{show_cpout_features}
\title{Display all features measured by CellProfiler.}
\usage{
show_cpout_features(
  path,
  display = c("cell_features", "image_features"),
  cell_features = "var_cell.csv",
  image_features = "var_Image.csv"
)
}
\arguments{
\item{path}{full path to the CellProfiler output folder}

\item{display}{single character indicating which features to display.
Accepted entries are \code{cell_features} to display extracted single-cell
features or \code{image_features} to display extracted image-level features.}

\item{cell_features}{single character indicating the name of the file storing
the extracted cell features.}

\item{image_features}{single character indicating the name of the file 
storing the extracted image features.}
}
\value{
a \code{\link[DT]{datatable}} object
}
\description{
Searchable datatable object of cell and image features as 
extracted by CellProfiler.
}
\examples{
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

# Display cell features 
show_cpout_features(path)

# Display image features 
show_cpout_features(path, display = "image_features")

}
\seealso{
\code{\link{read_cpout}} for the CellProfiler reader function
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/patchSize.R
\name{patchSize}
\alias{patchSize}
\title{Function to compute the area of c3ll patches}
\usage{
patchSize(
  object,
  patch_name = "patch_id",
  coords = c("Pos_X", "Pos_Y"),
  convex = FALSE
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{patch_name}{single character indicating the \code{colData(object)} entry
containing the patch cell identifiers.}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries of the cells' x and y locations.}

\item{convex}{should the convex hull be computed to construct the polygon?
Default: the concave hull is computed.}
}
\value{
A DataFrame object containing the patch identifier, the constructed
polygon and the polygon size.
}
\description{
This function constructs polygons around patch cells and
computes their area.
}
\examples{
library(cytomapper)
data(pancreasSCE)

# Build interaction graph
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "expansion", threshold = 20)

# Detect patches of "celltype_B" cells
pancreasSCE <- patchDetection(pancreasSCE, 
                              patch_cells = pancreasSCE$CellType == "celltype_B",
                              expand_by = 5, img_id = "ImageNb",
                              colPairName = "expansion_interaction_graph")
                              
# Compute the patch area
patchSize(pancreasSCE)
  
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binAcrossPixels.R
\name{binAcrossPixels}
\alias{binAcrossPixels}
\title{Aggregate consecutive pixels per single-metal spot}
\usage{
binAcrossPixels(
  object,
  bin_size,
  spot_id = "sample_id",
  assay_type = "counts",
  statistic = "sum",
  ...
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} object containing pixel
intensities for all channels. Individual pixels are stored as columns and
channels are stored as rows.}

\item{bin_size}{single numeric indicating how many consecutive pixels per
spot should be aggregated.}

\item{spot_id}{character string indicating which \code{colData(object)} entry
stores the isotope names of the spotted metal.}

\item{assay_type}{character string indicating which assay to use.}

\item{statistic}{character string indicating the statistic to use for
aggregating consecutive pixels.}

\item{...}{additional arguments passed to \code{aggregateAcrossCells}}
}
\value{
returns the binned pixel intensities in form of a 
\code{SingleCellExperiment} object
}
\description{
Helper function for estimating the spillover matrix. Per metal 
spot, consecutive pixels a aggregated (default: summed).
}
\examples{
path <- system.file("extdata/spillover", package = "imcRtools")
# Read in .txt files
sce <- readSCEfromTXT(path)
dim(sce)

# Visualizes heatmap before aggregation
plotSpotHeatmap(sce)

# Sum consecutive pixels
sce <- binAcrossPixels(sce, bin_size = 10)
dim(sce)

# Visualizes heatmap after aggregation
plotSpotHeatmap(sce)

}
\seealso{
\code{\link[scrapper]{aggregateAcrossCells}} for the aggregation
function
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/buildSpatialGraph.R
\name{buildSpatialGraph}
\alias{buildSpatialGraph}
\title{Builds an interaction graph based on the cells' locations}
\usage{
buildSpatialGraph(
  object,
  img_id,
  type = c("expansion", "knn", "delaunay"),
  k = NULL,
  directed = TRUE,
  max_dist = NULL,
  threshold = NULL,
  coords = c("Pos_X", "Pos_Y"),
  name = NULL,
  BNPARAM = KmknnParam(),
  BPPARAM = SerialParam(),
  ...
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{img_id}{single character indicating the \code{colData(object)} entry
containing the unique image identifiers.}

\item{type}{single character specifying the type of graph to be build.
Supported entries are \code{"expansion"} (default) to find interacting
cells via distance thresholding; \code{"delaunay"} to find interactions via
delaunay triangulation; \code{"knn"} to find the k nearest neighboring
cells.}

\item{k}{(when \code{type = "knn"}) single numeric integer defining the
number of nearest neighbors to search for.}

\item{directed}{(when \code{type = "knn"}) should the returned graph be
directed? (see details).}

\item{max_dist}{(when \code{type = "knn"} or \code{type = "delaunay"}) the
maximum distance at which to consider neighboring cells. All neighbors
within a distance larger than \code{max_dist} will be excluded from graph
construction.}

\item{threshold}{(when \code{type = "expansion"}) single numeric specifying
the maximum distance for considering neighbors}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries of the cells' x and y locations.}

\item{name}{single character specifying the name of the graph.}

\item{BNPARAM}{a \code{\link[BiocNeighbors]{BiocNeighborParam}} object
defining the algorithm to use.}

\item{BPPARAM}{a \code{\link[BiocParallel]{BiocParallelParam-class}} object
defining how to parallelize computations.}

\item{...}{additional parameters passed to the
\code{\link[BiocNeighbors]{findNeighbors}} function (\code{type =
"expansion"}), the \code{\link[RTriangle]{triangulate}} function
(\code{type = "delaunay"}) or the \code{\link[BiocNeighbors]{findKNN}}
function (\code{type = "knn"})).}
}
\value{
returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
containing the graph in form of a \code{SelfHits} object in
\code{colPair(object, name)}. The object is grouped by entries in the 
\code{img_id} slot.
}
\description{
Function to define cell-cell interactions via distance-based
expansion, delaunay triangulation or k nearest neighbor detection.
}
\section{Building an interaction graph}{

This function defines interacting cells in different ways. They are based
on the cells' centroids and do not incorporate cell shape or area.

1. When \code{type = "expansion"}, all cells within the radius
\code{threshold} are considered interacting cells.

2. When \code{type = "delaunay"}, interacting cells are found via a delaunay
triangulation of the cells' centroids.

3. When \code{type = "knn"}, interacting cells are defined as the \code{k}
nearest neighbors in the 2D spatial plane.

The \code{directed} parameter only affects graph construction via k nearest
neighbor search. For \code{directed = FALSE}, each interaction will be
stored as mutual edge (e.g. node 2 is connected to node 10 and vise versa).
For \code{type = "expansion"} and \code{type = "delaunay"}, each edge is
stored as mutual edge by default.

The graph is stored in form of a \code{SelfHits} object in
\code{colPair(object, name)}. This object can be regarded as an edgelist
and coerced to an \code{igraph} object via
\code{graph_from_edgelist(as.matrix(colPair(object, name)))}.
}

\section{Choosing the graph construction method}{

When finding interactions via \code{expansion} or \code{knn}, the
\code{\link[BiocNeighbors]{findNeighbors}} or
\code{\link[BiocNeighbors]{findKNN}} functions are used, respectively. Both
functions accept the \code{BNPARAM} parameter via which the graph
construction method can be defined (default
\code{\link[BiocNeighbors]{KmknnParam}}). For an overview on the different
algorithms, see
\code{\link[BiocNeighbors]{BiocNeighborParam}}. Within the
\code{BiocNeighborParam} object, \code{distance} can be set to
\code{"Euclidean"} (default), \code{"Manhattan"} or \code{"Cosine"}.
}

\section{Ordering of the output object}{

The \code{buildSpatialGraph} function operates on individual images.
Therefore the returned object is grouped by entries in \code{img_id}. 
This means all cells of a given image are grouped together in the object.
The ordering of cells within each individual image is the same as the ordering
of these cells in the input object.
}

\examples{
path <- system.file("extdata/mockData/steinbock", package = "imcRtools")
spe <- read_steinbock(path)

# Constructing a graph via expansion
spe <- buildSpatialGraph(spe, img_id = "sample_id",
                         type = "expansion", threshold = 10)
colPair(spe, "expansion_interaction_graph")

# Constructing a graph via delaunay triangulation
spe <- buildSpatialGraph(spe, img_id = "sample_id",
                         type = "delaunay")
colPair(spe, "delaunay_interaction_graph")

# Constructing a graph via k nearest neighbor search
spe <- buildSpatialGraph(spe, img_id = "sample_id",
                         type = "knn", k = 5)
colPair(spe, "knn_interaction_graph")

}
\seealso{
\code{\link[BiocNeighbors]{findNeighbors}} for the function finding
interactions via expansion

\code{\link[BiocNeighbors]{findKNN}} for the function finding interactions
via nearest neighbor search

\code{\link[RTriangle]{triangulate}} for the function finding interactions
via delaunay triangulation

\code{\link{plotSpatial}} for visualizing spatial graphs
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotInteractions.R
\name{plotInteractions}
\alias{plotInteractions}
\title{Plot interaction graph}
\usage{
plotInteractions(
  out,
  object,
  label,
  group_by,
  node_color_by = NULL,
  node_size_by = NULL,
  node_color_fix = NULL,
  node_size_fix = NULL,
  node_label_repel = TRUE,
  node_label_color_by = NULL,
  node_label_color_fix = NULL,
  edge_color_by = NULL,
  edge_color_fix = NULL,
  edge_width_by = NULL,
  edge_width_fix = NULL,
  draw_edges = TRUE,
  return_data = FALSE,
  graph_layout = "circle"
)
}
\arguments{
\item{out}{a data frame, usually the output from \code{countInteractions} or 
\code{testInteractions}, representing an edge list with columns \code{"group_by",
"from_label" and "to_label"}. Additional columns may be included to specify 
edge attributes (weight or color).}

\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object.}

\item{label}{single character specifying the \code{colData(object)} entry
which stores the cell labels. These can be cell-types labels or other
metadata entries.}

\item{group_by}{a single character indicating the \code{colData(object)}
entry by which interactions are grouped. This is usually the image or patient ID. 
a single character indicating the \code{colData(object)}}

\item{node_color_by}{single character either
\code{NULL, "name","n_cells", "n_group"} by which the nodes should be
colored.}

\item{node_size_by}{single character either \code{NULL, "n_cells","n_group"} 
by which the size of the nodes are defined.}

\item{node_color_fix}{single character specifying the color of all nodes.}

\item{node_size_fix}{single numeric specifying the size of all nodes.}

\item{node_label_repel}{should nodes be labelled? Defaults to TRUE.}

\item{node_label_color_by}{single character either
\code{NULL, "name","n_cells","n_group"} by which the node labels should be
colored.}

\item{node_label_color_fix}{single character specifying the color of all node
labels.}

\item{edge_color_by}{single character indicating the name of the column of \code{"out"} 
used represent edge colors. This column is usually newly added by the user and must assign a 
unique value to each 'from_label'–'to_label' pair. Typically, these values could encode 
the direction of significantly interacting cell type pairs.}

\item{edge_color_fix}{single character specifying the color of all edges.}

\item{edge_width_by}{single character indicating the name of the column of \code{"out"} 
used to scale edge widths. The values in this column are averaged for each 
'from_label'–'to_label' pair. Typically, this could be the 'ct' column from 
of \code{"out"} or a newly added column representing an interaction feature.}

\item{edge_width_fix}{single numeric specifying the width of all edges.}

\item{draw_edges}{should edges be drawn between nodes? Defaults to TRUE.}

\item{return_data}{should the edge list and vertex metadata for graph
construction be returned as a \code{list} of two \code{data.frames}?}

\item{graph_layout}{single character of
\code{"circle", "chord", "linear", "fr", "kk", "drl", "stress", "graphopt", 
"lgl", "tree", "sugiyama", "star", "nicely", "manual", "grid", "mds", "sphere", 
"randomly", "gem", "dh"} which defines the graph layout.
Defaults to \code{"circle"}. For more information, see \link[ggraph]{ggraph}.}
}
\value{
returns a \code{ggplot} object or a \code{list} of two
\code{data.frames}.
}
\description{
Function to plot directed interaction graphs based on symbolic 
edge-lists and vertex metadata.
The user can specify node, node_label and edge aesthetics using dedicated
arguments. The resulting plot can be further refined with `ggplot2` for node 
styling and `ggraph` for edge-specific customization.
}
\examples{
set.seed(22)
library(cytomapper)
library(BiocParallel)
data(pancreasSCE)

## 1. countInteractions or testInteractions
sce  <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", type = "knn", k = 3)

count_out <- countInteractions(sce,
                               group_by = "ImageNb",
                               label = "CellType",
                               method = "classic", # choose from c("classic", "histocat", "patch", "interaction")
                               colPairName = "knn_interaction_graph")

test_out <- testInteractions(sce, 
                             group_by = "ImageNb",
                             label = "CellType", 
                             method = "classic", # choose from c("classic", "histocat", "patch", "interaction")
                             colPairName = "knn_interaction_graph", 
                             iter = 100, 
                             p_threshold = 0.5, 
                             BPPARAM = SerialParam(RNGseed = 123))

## 2. Plot interactions 

# default                
plotInteractions(count_out, sce, "CellType", "ImageNb")

# adjust node aesthetics
plotInteractions(count_out, sce, "CellType", "ImageNb",
                 node_color_by = "name",
                 node_size_by = "n_cells")
                 
# adjust edge aesthetics
plotInteractions(test_out, sce, "CellType", "ImageNb", 
                 edge_width_by = "ct")
                   
# Plot interactions - return data
plotInteractions(test_out, sce, "CellType", "ImageNb",
                 return_data = TRUE)          
                  
}
\seealso{
\code{\link{countInteractions}} for counting (but not testing) cell-cell
interactions per grouping level.
\code{\link{testInteractions}} for testing cell-cell 
interactions per grouping level.
}
\author{
Marlene Lutz (\email{marlene.lutz@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterSpatialContext.R
\name{filterSpatialContext}
\alias{filterSpatialContext}
\title{Filter spatial contexts}
\usage{
filterSpatialContext(
  object,
  entry = "spatial_context",
  group_by = "sample_id",
  group_threshold = NULL,
  cells_threshold = NULL,
  name = "spatial_context_filtered"
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{entry}{a single character specifying the \code{colData(object)} entry 
containing the \code{detectSpatialContext} output. Defaults to 
"spatial_context".}

\item{group_by}{a single character indicating the \code{colData(object)}
entry by which SCs are grouped. This is usually the image or patient ID. 
Defaults to "sample_id".}

\item{group_threshold}{a single numeric specifying the minimum number of
group entries in which a SC is detected.}

\item{cells_threshold}{a single numeric specifying the minimum total number
of cells in a SC.}

\item{name}{a single character specifying the name of the output saved in 
\code{colData(object)}. Defaults to "spatial_context_filtered".}
}
\value{
returns an object of \code{class(object)} containing a new column
entry to \code{colData(object)[[name]]} and a new \code{data.frame} entry to
\code{metadata(object)[["filterSpatialContext"]]} containing the group and
cell counts per SC.
}
\description{
Function to filter detected spatial contexts (SCs) based on a
user-defined threshold for number of group entries and/or cells.
}
\examples{
set.seed(22)
library(cytomapper)
data(pancreasSCE)

## 1. Cellular neighborhood (CN)
sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_cn_graph",
                        k = 5)

sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
                         aggregate_by = "metadata",
                         count_by = "CellType",
                         name = "aggregatedCellTypes")

cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
sce$cellular_neighborhood <- factor(cur_cluster$cluster)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_cn_graph",
           node_color_by = "cellular_neighborhood",
           scales = "free")

## 2. Spatial context (SC)
sce <- buildSpatialGraph(sce, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_sc_graph",
                        k = 15)

sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
                         aggregate_by = "metadata",
                         count_by = "cellular_neighborhood",
                         name = "aggregatedNeighborhood")

# Detect spatial context
sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                           threshold = 0.9)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_sc_graph",
           node_color_by = "spatial_context",
           scales = "free")
            
# Filter spatial context
# By group
sce <- filterSpatialContext(sce, group_by = "ImageNb", 
                            group_threshold = 2)

plotSpatial(sce, img_id = "ImageNb", 
            colPairName = "knn_sc_graph", 
            node_color_by = "spatial_context_filtered",
            scales = "free")

# By cells
sce <- filterSpatialContext(sce, group_by = "ImageNb", 
                            cells_threshold = 15)

plotSpatial(sce, img_id = "ImageNb", 
           colPairName = "knn_sc_graph", 
           node_color_by = "spatial_context_filtered",
           scales = "free")
           
}
\references{
\href{https://doi.org/10.1016/j.cels.2021.09.012}{
Bhate S. et al., Tissue schematics map the specialization of immune tissue 
motifs and their appropriation by tumors, Cell Systems, 2022}
}
\seealso{
\code{\link[imcRtools]{detectSpatialContext}} for the function to detect
spatial contexts

\code{\link[imcRtools]{plotSpatialContext}} for the function to plot 
spatial context graphs
}
\author{
Lasse Meyer (\email{lasse.meyer@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSpotHeatmap.R
\name{plotSpotHeatmap}
\alias{plotSpotHeatmap}
\title{Summarizes and visualizes the pixel intensities per spot and channel}
\usage{
plotSpotHeatmap(
  object,
  spot_id = "sample_id",
  channel_id = "channel_name",
  assay_type = "counts",
  statistic = "median",
  log = TRUE,
  threshold = NULL,
  order_metals = TRUE,
  color = viridis(100),
  breaks = NA,
  legend_breaks = NA,
  cluster_cols = FALSE,
  cluster_rows = FALSE,
  ...
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} object containing pixel
intensities per channel. Individual pixels are stored as columns and
channels are stored as rows.}

\item{spot_id}{character string indicating which \code{colData(object)} entry
stores the isotope names of the spotted metal. Entries should be of the 
form (mt)(mass) (e.g. Sm152 for Samarium isotope with the atomic mass 152).}

\item{channel_id}{character string indicating which \code{rowData(object)} 
entry contains the isotope names of the acquired channels.}

\item{assay_type}{character string indicating which assay to use (default
\code{counts}).}

\item{statistic}{the statistic to use when aggregating channels per spot
(default \code{median})}

\item{log}{should the aggregated pixel intensities be \code{log10(x + 1)} 
transformed?}

\item{threshold}{single numeric indicating a threshold after pixel
aggregation. All aggregated values larger than \code{threshold} will be
labeled as \code{1}.}

\item{order_metals}{should the metals be ordered based on spotted mass?}

\item{color}{see parameter in \code{\link[pheatmap]{pheatmap}}}

\item{breaks}{see parameter in \code{\link[pheatmap]{pheatmap}}}

\item{legend_breaks}{see parameter in \code{\link[pheatmap]{pheatmap}}}

\item{cluster_cols}{see parameter in \code{\link[pheatmap]{pheatmap}}}

\item{cluster_rows}{see parameter in \code{\link[pheatmap]{pheatmap}}}

\item{...}{other arguments passed to \code{pheatmap}.}
}
\value{
a \code{\link[pheatmap]{pheatmap}} object
}
\description{
Helper function for estimating the spillover matrix. This
function visualizes the median pixel intensities per spot (rows) and per
channel (columns) in form of a heatmap.
}
\section{Quality control for spillover estimation}{

Visualizing the aggregated pixel intensities serves two purposes:

\enumerate{
\item Small median pixel intensities (< 200 counts) might hinder the robust
estimation of the channel spillover. In that case, consecutive pixels can be
summed (see \code{\link{binAcrossPixels}}).
\item Each spotted metal (row) should show the highest median pixel intensity
in its corresponding channel (column). If this is not the case, either the
naming of the .txt files was incorrect or the incorrect metal was spotted.
}

By setting the \code{threshold} parameter, the user can easily identify spots
where pixel intensities are too low for robust spillover estimation.
}

\examples{
path <- system.file("extdata/spillover", package = "imcRtools")
# Read in .txt files
sce <- readSCEfromTXT(path)

# Visualizes heatmap
plotSpotHeatmap(sce)

# Visualizes thresholding results
plotSpotHeatmap(sce, log = FALSE, threshold = 200)

}
\seealso{
\code{\link[pheatmap]{pheatmap}} for visual modifications

\code{\link[scrapper]{aggregateAcrossCells}} for the aggregation
function
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/aggregateNeighbors.R
\name{aggregateNeighbors}
\alias{aggregateNeighbors}
\title{Function to aggregate all neighbors of each cell.}
\usage{
aggregateNeighbors(
  object,
  colPairName,
  aggregate_by = c("metadata", "expression"),
  count_by = NULL,
  proportions = TRUE,
  assay_type = NULL,
  subset_row = NULL,
  statistic = c("mean", "median", "sd", "var"),
  name = NULL
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{colPairName}{single character indicating the \code{colPair(object)}
entry containing the neighbor information.}

\item{aggregate_by}{character specifying whether the neighborhood should be
summarized by cellular features stored in \code{colData(object)}
(\code{aggregate_by = "metdata"}) or by marker expression of the
neighboring cells (\code{aggregate_by = "expression"}).}

\item{count_by}{for \code{summarize_by = "metadata"}, a single character
specifying the \code{colData(object)} entry containing the cellular
metadata that should be summarized across each cell's neighborhood.}

\item{proportions}{single logical indicating whether aggregated metadata
should be returned in form of proportions instead of absolute counts.}

\item{assay_type}{for \code{summarize_by = "expression"}, single character
indicating the assay slot to use.}

\item{subset_row}{for \code{summarize_by = "expression"}, an integer, logical
or character vector specifying the features to use. If NULL, defaults to
all features.}

\item{statistic}{for \code{summarize_by = "expression"}, a single character
specifying the statistic to be used for summarizing the expression values
across all neighboring cells. Supported entries are "mean", "median", "sd",
"var". Defaults to "mean" if not specified.}

\item{name}{single character specifying the name of the data frame to be
saved in the \code{colData(object)}. Defaults to "aggregatedNeighbors" when
\code{summarize_by = "metadata"} or "{statistic}_aggregatedExpression" when
\code{summarize_by = "expression"}.}
}
\value{
returns an object of \code{class(object)} containing the aggregated
values in form of a \code{DataFrame} object in
\code{colData(object)[[name]]}.
}
\description{
Function to summarize categorical or expression values of all
neighbors of each cell.
}
\examples{
library(cytomapper)
data(pancreasSCE)

sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                         type = "knn", k = 3)
                         
# Aggregating neighboring cell-types
sce <- aggregateNeighbors(sce, colPairName = "knn_interaction_graph",
                         aggregate_by = "metadata",
                         count_by = "CellType")
sce$aggregatedNeighbors

# Aggregating neighboring expression values
sce <- aggregateNeighbors(sce, colPairName = "knn_interaction_graph",
                         aggregate_by = "expression",
                         assay_type = "exprs",
                         statistic = "mean")
sce$mean_aggregatedExpression
  
}
\author{
Daniel Schulz (\email{daniel.schulz@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/patchDetection.R
\name{patchDetection}
\alias{patchDetection}
\title{Function to detect patches containing defined cell types}
\usage{
patchDetection(
  object,
  patch_cells,
  colPairName,
  min_patch_size = 1,
  name = "patch_id",
  expand_by = 0,
  coords = c("Pos_X", "Pos_Y"),
  convex = FALSE,
  img_id = NULL,
  BPPARAM = SerialParam()
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{patch_cells}{logical vector of length equal to the number of cells
contained in \code{object}. \code{TRUE} entries define the cells to consider
for patch detection (see Details).}

\item{colPairName}{single character indicating the \code{colPair(object)}
entry containing the neighbor information.}

\item{min_patch_size}{single integer indicating the minimum number of 
connected cells that make up a patch before expansion.}

\item{name}{single character specifying the \code{colData} entry storing
the patch IDs in the returned object.}

\item{expand_by}{single numeric indicating in which vicinity range cells
should be considered as belonging to the patch (see Details).}

\item{coords}{character vector of length 2 specifying the names of the
\code{colData} (for a \code{SingleCellExperiment} object) or the
\code{spatialCoords} entries of the cells' x and y locations.}

\item{convex}{should the convex hull be computed before expansion? Default:
the concave hull is computed.}

\item{img_id}{single character indicating the \code{colData(object)} entry
containing the unique image identifiers.}

\item{BPPARAM}{a \code{\link[BiocParallel]{BiocParallelParam-class}} object
defining how to parallelize computations.}
}
\value{
An object of \code{class(object)} containing a patch ID for each 
cell in \code{colData(object)[[name]]}. If \code{expand_by > 0},  cells in the 
output object are grouped by entries in \code{img_id}.
}
\description{
Function to detect spatial clusters of defined types of cells.
By defining a certain distance threshold, all cells within the vicinity
of these clusters are detected as well.
}
\section{Detecting patches of defined cell types}{

This function works as follows:

1. Only cells defined by \code{patch_cells} are considered for patch 
detection.

2. Patches of connected cells are detected. Here, cell-to-cell connections
are defined by the interaction graph stored in 
\code{colPair(object, colPairName)}. At this point, patches that contain 
fewer than \code{min_patch_size} cells are removed.

3. If \code{expand_by > 0}, a concave (default) or convex hull is constructed
around each patch. This is is then expanded by \code{expand_by} and cells
within the expanded hull are detected and assigned to the patch. This 
expansion only works if a patch contains at least 3 cells.

The returned object contains an additional entry 
\code{colData(object)[[name]]}, which stores the patch ID per cell. \code{NA}
indicate cells that are not part of a patch.
}

\section{Ordering of the output object}{

If \code{expand_by > 0}, the \code{patchDetection} function operates on individual images.
Therefore the returned object is grouped by entries in \code{img_id}. 
This means all cells of a given image are grouped together in the object.
The ordering of cells within each individual image is the same as the ordering
of these cells in the input object.

If \code{expand_by = 0}, the ordering of cells in the output object is the same as
in the input object.
}

\examples{
library(cytomapper)
data(pancreasSCE)

# Visualize cell types
plotSpatial(pancreasSCE, 
            img_id = "ImageNb", 
            node_color_by = "CellType",
            scales = "free")

# Build interaction graph
pancreasSCE <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb", 
                                 type = "expansion", threshold = 20)

# Detect patches of "celltype_B" cells
pancreasSCE <- patchDetection(pancreasSCE, 
                              patch_cells = pancreasSCE$CellType == "celltype_B",
                              colPairName = "expansion_interaction_graph")
                              
plotSpatial(pancreasSCE, 
            img_id = "ImageNb", 
            node_color_by = "patch_id",
            scales = "free")

# Include cells in vicinity
pancreasSCE <- patchDetection(pancreasSCE, 
                              patch_cells = pancreasSCE$CellType == "celltype_B",
                              colPairName = "expansion_interaction_graph",
                              expand_by = 20, 
                              img_id = "ImageNb")

plotSpatial(pancreasSCE, 
            img_id = "ImageNb", 
            node_color_by = "patch_id",
            scales = "free")
  
}
\references{
\href{https://www.biorxiv.org/content/10.1101/2021.07.29.454093v1}{
Hoch, T. et al., Multiplexed Imaging Mass Cytometry of Chemokine Milieus in 
Metastatic Melanoma Characterizes Features of Response to Immunotherapy., 
bioRxiv 2021}
}
\author{
Tobias Hoch

adapted by Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/detectCommunity.R
\name{detectCommunity}
\alias{detectCommunity}
\title{Detect the spatial community of each cell}
\usage{
detectCommunity(
  object,
  colPairName,
  size_threshold = 0,
  group_by = NULL,
  name = "spatial_community",
  cluster_fun = "louvain",
  BPPARAM = SerialParam()
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{colPairName}{single character indicating the \code{colPair(object)}
entry containing the neighbor information.}

\item{size_threshold}{single positive numeric that specifies the minimum 
number of cells per community. Defaults to 0.}

\item{group_by}{single character indicating that spatial community 
detection will be performed separately for all unique entries to 
\code{colData(object)[,group_by]}.}

\item{name}{single character specifying the name of the output saved in 
\code{colData(object)}. Defaults to "spatial_community".}

\item{cluster_fun}{single character specifying the function to use for 
community detection. Options are all strings that contain the suffix of an 
\code{igraph} community detection algorithm (e.g. "walktrap"). 
Defaults to "louvain".}

\item{BPPARAM}{a \code{\link[BiocParallel]{BiocParallelParam-class}} object
defining how to parallelize computations. Applicable when \code{group_by} is 
specified and defaults to \code{SerialParam()}. 
For reproducibility between runs, we recommend defining \code{RNGseed} in the
 \code{\link[BiocParallel]{BiocParallelParam-class}} object.}
}
\value{
returns an object of \code{class(object)} containing a new column 
entry to \code{colData(object)[[name]]}.
}
\description{
Function to detect the spatial community of each cell as 
proposed by \href{https://www.nature.com/articles/s41586-019-1876-x}{
Jackson et al., The single-cell pathology landscape of breast cancer, Nature, 
2020}. Each cell is clustered based on its interactions as defined by a 
spatial object graph.
}
\section{Spatial community detection procedure}{

1. Create an igraph object from the edge list stored in 
\code{colPair(object, colPairName)}.  

2. Perform community detection using the specified \code{cluster_fun} algorithm.  
  
3. Store the community IDs in a vector and replace all communities with 
a size smaller than \code{size_threshold} by NA.   

Optional steps: Specify \code{group_by} to perform spatial community 
detection separately for all unique entries to \code{colData(object)[,group_by]} 
e.g. for tumor and non-tumor cells.
}

\examples{
library(cytomapper)
library(BiocParallel)
data(pancreasSCE)

sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                        type = "expansion",
                        name = "neighborhood",
                        threshold = 20)

## Detect spatial community 
set.seed(22)
sce <- detectCommunity(sce, 
                      colPairName = "neighborhood", 
                      size_threshold = 10)

plotSpatial(sce,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            scales = "free")
            
## Detect spatial community - specify group_by
sce <- detectCommunity(sce, 
                       colPairName = "neighborhood", 
                       group_by = "CellType", 
                       size_threshold = 10,
                       BPPARAM = SerialParam(RNGseed = 22)) 

plotSpatial(sce,
            img_id = "ImageNb",
            node_color_by = "spatial_community",
            scales = "free")
           
}
\references{
\href{https://www.nature.com/articles/s41586-019-1876-x}{
Jackson et al., The single-cell pathology landscape of breast cancer, 
Nature, 2020}
}
\author{
Lasse Meyer (\email{lasse.meyer@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/detectSpatialContext.R
\name{detectSpatialContext}
\alias{detectSpatialContext}
\title{Detect the spatial context of each cell based on its neighborhood}
\usage{
detectSpatialContext(
  object,
  entry = "aggregatedNeighbors",
  threshold = 0.9,
  name = "spatial_context"
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object}

\item{entry}{single character specifying the \code{colData(object)}
entry containing the \code{aggregateNeighbors} DataFrame output. 
Defaults to "aggregatedNeighbors".}

\item{threshold}{single numeric between 0 and 1 that specifies the fraction 
threshold for SC assignment. Defaults to 0.9.}

\item{name}{single character specifying the name of the output saved in 
\code{colData(object)}. Defaults to "spatial_context".}
}
\value{
returns an object of \code{class(object)} containing a new column 
entry to \code{colData(object)[[name]]}
}
\description{
Function to detect the spatial context (SC) of each cell. 
Based on its sorted (high-to-low) cellular neighborhood (CN) fractions in a 
spatial interaction graph, the SC of each cell is assigned as the set of CNs 
that cumulatively exceed a user-defined fraction threshold. 

The term was coined by \href{https://doi.org/10.1016/j.cels.2021.09.012}{
Bhate S. et al., Tissue schematics map the specialization of immune tissue 
motifs and their appropriation by tumors, Cell Systems, 2022} and describes 
tissue regions in which distinct CNs may be interacting.
}
\section{Spatial context background}{

The function relies on CN fractions for each cell in a 
spatial interaction graph (originally a k-nearest neighbor (KNN) graph).

We can retrieve the CN fractions using the \link[imcRtools]{buildSpatialGraph} 
and \link[imcRtools]{aggregateNeighbors} functions.

The window size (k for KNN) for \link[imcRtools]{buildSpatialGraph} should 
reflect a length scale on which biological signals can be exchanged and 
depends, among others, on cell density and tissue area. In view of their 
divergent functionality, we recommend to use a larger window size for SC 
(interaction between local processes) than for CN (local processes) detection.

Subsequently, the CN fractions are sorted from high-to-low and the SC of
each cell is assigned the minimal combination of SCs that additively
surpass a user-defined threshold. The default threshold of 0.9 aims to
represent the dominant CNs, hence the most prevalent signals, in a given window.

For more details, please refer to:
\href{https://doi.org/10.1016/j.cels.2021.09.012}{ Bhate S. et al., Tissue
schematics map the specialization of immune tissue motifs and their
appropriation by tumors, Cell Systems, 2022}.
}

\examples{
set.seed(22)
library(cytomapper)
data(pancreasSCE)

## 1. Cellular neighborhood (CN)
sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_cn_graph",
                        k = 5)

sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
                         aggregate_by = "metadata",
                         count_by = "CellType",
                         name = "aggregatedCellTypes")

cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
sce$cellular_neighborhood <- factor(cur_cluster$cluster)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_cn_graph",
           node_color_by = "cellular_neighborhood",
           scales = "free")

## 2. Spatial context (SC)
sce <- buildSpatialGraph(sce, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_sc_graph",
                        k = 15)

sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
                         aggregate_by = "metadata",
                         count_by = "cellular_neighborhood",
                         name = "aggregatedNeighborhood")

# Detect spatial context
sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                           threshold = 0.9)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_sc_graph",
           node_color_by = "spatial_context",
           scales = "free")
           
}
\references{
\href{https://doi.org/10.1016/j.cels.2021.09.012}{
Bhate S. et al., Tissue schematics map the specialization of immune tissue 
motifs and their appropriation by tumors, Cell Systems, 2022}
}
\seealso{
\code{\link[imcRtools]{filterSpatialContext}} for the function to filter 
spatial contexts

\code{\link[imcRtools]{plotSpatialContext}} for the function to plot 
spatial context graphs
}
\author{
Lasse Meyer (\email{lasse.meyer@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readSCEfromTXT.R
\name{readSCEfromTXT}
\alias{readSCEfromTXT}
\title{Generates a SingleCellExperiment from .txt files}
\usage{
readSCEfromTXT(
  x,
  pattern = ".txt$",
  metadata_cols = c("Start_push", "End_push", "Pushes_duration", "X", "Y", "Z"),
  verbose = TRUE,
  read_metal_from_filename = TRUE
)
}
\arguments{
\item{x}{input can be of different types:
\describe{
\item{A path}{Full path to where the single stain .txt files are located.}
\item{A list object}{A named list object where each entry is a
\code{data.frame} or coercible to one. The names of each entry indicate the
spotted metals (see details).}
}}

\item{pattern}{pattern to select which files should be read in (default
\code{".txt$"}). Only used when \code{x} is a path.}

\item{metadata_cols}{character vector indicating which column entries of the
.txt files should be saved in the \code{colData(sce)} slot.}

\item{verbose}{logical indicating if additional information regarding the
spotted and acquired masses should be shown.}

\item{read_metal_from_filename}{should the sample metal and mass be extracted
from the file/object names?}
}
\value{
returns a SCE object where pixels are stored as columns and acquired
channels are stored as rows.
}
\description{
Helper function to process raw .txt files acquired by the
Hyperion imaging system into a \code{\linkS4class{SingleCellExperiment}}
object. This function is mainly used to read-in data generated from a
"spillover slide". Here, each .txt file contains the measurements of
multiple pixels for a single stain across all open channels.
}
\section{Reading in .txt files for spillover correction}{


As described in the original publication, single metal spots are acquired
using the Hyperion imaging system. Each acquisition corresponds to one spot.
All acquisitions are stored in a single .mcd file and individual acquisitions
are stored in single .txt files.

This function aggregates these measurements into a single
\code{SingleCellExperiment} object. For this, two inputs are possible:

\enumerate{
\item \code{x} is a path:
By default all .txt files are read in from the specified path. Here, the path
should indicate the location of the spillover slide measurement. The file
names of the .txt file must contain the spotted metal isotope name in the
format \code{(mt)(mass)} (e.g. \code{Sm152} for Samarium isotope with the
atomic mass 152). Internally, the last occurrence of such a pattern is read
in as the metal isotope name and stored in the \code{colData(sce)$sample_id}
slot.

\item \code{x} is a named list:
If there are issues with reading in the metal isotope names from the .txt
file names, the user can provide a list for which each entry contains the
contents of a single .txt file. The names of the list must indicate the
spotted metal in the format \code{(mt)(mass)}. These names will be stored in
the \code{colData(sce)$sample_id} slot.
}

When \code{read_metal_from_filename = FALSE}, the function will not attempt
to read in the spotted metal isotopes from the file or list names. Therefore,
only the \code{sample_id} will be set based on the file/list names.
}

\examples{
# Read files from path
path <- system.file("extdata/spillover", package = "imcRtools")

sce <- readSCEfromTXT(path) 
sce

# Read files as list
cur_file_names <- list.files(path, pattern = ".txt", full.names = TRUE)
cur_files <- lapply(cur_file_names, read.delim)
names(cur_files) <- sub(".txt", "", basename(cur_file_names))

sce <- readSCEfromTXT(cur_files) 
sce

}
\references{
\href{https://www.sciencedirect.com/science/article/pii/S1550413118306910}{Chevrier,
S. et al. 2017. “Compensation of Signal Spillover in Suspension and Imaging
Mass Cytometry.” Cell Systems 6: 612–20.}
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotSpatialContext.R
\name{plotSpatialContext}
\alias{plotSpatialContext}
\title{Plot spatial context graph}
\usage{
plotSpatialContext(
  object,
  entry = "spatial_context",
  group_by = "sample_id",
  node_color_by = NULL,
  node_size_by = NULL,
  node_color_fix = NULL,
  node_size_fix = NULL,
  node_label_repel = TRUE,
  node_label_color_by = NULL,
  node_label_color_fix = NULL,
  draw_edges = TRUE,
  edge_color_fix = NULL,
  return_data = FALSE
)
}
\arguments{
\item{object}{a \code{SingleCellExperiment} or \code{SpatialExperiment}
object.}

\item{entry}{single character specifying the \code{colData(object)} entry
containing the \code{\link[imcRtools]{detectSpatialContext}} output.
Defaults to "spatial_context".}

\item{group_by}{a single character indicating the \code{colData(object)}
entry by which SCs are grouped. This is usually the image or patient ID. 
Defaults to "sample_id".}

\item{node_color_by}{single character either
\code{NULL, "name","n_cells", "n_group"} by which the nodes should be
colored.}

\item{node_size_by}{single character either \code{NULL, "n_cells","n_group"} 
by which the size of the nodes are defined.}

\item{node_color_fix}{single character specifying the color of all nodes.}

\item{node_size_fix}{single numeric specifying the size of all nodes.}

\item{node_label_repel}{should nodes be labelled? Defaults to TRUE.}

\item{node_label_color_by}{single character either
\code{NULL, "name","n_cells","n_group"} by which the node labels should be
colored.}

\item{node_label_color_fix}{single character specifying the color of all node
labels.}

\item{draw_edges}{should edges be drawn between nodes? Defaults to TRUE.}

\item{edge_color_fix}{single character specifying the color of all edges.}

\item{return_data}{should the edge list and vertex metadata for graph
construction be returned as a \code{list} of two \code{data.frames}?}
}
\value{
returns a \code{ggplot} object or a \code{list} of two
\code{data.frames}.
}
\description{
Function to plot directed spatial context graphs based on
symbolic edge-lists and vertex metadata, which operates on the cohort-level.
The user can specify node, node_label and edge aesthetics.
}
\examples{
set.seed(22)
library(cytomapper)
data(pancreasSCE)

## 1. Cellular neighborhood (CN)
sce <- buildSpatialGraph(pancreasSCE, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_cn_graph",
                        k = 5)

sce <- aggregateNeighbors(sce, colPairName = "knn_cn_graph",
                         aggregate_by = "metadata",
                         count_by = "CellType",
                         name = "aggregatedCellTypes")

cur_cluster <- kmeans(sce$aggregatedCellTypes, centers = 3)
sce$cellular_neighborhood <- factor(cur_cluster$cluster)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_cn_graph",
           node_color_by = "cellular_neighborhood",
           scales = "free")

## 2. Spatial context (SC)
sce <- buildSpatialGraph(sce, img_id = "ImageNb",
                        type = "knn",
                        name = "knn_sc_graph",
                        k = 15)

sce <- aggregateNeighbors(sce, colPairName = "knn_sc_graph",
                         aggregate_by = "metadata",
                         count_by = "cellular_neighborhood",
                         name = "aggregatedNeighborhood")

# Detect spatial context
sce <- detectSpatialContext(sce, entry = "aggregatedNeighborhood",
                           threshold = 0.9)

plotSpatial(sce, img_id = "ImageNb",
           colPairName = "knn_sc_graph",
           node_color_by = "spatial_context",
           scales = "free")
            
# Plot spatial context - default
plotSpatialContext(sce, group_by = "ImageNb")

# Plot spatial context - adjust aesthetics
plotSpatialContext(sce, group_by = "ImageNb",
                   node_color_by = "name",
                   node_size_by = "n_cells",
                   node_label_color_by = "name")
                   
plotSpatialContext(sce, group_by = "ImageNb",
                   node_color_by = "n_cells",
                   node_size_by = "n_group")
                   
# Plot spatial context - return data
plotSpatialContext(sce, group_by = "ImageNb",
                  return_data = TRUE)          
                  
}
\references{
\href{https://doi.org/10.1016/j.cels.2021.09.012}{
Bhate S. et al., Tissue schematics map the specialization of immune tissue 
motifs and their appropriation by tumors, Cell Systems, 2022}
}
\seealso{
\code{\link[imcRtools]{detectSpatialContext}} for the function to detect
spatial contexts

\code{\link[imcRtools]{filterSpatialContext}} for the function to filter 
spatial contexts
}
\author{
Lasse Meyer (\email{lasse.meyer@uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_steinbock.R
\name{read_steinbock}
\alias{read_steinbock}
\title{Reads in single-cell data generated by the steinbock pipeline}
\usage{
read_steinbock(
  path,
  intensities_folder = "intensities",
  regionprops_folder = "regionprops",
  graphs_folder = "neighbors",
  pattern = NULL,
  extract_cellid_from = "Object",
  extract_coords_from = c("centroid-1", "centroid-0"),
  image_file = "images.csv",
  extract_imagemetadata_from = c("width_px", "height_px"),
  panel_file = "panel.csv",
  extract_names_from = "name",
  return_as = c("spe", "sce"),
  BPPARAM = SerialParam()
)
}
\arguments{
\item{path}{full path to the steinbock output folder}

\item{intensities_folder}{name of the folder containing the intensity 
measurements per image}

\item{regionprops_folder}{name of the folder containing the cell-specific
morphology and spatial measurements per image. Can be set to \code{NULL} to 
exclude reading in morphology measures.}

\item{graphs_folder}{name of the folder containing the spatial connectivity
graphs per image. Can be set to \code{NULL} to exclude reading in graphs.}

\item{pattern}{regular expression specifying a subset of files that should 
be read in.}

\item{extract_cellid_from}{single character indicating which column entry in 
the intensity files contains the integer cell id.}

\item{extract_coords_from}{character vector indicating which column entries 
in the regionprops files contain the x (first entry) and y (second entry) 
coordinates.}

\item{image_file}{single character indicating the file name storing meta data
per image (can be \code{NULL}).}

\item{extract_imagemetadata_from}{character vector indicating which
additional image specific metadata to extract from the \code{image_file}.
These will be stored in the \code{colData(x)} slot as object/cell-specific
entries.}

\item{panel_file}{single character containing the name of the panel file. 
This can either be inside the steinbock path (recommended) or located 
somewhere else.}

\item{extract_names_from}{single character indicating the column of the panel
file containing the channel names.}

\item{return_as}{should the object be returned as 
\code{\linkS4class{SpatialExperiment}} (\code{return_as = "spe"}) or
\code{\linkS4class{SingleCellExperiment}} (\code{return_as = "sce"}).}

\item{BPPARAM}{parameters for parallelised processing.}
}
\value{
returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
object markers in rows and cells in columns.
}
\description{
Reader function to generate a
\code{\linkS4class{SpatialExperiment}} or
\code{\linkS4class{SingleCellExperiment}} object from single-cell data
obtained by the 
\href{https://github.com/BodenmillerGroup/steinbock}{steinbock}
pipeline.
}
\section{The returned data container}{

In the case of both containers \code{x}, intensity features are stored in
the \code{counts(x)} slot. Morphological features are stored in the
\code{colData(x)} slot. The graphs are stored as 
\code{\link[S4Vectors]{SelfHits}} object in the 
\code{colPair(x, "neighborhood")} slot.

In the case of a returned \code{SpatialExperiment} object, the cell 
coordinates are stored in the \code{spatialCoords(x)} slot.

In the case of a returned \code{SingleCellExperiment} object, the cell 
coordinates are stored in the \code{colData(x)} slot named as \code{Pos_X}
and \code{Pos_Y}.
}

\examples{
path <- system.file("extdata/mockData/steinbock", package = "imcRtools")

# Read in as SpatialExperiment object
x <- read_steinbock(path)
x

# Read in as SingleCellExperiment object
x <- read_steinbock(path, return_as = "sce")
x

# Read in a subset of files
x <- read_steinbock(path, pattern = "mockData1")
x

# Only read in intensities
x <- read_steinbock(path, graphs_folder = NULL, regionprops_folder = NULL)
x

# Parallelisation
x <- read_steinbock(path, BPPARAM = BiocParallel::bpparam())

}
\seealso{
\url{https://github.com/BodenmillerGroup/steinbock} for the pipeline

\code{\link{read_cpout}} for reading in single-cell data as produced by the
ImcSegmentationPipeline

\code{\link[SingleCellExperiment]{SingleCellExperiment}} and 
\code{\link[SpatialExperiment]{SpatialExperiment}} for the constructor 
functions.

\code{\link[SingleCellExperiment]{colPair}} for information on how to work
with the cell-cell interaction graphs

\code{\link[BiocParallel]{bpparam}} for the parallelised backend
}
\author{
Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/read_cpout.R
\name{read_cpout}
\alias{read_cpout}
\title{Reads in single-cell data generated by the ImcSegmentationPipeline}
\usage{
read_cpout(
  path,
  object_file = "cell.csv",
  image_file = "Image.csv",
  panel_file = "panel.csv",
  graph_file = "Object relationships.csv",
  object_feature_file = "var_cell.csv",
  intensities = "Intensity_MeanIntensity_FullStack",
  extract_imgid_from = "ImageNumber",
  extract_cellid_from = "ObjectNumber",
  extract_coords_from = c("Location_Center_X", "Location_Center_Y"),
  extract_cellmetadata_from = c("AreaShape_Area", "Neighbors_NumberOfNeighbors_8",
    "AreaShape_Eccentricity", "AreaShape_MajorAxisLength", "AreaShape_MinorAxisLength",
    "AreaShape_MeanRadius"),
  extract_imagemetadata_from = c("Metadata_acname", "Metadata_acid",
    "Metadata_description"),
  extract_graphimageid_from = "First Image Number",
  extract_graphcellids_from = c("First Object Number", "Second Object Number"),
  extract_metal_from = "Metal Tag",
  scale_intensities = TRUE,
  extract_scalingfactor_from = "Scaling_FullStack",
  return_as = c("spe", "sce")
)
}
\arguments{
\item{path}{full path to the CellProfiler output folder.}

\item{object_file}{single character indicating the file name storing the
object/cell-specific intensities and metadata.}

\item{image_file}{single character indicating the file name storing meta data
per image (can be \code{NULL}).}

\item{panel_file}{single character indicating the file name storing the panel
information (can be \code{NULL}).}

\item{graph_file}{single character indicating the file name storing the
object/cell interaction information (can be \code{NULL}).}

\item{object_feature_file}{single character indicating the file name storing
object/cell feature information.}

\item{intensities}{single character indicating which column entries of the
\code{object_file} contain the intensity features of interest. See details.}

\item{extract_imgid_from}{single character indicating which column entries of
the \code{object_file} and \code{image_file} contain the image integer ID.}

\item{extract_cellid_from}{single character indicating which column entry
of the \code{object_file} contains the object/cell integer ID.}

\item{extract_coords_from}{character vector indicating which column entries
of the \code{object_file} contain the x and y location of the
objects/cells.}

\item{extract_cellmetadata_from}{character vector indicating which additional
object/cell specific metadata to extract from the \code{object_file}.}

\item{extract_imagemetadata_from}{character vector indicating which
additional image specific metadata to extract from the \code{image_file}.
These will be stored in the \code{colData(x)} slot as object/cell-specific
entries.}

\item{extract_graphimageid_from}{single character indicating  which column
entries of the \code{graph_file} contain the image integer ID.}

\item{extract_graphcellids_from}{character vector indicating which column
entries of the \code{graph_file} contain the first and second object/cell
integer IDs. These will be stored as the \code{from} and \code{to} entry of
the \code{SelfHits} object in colPair(x, "neighborhood").}

\item{extract_metal_from}{single character indicating which column entry of
the \code{panel_file} contains the metal isotopes of the used antibodies.
This entry is used to match the panel information to the acquired channel
information.}

\item{scale_intensities}{single logical. Should the measured intensity
features be scaled by \code{extract_scalingfactor_from}.}

\item{extract_scalingfactor_from}{single character indicating which column
entries of the \code{image_file} contain the image specific scaling factor.}

\item{return_as}{should the object be returned as
\code{\linkS4class{SpatialExperiment}} (\code{return_as = "spe"}) or
\code{\linkS4class{SingleCellExperiment}} (\code{return_as = "sce"}).}
}
\value{
returns a \code{SpatialExperiment} or \code{SingleCellExperiment}
object with markers in rows and cells in columns.
}
\description{
Reader function to generate a
\code{\linkS4class{SpatialExperiment}} or
\code{\linkS4class{SingleCellExperiment}} object from single-cell data
obtained by the 
\href{https://github.com/BodenmillerGroup/ImcSegmentationPipeline}{ImcSegmentationPipeline}
pipeline.
}
\section{The returned data container}{

In the case of both containers \code{x}, intensity features (as selected
by the \code{intensities} parameter) are stored in the \code{counts(x)} slot.
Cell metadata (e.g morphological features) are stored in the
\code{colData(x)} slot. The interaction graphs are stored as
\code{\link[S4Vectors]{SelfHits}} object in the 
\code{colPair(x, "neighborhood")} slot.

Intensity features are extracted via partial string matching. Internally, the 
\code{read_cpout} function checks if per channel a single intensity feature
is read in (by checking the \code{_cXY} ending where \code{XY} is the 
channel number).

In the case of a returned \code{SpatialExperiment} object, the cell 
coordinates are stored in the \code{spatialCoords(x)} slot.

In the case of a returned \code{SingleCellExperiment} object, the cell 
coordinates are stored in the \code{colData(x)} slot named as \code{Pos_X}
and \code{Pos_Y}.
}

\examples{
path <- system.file("extdata/mockData/cpout", package = "imcRtools")

# Read in as SpatialExperiment object
x <- read_cpout(path, graph_file = "Object_relationships.csv")
x

# Read in as SingleCellExperiment object
x <- read_cpout(path, graph_file = "Object_relationships.csv", 
                return_as = "sce")
x

}
\seealso{
\url{https://github.com/BodenmillerGroup/ImcSegmentationPipeline} for the 
pipeline

\code{\link{read_steinbock}} for reading in single-cell data as produced by 
the steinbock pipeline

\code{\link[SingleCellExperiment]{colPair}} for information on how to work
with the cell-cell interaction graphs
}
\author{
Tobias Hoch

Nils Eling (\email{nils.eling@dqbm.uzh.ch})
}
